/***< file >******************************************************************/
/*	Title		:	PS-X System												 */
/*	Version		:	1.00													 */
/*	Code		:	pachinko												 */
/*	Filename	:	lt_sys.h												 */
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							 */
/*	Date		:	04/11/1995												 */
/*	Note		:	VXeɊ֌W郏[N̐ݒ							 */
/*									 Copyright(C) by KONAMI.Co.LTD			 */
/*****************************************************************************/

#ifndef	LT_SYS_H_DEF
#define LT_SYS_H_DEF

/*==========================================================================*/
/*		OT, PACKET ر														*/
/*==========================================================================*/
#define		NBUFF		2

#define		KUGI_OT		3
#define		OT_LENGTH	6
#define		OT3_LENGTH	13
#define		MOT_LENGTH	5

#define		OTSIZE		(1<<OT_LENGTH)
#define		OT3SIZE		(1<<OT3_LENGTH)
#define		MOTSIZE		(1<<MOT_LENGTH)
#define		OT_NUMBER	10

/*#define		PACKETMAX	0x18000*/
#define		PACKETMAX	0x18000

#define		SCRATCH		(u_long *)0x1f800000		/* ׯ߯ */

/*==========================================================================*/
/*		oO`FbNp														*/
/*==========================================================================*/
#define		CDCUT			/* bc֘A̐͂ */

/*==========================================================================*/
/*		Wx`														*/
/*==========================================================================*/
#define		ERR			0
#define		OK			1

#define		FALSE		0
#define		TRUE		1		/* C[vp */

#define		ON			1
#define		OFF			0

#define		YES			0
#define		NO			1

#define		NULL_PNT	(void *)0x00000


/*--------------------------------------------------------------------------*/
/*	\̂̒`															*/
/*--------------------------------------------------------------------------*/
/*--------------------------------------*/
/*	OT\̂а						*/
/*--------------------------------------*/
typedef struct _GsOT_TAG_D{
        unsigned	p : 24;
        unsigned	char num : 8;
} GsOT_TAG_D;


/*--------------------------------------*/
typedef struct _GsOT_D{
	unsigned long 	length;
	GsOT_TAG_D		*org;
	unsigned long 	offset;
	unsigned long 	point;
	GsOT_TAG_D		*tag;
} GsOT_D;

/*--------------------------------------*/
/*	߹ė̈							*/
/*--------------------------------------*/
typedef unsigned char   PACKET_D;


/*--------------------------------------*/
/*	޼ުܰر̍\				*/
/*--------------------------------------*/
#if 1
#define		OBJW_AREA_SIZE		(0x28000)				/* obj work size */
#else
#define		OBJW_AREA_SIZE		(0x200)				/* obj work size */
#endif
#define		OBJW_PRI_NUM		(0x10)					/* obj work priority */

/* -------------------------------------*/
/*	޼ުܰͯް̍\			*/
/* -------------------------------------*/

struct OBJ_QUEUE_HEAD{
	struct OBJ_QUEUE_HEAD 			*prev;		/* Oɏڽ */
	struct OBJ_QUEUE_HEAD 			*next;		/* ŏڽ */
	u_long					size;		/* mۂ̻ܰ */
};

typedef struct _OBJ_W_HEAD {
	struct OBJ_QUEUE_HEAD		queue;
	u_long				objfunc;	/* OBJ֐ */
	u_long				func;		/* ֐ */
} OBJ_W_HEAD;

typedef struct _OBJ_W_AREA {
	struct OBJ_QUEUE_HEAD	objw_que_head[OBJW_PRI_NUM+1];	/* ײèʂ̐擪ڽ */
	struct OBJ_QUEUE_HEAD	objw_empty_head;				/* ̈̐擪ڽ */
	u_char			objw_area[OBJW_AREA_SIZE];		/* obj work area */
} OBJ_W_AREA;

/*----------------------------------*/
/*	ިޯ̧̍\				*/
/*----------------------------------*/
typedef struct _DISP_BUFF {
	long		x_res;		/* 𑜓x */
	long		y_res;		/* 𑜓x */
	long		x[2];		/* ޯ̧wWiۑpj*/
	long		y[2];		/* ޯ̧xWiۑpj*/
	long		cx[2];		/* p */
	long		cy[2];		/* p */
	u_long		flug;		/* p׸ */
	long		x_save;		/* 𑜓x */
	long		y_save;		/* 𑜓x */
} DISP_BUFF;

/*----------------------------------*/
/*	߯ނ̍\					*/
/*----------------------------------*/
#define		JOY1		0
#define		JOY2		1

typedef struct _JOY_W	{
	u_long	joy_new;	/* ݂ ͒l */
	u_long	joy_old;	/* O ͒l */
	u_long	joy_trg;	/* (joy_w ^ joyold) & joy_w */
	u_long	joy_ntrg;	/* (joy_w ^ joyold) & joy_old */
} JOY_W;

typedef	struct {
	unsigned int pad_l_right		:4;
	unsigned int pad_l_right_flag	:1;
	unsigned int pad_l_left			:4;
	unsigned int pad_l_left_flag	:1;
	unsigned int pad_l_up			:4;
	unsigned int pad_l_up_flag		:1;
	unsigned int pad_l_down			:4;
	unsigned int pad_l_down_flag	:1;
	unsigned int pad_L1				:4;
	unsigned int pad_L1_flag		:1;
	unsigned int pad_L2				:4;
	unsigned int pad_L2_flag		:1;
	unsigned int pad_R1				:4;
	unsigned int pad_R1_flag		:1;
	unsigned int pad_R2				:4;
	unsigned int pad_R2_flag		:1;
	unsigned int counter			:4;
}PAD_W;

/*----------------------------------*/
/*	ްݽpܰ̍\			*/
/*----------------------------------*/
#define		TRANSW_SUU	0x100
#define 	TRANSW_SIZE	(sizeof (TRANS_W))

typedef struct _TRANS_W	{
	u_long		address;		/* ްڽ */
	u_short		type;			/* ް */
	u_short		kind;			/* ]@̎ */
	u_long		free;			/* ذܰ (ް̱ڽȂǂ̕ۑɎgp) */
} TRANS_W;

#define	M_trans_address(p)		(p->address)
#define	M_trans_type(p)			(p->type)
#define	M_trans_kind(p)			(p->kind)
#define	M_trans_free(p)			(p->free)

/*----------------------------------*/
/*	ݸޗpܰ						*/
/*----------------------------------*/
#define	STRING_TDN				4
#define	STRING_TD0				0
#define	STRING_TD1				1
#define	STRING_TD2				2
#define	STRING_TD3				3

#ifdef	S_DUMP_ON
#define	STRING_BUF_SIZE			0x400
#else
#define	STRING_BUF_SIZE			0x100
#endif

/* readflag */
#define	STRING_READ_ON			0
#define	STRING_READ_OFF			1

/* ftype, ctype */
#define	STRING_BIN_TYPE			0
#define	STRING_CSR_TYPE			1
#define	STRING_COL_TYPE			1

/* mode */
#define	STRING_MODE08			8
#define	STRING_MODE16			16

/* CD read request */
#define	READ_REQ_MAX			8

/* ݸްpðް̍\ */
typedef struct _STRING_TD {
	u_long		cdhdnum;						/* cdhdް */
	u_long		ftype;							/* ̧̫ق */
	u_long		fname;							/* ̫Ȱ */
	u_short		fx, fy, fw, fh;					/* ̫Ļ */
	u_long		ctype;							/* װ̧ق */
	u_long		cname;							/* װ Ȱ */
	u_short		cx, cy, cw, ch;					/* װ */
	u_short		w, h;							/* ̫Ă̻ */
	u_long		uvp;							/* uvðٱڽ߲ */
} STRING_TD;

/* bcigcj̓ǂݏovqueueobt@ */
typedef struct _READ_REQUEST {
	u_long		status;						/* ݂̏					*/
	u_long		cdhd;						/* HD_DATA or CD_DATA ׸		*/
	u_long		dst;						/* ]						*/
	u_long		size;						/* 							*/
	u_long		sect;						/* (HD)̧ٖ, (CD)ξԍ	*/
	u_char		cd_step;					/* CD_READ STEP	*/
} READ_REQUEST;

#define	M_string_td_cdhdnum(p)		(p->cdhdnum)
#define	M_string_td_ftype(p)		(p->ftype)
#define	M_string_td_fname(p)		(p->fname)
#define	M_string_td_fx(p)			(p->fx)
#define	M_string_td_fy(p)			(p->fy)
#define	M_string_td_fw(p)			(p->fw)
#define	M_string_td_fh(p)			(p->fh)
#define	M_string_td_ctype(p)		(p->ctype)
#define	M_string_td_cname(p)		(p->cname)
#define	M_string_td_cx(p)			(p->cx)
#define	M_string_td_cy(p)			(p->cy)
#define	M_string_td_cw(p)			(p->cw)
#define	M_string_td_ch(p)			(p->ch)
#define	M_string_td_w(p)			(p->w)
#define	M_string_td_h(p)			(p->h)
#define	M_string_td_uvp(p)			(p->uvp)

/*----------------------------------*/
/*	аèނ̍\			*/
/*----------------------------------*/
typedef struct _GsSPRITE_D {
	unsigned long attribute;
	short x,y;
	unsigned short w,h;
	unsigned short tpage;
	unsigned char u,v;
	short cx,cy;
	unsigned char r,g,b;
	short mx,my;
	short scalex,scaley;
	long rotate;
} GsSPRITE_D;

typedef struct _PRIM {
	char	prim[0x180];
} PRIM;

/*--------------------------*/
/*	ݸސpܰ			*/
/*--------------------------*/
typedef	struct _STRING_W {
	GsSPRITE_D			prim;					/* è */
	short				fx;						/* ̫Ă̂W */
	short				fy;						/* ̫Ă̂W */
	short				cx;						/* ʶװ̂W */
	short				cy;						/* ʶװ̂W */
} STRING_W;

#define		M_string_fx(p)		(p->fx)			/* ̫Ă̂W */
#define		M_string_fy(p)		(p->fy)			/* ̫Ă̂W */
#define		M_string_cx(p)		(p->cx)			/* ʶװ̂W */
#define		M_string_cy(p)		(p->cy)			/* ʶװ̂W */

/*----------------------------------*/
/*	ݺpܰ̍\			*/
/*----------------------------------*/
#define		P_OBJ_NUM			0x40				/* pobj ̾max */
#define		P_HITOBJ_NUM		0x20				/* hitpobj ̾max */
#define		TAMA_NUM			0x20				/* ʂĂł */

typedef struct _PACHINKO_W	{
	long		pach_num;						/* ݺ̔ԍ */
} PACHINKO_W;

typedef struct _P_DATA_W	{
	u_long		pach_switch;					/* d ON/OFF */
	u_long		pach_tama;						/* ݺʂ̾ */
	long		pach_v;							/* ݺ̂Q_Ԃ̋ */
	long		pach_tama_s;					/* ݺʂ̏x */
	long		pach_tama_t;					/* ݺʂ̑łoԊu */
	short		pach_tome_flag;					/* ݺ~ߑł׸ */
	short		pach_tome_timer;				/* ݺ~ߑłϰ */
	u_long		bugcode;						/* ޸޺޾ܰ */
	long		modelscale;						/* ݸނ̽ */
	long		modelsizex;						/* ݸޑ̻ނ */
	long		modelsizey;						/* ݸޑ̻ނ */
	long		modelsizez;						/* ݸޑ̻ނ */
	u_long		ekisyousizex;					/* tذݻ x */
	u_long		ekisyousizey;					/* tذݻ y */
	short		ekisyoudotx;					/* tޯĻ x */
	short		ekisyoudoty;					/* tޯĻ y */
	u_long		ekisyoudotsizex;				/* tޯĻ x */
	u_long		ekisyoudotsizey;				/* tޯĻ y */
	short		ekisyoux0;						/* tذݍW x0 */
	short		ekisyouy0;						/* tذݍW y0 */
	short		ekisyouz0;						/* tذݍW z0 */
	short		ekisyoux1;						/* tذݍW x1 */
	short		ekisyouy1;						/* tذݍW y1 */
	short		ekisyouz1;						/* tذݍW z1 */
	short		ekisyoux2;						/* tذݍW x2 */
	short		ekisyouy2;						/* tذݍW y2 */
	short		ekisyouz2;						/* tذݍW z2 */
	short		ekisyoux3;						/* tذݍW x3 */
	short		ekisyouy3;						/* tذݍW y3 */
	short		ekisyouz3;						/* tذݍW z3 */
	long		ekisyourom;						/* tROMڽ߲ */
	long		modelkugiR;						/* ݸޓB̻ r */
	long		modelkugiH;						/* ݸޓB̻ h */
	long		modelkugiHR;					/* ݸޓB̻ hr */
	long		modeltamaR;						/* ݸދʂ̻ r */
	u_long		modelG;							/* d͉x */
	long		modelshoot;						/* ݺʔ߲ */
	u_long		moveR;							/* ~ړ̔a */
	u_long		modulesize;						/* Ӽޭٻ */
	u_long		*kdatap;						/* Bް߲ */
	long		centerAx, centerAy;				/* S A */
	long		centerBx, centerBy;				/* S B */
	long		centerCx, centerCy;				/* S C */
	long		centerDx, centerDy;				/* S D */
	long		centerAr;						/* a A */
	long		centerBr;						/* a B */
	long		centerCr;						/* a C */
	long		centerDr;						/* a D */
	long		centerEr;						/* a E */
	long		firex;							/* ˈʒu */
	long		firey;							/* ˈʒu */
	long		pobj[P_OBJ_NUM];				/* pobjڽ */
	long		hitobj[P_HITOBJ_NUM];			/* objڽ */
	u_long		tama_num[TAMA_NUM];				/* ݺʂ̾Ăł鐔 */
	u_long		*esfp;							/* t ֐߲ */
	u_long		*randcfp;						/* Ѷ ֐߲ */
	u_long		randc;							/* Ѷ */
	u_long		randcn;							/* Ѷĉ */
	u_long		randcw;							/* ѶĂ̳ */
	u_long		randcwn;						/* ѶĂ̳ĉ */
} P_DATA_W;

/*===========================================================================*/
/* VXep[N\́i\tgZbgj*/
/*===========================================================================*/
typedef struct _SYS_W {
	/*----------------------*/
	/* ьnܰ			*/
	/*----------------------*/
	u_long		ev0;						/*  */
	u_long		ev1;						/*  */
	u_long		ev2;						/*  */
	u_long		ev3;						/*  */
	u_long		stimer;						/* SystempTimer */
	u_long		gtimer;						/* GAMEpTimer */

	u_long		stepw;						/* Ҳݽïߒl */
	u_long		stepw_end;					/* ҲݽïߏI׸ */
	u_long		stepw_s;					/* ޽ïߒl */
	u_long		stepw_s_end;				/* ޽ïߏI׸ */
	u_long		gstepw;						/* ްѽïߒl */
	u_long		gstepw_end;					/* ްѽïߏI׸ */
	u_long		gstepw_s;					/* ްѻ޽ïߒl */
	u_long		gstepw_s_end;				/* ްѻ޽ïߏI׸*/
	u_long		vsync_no;					/* VSync鐂	*/

	long		activebuff;					/* `撆ޯ̧ԍۑ */

	u_long		reset_fg;					/* Software Reset flag  */
	u_long		reset_counter;				/*                Timer */
	u_long		pause_fg;					/* |[YtO (1->enable) */
	u_long		pause_ok;					/* ߰ގ󂯂׸ (1->enable) */

	u_long		fade_flag;					/* ̪׸ */

	u_long		class_off;					/* CLASS_W disable tO */

	u_long		select_root;				/* ڸٰް */
	u_long		select_number;				/* ڸް */
	u_long		view_z;						/* _ */

	/*----------------------*/
	/* J°ٗpܰ			*/
	/*----------------------*/
	u_long		item_flag;					/* item ׸ */
	u_short		item_step;					/* item ï */
	u_short		item_step_s;				/* item ï  */
	short		item_num;					/* item ڸް */
	short		item_num_s;					/* item ڸް  */
	PRIM		item_prim;					/* їpײܰ */

	/*----------------------*/
	/* דWJޯ̧			*/
	/*----------------------*/
/*	u_char		decode_buf[256*256];*/	 	/* 0x4000 */

	/*----------------------*/
	/* ިޯ̧			*/
	/*----------------------*/
	DISP_BUFF	disp_buff;					/* ިޯ̧̍Wۑر */

	/*----------------------*/
	/* ذݵ̾Ĉʒu		*/
	/*----------------------*/
	long		screen_offsetx;
	long		screen_offsety;

	/*----------------------*/
	/* ٰĶ				*/
	/*----------------------*/
	u_long		S_line_rc;					/* AٰĶ */

	/*----------------------*/
	/* ۰				*/
	/*----------------------*/
	JOY_W		S_joy_w[2];					/* JOY-PADpܰ */
	long		S_joy_id;					/* ޮè̏ */
	PAD_W		pad_w[2];

	/*----------------------*/
	/* CDHD ްǗܰ		*/
	/*----------------------*/
	u_char		cd_status[8];

	/*----------------------*/
	/* ]pܰ 		*/
	/*----------------------*/
	TRANS_W		transw[TRANSW_SUU];			/* ްݽpܰ */

	/*----------------------*/
	/* ݸޗpܰ			*/
	/*----------------------*/
	STRING_TD	*string_td[STRING_TDN];		/* ݸðް߲ */
	STRING_W	stringw;					/* ݸܰ */
	u_long		string_buf[STRING_BUF_SIZE];/* ݸbuf */
	u_long		string_bufp;				/* ݸbuf߲ */
	u_long		string_np;					/* ݸ߲ */

	/*----------------------*/
	/* CD read queuepܰ	*/
	/*----------------------*/
	READ_REQUEST	read_request[READ_REQ_MAX];

	/*----------------------*/
	/* GAME ܰ				*/
	/*----------------------*/
	short		sound_st_mn;				/* ޗp׸ށi0:ڵj	*/
	short		mode_num;					/* ڸӰް */
	short		mode0_num;					/* UӰް */
	short		mode1_num;					/* HӰް */
	short		mode2_num;					/* Ӱް */
	short		mode3_num;					/* L^Ӱް */
	short		mode4_num;					/* USERӰް */

	/*----------------------*/
	/* ݺpܰ		*/
	/*----------------------*/
	PACHINKO_W	pachinkow;					/* ݺܰ */
/*	P_DATA_W	pdw;		*/				/* ݺܰ */

	u_long		obj_use_max;
	u_long		max_obj_adr;
/*	u_long		work[0x200];	*/			/* ذܰ */
} SYS_W;

/*===========================================================================*/
/* VXep[N\́i\tgZbgۑj*/
/*===========================================================================*/
typedef struct _SYS0_W {
	u_long	S0_testw;
} SYS0_W;

/*--------------------------------------------------------------------------*/
/*	ϸے`																	*/
/*--------------------------------------------------------------------------*/
#define	sys_w	register SYS_W   *s = S_sys_w
#define	sys0_w	register SYS0_W  *s0 = S_sys0_w

#define		M_ev0()				(S_sys_w->ev0)
#define		M_ev1()				(S_sys_w->ev1)
#define		M_ev2()				(S_sys_w->ev2)
#define		M_ev3()				(S_sys_w->ev3)
#define		M_stimer()			(S_sys_w->stimer)
#define		M_gtimer()			(S_sys_w->gtimer)

#define		M_stepw()			(S_sys_w->stepw)
#define		M_stepw_s()			(S_sys_w->stepw_s)
#define		M_stepw_end()		(S_sys_w->stepw_end)
#define		M_stepw_s_end()		(S_sys_w->stepw_s_end)
#define		M_gstepw()			(S_sys_w->gstepw)
#define		M_gstepw_end()		(S_sys_w->gstepw_end)
#define		M_gstepw_s()		(S_sys_w->gstepw_s)
#define		M_gstepw_s_end()	(S_sys_w->gstepw_s_end)

/*----------------------------------*/
/*	דWJޯ̧					*/
/*----------------------------------*/
#define		M_decode_buf()		(S_sys_w->decode_buf[0])

/*----------------------------------*/
/*	ިڲ						*/
/*----------------------------------*/
#define		M_activebuff()		(S_sys_w->activebuff)

#define		M_reset_fg()		(S_sys_w->reset_fg)

#define		M_disp_buf()		(S_sys_w->disp_buf)
#define		M_graph_x_res()		(S_sys_w->disp_buff.x_res) /* 𑜓x */
#define		M_graph_y_res()		(S_sys_w->disp_buff.y_res) /* 𑜓x */
#define		M_graph_x_zero()	(-(S_sys_w->disp_buff.x_res)/2)/*𑜓x*/
#define		M_graph_y_zero()	(-(S_sys_w->disp_buff.y_res)/2)/*𑜓x*/
#define		M_disp_buff_x(n)	(S_sys_w->disp_buff.x[n])	 /* ޯ̧X */
#define		M_disp_buff_y(n)	(S_sys_w->disp_buff.y[n])	 /* ޯ̧Y */
#define		M_disp_buff_cx(n)	(S_sys_w->disp_buff.cx[n])
#define		M_disp_buff_cy(n)	(S_sys_w->disp_buff.cy[n])
#define		M_disp_buff_flug()	(S_sys_w->disp_buff.flug)	/* p׸ */

#define		M_graph_xy_push()	(S_sys_w->disp_buff.x_save = \
								S_sys_w->disp_buff.x_res);\
								(S_sys_w->disp_buff.y_save = \
								S_sys_w->disp_buff.y_res);
#define		M_graph_xy_pop()	(S_sys_w->disp_buff.x_res = \
								S_sys_w->disp_buff.x_save);\
								(S_sys_w->disp_buff.y_res = \
								S_sys_w->disp_buff.y_save);

/*----------------------------------*/
/*	ذݵ̾Ĉʒu					*/
/*----------------------------------*/
#define		M_screen_offsetx()	S_sys_w->screen_offsetx
#define		M_screen_offsety()	S_sys_w->screen_offsety

/*----------------------------------*/
/*	۰							*/
/*----------------------------------*/
/* ۰ׂ͕̓ϐ */
#define		M_joy_new(n)	(S_sys_w->S_joy_w[n].joy_new)
#define		M_joy_old(n)	(S_sys_w->S_joy_w[n].joy_old)
#define		M_joy_trg(n)	(S_sys_w->S_joy_w[n].joy_trg)
#define		M_joy_ntrg(n)	(S_sys_w->S_joy_w[n].joy_ntrg)

/* ۰ׂidϐ */
#define		M_joy_id()		(S_sys_w->S_joy_id)

/*----------------------------------*/
/*	CDHD ްǗܰ				*/
/*----------------------------------*/
#define		M_cd_status()		(S_sys_w->cd_status[0])
#define		M_cd_statusn(n)		(S_sys_w->cd_status[n])

/*----------------------------------*/
/*	ٰĶ						*/
/*----------------------------------*/
/* ٰĶۑϐ */
#define		M_line_rc()		(S_sys_w->S_line_rc)

/*----------------------------------*/
/*	׸&ï						*/
/*----------------------------------*/
#define		M_pause_fg()		(S_sys_w->pause_fg)
#define		M_pause_fg_ON()		S_sys_w->pause_fg = ON
#define		M_pause_fg_OFF()	S_sys_w->pause_fg = OFF

#define		M_view_z()			(S_sys_w->view_z)

/*----------------------------------*/
/*	item ׸						*/
/*----------------------------------*/
#define		M_item_flag()		(S_sys_w->item_flag)
#define		M_item_step()		(S_sys_w->item_step)
#define		M_item_step_s()		(S_sys_w->item_step_s)
#define		M_item_num()		(S_sys_w->item_num)
#define		M_item_num_s()		(S_sys_w->item_num_s)
#define		M_item_prim()		(S_sys_w->item_prim)

/*----------------------------------*/
/*	̪׸						*/
/*----------------------------------*/
#define		M_fade_flag()		(S_sys_w->fade_flag)

/*----------------------------------*/
/*	ݽܰ							*/
/*----------------------------------*/
#define		M_transw()			(S_sys_w->transw[0])

/*----------------------------------*/
/*	GAME ܰ						*/
/*----------------------------------*/
#define		M_mode_num()		(S_sys_w->mode_num)
#define		M_mode0_num()		(S_sys_w->mode0_num)
#define		M_mode1_num()		(S_sys_w->mode1_num)
#define		M_mode2_num()		(S_sys_w->mode2_num)
#define		M_mode3_num()		(S_sys_w->mode3_num)
#define		M_mode4_num()		(S_sys_w->mode4_num)

/*----------------------------------*/
/*	ݺp						*/
/*----------------------------------*/
#define	M_pach_num()		(S_sys_w->pachinkow.pach_num)

#define	M_pach_switch()		(S_sys_w->pdw.pach_switch)
#define	M_pach_tama()		(S_sys_w->pdw.pach_tama)
#define	M_pach_v()			(S_sys_w->pdw.pach_v)
#define	M_pach_tama_s()		(S_sys_w->pdw.pach_tama_s)
#define	M_pach_tama_t()		(S_sys_w->pdw.pach_tama_t)
#define	M_pach_tome_flag()	(S_sys_w->pdw.pach_tome_flag)
#define	M_pach_tome_timer()	(S_sys_w->pdw.pach_tome_timer)

/* pdw ̐擪ڽ */
#define	M_pdw()					(&(S_sys_w->pdw))
/* ޸޺޾ܰ */
#define	M_pdata_bugcode()		(S_sys_w->pdw.bugcode)
/* ݸނ̽ */
#define	M_pdata_modelscale()	(S_sys_w->pdw.modelscale)
/*ݸޑ̻ނ*/
#define	M_pdata_modelsize()		(S_sys_w->pdw.modelsizex)
/* ݸޑ̻ނ*/
#define	M_pdata_modelsizex()	(S_sys_w->pdw.modelsizex)
/* ݸޑ̻ނ*/
#define	M_pdata_modelsizey()	(S_sys_w->pdw.modelsizey)
/* ݸޑ̻ނ*/
#define	M_pdata_modelsizez()	(S_sys_w->pdw.modelsizez)
/* tذ݂̻ */
#define	M_pdata_ekisyousizex()	(S_sys_w->pdw.ekisyousizex)
#define	M_pdata_ekisyousizey()	(S_sys_w->pdw.ekisyousizey)
/* tޯĻ */
#define	M_pdata_ekisyoudotx()	(S_sys_w->pdw.ekisyoudotx)
#define	M_pdata_ekisyoudoty()	(S_sys_w->pdw.ekisyoudoty)
#define	M_pdata_ekisyoudotsizex()	(S_sys_w->pdw.ekisyoudotsizex)
#define	M_pdata_ekisyoudotsizey()	(S_sys_w->pdw.ekisyoudotsizey)
/* tذ݂̍W */
#define	M_pdata_ekisyoux0()		(S_sys_w->pdw.ekisyoux0)
#define	M_pdata_ekisyouy0()		(S_sys_w->pdw.ekisyouy0)
#define	M_pdata_ekisyouz0()		(S_sys_w->pdw.ekisyouz0)
#define	M_pdata_ekisyoux1()		(S_sys_w->pdw.ekisyoux1)
#define	M_pdata_ekisyouy1()		(S_sys_w->pdw.ekisyouy1)
#define	M_pdata_ekisyouz1()		(S_sys_w->pdw.ekisyouz1)
#define	M_pdata_ekisyoux2()		(S_sys_w->pdw.ekisyoux2)
#define	M_pdata_ekisyouy2()		(S_sys_w->pdw.ekisyouy2)
#define	M_pdata_ekisyouz2()		(S_sys_w->pdw.ekisyouz2)
#define	M_pdata_ekisyoux3()		(S_sys_w->pdw.ekisyoux3)
#define	M_pdata_ekisyouy3()		(S_sys_w->pdw.ekisyouy3)
#define	M_pdata_ekisyouz3()		(S_sys_w->pdw.ekisyouz3)
/* tROMڽ߲ */
#define	M_pdata_ekisyourom()	(S_sys_w->pdw.ekisyourom)
/* ݸޓB r */
#define	M_pdata_modelkugiR()	(S_sys_w->pdw.modelkugiR)
/* ݸޓB h */
#define	M_pdata_modelkugiH()	(S_sys_w->pdw.modelkugiH)
/* ݸޓB hr */
#define	M_pdata_modelkugiHR()	(S_sys_w->pdw.modelkugiHR)
/* ݸދ r */
#define	M_pdata_modeltamaR()	(S_sys_w->pdw.modeltamaR)
/* Ӽޭٻ */
#define	M_pdata_modulesize()	(S_sys_w->pdw.modulesize)
/* ݸޏd͉x*/
#define	M_pdata_modelG()		(S_sys_w->pdw.modelG)
/* ݺʔ߲ */
#define	M_pdata_modelshoot()	(S_sys_w->pdw.modelshoot)
/* ~ړ̔a */
#define	M_pdata_moveR()			(S_sys_w->pdw.moveR)
/* Bް߲ */
#define M_pdata_kdatap()		(S_sys_w->pdw.kdatap)
/* ˯pر */
#define	M_pdata_atari()			(S_sys_w->pdw.atari[0][0])
/* S_ A W */
#define	M_pdata_centerAx()		(S_sys_w->pdw.centerAx)
/* S_ A W */
#define	M_pdata_centerAy()		(S_sys_w->pdw.centerAy)
/* S_ B W */
#define	M_pdata_centerBx()		(S_sys_w->pdw.centerBx)
/* S_ B W */
#define	M_pdata_centerBy()		(S_sys_w->pdw.centerBy)
/* S_ C W */
#define	M_pdata_centerCx()		(S_sys_w->pdw.centerCx)
/* S_ C W */
#define	M_pdata_centerCy()		(S_sys_w->pdw.centerCy)
/* S_ D W */
#define	M_pdata_centerDx()		(S_sys_w->pdw.centerDx)
/* S_ D W */
#define	M_pdata_centerDy()		(S_sys_w->pdw.centerDy)
/* S_ A a */
#define	M_pdata_centerAr()		(S_sys_w->pdw.centerAr)
/* S_ B a */
#define	M_pdata_centerBr()		(S_sys_w->pdw.centerBr)
/* S_ C a */
#define	M_pdata_centerCr()		(S_sys_w->pdw.centerCr)
/* S_ D a */
#define	M_pdata_centerDr()		(S_sys_w->pdw.centerDr)
/* S_ E a */
#define	M_pdata_centerEr()		(S_sys_w->pdw.centerEr)
/* ˈʒu */
#define	M_pdata_firex()			(S_sys_w->pdw.firex)
/* ˈʒu */
#define	M_pdata_firey()			(S_sys_w->pdw.firey)
/* POBJڽ */
#define M_pdata_pobjp()			(&(S_sys_w->pdw.pobj[0]))
#define M_pdata_pobj(n)			(S_sys_w->pdw.pobj[n])
/* OBJڽ */
#define M_pdata_hitobjp()		(&(S_sys_w->pdw.hitobj[0]))
#define M_pdata_hitobj(n)		(S_sys_w->pdw.hitobj[n])
#define	M_pdata_tama_num(n)		(S_sys_w->pdw.tama_num[n])

/* t֐߲ */
#define	M_pdata_esfp()					(S_sys_w->pdw.esfp)
#define	M_pdata_randcfp()				(S_sys_w->pdw.randcfp)

/* Ѷ */
#define	M_pdata_randc()					(S_sys_w->pdw.randc)
#define	M_pdata_randcn()				(S_sys_w->pdw.randcn)
#define	M_pdata_randcw()				(S_sys_w->pdw.randcw)
#define	M_pdata_randcwn()				(S_sys_w->pdw.randcwn)


/*----------------------------------*/
/*	ݸޗpϸ						*/
/*----------------------------------*/
#define	M_string_bufp()			(S_sys_w->string_bufp)
#define	M_string_td(n)			(S_sys_w->string_td[n])
#define	M_string_buf()			(S_sys_w->string_buf[0])
#define	M_stringw()				(S_sys_w->stringw)
#define	M_string_np()				(S_sys_w->string_np)

/*----------------------------------*/
/*	free work						*/
/*----------------------------------*/
#define		M_workp()				(&(S_sys_w->work[0]))
#define		M_work(n)				(S_sys_w->work[n])

#endif


