/***< file >*****************************************************************/
/*	Title		:	PS-X Tool												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	psxcsr.h												*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	05/29/1995												*/
/*	Note		:	*.csr ϊc[										*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/*****************************************************************************/
#ifndef	PSXCVT_H_DEF
#define PSXCVT_H_DEF

/*----------------------------------------------*/
/*	̧ق									*/
/*----------------------------------------------*/
#define	CSR_TYPE		0x00
#define	COL_TYPE		0x01
#define	OPD_TYPE		0x02
#define	TMD_TYPE		0x03
#define	PMD_TYPE		0x04
#define	TOD_TYPE		0x05
#define	TIM_TYPE		0x06
#define	BGD_TYPE		0x07
#define	CEL_TYPE		0x08
#define	ANM_TYPE		0x09
#define	BIN_TYPE		0x0a

/*----------------------------------------------*/
/*	CSŖ ͯްޏ						*/
/*----------------------------------------------*/
#define	PRESS_ON		0x0100					/* ްk */
#define	PRESS_OFF		0x0000					/* ް񈳏k */

#define	TYPE_CODE		0x000000ff				/* ߺ */
#define	PRESS_CODE		0x00000100				/* k */
#define	PRESS_BIT		0x08					/* k */
#define	COLMODE_CODE	0x00000200				/* csr װӰ */
#define	COLMODE_BIT		0x09					/* csr װӰ */

/*----------------------------------------------*/
/*	CSŖ										*/
/*----------------------------------------------*/
#define K_CSR 		0x00						/* PIGŞفAװȂ(*.csr) */
#define	KIND_POINT	0x08						/* ͯްނ߲ */
#define	COL_MODE	(0x20+0x04)					/* ̧ͯް̶װӰ */
#define	CSR_CHRDATA	(0x20+0x10+0x200)			/* ްͯް */
#define	CSRWSIZE	128							/* csŗق̍őw */
#define	CSRHSIZE	128							/* csŗق̍őh */
#define	BIT4PIC		4							/* 4bitӰނ߸ق̐ */
#define	BIT8PIC		2							/* 8bitӰނ߸ق̐ */
#define	COLMODE16	0							/* װӰ16 */
#define	COLMODE256	1							/* װӰ256 */
#define	COLMODE16P	4							/* װӰ16߸ق̐ */
#define	COLMODE256P	2							/* װӰ256߸ق̐ */

#define	PICDATA16		0x2000
#define	PICDATA256		0x4000

typedef struct _PIC16 {
    u_char data[0x2000] ;
} PIC16 ; 									/* 4000H */

typedef struct _PIC256 {
    u_char data[0x4000] ;
} PIC256 ; 									/* 4000H */


/*----------------------------------------------*/
/*	COĻ										*/
/*----------------------------------------------*/
#define K_COL 		0x06						/* PIGŞفAװȂ(*.csr) */
#define	COL_DATA	0x20						/* װްͯް */

/*----------------------------------*/
/*	*.csr ͯް̍\				*/
/*----------------------------------*/
typedef struct _CSR_W	{
	u_long	code;
	short	x, y, w, h ;
} CSR_W;

#define		M_csr_code(p)	(p->code)
#define		M_csr_x(p)		(p->x)
#define		M_csr_y(p)		(p->y)
#define		M_csr_w(p)		(p->w)
#define		M_csr_h(p)		(p->h)

/*----------------------------------*/
/*	*.col ͯް̍\				*/
/*----------------------------------*/
typedef struct _COL_W	{
	u_long	code;
	short	x, y, w, h ;
} COL_W;


/*----------------------------------------------*/
/*	OPḐ										*/
/*----------------------------------------------*/
#define OPD_OBJ_MAX 	16		/* OT_SIZE-1 ȉɂ邱		*/
#define EKISHO_OBJ_MAX	8		/* OT_SIZE-1 ȉɂ邱		*/

/*----------------------------------*/
/*	*.opd ް̍\				*/
/*----------------------------------*/
typedef struct _OPD_HEAD {
	short		obj_number;
	short		color_mode;
	u_long		csr_address;
	u_long		col_address;
	u_long		pat_address;
	u_long		anm_address;
} OPD_HEAD;

typedef struct _OPD_COL_DATA {
	u_long		address;
	short		x, y;
} OPD_COL_DATA;

typedef struct _OPD_CSR_DATA {
	u_long		address;
	short		x, y;
} OPD_CSR_DATA;

typedef struct _OPD_PAT_DATA {
	u_long		command;
	u_long		address;
} OPD_PAT_DATA;

typedef struct _OPD_OBJ_DATA {
	short		u, v;
	u_short		w, h;
	short		csr_number;
	short		palette_number;
} OPD_OBJ_DATA;

typedef struct _OPD_ANM_DATA {
	u_short		pat_number;
	u_short		time;
} OPD_ANM_DATA;


#define		OPD_CMD_DATA		0		/*	ʏf[^						*/
#define		OPD_CMD_LOOP		1		/*	擪p^[֖߂				*/
#define		OPD_CMD_STOP		2		/*	noc̒~				*/
#define		OPD_CMD_END			3		/*	nocI					*/
#define		OPD_CMD_GOTO		4		/*	wp^[֔				*/
#define		OPD_CMD_TR_CSR		5		/*	wbrq̓]				*/
#define		OPD_CMD_ST_ANIME	6		/*	wAj[V̋Jn	*/
#define		OPD_CMD_AC_ANIME	7		/*	Aj[V̕ύX|Cg	*/
#define		OPD_CMD_SET_FLAG	8		/*	tO̐ݒ					*/
#define		OPD_CMD_REPEAT		9		/*	w񐔕JԂ				*/

#define		OPD_COMMAND_NUMBER		9

#endif
