/***< file >*****************************************************************/
/*	Title		:	PS-X System												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	s_work.h												*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	1995.06.27												*/
/*	Note		:															*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/
#ifndef	O_PRIM_H_DEF
#define O_PRIM_H_DEF

/*--------------------------------------------------------------------------*/
/*	萔̒`																*/
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
/*	p̂̒`															*/
/*--------------------------------------------------------------------------*/
/*--------------------------------------*/
/* XYZ W̐A̐ݒ		*/
/*--------------------------------------*/
typedef union _COORD{
	short	h[2];		/* ʍWij*/
	long	l;			/* ʍWij*/
} COORD;

/*--------------------------------------------------------------------------*/
/*	\̂̒`															*/
/*--------------------------------------------------------------------------*/
typedef	struct _USER_STATE {
	u_short				step;						/* ï */
	u_short				step_s;						/* ޽ï */
	u_long				free[40];					/* ذܰ */
} USER_STATE;

typedef	struct _USER_W {
	OBJ_W_HEAD			header;						/* ޼ުܰͯް */
	USER_STATE			state;
} USER_W;

/*--------------------------------------------------------------------------*/
typedef	struct _ZOOM {
	COORD				x;							/* ް X */
	COORD				y;							/* ް Y */
	COORD				z;							/* ް Z */
	SVECTOR				vi[4];						/* ޸ */
} ZOOM;


#define	M_zoom_x_h(p)		(p->vector.zoom.x.h[1])			/*  */
#define	M_zoom_x_l(p)		(p->vector.zoom.x.l)			/*_*/
#define	M_zoom_y_h(p)		(p->vector.zoom.y.h[1])			/*  */
#define	M_zoom_y_l(p)		(p->vector.zoom.y.l)			/*_*/
#define	M_zoom_h(p)			(p->vector.zoom.z.h[1])			/*  */
#define	M_zoom_l(p)			(p->vector.zoom.z.l)			/*_*/

#define	M_zoom_v(p)			p->vector.zoom.vi[0]
#define	M_zoom_v0_vx(p)		p->vector.zoom.vi[0].vx
#define	M_zoom_v0_vy(p)		p->vector.zoom.vi[0].vy
#define	M_zoom_v0_vz(p)		p->vector.zoom.vi[0].vz
#define	M_zoom_v1_vx(p)		p->vector.zoom.vi[1].vx
#define	M_zoom_v1_vy(p)		p->vector.zoom.vi[1].vy
#define	M_zoom_v1_vz(p)		p->vector.zoom.vi[1].vz
#define	M_zoom_v2_vx(p)		p->vector.zoom.vi[2].vx
#define	M_zoom_v2_vy(p)		p->vector.zoom.vi[2].vy
#define	M_zoom_v2_vz(p)		p->vector.zoom.vi[2].vz
#define	M_zoom_v3_vx(p)		p->vector.zoom.vi[3].vx
#define	M_zoom_v3_vy(p)		p->vector.zoom.vi[3].vy
#define	M_zoom_v3_vz(p)		p->vector.zoom.vi[3].vz

#define	M_zoom_v_copy(p)	p->vector.zoom.vi[0].vx = p->vector.vect[0].vx;\
							p->vector.zoom.vi[0].vy = p->vector.vect[0].vy;\
							p->vector.zoom.vi[1].vx = p->vector.vect[1].vx;\
							p->vector.zoom.vi[1].vy = p->vector.vect[1].vy;\
							p->vector.zoom.vi[2].vx = p->vector.vect[2].vx;\
							p->vector.zoom.vi[2].vy = p->vector.vect[2].vy;\
							p->vector.zoom.vi[3].vx = p->vector.vect[3].vx;\
							p->vector.zoom.vi[3].vy = p->vector.vect[3].vy

/*--------------------------------------------------------------------------*/
typedef	struct _PRIM_VECTOR {
	COORD				x, y, z;					/* Wl */
	COORD				sx, sy, sz;					/* ړx */
	short				u, v;						/* u, v ̵̾ */
	COORD				du, dv;						/* u, v ̈ړl */
	short				w, h;						/* w, h ̵̾ */
	COORD				dw, dh;						/* w, h ̈ړl */
	VECTOR				trans;						/* ʒu */
	SVECTOR				angle;						/* ]p */
	COORD				ax, ay, az;					/* ]l */
	COORD				sax, say, saz;				/* ]߰ */
	MATRIX				rottrans;					/* ]s */
	VECTOR				scale;						/* ق̒ */
	SVECTOR				vect[4];					/* ޸ */
	ZOOM				zoom;						/* ް */
} PRIM_VECTOR;

/*------------------------ PRIM STATUS -------------------------------------*/
typedef	struct _PRIM_STATE {
	u_short				step;						/* ï */
	u_short				step_s;						/* ï߻ */
	u_short				kind;						/* kind */
	u_short				timer;						/* ϰ */
	u_long				status;						/* ð */
	u_long				ot;							/* OT ̗D */
	u_long				pri;						/* ײè */
	u_long				free[10];					/* ذܰ */
} PRIM_STATE;

/*--------------------------*/
/*	PRIM_STATE ϸۂ̒`	*/
/*--------------------------*/
#define	M_state_step(p)				(p->state.step)				/* ï */
#define	M_state_step_s(p)			(p->state.step_s)			/* ޽ï */
#define	M_state_kind(p)				(p->state.kind)				/* kind */
#define	M_state_timer(p)			(p->state.timer)			/* ϰ */
#define	M_state_status(p)			(p->state.status)			/* è */
#define	M_state_ot(p)				(p->state.ot)				/* OT̗D */
#define	M_state_pri(p)				(p->state.pri)				/* ײè */
#define	M_state_free(p)				(p->state.free)				/* ذر */
#define	M_state_freen(p, n)			(p->state.free[n])			/* ذر */

/*--------------------------------------------------*/
/*	ð׸ނ̓e									*/
/*													*/
/*	status											*/
/*	0-1					_ݒp׸				*/
/*	2					xZ׸				*/
/*  3-4					gAk׸				*/
/*	5-6					GsSortSprite׸		*/
/*	7					u, v, w, h ړ׸			*/
/*	8					]߰׸				*/
/*  22					] V					*/
/*  23					] H					*/
/*  31					\ ON / OFF				*/
/*--------------------------------------------------*/
#define		VIEW_FLAG		0x00000003				/* _̐ݒ׸ */
#define		SPEED_ADD_FLAG	0x00000004				/* xZ׸ */
#define		ZOOM_FLAG1		0x00000008				/* gk׸1 */
#define		ZOOM_FLAG2		0x00000010				/* gk׸2 */
#define		OT_SPRITE_FLAG	(3<<5)					/* GsSPRITE o^ */
#define		UVWH_MOVE_FLAG	0x00000080				/* u, v, w, h ړ׸ */
#define		ANGLE_FLAG		0x00000100				/* ]߰׸ */
#define		V_FLAG			0x00400000				/* ] */
#define		H_FLAG			0x00800000				/* ] */
#define		DISP_FLAG		0x80000000				/* \׸ */

#define		VIEW_FLAGN		0xFFFFFFFC				/* _̐ݒ׸ */
#define		SPEED_ADD_FLAGN	0xFFFFFFFB				/* xZ׸ */
#define		ZOOM_FLAGN1		0xFFFFFFF7				/* gk׸1 */
#define		ZOOM_FLAGN2		0xFFFFFFEF				/* gk׸2 */
#define		OT_SPRITE_FLAGN	(~(3<<5))				/* GsSPRITE o^ */
#define		UVWH_MOVE_FLAGN	0xffffff7f				/* u, v, w, h ړ׸ */
#define		ANGLE_FLAGN		0xfffff1ff				/* ]߰׸ */
#define		V_FLAGN			0xffbfffff				/* ] */
#define		H_FLAGN			0xff7fffff				/* ] */
#define		DISP_FLAGN		0x7fffffff				/* \׸ */

#define		VIEW_SCREEN				0				/* ذݍWn */
#define		VIEW_LOCAL				1				/* _۰ٍW */
#define		VIEW_GLOBAL				2				/* _۰ٍW */

#define		OT_SPRITE				0<<5			/* GsSortSprite */
#define		OT_FAST_SPRITE			1<<5			/* GsSortFastSprite */
#define		OT_FLIP_SPRITE			2<<5			/* GsSortFlipSprite */

/*------------------*/
/*	_			*/
/*------------------*/
#define M_gte_view_set_S(p)		p->state.status = \
								((p->state.status) & VIEW_FLAGN)
#define M_gte_view_set_L(p)		p->state.status = \
								((p->state.status) & VIEW_FLAGN);\
								p->state.status |= VIEW_LOCAL
#define M_gte_view_set_G(p)		p->state.status = \
								((p->state.status) & VIEW_FLAGN);\
								p->state.status |= VIEW_GLOBAL

#define M_gte_view_check(p)		((p->state.status)&VIEW_FLAG)

/*------------------*/
/*	GsSPRITE		*/
/*------------------*/
#define M_GsSortSprite_set(p)		p->state.status = \
									((p->state.status) & OT_SPRITE_FLAGN);\
									p->state.status |= OT_SPRITE
#define M_GsSortFastSprite_set(p)	p->state.status = \
									((p->state.status) & OT_SPRITE_FLAGN);\
									p->state.status |= OT_FAST_SPRITE
#define M_GsSortFlipSprite_set(p)	p->state.status = \
									((p->state.status) & OT_SPRITE_FLAGN);\
									p->state.status |= OT_FLIP_SPRITE

#define M_GsSortSprite_check(p)		(((p->state.status)&OT_SPRITE_FLAG)>>5)

/*------------------*/
/*	x			*/
/*------------------*/
#define	M_speed_add_ON(p)		(p->state.status |= SPEED_ADD_FLAG)
#define	M_speed_add_OFF(p)		(p->state.status &= SPEED_ADD_FLAGN)
#define	M_speed_add_check(p)	((p->state.status) & SPEED_ADD_FLAG)

/*------------------*/
/*	gk		*/
/*------------------*/
#define	M_zoom_ON(p)			(p->state.status |= ZOOM_FLAG1)
#define	M_zoom_ON2(p)			(p->state.status |= ZOOM_FLAG2)
#define	M_zoom_OFF(p)			(p->state.status &= ZOOM_FLAGN1)
#define	M_zoom_OFF2(p)			(p->state.status &= ZOOM_FLAGN2)
#define	M_zoom_check1(p)		((p->state.status) & ZOOM_FLAG1)
#define	M_zoom_check2(p)		((p->state.status) & ZOOM_FLAG2)


/*------------------*/
/*	uvwh ړ		*/
/*------------------*/
#define	M_uvwh_ON(p)			(p->state.status |= UVWH_MOVE_FLAG)
#define	M_uvwh_OFF(p)			(p->state.status &= UVWH_MOVE_FLAGN)
#define	M_uvwh_check(p)			((p->state.status) & UVWH_MOVE_FLAG)

/*------------------*/
/*	]			*/
/*------------------*/
#define	M_angle_ON(p)			(p->state.status |= ANGLE_FLAG)
#define	M_angle_OFF(p)			(p->state.status &= ANGLE_FLAGN)
#define	M_angle_check(p)		((p->state.status) & ANGLE_FLAG)

/*------------------*/
/*	]		*/
/*------------------*/
#define	M_V_ON(p)				(p->state.status |= V_FLAG)
#define	M_V_OFF(p)				(p->state.status &= V_FLAGN)
#define	M_V_check(p)			((p->state.status) & V_FLAG)

/*------------------*/
/*	]		*/
/*------------------*/
#define	M_H_ON(p)				(p->state.status |= H_FLAG)
#define	M_H_OFF(p)				(p->state.status &= H_FLAGN)
#define	M_H_check(p)			((p->state.status) & H_FLAG)

/*------------------*/
/*	\			*/
/*------------------*/
#define	M_disp_ON(p)			(p->state.status &= DISP_FLAGN)
#define	M_disp_OFF(p)			(p->state.status |= DISP_FLAG)
#define	M_disp_check(p)			((p->state.status) & DISP_FLAG)

/*--------------------------- ޼ުܰ ------------------------------------*/
typedef struct _TIMANIME_W	{
	u_long		patternad;
	u_long		timer;
} TIMANIME_W;


#define		M_timanm_patternad(p)		(p->patternad)
#define		M_timanm_timer(p)			(p->timer)


typedef	struct _PRIM_COLOR {
	char				r, g, b;					/* Px */
	char				abr;						/* ڰ */
} PRIM_COLOR;

/*--------------------------*/
/*	COLOR ϸۂ̒`			*/
/*--------------------------*/
#define	M_color_r(p)			(p->color.r)
#define	M_color_g(p)			(p->color.g)
#define	M_color_b(p)			(p->color.b)
#define	M_color_abr(p)			(p->color.abr)


typedef	struct _OBJ_W {
	OBJ_W_HEAD			header;						/* ޼ުܰͯް */
	PRIM_VECTOR			vector;						/* ޸ */
	PRIM_COLOR			color;						/* װ */
	PRIM_STATE			state;						/* è */
} OBJ_W;

/*--------------------------- è޻ϯ -----------------------------*/
typedef	struct _PRIM_W {
	OBJ_W_HEAD			header;						/* ޼ުܰͯް */
	PRIM_VECTOR			vector;						/* ޸ */
	PRIM_COLOR			color;						/* װ */
	PRIM_STATE			state;						/* è */
	POLY_FT4			prim;						/* è */
} PRIM_W;

/*--------------------------------------------------------------------------*/
/*			LINE															*/
/*--------------------------------------------------------------------------*/
/*----- A -----*/
typedef	struct _GsLINE_W {
	OBJ_W_HEAD			header;						/* ޼ުܰͯް */
	PRIM_VECTOR			vector;						/* ޸ */
	PRIM_COLOR			color;						/* װ */
	PRIM_STATE			state;						/* è */
	GsLINE				prim;						/* è */
} GsLINE_W;

/*--------------------------------------------------------------------------*/
/*			POLY															*/
/*--------------------------------------------------------------------------*/
typedef	struct _POLY_G4_W {
	OBJ_W_HEAD			header;						/* ޼ުܰͯް */
	PRIM_VECTOR			vector;						/* ޸ */
	PRIM_COLOR			color;						/* װ */
	PRIM_STATE			state;						/* è */
	POLY_G4				prim;						/* è */
} POLY_G4_W;

typedef	struct _POLY_FT4_W {
	OBJ_W_HEAD			header;						/* ޼ުܰͯް */
	PRIM_VECTOR			vector;						/* ޸ */
	PRIM_COLOR			color;						/* װ */
	PRIM_STATE			state;						/* è */
	POLY_FT4			prim;						/* è */
} POLY_FT4_W;

/*--------------------------------------------------------------------------*/
/*			SPRITE															*/
/*--------------------------------------------------------------------------*/
typedef	struct _GsSPRITE_W {
	OBJ_W_HEAD			header;						/* ޼ުܰͯް */
	PRIM_VECTOR			vector;						/* ޸ */
	PRIM_COLOR			color;						/* װ */
	PRIM_STATE			state;						/* è */
	GsSPRITE			prim;						/* è */
} GsSPRITE_W;

/*--------------------------------------------------------------------------*/
/*			VIEW															*/
/*--------------------------------------------------------------------------*/
typedef	struct _GteVIEW_W {
	OBJ_W_HEAD			header;						/* ޼ުܰͯް */
	PRIM_VECTOR			vector;						/* ޸ */
	PRIM_COLOR			color;						/* װ */
	PRIM_STATE			state;						/* è */
} GteVIEW_W;

typedef	struct _GsRVIEW2_W {
	OBJ_W_HEAD			header;						/* ޼ުܰͯް */
	PRIM_STATE			state;						/* è */
	COORD				sturnx, sturny, sturnz;		/* ]Agkx */
	COORD				anglex, angley;				/* ]px */
	COORD				distance;					/* S_̋ */
	COORD				sx, sy;						/* X,Ÿړx */
	SVECTOR 			scale;						/*  */
	GsRVIEW2			view;						/* ޭ */
} GsRVIEW2_W;

#define	M_gs_view(p)				(p->view)			/* _ */
#define	M_gs_view_vpx(p)			(p->view.vpx)		/* _W */
#define	M_gs_view_vpy(p)			(p->view.vpy)		/* _W */
#define	M_gs_view_vpz(p)			(p->view.vpz)		/* _W */
#define	M_gs_view_vrx(p)			(p->view.vrx)		/* QƓ_W */
#define	M_gs_view_vry(p)			(p->view.vry)		/* QƓ_W */
#define	M_gs_view_vrz(p)			(p->view.vrz)		/* QƓ_W */
#define	M_gs_view_rz(p)				(p->view.rz)		/* _X */
#define	M_gs_view_super(p)			(p->view.super)		/* _ݒW߲ */

#define	M_gs_view_sturn_x(p)		(p->sturnx.l)		/* ]x */
#define	M_gs_view_sturn_y(p)		(p->sturny.l)		/* ]x */
#define	M_gs_view_szoom_z(p)		(p->sturnz.l)		/* ]x */
#define	M_gs_view_distance(p)		(p->distance.l)		/* S_̋ */
#define	M_gs_view_angle_x(p)		(p->anglex.l)		/* ]x */
#define	M_gs_view_angle_y(p)		(p->angley.l)		/* ]x */
#define	M_gs_view_sx(p)				(p->sx.l)			/* ړx */
#define	M_gs_view_sy(p)				(p->sy.l)			/* ړx */
#define	M_gs_view_scale(p)			(p->scale)			/*  */

/*--------------------------------------------------------------------------*/
/*			LIGHT															*/
/*--------------------------------------------------------------------------*/
typedef	struct _GsF_LIGHT_W {
	OBJ_W_HEAD			header;						/* ޼ުܰͯް */
	PRIM_VECTOR			vector;						/* ޸ */
	PRIM_COLOR			color;						/* װ */
	PRIM_STATE			state;						/* è */
	GsF_LIGHT			light[3];					/* s */
} GsF_LIGHT_W;

#define	M_gs_light(p, n)			(p->light[n])		/*  */
#define	M_gs_light_vx(p, n)			(p->light[n].vx)	/* ޸ق */
#define	M_gs_light_vy(p, n)			(p->light[n].vy)	/* ޸ق */
#define	M_gs_light_vz(p, n)			(p->light[n].vz)	/* ޸ق */
#define	M_gs_light_r(p, n)			(p->light[n].r)		/* light̐F r */
#define	M_gs_light_g(p, n)			(p->light[n].g)		/* light̐F g */
#define	M_gs_light_b(p, n)			(p->light[n].b)		/* light̐F b */

#define	M_gs_light_vx_set(p, n, d)	p->light[n].vx = d	/* ޸ق */
#define	M_gs_light_vy_set(p, n, d)	p->light[n].vy = d	/* ޸ق */
#define	M_gs_light_vz_set(p, n, d)	p->light[n].vz = d	/* ޸ق */
#define	M_gs_light_r_set(p, n, d)	p->light[n].r = d	/* light̐F r */
#define	M_gs_light_g_set(p, n, d)	p->light[n].g = d		/* light̐F g */
#define	M_gs_light_b_set(p, n, d)	p->light[n].b = d		/* light̐F b */

/*--------------------------------------------------------------------------*/
/*			OPD																*/
/*--------------------------------------------------------------------------*/

typedef	struct _OPD_W {
	OBJ_W_HEAD			header;						/*	޼ުܰͯް */
	POLY_FT4_W			*obj_ft4[OPD_OBJ_MAX];
	short				ot;					/*	\̗D(Wot̔ԍ)	p	*/
	short				terminate_flag;		/*	OPD_W ̏I			p	*/
				/*	AvobjfuncɒNULLďIȂ	*/
	u_long				opd_address;							/*		p	*/
	u_long				timer;
	u_long				anime_no;
	u_long				pattern_no;
	u_long				flag;
	long				repeat_no;
	u_long				nextanime_no;							/*		p	*/
	long				center_x;								/*		p	*/
	long				center_y;								/*		p	*/
} OPD_W;

typedef struct _EKISHO_PMD_DATA {
	POLY_FT4			prim;					/* è */
	SVECTOR				vect[4];						/* ޸ */
}EKISHO_PMD_DATA;

typedef struct _EKISHO_PMD {
	u_long				type;
	EKISHO_PMD_DATA		*data;
	POLY_FT4			*fbuf;		/* draw buffer for divide */
}EKISHO_PMD;

typedef	struct _EKISHO_W {
	OBJ_W_HEAD			header;						/*	޼ުܰͯް */
	EKISHO_PMD			pmd_data;
	short				ot;					/*	\̗D(Wot̔ԍ)	p	*/
	short				terminate_flag;		/*	OPD_W ̏I			p	*/
				/*	AvobjfuncɒNULLďIȂ	*/
	u_long				opd_address;							/*		p	*/
	u_long				timer;
	u_long				anime_no;
	u_long				pattern_no;
	u_long				flag;
	long				repeat_no;
	u_long				nextanime_no;							/*		p	*/
	short				palette_number;							/*		p	*/
									/* PUF[hɁ|PȊOw肳ꂽ
											IɃpbgύX		*/
} EKISHO_W;

/*--------------------------------------------------------------------------*/
/*	ϸے`																	*/
/*--------------------------------------------------------------------------*/
/*--------------------------- PRIMITIVE ------------------------------------*/
#define	M_prim(p)				(p->prim)
#define	M_prim_tag(p)			(p->prim.tag)			/* è̯ */
#define	M_prim_code(p)			(p->prim.code)			/* èID */

#define	M_prim_r(p)				(p->prim.r)				/* Pxl */
#define	M_prim_g(p)				(p->prim.g)
#define	M_prim_b(p)				(p->prim.b)
#define	M_setRGB(p,dr,dg,db)	(p->prim.r) = dr;\
								(p->prim.g) = dg;\
								(p->prim.b) = db

#define	M_prim_r0(p)			(p->prim.r0)			/* Pxl */
#define	M_prim_g0(p)			(p->prim.g0)
#define	M_prim_b0(p)			(p->prim.b0)
#define	M_prim_r1(p)			(p->prim.r1)
#define	M_prim_g1(p)			(p->prim.g1)
#define	M_prim_b1(p)			(p->prim.b1)
#define	M_prim_r2(p)			(p->prim.r2)
#define	M_prim_g2(p)			(p->prim.g2)
#define	M_prim_b2(p)			(p->prim.b2)
#define	M_prim_r3(p)			(p->prim.r3)
#define	M_prim_g3(p)			(p->prim.g3)
#define	M_prim_b3(p)			(p->prim.b3)

#define	M_prim_x0(p)			(p->prim.x0)			/* _W */
#define	M_prim_y0(p)			(p->prim.y0)
#define	M_prim_x1(p)			(p->prim.x1)
#define	M_prim_y1(p)			(p->prim.y1)
#define	M_prim_x2(p)			(p->prim.x2)
#define	M_prim_y2(p)			(p->prim.y2)
#define	M_prim_x3(p)			(p->prim.x3)
#define	M_prim_y3(p)			(p->prim.y3)

#define	M_prim_u0(p)			(p->prim.u0)			/* øW */
#define	M_prim_v0(p)			(p->prim.v0)
#define	M_prim_u1(p)			(p->prim.u1)
#define	M_prim_v1(p)			(p->prim.v1)
#define	M_prim_u2(p)			(p->prim.u2)
#define	M_prim_v2(p)			(p->prim.v2)
#define	M_prim_u3(p)			(p->prim.u3)
#define	M_prim_v3(p)			(p->prim.v3)

#define	M_prim_tpage(p)			(p->prim.tpage)			/* ø߰ID */
#define	M_prim_clut(p)			(p->prim.clut)			/* CLUT ID */

/*----------------------------------------------------- ȩ̀p */
#define	M_primw(p, n)				(p->prim[n])
#define	M_prim_tagw(p, n)			(p->prim[n].tag)		/* è̯ */
#define	M_prim_codew(p, n)			(p->prim[n].code)		/* èID */

#define	M_prim_rw(p, n)				(p->prim[n].r)				/* Pxl */
#define	M_prim_gw(p, n)				(p->prim[n].g)
#define	M_prim_bw(p, n)				(p->prim[n].b)
#define	M_setRGBw(p,dr,dg,db, n)	(p->prim[n].r) = dr;\
									(p->prim[n].g) = dg;\
									(p->prim[n].b) = db

#define	M_prim_r0w(p, n)			(p->prim[n].r0)			/* Pxl */
#define	M_prim_g0w(p, n)			(p->prim[n].g0)
#define	M_prim_b0w(p, n)			(p->prim[n].b0)
#define	M_prim_r1w(p, n)			(p->prim[n].r1)
#define	M_prim_g1w(p, n)			(p->prim[n].g1)
#define	M_prim_b1w(p, n)			(p->prim[n].b1)
#define	M_prim_r2w(p, n)			(p->prim[n].r2)
#define	M_prim_g2w(p, n)			(p->prim[n].g2)
#define	M_prim_b2w(p, n)			(p->prim[n].b2)
#define	M_prim_r3w(p, n)			(p->prim[n].r3)
#define	M_prim_g3w(p, n)			(p->prim[n].g3)
#define	M_prim_b3w(p, n)			(p->prim[n].b3)

#define	M_prim_x0w(p, n)			(p->prim[n].x0)			/* _W */
#define	M_prim_y0w(p, n)			(p->prim[n].y0)
#define	M_prim_x1w(p, n)			(p->prim[n].x1)
#define	M_prim_y1w(p, n)			(p->prim[n].y1)
#define	M_prim_x2w(p, n)			(p->prim[n].x2)
#define	M_prim_y2w(p, n)			(p->prim[n].y2)
#define	M_prim_x3w(p, n)			(p->prim[n].x3)
#define	M_prim_y3w(p, n)			(p->prim[n].y3)

#define	M_prim_u0w(p, n)			(p->prim[n].u0)			/* øW */
#define	M_prim_v0w(p, n)			(p->prim[n].v0)
#define	M_prim_u1w(p, n)			(p->prim[n].u1)
#define	M_prim_v1w(p, n)			(p->prim[n].v1)
#define	M_prim_u2w(p, n)			(p->prim[n].u2)
#define	M_prim_v2w(p, n)			(p->prim[n].v2)
#define	M_prim_u3w(p, n)			(p->prim[n].u3)
#define	M_prim_v3w(p, n)			(p->prim[n].v3)

#define	M_prim_tpagew(p, n)			(p->prim[n].tpage)		/* ø߰ID */
#define	M_prim_clutw(p, n)			(p->prim[n].clut)		/* CLUT ID */

/*---------------------------------------------------------------- GsSPRITE */
#define	M_prim_attribute(p)		(p->prim.attribute)
#define	M_prim_x(p)				(p->prim.x)
#define	M_prim_y(p)				(p->prim.y)
#define	M_prim_w(p)				(p->prim.w)
#define	M_prim_h(p)				(p->prim.h)
#define	M_prim_u(p)				(p->prim.u)
#define	M_prim_v(p)				(p->prim.v)
#define	M_prim_cx(p)			(p->prim.cx)
#define	M_prim_cy(p)			(p->prim.cy)
#define	M_prim_r(p)				(p->prim.r)
#define	M_prim_g(p)				(p->prim.g)
#define	M_prim_b(p)				(p->prim.b)
#define	M_prim_mx(p)			(p->prim.mx)
#define	M_prim_my(p)			(p->prim.my)
#define	M_prim_scalex(p)		(p->prim.scalex)
#define	M_prim_scaley(p)		(p->prim.scaley)
#define	M_prim_rotate(p)		(p->prim.rotate)

/*--------------------------------------------------*/
/*		GsSPRITE attribute ̓e					*/
/*--------------------------------------------------*/
#define	ATTR6			(1<<6)			/* Px  0: off  1: on */
#define	ATTR22			(1<<22)			/* ]  0: 񔽓]  1: ] */
#define	ATTR23			(1<<22)			/* ]  0: 񔽓]  1: ] */
#define	ATTR24_0		(0<<24)			/* ײޯ 4bitCLUT */
#define	ATTR24_1		(1<<24)			/* ײޯ 8bitCLUT */
#define	ATTR24_2		(2<<24)			/* ײޯ 15bitCLUT */
#define	ATTR27			(1<<27)			/* ]gk@\  0: ON  1: OFF */
#define	ATTR28_0		(0<<28)			/* ڰ 0 */
#define	ATTR28_1		(1<<28)			/* ڰ 1 */
#define	ATTR28_2		(2<<28)			/* ڰ 2 */
#define	ATTR28_3		(3<<28)			/* ڰ 3 */
#define	ATTR30			(1<<30)			/*  ON/OFF  0: OFF  1: ON */
#define	ATTR31			(1<<31)			/* \ / \  0: ON  1: OFF */

#define	ATTR6N			(~(1<<6))
#define	ATTR22N			(~(1<<22))
#define	ATTR23N			(~(1<<22))
#define	ATTR24_0N		(~(0<<24))
#define	ATTR24_1N		(~(1<<24))
#define	ATTR24_2N		(~(2<<24))
#define	ATTR27N			(~(1<<27))
#define	ATTR28_0N		(~(0<<28))
#define	ATTR28_1N		(~(1<<28))
#define	ATTR28_2N		(~(2<<28))
#define	ATTR28_3N		(~(3<<28))
#define	ATTR30N			(~(1<<30))
#define	ATTR31N			(~(1<<31))

#define	M_spr_attr6_ON(p)			(p->prim.attribute) |= ATTR6;
#define	M_spr_attr22_ON(p)			(p->prim.attribute) |= ATTR22;
#define	M_spr_attr23_ON(p)			(p->prim.attribute) |= ATTR23;
#define	M_spr_attr24_0_ON(p)		(p->prim.attribute) |= ATTR24_0;
#define	M_spr_attr24_1_ON(p)		(p->prim.attribute) |= ATTR24_1;
#define	M_spr_attr24_2_ON(p)		(p->prim.attribute) |= ATTR24_2;
#define	M_spr_attr27_OFF(p)			(p->prim.attribute) |= ATTR27;
#define	M_spr_attr28_0_ON(p)		(p->prim.attribute) |= ATTR28_0;
#define	M_spr_attr28_1_ON(p)		(p->prim.attribute) |= ATTR28_1;
#define	M_spr_attr28_2_ON(p)		(p->prim.attribute) |= ATTR28_2;
#define	M_spr_attr28_3_ON(p)		(p->prim.attribute) |= ATTR28_3;
#define	M_spr_attr30_ON(p)			(p->prim.attribute) |= ATTR30;
#define	M_spr_attr31_OFF(p)			(p->prim.attribute) |= ATTR31;

#define	M_spr_attr6_OFF(p)			(p->prim.attribute) &= ATTR6N;
#define	M_spr_attr22_OFF(p)			(p->prim.attribute) &= ATTR22N;
#define	M_spr_attr23_OFF(p)			(p->prim.attribute) &= ATTR23N;
#define	M_spr_attr24_0_OFF(p)		(p->prim.attribute) &= ATTR24_0N;
#define	M_spr_attr24_1_OFF(p)		(p->prim.attribute) &= ATTR24_1N;
#define	M_spr_attr24_2_OFF(p)		(p->prim.attribute) &= ATTR24_2N;
#define	M_spr_attr27_ON(p)			(p->prim.attribute) &= ATTR27N;
#define	M_spr_attr28_0_OFF(p)		(p->prim.attribute) &= ATTR28_0N;
#define	M_spr_attr28_1_OFF(p)		(p->prim.attribute) &= ATTR28_1N;
#define	M_spr_attr28_2_OFF(p)		(p->prim.attribute) &= ATTR28_2N;
#define	M_spr_attr28_3_OFF(p)		(p->prim.attribute) &= ATTR28_3N;
#define	M_spr_attr30_OFF(p)			(p->prim.attribute) &= ATTR30N;
#define	M_spr_attr31_ON(p)			(p->prim.attribute) &= ATTR31N;

/*--------------------------- PRIM_VECTOR ----------------------------------*/
/*------------------------------*/
/*		޼ުčW X,Y,Z		*/
/*------------------------------*/
#define	M_vect_x_h(p)				(p->vector.x.h[1])			/*  */
#define	M_vect_y_h(p)				(p->vector.y.h[1])			/*  */
#define	M_vect_z_h(p)				(p->vector.z.h[1])			/*  */
#define	M_vect_x_h_set(p,data)		p->vector.x.h[1] = data	/*  */
#define	M_vect_y_h_set(p,data)		p->vector.y.h[1] = data	/*  */
#define	M_vect_z_h_set(p,data)		p->vector.z.h[1] = data	/*  */
#define	M_vect_x_h_add(p,data)		p->vector.x.h[1] += data/* Z */
#define	M_vect_y_h_add(p,data)		p->vector.y.h[1] += data/* Z */
#define	M_vect_z_h_add(p,data)		p->vector.z.h[1] += data/* Z */

#define	M_vect_x_l(p)				(p->vector.x.l)			/*_*/
#define	M_vect_y_l(p)				(p->vector.y.l)			/*_*/
#define	M_vect_z_l(p)				(p->vector.z.l)			/*_*/
#define	M_vect_x_l_set(p,data)		p->vector.x.l = data  /*_*/
#define	M_vect_y_l_set(p,data)		p->vector.y.l = data  /*_*/
#define	M_vect_z_l_set(p,data)		p->vector.z.l = data  /*_*/
#define	M_vect_x_l_add(p,data)		p->vector.x.l += data /*_Z*/
#define	M_vect_y_l_add(p,data)		p->vector.y.l += data /*_Z*/
#define	M_vect_z_l_add(p,data)		p->vector.z.l += data /*_Z*/

/*------------------------------*/
/*		޼ުđx X,Y,Z		*/
/*------------------------------*/
#define	M_vect_sx_h(p)				(p->vector.sx.h[1])			/* sx */
#define	M_vect_sy_h(p)				(p->vector.sy.h[1])			/* sy */
#define	M_vect_sz_h(p)				(p->vector.sz.h[1])			/* sz */
#define	M_vect_sx_h_set(p,data)		p->vector.sx.h[1] = data	/* sx*/
#define	M_vect_sy_h_set(p,data)		p->vector.sy.h[1] = data	/* sy*/
#define	M_vect_sz_h_set(p,data)		p->vector.sz.h[1] = data	/* sz*/
#define	M_vect_sx_h_add(p,data)		p->vector.sx.h[1] += data	/* sxZ*/
#define	M_vect_sy_h_add(p,data)		p->vector.sy.h[1] += data	/* syZ*/
#define	M_vect_sz_h_add(p,data)		p->vector.sz.h[1] += data	/* szZ*/

#define	M_vect_sx_l(p)				(p->vector.sx.l)		/*_sx*/
#define	M_vect_sy_l(p)				(p->vector.sy.l)		/*_sy*/
#define	M_vect_sz_l(p)				(p->vector.sz.l)		/*_sz*/
#define	M_vect_sx_l_set(p,data)		p->vector.sx.l = data  /*_sx*/
#define	M_vect_sy_l_set(p,data)		p->vector.sy.l = data  /*_sy*/
#define	M_vect_sz_l_set(p,data)		p->vector.sz.l = data  /*_sz*/
#define	M_vect_sx_l_add(p,data)		p->vector.sx.l += data /*_sxZ*/
#define	M_vect_sy_l_add(p,data)		p->vector.sy.l += data /*_syZ*/
#define	M_vect_sz_l_add(p,data)		p->vector.sz.l += data /*_szZ*/

#define	M_vect_x_sx_add(p)	p->vector.x.l += p->vector.sx.l		/* XxZ */
#define	M_vect_y_sy_add(p)	p->vector.y.l += p->vector.sy.l		/* YxZ */
#define	M_vect_z_sz_add(p)	p->vector.z.l += p->vector.sz.l		/* ZxZ */

															/* ʒu޸پ */
#define M_vect_trans_set(p)	p->vector.trans.vx = (long)p->vector.x.h[1];\
							p->vector.trans.vy = (long)p->vector.y.h[1];\
							p->vector.trans.vz = (long)p->vector.z.h[1]

/*------------------------------*/
/*		u, v ̾				*/
/*------------------------------*/
#define	M_vect_u(p)				(p->vector.u)					/* u ̾ */
#define	M_vect_v(p)				(p->vector.v)					/* v ̾ */

/*------------------------------*/
/*		u, v ړl				*/
/*------------------------------*/
#define	M_vect_du_h(p)			(p->vector.du.h[1])	/* u ړl@ */
#define	M_vect_du_l(p)			(p->vector.du.l)	/* u ړl@ */
#define	M_vect_dv_h(p)			(p->vector.dv.h[1])	/* v ړl@ */
#define	M_vect_dv_l(p)			(p->vector.dv.l)	/* v ړl@ */

/*------------------------------*/
/*		w, h ̾				*/
/*------------------------------*/
#define	M_vect_w(p)				(p->vector.w)					/* w ̾ */
#define	M_vect_h(p)				(p->vector.h)					/* h ̾ */

/*------------------------------*/
/*		w, h ړl				*/
/*------------------------------*/
#define	M_vect_dw_h(p)			(p->vector.dw.h[1])	/* w ړl@ */
#define	M_vect_dw_l(p)			(p->vector.dw.l)	/* w ړl@ */
#define	M_vect_dh_h(p)			(p->vector.dh.h[1])	/* h ړl@ */
#define	M_vect_dh_l(p)			(p->vector.dh.l)	/* h ړl@ */

/*------------------------------*/
/*		޸ٍW V				*/
/*------------------------------*/
#define	M_vect_v_vx(p, n)			(p->vector.vect[n].vx)		/* ޸ق*/
#define	M_vect_v_vy(p, n)			(p->vector.vect[n].vy)		/* ޸ق*/
#define	M_vect_v_vz(p, n)			(p->vector.vect[n].vz)		/* ޸ق*/
#define	M_vect_v_pad(p, n)			(p->vector.vect[n].pad)		/* ї\ */

#define	M_vect_v0(p)				(p->vector.vect[0])			/* ޸ */
#define	M_vect_v0_vx(p)				(p->vector.vect[0].vx)		/* ޸ق*/
#define	M_vect_v0_vy(p)				(p->vector.vect[0].vy)		/* ޸ق*/
#define	M_vect_v0_vz(p)				(p->vector.vect[0].vz)		/* ޸ق*/
#define	M_vect_v0_pad(p)			(p->vector.vect[0].pad)		/* ї\ */

#define	M_vect_v1(p)				(p->vector.vect[1])			/* ޸ */
#define	M_vect_v1_vx(p)				(p->vector.vect[1].vx)		/* ޸ق*/
#define	M_vect_v1_vy(p)				(p->vector.vect[1].vy)		/* ޸ق*/
#define	M_vect_v1_vz(p)				(p->vector.vect[1].vz)		/* ޸ٓ͂*/
#define	M_vect_v1_pad(p)			(p->vector.vect[1].pad)		/* ї\ */

#define	M_vect_v2(p)				(p->vector.vect[2])			/* ޸ */
#define	M_vect_v2_vx(p)				(p->vector.vect[2].vx)		/* ޸ق*/
#define	M_vect_v2_vy(p)				(p->vector.vect[2].vy)		/* ޸ق*/
#define	M_vect_v2_vz(p)				(p->vector.vect[2].vz)		/* ޸ق*/
#define	M_vect_v2_pad(p)			(p->vector.vect[2].pad)		/* ї\ */

#define	M_vect_v3(p)				(p->vector.vect[3])			/* ޸ */
#define	M_vect_v3_vx(p)				(p->vector.vect[3].vx)		/* ޸ق*/
#define	M_vect_v3_vy(p)				(p->vector.vect[3].vy)		/* ޸ق*/
#define	M_vect_v3_vz(p)				(p->vector.vect[3].vz)		/* ޸ق*/
#define	M_vect_v3_pad(p)			(p->vector.vect[3].pad)		/* ї\ */

/*------------------------------*/
/*		ړ޸				*/
/*------------------------------*/
#define	M_vect_trans(p)				(p->vector.trans)			/* ړW */
#define	M_vect_trans_vx(p)			(p->vector.trans.vx)		/* ړW*/
#define	M_vect_trans_vy(p)			(p->vector.trans.vy)		/* ړW*/
#define	M_vect_trans_vz(p)			(p->vector.trans.vz)		/* ړW*/
#define	M_vect_trans_pad(p)			(p->vector.trans.pad)		/* ї\ */

/*------------------------------*/
/*		]޸				*/
/*------------------------------*/
#define	M_vect_angle(p)				(p->vector.angle)			/* ]px */
#define	M_vect_angle_vx(p)			(p->vector.angle.vx)		/* ]px*/
#define	M_vect_angle_vy(p)			(p->vector.angle.vy)		/* ]px*/
#define	M_vect_angle_vz(p)			(p->vector.angle.vz)		/* ]px*/
#define	M_vect_angle_pad(p)			(p->vector.angle.pad)		/* ї\ */

/*------------------------------*/
/*		]߰				*/
/*------------------------------*/
#define	M_vect_angle_x_h(p)		(p->vector.ax.h[1])		/* ]l  */
#define	M_vect_angle_x_l(p)		(p->vector.ax.l)		/* ]l  */
#define	M_vect_sangle_x_h(p)	(p->vector.sax.h[1])	/* ]߰ސ */
#define	M_vect_sangle_x_l(p)	(p->vector.sax.l)		/* ]߰ޕ*/

#define	M_vect_angle_y_h(p)		(p->vector.ay.h[1])		/* ]l  */
#define	M_vect_angle_y_l(p)		(p->vector.ay.l)		/* ]l  */
#define	M_vect_sangle_y_h(p)	(p->vector.say.h[1])	/* ]߰ސ */
#define	M_vect_sangle_y_l(p)	(p->vector.say.l)		/* ]߰ޕ*/

#define	M_vect_angle_z_h(p)		(p->vector.az.h[1])		/* ]l  */
#define	M_vect_angle_z_l(p)		(p->vector.az.l)		/* ]l  */
#define	M_vect_sangle_z_h(p)	(p->vector.saz.h[1])	/* ]߰ސ */
#define	M_vect_sangle_z_l(p)	(p->vector.saz.l)		/* ]߰ޕ*/

/* GsSPRITE_W p */
#define	M_vect_rotate(p)		(p->vector.az.l)		/* ]l */
#define	M_vect_srotate(p)		(p->vector.saz.h[1])	/* ]߰ސ */

/*------------------------------*/
/*		]د				*/
/*------------------------------*/
#define	M_vect_rottrans(p)			(p->vector.rottrans)		/* ]s */
#define	M_vect_rottrans_m(p, n0, n1) (p->vector.rottrans[n0][n1])/*]s m*/
#define	M_vect_rottrans_n(p, n)		(p->vector.rottrans[n])		/* ]s n*/

/*------------------------------*/
/*		޸				*/
/*------------------------------*/
#define	M_vect_scale(p)				(p->vector.scale)			/*  */
#define	M_vect_scale_vx(p)			(p->vector.scale.vx)		/* ق*/
#define	M_vect_scale_vy(p)			(p->vector.scale.vy)		/* ق*/
#define	M_vect_scale_vz(p)			(p->vector.scale.vz)		/* ق*/
#define	M_vect_scale_pad(p)			(p->vector.scale.pad)		/* ї\ */

/*--------------------------------------------------------------------------*/
/*	ߐ錾															*/
/*--------------------------------------------------------------------------*/
#ifndef	SUB_FUNC_DEF

/*------------ ڰp USER_W ֐ -------------------------------------*/
void	O_USER_W(USER_W *);								/* USER_W p */

/*------------ _ݒp GteVIEW_W ֐ ---------------------------------*/
#if 0
void	O_GteVIEW_W(GteVIEW_W *);						/* GTE VIEW p */
#endif
/*------------ èގw֐ --------------------------------------------*/
void	O_GsLINE_W(GsLINE_W *);						/* GsLINE */

void	O_POLY_G4_W(POLY_G4_W *);					/* POLY_G4 */

void	O_POLY_FT4_W(POLY_FT4_W *);					/* POLY_FT4 */
void	O_poly_ft4_w(POLY_FT4_W *);					/* POLY_FT4 */

void 	O_GsSPRITE_W(GsSPRITE_W *);					/* GsSPRITE */
void	O_gssprite_w(GsSPRITE_W *);					/* GsSPRITE */

/*------------- POLY_FT4_WgpĂ޼ުܰɑ΂ĊȈՏݒs */
void 	S_POLY_FT4_W_InitAll(POLY_FT4_W *, u_long *, u_long *, 
							short, short, short, u_char, long);

/*------------- ޼ު֐p ---------------------------------------------*/
void 	O_vect_speed_add(PRIM_W *);			/* ޸ق̽߰މZ */
void 	O_angle_speed_add(PRIM_W *);		/* ]߰ */
void 	O_spr_angle_speed_add(GsSPRITE_W *);	/* ]߰ށ@GsSPRITEp */

/*------------- ėp޼ު p֐ ----------------------------------------*/

/*------------- p֐ ---------------------------------------------------*/
void	O_prim_trans_s(PRIM_W *);				/* PRIM_W ̏ (۰) */
#ifdef LOCAL_WORLD
void	O_prim_trans_l(PRIM_W *);				/* PRIM_W ̏ (۰) */
void	O_prim_trans_g(PRIM_W *);				/* PRIM_W ̏ (۰) */
#endif
void	O_prim_zoom(PRIM_W *);					/* ZOOM ̏ */
void 	o_prim_zoom_x(SVECTOR *,SVECTOR *, long, long);
void 	o_prim_zoom_y(SVECTOR *,SVECTOR *, long, long);

void 	O_prime_hv(PRIM_W *);					/* HV] */
void 	O_poly_ft4_uvwh(POLY_FT4_W *);			/* UVWH  */
void 	O_gssprite_uv(GsSPRITE_W *);			/* UV ̈ړ */

extern void	O_OPD_W( OPD_W * );
extern void	O_OPD_W_INIT( OPD_W *objp, int anime_no);
extern void O_opd_clear( OPD_W *objp );
extern void	O_opd_anime_change( OPD_W *objp, int anime_no);

#endif
#endif
