/*===================================================================
 *  Title           : PSX System
 *                  : - Sound include file -
 *  version         : 0.00
 *
 *  Code            : VX012 
 *  Filename        : sd_vx002.h
 *  Creator         : KONAMI(C) T.S.D  S.Enomoto
 *  First edition   : 1994.06.21
 *
 *  Note            : 
 *                  : 
 *                                      Copyright(C) by KONAMI.Co.LTD
 *===================================================================*/
/*#define     PSXA                            /**/

#include        <libsnd.h>
#include        <libspu.h>
#include        <libcd.h>
#include        <libsn.h>
#include        <sys/file.h>

#define FNAME_SIZE      32

/*----------------------------------*/
/*          u`a@\          */
/*----------------------------------*/
typedef struct {
    int        *vab_adrs;
    char        vab_head[FNAME_SIZE];           /* Vab Header File Name*/
    u_int       loch;                           /* Location MMSSSS*/
    int         size1;                          /* Header File Size*/
    char        vab_name[FNAME_SIZE];           /* VAB FILE NAME*/
    u_int       loc;                            /* Location MMSSSS*/
    int         size2;                          /* Body File Size*/
    char        vab_id;                         /* VAB id */
    char        vab_gp;                         /* VAB Group*/
    char        start_up;                       /* START UP*/
} VAB_S;

/*----------------------------------*/
/*          rdp@\          */
/*----------------------------------*/
typedef struct {
    u_char      *seq_adrs;                      /* SEQ ADRS */
    char        seq_type;                       /* SEQ TYPE */
    char        seq_next;                       /* NEXT SEQ */
    char        seq_name[FNAME_SIZE];           /* SEQ FILE NAME */
    u_int       loc;                            /* Location*/
    char        sep_id;                         /* SEP id*/
    short       size1;                          /* Header File Size*/
    char        seq_vab;                        /* VABS NO */
    char        seq_id;                         /* SEQ id*/
    char        lch;                            /**/
    char        rch;                            /**/
} SEQ_S;

/*----------------------------------*/
/*          ʉ@\          */
/*----------------------------------*/
typedef struct {
	short       prog;	                        /* program no */
	short       pitch;                  	    /* pitch */
	char        lch;                            /* 0 - 127 */
	char        rch;                            /* 0 - 127 */
    char        vab_gp;                         /* VAB Group*/
    char        flag;                           /* r */
} KON;

typedef struct {
	short       prog;	                        /* program no */
	short       note;	                 	    /* pitch */
	short       usen;                           /* 0 - 127 */
	short       vol;                            /* 0 - 127 */
    short       m_vab;                         /* VAB Group*/
    short       xa;                           /* xa se */
    char        flag;                           /* r */
} SD_SE_TBL;


typedef struct {
	char *file_name;
	u_char *tr_addr;
	int size;
	int sector;
	int type;
}SD_FILE;

/*-----------------------------------*/
/*          w`P|V         */
/*-----------------------------------*/
typedef struct {
    u_short    size_s;                          /**/
    u_char     size_e;                          /**/
    char     vol;                               /**/
    char     fno;                               /**/
    char     ch;                                /**/
} XA_SE_S;

typedef struct {
    u_int    size_s;                          /**/
    u_int    size_e;                          /**/
    char     bank;                              /**/
    char     fno;                               /**/
    char     ch;                                /**/
    char     type;
    char     lch;
    char     rch;
} XA_BGM_S;

/*----------------------------------*/
/*      w`t@C\          */
/*----------------------------------*/
typedef struct {
    char        f_name[FNAME_SIZE];             /* File Name*/
    u_short     loc;                            /* Location MMSSSS*/
} XA_FILE_S;

/*----------------------------------*/
/*      c`t@C\          */
/*----------------------------------*/
typedef struct {
    char        f_name[2];                      /* File Name*/
    char        loc[3];                         /* Location MMSSSS*/
    char        type;
    char        lch;
    char        rch;
} DA_FILE_S;

/*-----------------------------------*/
/*          w`p               */
/*-----------------------------------*/
typedef union {
    u_int   posl;
    u_char  pos[4];
} XA_POS_S;

typedef union {
    u_int   posl;
    u_char  pos[8];
} XA_POS2_S;

/*----------------------------------*/
/*     vO[@@@@@@@ */
/*----------------------------------*/

typedef struct {
	int se_counter;
	int se_next_counter;
	int se_no;
	
	short voice;
	
	short vabId;
	short prog;
	short tone;
	short note;
	short fine;
	short voll;
	short volr;
	
	
	int pitch;
	int pitch_flag;		/*	IWiJEg	*/
	int pitch_counter;
	int pitch_depth;
	int pitch_delay_time;

	int vol;
	int vol_flag;		/*	IWiJEg	*/
	int vol_counter;
	int vol_depth;
	int vol_delay_time;

	int pan;
	int pan_flag;		/*	IWiJEg	*/
	int pan_counter;
	int pan_depth;
	int pan_delay_time;
} SD_PROG_SE;


/*==================================================================*/
/*          @ʒ`                                    */
/*==================================================================*/

/*----------------------------------------------*/
/*          bc    ֌W                        */
/*----------------------------------------------*/
#define     XA_STOP             0               /* bc||Y*/
#define     XA_PLAY_VOICE       1               /* w`@ʉ@t*/
#define     XA_PLAY_BGM         3               /* w`@afl@t*/
#define     XA_PLAY_DA          4               /* bcc`  t*/
#define     XA_PLAY_SE_P        5               /* w`@ۗ*/
#define     XA_START0           6
#define     XA_START1           7
#define     XA_NOW_SEEK         9
#define     XA_ERROR            90
#define     XA_ERROR2           91
#define     XA_ERROR3           92
#define     XA_ERROR4           93
#define     XA_CALL_2           10              /* w`yтc`*/
#define     XA_CALL_1           20              /* w`yтc`*/
#define     XA_PHASE1           30
#define     XA_PHASE2           40
#define     XA_VAG              50
#define     XA_PLAY_BGM_P       8              /* w`@afl@ۗ*/
#define     XA_PAUSE            60
#define     XA_PAUSE2           61
#define     XA_PAUSE3           62
#define     DA_PAUSE            68
#define     DA_PAUSE2           69
#define     DA_PAUSE3           70
#define     XA_PAUSE4           71
#define     DA_PAUSE4           72
#define     XA_CDPAUSE           73
/*----------------------------------------------*/
/*          ʊ֌W                            */
/*----------------------------------------------*/

#define     SVOL		         82			    /* seq data volume */
#define     SE_DEF_V             87             /* SE Default Volume */
#define     MVOL		        122			    /* main volume */
#define     CD_VOL              105             /* CD Volume*/

#define     SEVOL		         87			    /* seq data volume */
#define     SE_MAX_V            127             /* SE Default Volume */

#define     XA_FADE1            2               /* XA FADE*/
#define     XA_FADE2            3               /* XA FADE*/
#define     XA_FADE3            4               /* XA FADE*/
#define     XA_FADE4            8               /* XA FADE*/
#define     SPU_FADE1           600             /* SPU FADE*/
#define     SPU_FADE2           300             /* SPU FADE*/
#define     SPU_FADE3           200             /* SPU FADE*/
#define     SPU_FADE4           100             /* SPU FADE*/

/*----------------------------------------------*/
/*          t@CGg                    */
/*----------------------------------------------*/
#define     DA_MAX              0               /* DA FILE ̐*/
#define     VAB_ENTRY           1               /* VAB ̐ */
#define     SEQ_ENTRY           0               /* BGM@̐ */
#define     SE_SEQ_ENTRY		0               /* ʉV|PX̐ */
#define     XA_BGM_ENTRY        0x36              /* XA BGM@̐ */
#define     DA_BGM_ENTRY        0               /* DA BGM@̐ */
#define     XA_FILE_ENTRY       0               /* XA FILE ̐*/

#define MAX_RETRY   32                          /* 128 */

#define     SE_ENTRY          0x133             /* ʉ̐ */
#define     XA_ENTRY            0               /* XA SE̐*/


#define VAB_ADDR	0x801d0000L		            /* vab data address */
#define SEQ_ADDR	0x801d4000L		            /* seq data address */
#define VAB_ADDR0	0x801e0000L		            /* VAB data address */
#define VAB_ADDR1	0x801e8000L		            /* VAB data address */

#define VAB_BSIZE   1024*32*2                   /* VAB BUF SIZE     */
#define VAB_SECTOR  0x32                        /* 32KByte BCD 16 SECTOR    */
/*#define VAB_SECTOR  32                          /* 32KByte BCD 16 SECTOR    */

#define STR_ENTRY   4
#define CD_POLLING      3


enum SD_ST {
	ST_ALL= 0,
	ST_KING,
	ST_KISS
};

typedef struct SD_Stage {
	unsigned char vh_name[0x20];
	unsigned int vh_size;
	unsigned char vb_name[0x20];
	unsigned int vb_size;
	unsigned char str_vh_name[0x20];
	unsigned int str_vh_size;
	unsigned char str_vb_name[0x20];
	unsigned int str_vb_size;
} SD_STAGE;

/*--------------------------------------*/
/*              orw`                */
/*--------------------------------------*/
#define CDPAUSE     0
#define CDDEPAUSE   1


#define XBGM         0

#define XSE          82887


#include		"sd_lev.h"
#include        "sd_prot.h"

