/***< file >*****************************************************************/
/*	Title		:	PlayStation												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	g_graph.c											*/
/*	Author		:	KONAMI(c) ց{勴@							*/
/*	Date		:	1995.12.19										*/
/*	Note		:						*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include	"lt_all.h"
#include	"s_obj.h"
#include	"s_objset.h"
#include    "s_work.h"
#include	"s_init.h"
#include	"s_trans.h"
#include	"s_item.h"
#include	"g_graph.h"
#include	"l_kanji.h"
#include	"n_gsboxf.h"
#include	"g_gsline.h"
#include	"g_gsboxf.h"
/*==========================================================================*/
/*	define																	*/
/*==========================================================================*/

#define	EXIT	0

#define MAX_DATA_SUU	128

#define K_DISP_X	(double)(3*M_graph_x_res())/(double)(4*M_graph_y_res())

#define	INIT_HAIKEI_Z 		40 	/* ޯzW */
#define	INIT_BOX_Z 			30 	/* ޯzW */
#define INIT_LINE_Z			20
#define	INIT_GRAPH_LINE_Z	10
/*====================================================================*/
/*  \̂̐錾													  */
/*====================================================================*/

typedef struct	_keisen_data{
	long	start;
	long	end;
	long	range;
	long	number;
}Keisen_data;

typedef	struct	_waku_data{
	Keisen_data	x_keisen;
	Keisen_data y_keisen;
	long		y_keta;
	long		x_length;
	long		x_center;
	long		y_length;
	long		y_center;
}Waku_data;

/*@L^[hp̃XvCgv~eBu̍\́@*/
typedef struct {
	GsSPRITE	sprite;
	SVECTOR		coord;
	short		state;
} G_GsSPRITE_PRIM;

typedef struct {
	POLY_G4		poly;
	u_short		pri;
	short		state;
} G_POLYG4_PRIM;

static	POLY_FT4_W 	*char_objp[2];
static	POLY_FT4_W 	*memori_objp[2][16];

/*static	GsLINE_W 	*kei_objp[2][16];
static	GsLINE_W	*graph_objp[MAX_DATA_SUU];*/
static	GsLINE_PRIM 	kei_objp[2][16];
static	GsLINE_PRIM		graph_objp[MAX_DATA_SUU];


static	GsBOXF_PRIM		bou_objp[MAX_DATA_SUU],
						kiroku_bg[3];
static	G_POLYG4_PRIM	back_objp;

extern	char g_num_font[][24];

/*==========================================================================*/
/*	vg^Cv錾														*/
/*==========================================================================*/




/*	AvP[VwƂȂ֐	*/

static void g_waku( G_data *, Waku_data *, short);
static void g_graph( G_data *, Waku_data *);

static void G_keisen(Keisen_data *keisen, int flag, int flag2, int d_min,
			int d_max, long *data1, long *data2, long data_num, long line_max);
static void G_poly_ft4_w_init( POLY_FT4_W *objp, short x, short y, short z,
							u_char rgb, long scale, int u, int v,
							int col_x, int col_y, int length,int);
static void G_ft4_dummy(POLY_FT4_W *objp);
static void g_back_set(G_data *g_data, Waku_data *w_data);

/***< global function >**********************************************/
/*	`F		G_dedama(objp)										*/
/*	F		USER_W		*objp:޼ު߲						*/
/*	F		flagP̎AL^[hp̗OsB	*/
/*	ԒlF		Ȃ												*/
/********************************************************************/
/*----- function -----*/
int G_graph( G_data *data,short flag)
{
	Waku_data	waku_data;
	u_short		col_data[16];

	if( data->data_num < 2 )
		return( 0 );

	/*S_disp_sys_change(320,240);*/

	bzero( (char *)char_objp, sizeof(char_objp) );
	bzero( (char *)memori_objp, sizeof(memori_objp) );
	bzero( (char *)kei_objp, sizeof(kei_objp) );
	bzero( (char *)graph_objp, sizeof(graph_objp) );
	bzero( (char *)bou_objp, sizeof(bou_objp) );
	bzero( (char *)&back_objp, sizeof(back_objp) );
	bzero( (char *)col_data, sizeof(col_data) );

	col_data[1] = data->comment_col;
	OLoadImage( data->col_x, data->col_y, 16, 1, (u_long *)col_data );

	if( data->y_bou_address )
	{
		G_keisen(&waku_data.x_keisen, 0, 1, 0, 0,
									data->x_address, 0, data->data_num, 5);
	}
	else
	{
		G_keisen(&waku_data.x_keisen, 0, 0, 0, 0,
									data->x_address, 0, data->data_num, 5);
	}

	if( data->y_sen_address && data->y_bou_address )
	{
		G_keisen(&waku_data.y_keisen, 1, 0, data->default_min,
								data->default_max, data->y_sen_address,
								data->y_bou_address, data->data_num, 5);
	}
	else if( data->y_sen_address && !data->y_bou_address )
	{
		G_keisen(&waku_data.y_keisen, 0, 0, data->default_min,
				data->default_max, data->y_sen_address, 0, data->data_num, 5);
	}
	else if( !data->y_sen_address && data->y_bou_address )
	{
		G_keisen(&waku_data.y_keisen, 0, 0, data->default_min,
				data->default_max, data->y_bou_address, 0, data->data_num, 5);
	}

	g_waku( data, &waku_data,flag);
	g_graph( data, &waku_data);

	return( 1 );
}


static void g_waku( G_data *g_data, Waku_data *w_data, short flag)
{
	int		i,j;
	u_short	work_area[256];
	static char		suuji[] = "OPQRSTUVWX|";
	long	memori;
	int		keta, keta2;
	int		line_no;
	u_short *ptr;
	int		minus_flag;
	short	x,y,x0 = 0, y0 = 0, x1 = 0,y1 = 0;
	short 	offset;
	
	w_data->y_keta = strlen(g_data->y_char)/2*3;
	for( i=0; i<w_data->y_keisen.number; i++ ){
		memori = w_data->y_keisen.start + w_data->y_keisen.range*i;

		keta = 	keta2 = 1;
		while( memori/keta ){
			keta*=10;
			keta2++;
		}
		if( keta2 > 1 ){
			keta /= 10;
			keta2--;
		}

		keta2 = keta2 + (keta2-1)/3;

		if( memori < 0 ){
			keta2++;
		}

		if( keta2 > w_data->y_keta ){
			w_data->y_keta = keta2;
		}
	}



	w_data->x_length   = g_data->disp_size.x-w_data->y_keta*4/*12*/;
	w_data->x_center   = g_data->disp_posi.x+w_data->y_keta*2/*6*/;
	w_data->y_length   = g_data->disp_size.y-12;
	w_data->y_center   = g_data->disp_posi.y-6;

	(u_long *)char_objp[0] = S_obj_set( (u_long)G_ft4_dummy,
				(u_long)O_POLY_FT4_W, (u_long)sizeof(PRIM_W), 0);

	G_poly_ft4_w_init(char_objp[0], w_data->x_center+w_data->x_length/2-strlen(g_data->x_char)*3,
		w_data->y_center+w_data->y_length/2+10, 200, 0x80, ONE,
		g_data->moji_x, g_data->moji_y, g_data->col_x, g_data->col_y, strlen(g_data->x_char),L_FONT_SIZE);


	Kanji12_load( g_data->x_char, (u_short *)g_data->font_address,
					strlen(g_data->x_char), 1,
					g_data->moji_x, g_data->moji_y, 0 );

	(u_long *)char_objp[1] = S_obj_set( (u_long)G_ft4_dummy,
				(u_long)O_POLY_FT4_W, (u_long)sizeof(PRIM_W), 0);

	G_poly_ft4_w_init(char_objp[1], w_data->x_center-w_data->x_length/2-strlen(g_data->y_char)*3,
		w_data->y_center-w_data->y_length/2+6, 200, 0x80, ONE, g_data->moji_x+32, g_data->moji_y, g_data->col_x, g_data->col_y, strlen(g_data->y_char),L_FONT_SIZE);

	Kanji12_load( g_data->y_char, (u_short *)g_data->font_address,
					strlen(g_data->y_char), 1,
					g_data->moji_x+32, g_data->moji_y, 0 );

	line_no = 1;
															/*  */
	for( i=0; i<w_data->y_keisen.number+1; i++ ){
		x = w_data->x_center;	/* Wʒu  */
		y = w_data->y_center-w_data->y_length/2+(w_data->y_length*i)/
				w_data->y_keisen.number;
		x0 = -w_data->x_length/2;
		y0 = 0;
		x1 = w_data->x_length/2/*-1*/;
		y1 = 0;
		InitGsLINE(&kei_objp[0][i],x+x0,y+y0,x+x1,y+y1,
			RGB8R(g_data->line_col),RGB8G(g_data->line_col),
				RGB8B(g_data->line_col),INIT_LINE_Z);
		if( i<w_data->y_keisen.number )
		{
			memori = w_data->y_keisen.start + w_data->y_keisen.range*i;
			(u_long *)memori_objp[0][i] = S_obj_set( (u_long)G_ft4_dummy,
						(u_long)O_POLY_FT4_W, (u_long)sizeof(PRIM_W), 0);

			keta = 1;
			keta2 = 1;
			while( memori/keta ){
				keta*=10;
				keta2++;
			}
			if( keta2 > 1 ){
				keta /= 10;
				keta2--;
			}

			minus_flag = 0;

			if( memori < 0 ){
				ptr = GetKanjiAddress((u_char *)&suuji[20],
												(u_short *)g_data->font_address);

				ExpandKanji((u_short*)&g_num_font[13][0]/*ptr*/, work_area, 1, 0);
				OLoadImage(g_data->moji_x, g_data->moji_y+12*line_no,
							L_FONT_SIZE/4, L_FONT_SIZE, (u_long *)work_area);
				DrawSync(0);
				minus_flag = 1;
				memori *= -1;
			}

			for( j=0; j<keta2; j++ ){
				ptr = GetKanjiAddress((u_char *)&suuji[memori/keta*2],
												(u_short *)g_data->font_address);

		/*	R̔{P^ɃR}ł߂̗Z@*/
			if( (j!=0) && ((j==keta2-3) || (j==keta2-6)) ){
				ExpandKanji((u_short*)&g_num_font[10][0]/*ptr*/, work_area, 1, 0);
				OLoadImage(g_data->moji_x+(j+minus_flag)*4/4,
							g_data->moji_y+12*line_no,
							L_FONT_SIZE/4, L_FONT_SIZE, (u_long *)work_area);
				DrawSync(0);
				j++;
				keta2++;
				}
		/*@܂ŁBvO͉AύXԂTōς񂾂̂ŉ䖝@*/

				ExpandKanji((u_short*)&g_num_font[memori/keta][0]/*ptr*/, work_area, 1, 0);
				OLoadImage(g_data->moji_x+(j+minus_flag)*4/4,
							g_data->moji_y+12*line_no,
							L_FONT_SIZE/4, L_FONT_SIZE, (u_long *)work_area);
				DrawSync(0);
				memori %= keta;
				keta /= 10;
			}

			G_poly_ft4_w_init(memori_objp[0][i],
				w_data->x_center-w_data->x_length/2-(keta2+minus_flag)*2/*4*//*6*//*-4*/ ,
				w_data->y_center+w_data->y_length/2-(w_data->y_length*i)/w_data->y_keisen.number,
					200, 0x80, ONE, g_data->moji_x, g_data->moji_y+12*line_no, g_data->col_x, g_data->col_y, (keta2+minus_flag)*2,4);
			line_no++;
		}
	}

	line_no = 1;
															/* c */
	for( i=0; i<w_data->x_keisen.number+1; i++ ){
		x = w_data->x_center-w_data->x_length/2+(w_data->x_length*i)/
			w_data->x_keisen.number;	/* Wʒu  */
		y = w_data->y_center;
		x0 = 0;
		y0 = -w_data->y_length/2;
		x1 = 0;
		y1 = w_data->y_length/2/*-1*/;
		InitGsLINE(&kei_objp[1][i],x+x0,y+y0,x+x1,y+y1,
			RGB8R(g_data->line_col),RGB8G(g_data->line_col),
				RGB8B(g_data->line_col),INIT_LINE_Z);

		if( i<w_data->x_keisen.number ){
			memori = w_data->x_keisen.start + w_data->x_keisen.range*i;
			(u_long *)memori_objp[1][i] = S_obj_set( (u_long)G_ft4_dummy,
						(u_long)O_POLY_FT4_W, (u_long)sizeof(PRIM_W), 0);

			keta = 1;
			keta2 = 1;
			while( memori/keta ){
				keta*=10;
				keta2++;
			}
			if( keta2 > 1 ){
				keta /= 10;
				keta2--;
			}

			minus_flag = 0;
			
			if( memori < 0 ){
				ptr = GetKanjiAddress((u_char *)&suuji[20],
												(u_short *)g_data->font_address);

				ExpandKanji((u_short*)&g_num_font[13][0]/*ptr*/, work_area, 1, 0);
				OLoadImage(g_data->moji_x+32, g_data->moji_y+12*line_no,
							L_FONT_SIZE/4, L_FONT_SIZE, (u_long *)work_area);
				DrawSync(0);
				minus_flag = 1;
				memori *= -1;
			}

		for( j=0; j<keta2; j++ )
		{
			ptr = GetKanjiAddress((u_char *)&suuji[memori/keta*2],
							(u_short *)g_data->font_address);

	/*@L^[hp̗OBƌĂO\Ȃ悤ɂ邾@*/
			if( (keta2==1) && (flag==1) )
			{			
				offset = 1;
			}
			else
			{
				offset = 0;
			}

			ExpandKanji((u_short*)&g_num_font[(memori/keta)+offset][0]/*ptr*/,
					 work_area, 1, 0);
				OLoadImage(g_data->moji_x+32+(j+minus_flag)*4/4,
							g_data->moji_y+12*line_no,
							L_FONT_SIZE/4, L_FONT_SIZE, (u_long *)work_area);
		DrawSync(0);
		memori %= keta;
		keta /= 10;
		}

			G_poly_ft4_w_init(memori_objp[1][i],
					w_data->x_center-w_data->x_length/2+(w_data->x_length*i)/w_data->x_keisen.number+4,
					w_data->y_center+w_data->y_length/2+10,
					200, 0x80, ONE, g_data->moji_x+32, g_data->moji_y+12*line_no, g_data->col_x, g_data->col_y, (keta2+minus_flag)*2,4);

			line_no++;
		}
	}

	/*  wiƂȂPOLY_GT4Zbg  */
	g_back_set(g_data, w_data);
}
static void g_graph( G_data *g_data, Waku_data *w_data)
{
	short		counter;
	long		start_x, start_y, end_x, end_y;
	long/*short*/		x = 0, y = 0, w = 0, h = 0;
	long/*short*/		x0,y0,x1,y1;


	if( g_data->y_sen_address != 0 ){
		for(counter = 0; counter < g_data->data_num-1; counter++) {
			start_x = ((g_data->x_address[counter]-w_data->x_keisen.start)*w_data->x_length)/(w_data->x_keisen.end-w_data->x_keisen.start);
			start_y = (long)(((double)(g_data->y_sen_address[counter]-w_data->y_keisen.start)*(double)w_data->y_length)/(double)(w_data->y_keisen.end-w_data->y_keisen.start));
			end_x = ((g_data->x_address[counter+1]-w_data->x_keisen.start)*w_data->x_length)/(w_data->x_keisen.end-w_data->x_keisen.start);
			end_y = (long)(((double)(g_data->y_sen_address[counter+1]-w_data->y_keisen.start)*(double)w_data->y_length)/(double)(w_data->y_keisen.end-w_data->y_keisen.start));

			x = w_data->x_center-w_data->x_length/2 + 1;
			y = w_data->y_center+w_data->y_length/2;
			x0 = start_x;
			y0 = -start_y;
			x1 = end_x;
			y1 = -end_y;

			InitGsLINE(&graph_objp[counter],x+x0,y+y0,x+x1,y+y1,
				RGB8R(g_data->graph_col),RGB8G(g_data->graph_col),
					RGB8B(g_data->graph_col),INIT_GRAPH_LINE_Z);
		}
	}

	if( g_data->y_bou_address != 0 )
	{
		for(counter = 0; counter < g_data->data_num; counter++)
		{
			if( g_data->y_bou_address[counter] > 0 )
			{
				start_x = ((g_data->x_address[counter]-w_data->x_keisen.start)*w_data->x_length)/(w_data->x_keisen.end-w_data->x_keisen.start);
				start_y = (long)(((double)(g_data->y_bou_address[counter]-w_data->y_keisen.start)*(double)w_data->y_length)/(double)(w_data->y_keisen.end-w_data->y_keisen.start));

				x = w_data->x_center-w_data->x_length/2+start_x + 1;
				y = w_data->y_center+w_data->y_length/2-start_y;
				w =	w_data->x_length/
							(w_data->x_keisen.end-w_data->x_keisen.start);
				if( w_data->y_keisen.start <= 0 )
				{
					h = (long)(((double)g_data->y_bou_address[counter]*(double)w_data->y_length)/
						(double)(w_data->y_keisen.end-w_data->y_keisen.start));
				}
				else
				{
					h = (long)(((double)(g_data->y_bou_address[counter]-w_data->y_keisen.start)*(double)w_data->y_length)/(double)(w_data->y_keisen.end-w_data->y_keisen.start));
				}
				
				InitGsBOXF(&bou_objp[counter],x,y,w,h,RGB8R(g_data->bou_col),
					RGB8G(g_data->bou_col),RGB8B(g_data->bou_col),INIT_BOX_Z);
			}
			else
			{
				start_x = ((g_data->x_address[counter]-w_data->x_keisen.start)*
					w_data->x_length)/
						(w_data->x_keisen.end-w_data->x_keisen.start);
				if( w_data->y_keisen.end <= 0 )
				{
					start_y = w_data->y_length-1;
				}
				else
				{
					start_y = (long)((-(double)w_data->y_keisen.start*(double)w_data->y_length)/
						(double)(w_data->y_keisen.end-w_data->y_keisen.start)-1);
				}
				
				x = w_data->x_center-w_data->x_length/2+start_x + 1;
				y = w_data->y_center+w_data->y_length/2-start_y;
				w = w_data->x_length/
						(w_data->x_keisen.end-w_data->x_keisen.start);
				if( w_data->y_keisen.end <= 0 )
				{
					h = ((w_data->y_keisen.end-g_data->y_bou_address[counter])*
						w_data->y_length)/
							(w_data->y_keisen.end-w_data->y_keisen.start);
				}
				else
				{
					h = (-g_data->y_bou_address[counter]*w_data->y_length)/
						(w_data->y_keisen.end-w_data->y_keisen.start);
				}
				InitGsBOXF(&bou_objp[counter],x,y,w,h,RGB8R(g_data->bou_col2),
					RGB8G(g_data->bou_col2),RGB8B(g_data->bou_col2),INIT_BOX_Z);
				
			}
		}
	}
}


static void G_keisen(Keisen_data *keisen, int flag, int flag2, int d_min,
			int d_max, long *data1, long *data2, long data_num, long line_max)
{
	int		i;
	int		min, max, keta;
	long	range;
	static int range_table[5] = { 1, 2, 5, 10, 20 };

	min = d_min;
	max = d_max;

	for( i=1; i<data_num; i++ ){
		if( max < data1[i] )		max = data1[i];
		if( min > data1[i] )		min = data1[i];
	}

	if( flag != 0 ){
		for( i=0; i<data_num; i++ ){
			if( max < data2[i] )		max = data2[i];
			if( min > data2[i] )		min = data2[i];
		}
	}

	max += flag2;

	range = max - min;
	keta = 1;
	range /= 10;
	while( range ){
		range /= 10;
		keta *= 10;
	}
	if( keta == 1 ){
		range = max-min;
		keisen->range = range_table[4] * keta;
	}
	else{
		range = (max-min)/(keta/10);
		keisen->range = range_table[4] * keta/10;
	}

	for( i=0; i<5; i++ ){
		if( range < range_table[i]*line_max ){
			if( keta == 1 )		keisen->range = range_table[i] * keta;
			else				keisen->range = range_table[i] * keta/10;
			break;
		}
	}

	keisen->start = min/keisen->range;
	keisen->end   = max/keisen->range;

	if( max > keisen->end*keisen->range )		keisen->end++;
	if( min < keisen->start*keisen->range )		keisen->start--;

	keisen->number = keisen->end - keisen->start;

	keisen->start *= keisen->range;
	keisen->end   *= keisen->range;
}

static void G_poly_ft4_w_init( POLY_FT4_W *objp, short x, short y, short z,
				u_char rgb, long scale, int u, int v, int col_x, int col_y, 
				int length,int font_size)
{
	M_vect_x_h(objp) = x;			/* W */
	M_vect_y_h(objp) = y;									/* W */
	M_vect_z_h(objp) = 62/*z*/;									/* W */
	setRGB0(&M_prim(objp), rgb, rgb, rgb);					/* Pxl */
	setVector(	&M_vect_scale(objp), scale/**(M_graph_x_res()/M_graph_y_res())*/,
				scale, scale);							/* ޸ */

	M_vect_u(objp) = (u%64)*4;
	M_vect_v(objp) = v%256;
	M_vect_w(objp) = length*font_size/2 /*- 1*/;
	M_vect_h(objp) = L_FONT_SIZE;

	M_vect_angle_y_h(objp) = 0;

	M_prim_tpage(objp) = GetTPage(0,1,u-(u%64),v-(v%256));

	M_prim_clut(objp) = GetClut( col_x, col_y );

#if 0
	setVector(&M_vect_v0(objp), -(font_size*length)/4  , -L_FONT_SIZE/2  ,0);
	setVector(&M_vect_v1(objp),  (font_size*length)/4/*-1*/, -L_FONT_SIZE/2  ,0);
	setVector(&M_vect_v2(objp), -(font_size*length)/4  ,  L_FONT_SIZE/2/*-1*/,0);
	setVector(&M_vect_v3(objp),  (font_size*length)/4/*-1*/,  L_FONT_SIZE/2/*-1*/,0);
	
#endif
	setVector(&M_vect_v0(objp), -(font_size*length)/4  , -L_FONT_SIZE/2  ,0);
	setVector(&M_vect_v1(objp),  (font_size*length)/4, -L_FONT_SIZE/2  ,0);
	setVector(&M_vect_v2(objp), -(font_size*length)/4  ,  L_FONT_SIZE/2 ,0);
	setVector(&M_vect_v3(objp),  (font_size*length)/4,  L_FONT_SIZE/2 ,0);

}

static void g_back_set(G_data *g_data, Waku_data *w_data)
{
	long			x, y, z;
	short			whight,hight;
	u_char			r1, g1, b1, r2, g2, b2;

	SetPolyG4(&back_objp.poly);
	
	x 		=  g_data->disp_posi.x+w_data->y_keta*2/*6*/;
	y		=  g_data->disp_posi.y-6;
	z		=  INIT_HAIKEI_Z;
	whight	=  g_data->disp_size.x-w_data->y_keta*4/*12*/;
	hight 	=  g_data->disp_size.y-12;

	r1 		= (u_char)(  g_data->bg_col_sita & 0x000000ff);
	g1 		= (u_char)( (g_data->bg_col_sita & 0x0000ff00) >> 8 );
	b1 		= (u_char)( (g_data->bg_col_sita & 0x00ff0000) >> 16 );

	r2 		= (u_char)(  g_data->bg_col_ue & 0x000000ff);
	g2 		= (u_char)( (g_data->bg_col_ue & 0x0000ff00) >> 8 );
	b2 		= (u_char)( (g_data->bg_col_ue & 0x00ff0000) >> 16 );

											/*@S_̐FZbg	*/

	
	setRGB0(&back_objp.poly, r1, g1, b1);
	setRGB1(&back_objp.poly, r1, g1, b1);
	setRGB2(&back_objp.poly, r2, g2, b2);
	setRGB3(&back_objp.poly, r2, g2, b2);

	back_objp.pri = z;
	back_objp.state = ON;

											/* غ݂̂S_w肷 */
	setXY4(&back_objp.poly,
		(whight/2)+x, hight/2+y, 
	 	-whight/2+x, hight/2+y, 
	 	(whight/2)+x, -hight/2+y,
	 	-whight/2+x, -hight/2+y);
			
	InitGsBOXF(&kiroku_bg[0],x-(whight/2),y-(hight/2),
				whight,hight,199,209,217,z);
	kiroku_bg[0].box.attribute = 0x40000000;
	InitGsBOXF(&kiroku_bg[1],x-(whight/2),y-(hight/2)+hight+1,
				whight,15,63,40,100,z);
	kiroku_bg[1].box.attribute = 0x40000000;

#if 0
	InitGsBOXF(&kiroku_bg[2],-160+10/*6*/,y-(hight/2)-1,
				abs((-160+10/*6*/)-(x-(whight/2))),hight + 17,63,40,100,z);
	kiroku_bg[2].box.attribute = 0x40000000;
#endif
	InitGsBOXF(&kiroku_bg[2],
			g_data->disp_posi.x-(g_data->disp_size.x/2),
			y-(hight/2)-1,
			abs((g_data->disp_posi.x-(g_data->disp_size.x/2))-(x-(whight/2))),
			hight + 17,63,40,100,z);
	kiroku_bg[2].box.attribute = 0x40000000;
}


static void G_ft4_dummy( POLY_FT4_W *objp )
{
}





void G_graph_clear()
{
	int		i, j;

	for( i=0; i<2; i++ ){
		if( char_objp[i] != 0 ){
			S_obj_clear((u_long*)char_objp[i]);
		}
	}

	for( i=0; i<2; i++ ){
		for( j=0; j<16; j++ ){
			if( memori_objp[i][j] != 0 ){
				S_obj_clear((u_long*)memori_objp[i][j]);
			}
		}
	}




}
/***< global function >******************************************************/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/****************************************************************************/
void G_graph_main(short flag,short bg_type)
{
	short	counter;
	short	i,j;
	
	if ( (bg_type==ON)&&(back_objp.state==ON) )
	{
		GsSortPoly(&back_objp.poly, (GsOT *)&Wot[flag][M_activebuff()], 
			back_objp.pri);
	}
	else
	{
		for(counter = 0; counter < 3; counter++)
		{
			if (kiroku_bg[counter].state == ON)
			{
				GsSortBoxFill(&kiroku_bg[counter].box,
    				(GsOT *)&Wot[flag][M_activebuff()], kiroku_bg[counter].pri);
			}
		}
	}  
		
	
	
	for(counter = 0; counter < MAX_DATA_SUU; counter++)
	{
		if (bou_objp[counter].state == ON)
		{
			GsSortBoxFill(&bou_objp[counter].box,
				(GsOT *)&Wot[flag][M_activebuff()], bou_objp[counter].pri);
		}
	}

	for(counter = 0; counter < MAX_DATA_SUU; counter++)
	{
		if (graph_objp[counter].state == ON)
		{
			GsSortLine(&graph_objp[counter].line,
				(GsOT *)&Wot[flag][M_activebuff()], graph_objp[counter].pri);
		}
	}

	for( i=0; i<2; i++ )
	{
		for( j=0; j<16; j++ )
		{
			if( kei_objp[i][j].state == ON )
			{
				GsSortLine(&kei_objp[i][j].line,
					(GsOT *)&Wot[flag][M_activebuff()], kei_objp[i][j].pri);
			}
		}
	}
	
	for( i=0; i<2; i++ ){
		if( char_objp[i] != 0 ){
			char_objp[i]->state.ot = flag;
		}
	}

	for( i=0; i<2; i++ ){
		for( j=0; j<16; j++ ){
			if( memori_objp[i][j] != 0 ){
				memori_objp[i][j]->state.ot = flag;
			}
		}
	}
	
}

/***< global function >******************************************************/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/****************************************************************************/

/*---< local function >-----------------------------------------------------*/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/

