/***< file >*****************************************************************/
/*	Title		:	PlayStation												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	s_cd.c													*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	1995.06.20												*/
/*	Note		:	CD_ROM,HDDǗ֐Q								*/
/*					s_cdhd.h												*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include 		"lt_all.h"
#include		"s_string.h"
#include		"s_cdhd.h"
/*==========================================================================*/
/*	define																	*/
/*==========================================================================*/
#define		HD_READ_SIZE	8192	/*2048 HDD Pɓǂݏł黲 */

#define		FIRST		1
#define		SECOND		2

static void s_hd_read(READ_REQUEST *req_data, int mode);
static void s_cd_read(READ_REQUEST *req_data);
static void s_cdhd_read( READ_REQUEST *req_data );
/*==========================================================================*/
/*	Program																	*/
/*==========================================================================*/

/***< function >*************************************************************/
/*	`F		S_cdhd_num_set(num)											*/
/*	F		u_long		num	:ðްo^ԍ							*/
/*	F		ǂݍް̔ԍo^								*/
/*	ԒlF		u_long		num :	Ĕԍ								*/
/*							-1	:s										*/
/****************************************************************************/
long S_cdhd_que_set( int cdhd, u_long dst, u_long size, u_long sect )
{
	int		i;

	for( i=0; i<READ_REQ_MAX; i++ ){
		if( S_sys_w->read_request[i].status == CD_STATUS_END ){
			S_sys_w->read_request[i].status	= CD_STATUS_REQ;
			S_sys_w->read_request[i].cdhd	= cdhd;
			S_sys_w->read_request[i].dst	= dst;
			S_sys_w->read_request[i].size	= size;
			S_sys_w->read_request[i].sect	= sect;
			S_sys_w->read_request[i].cd_step= 0;
			return(i);
		}
	}


	return(-1);
}

long S_cdhd_que_stat( int no )
{
	return( S_sys_w->read_request[no].status );
}

/***< function >*************************************************************/
/*	`F		S_cdhd()													*/
/*	F		Ȃ														*/
/*	F		CD,HDDްǂݍށB									*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/

void S_cdhd(void)
{
	int i;


	for( i=0; i<READ_REQ_MAX; i++ ){
		if( S_sys_w->read_request[i].status == CD_STATUS_READ ){
			s_cdhd_read( &(S_sys_w->read_request[i]) );
			return;
		}
	}

	for( i=0; i<READ_REQ_MAX; i++ ){
		if( S_sys_w->read_request[i].status == CD_STATUS_REQ ){
			s_cdhd_read( &(S_sys_w->read_request[i]) );
			return;
		}
	}

	return;
}

/***< function >*************************************************************/
/*	`F		S_cdhd_read(dp)												*/
/*	F		CDHD_READ_W		*dp	:ްڽ߲							*/
/*	F		CD,HDް̧ق̓ǂݍ݂B							*/
/*	ԒlF		ް̓ǂݍ		F@O								*/
/*									sF|P								*/
/****************************************************************************/

/*--- func ---*/
static void s_cdhd_read( READ_REQUEST *req_data )
{
	switch( req_data->cdhd ){
		case HD_DATA:
			s_hd_read( req_data, 0 );
			break;
		case HD_DATA_BLOCK:
			s_hd_read( req_data, 1 );
			break;
		case CD_DATA:
			s_cd_read( req_data );
			break;
	}
}


/***< function >*************************************************************/
/*	`F		S_hd_read(dp)												*/
/*	F		CDHD_READ_W		*dp:ްڽ߲							*/
/*	F		ʰިްǂݍ									*/
/*	ԒlF		ް̓ǂݍ		F@O								*/
/*									sF|P								*/
/****************************************************************************/
static void s_hd_read(READ_REQUEST *req_data, int mode)
{
	static int		fd;										/* ̧ */
	static long		fsize;
	static long		dst;

	if( req_data->status == CD_STATUS_REQ ){
		if ((fd = PCopen((u_char *)req_data->sect, 0, 0)) == -1) {
SFntPrint(80, 160, 0, 0, "FILE OPEN ERROR");
SFntPrint(80, 180, 0, 0, "FILE NAME = %s", (u_char *)req_data->sect);
			return;
		}

		req_data->status = CD_STATUS_READ;
		dst = 0;
		fsize = (int)PClseek(fd, 0, 2);					/* ̧ٻ */
		PClseek(fd, 0, 0);
printf( "Open! File name:%s\n", (char *)req_data->sect );
printf( "      File size:%d\n", (int)fsize );
printf( "      address  :%08x\n", (int)req_data->dst );
	}

	if( mode == 0 ){
		PClseek(fd, dst, 0);
		dst += PCread(fd, (char *)(req_data->dst+dst),
						((fsize-dst)>HD_READ_SIZE)?HD_READ_SIZE:(fsize-dst));
	}
	else{
		while( fsize > dst ){
			PClseek(fd, dst, 0);
			dst += PCread(fd, (char *)(req_data->dst+dst),
						((fsize-dst)>HD_READ_SIZE)?HD_READ_SIZE:(fsize-dst));
		}
	}

	if( fsize == dst ){
    	PCclose(fd);
		req_data->status = CD_STATUS_END;
printf( "file close\n" );
	}
}


/***< function >*************************************************************/
/*	`F		S_cd_read(dp)												*/
/*	F		CDHD_READ_W		*dp:ްڽ߲							*/
/*	F		CD_ROMްǂݍ									*/
/*	ԒlF		ް̓ǂݍ		F@O								*/
/*									sF|P								*/
/****************************************************************************/
static int cd_error_count;

static void s_cd_read(READ_REQUEST *req_data)
{
	CdlLOC	loc ;
	int err;

	SFntPrint( 80, 80, 0, 0, "*** CD READ NOW ***" );
	
	switch( req_data->cd_step ){
		case 0:
			cd_error_count = 0;
			if(req_data->status == CD_STATUS_REQ) {
				if(CdSync(1, &M_cd_status()) == CdlComplete){	/*	comannd end wait	*/
					req_data->cd_step++;
				}
printf("init\n");
			}
			break;
			
		case 1:
			CdIntToPos(req_data->sect , &loc);
			/*
			while(CdControlB(CdlPause, 0, &M_cd_status()) == 0);
			*/
printf("loc = %2x:%2x:%2x\n",loc.minute,loc.second,loc.sector);
			if(CdControl(CdlSetloc, (u_char*)&loc, &M_cd_status()) == 1){
				req_data->cd_step++;
				cd_error_count = 0;
			}else{
				cd_error_count++;
				if(cd_error_count > 0x40)	req_data->cd_step = 5;
			}
			break;
			
		case 2:
			if(CdSync(1, 0) == CdlComplete){
				if(CdRead(((int)(req_data->size+2047)/2048),
						  (u_long *)req_data->dst,
						  (u_char)CdlModeSpeed ) == 1){
printf("read start\n");
					req_data->cd_step++;
					cd_error_count = 0;
				}else{
					cd_error_count++;
					if(cd_error_count > 0x40)	req_data->cd_step = 5;
				}
			}
			break;
			
		case 3:
			if((err = CdReadSync(1, &M_cd_status())) == 0){
				req_data->status = CD_STATUS_END;
				req_data->cd_step = 0;
printf("end\n");
			} else {
				if(err == -1){
					req_data->cd_step = 5;
				}
			}
			break;
			
		case 5:
			CdControl(CdlReset,0,0);     /**/
			req_data->cd_step = 0;
		break;
		
		default:
			req_data->cd_step = 5;
			break;
	}
}

/***< function >*************************************************************/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/****************************************************************************/
/*---< function >-----------------------------------------------------------*/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/
