/***< file >*****************************************************************/
/*	Title		:	PlayStation												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	s_gsdobj.c												*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	1995.07.31												*/
/*	Note		:															*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include 		"lt_all.h"
#include		"s_gsdobj.h"


/*==========================================================================*/
/*	define																	*/
/*==========================================================================*/
static	MATRIX		tmpm;

/*==========================================================================*/
/*	Program																	*/
/*==========================================================================*/
void s_gsdobj3_coord_init(GsDOBJ3_W *);
void s_gsdobj3_model_init(GsDOBJ3_W *, u_long *);
void s_gsdobj2_coord_init(GsDOBJ2_W *);
void s_gsdobj2_model_init(GsDOBJ2_W *, u_long *, u_long);

/***< global function >******************************************************/
/*	`F		u_long	*S_gsdobj3_set(modelp, pri, type)					*/
/*	F		u_long	setfunc		:Ċ֐ڽ							*/
/*				u_long	*modelp		:ݸް߲						*/
/*				u_short	pri			:ײè								*/
/*				int		type		:									*/
/*	F		GsDOBJ3	Ă											*/
/*	ԒlF		u_long	objp		:Ăꂽ޼ު߲					*/
/****************************************************************************/
/* obj ֐̎ */
u_long	gsdobj3_func[] = {
	(u_long)O_GsSortObject3,
	(u_long)O_RotRMD_SV_FT3,
	(u_long)O_RotRMD_SV_FT3_mat,
};

/*--------------------------------------------------------------------------*/
u_long *S_gsdobj3_set(u_long setfunc, u_long *pmdp, u_short pri, int type)
{
	GsDOBJ3_W		*objp;

	if((objp = (GsDOBJ3_W *)S_obj_set((u_long)setfunc,			/* set֐ */
						(u_long)gsdobj3_func[type],				/* obj֐ */
						(int)sizeof(GsDOBJ3_W),					/* size */
						(u_short)pri)) != NULL) {				/* Dԍ */
		s_gsdobj3_coord_init(objp);
		s_gsdobj3_model_init(objp, pmdp);
	}
	return((u_long *)objp);
}

/*---< local function >-----------------------------------------------------*/
/*	`F		S_gsdobj3(objp)												*/
/*	F		GsDOBJ3_W	*objp	:޼ު߲							*/
/*	F																	*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
void S_gsdobj3(GsDOBJ3_W *objp)
{
}

/*---< local function >-----------------------------------------------------*/
/*	`F		s_gsdobj3_coord_init(objp)									*/
/*	F		GsDOBJ3_W 	*objp:	޼ު߲								*/
/*	F		GsDOBJ3ōWnĂ									*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
void s_gsdobj3_coord_init(GsDOBJ3_W *objp)
{
	GsInitCoordinate2(WORLD, &M_gs_coord(objp));		/* Wn̐ݒ */
}

/*---< local function >-----------------------------------------------------*/
/*	`F		s_gsdobj3_model_init(objp, tmdp)							*/
/*	F		GsDOBJ3_W 	*objp	:޼ު߲							*/
/*				u_long		*pmdp	:ݸް̱ڽ						*/
/*	F		޼ުĂPMDްݸ									*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
void s_gsdobj3_model_init(GsDOBJ3_W *objp, u_long *pmdp)
{
	GsLinkObject3((u_long)pmdp,
				(GsDOBJ3 *)&M_gs_gsdobj(objp));
}

/***< global function >******************************************************/
/*	`F		u_long	*S_gsdobj2_set(tmdp, pri, type, n)					*/
/*	F		u_long	*tmdp		:ݸް߲						*/
/*				u_short	pri			:ײè								*/
/*				int		type		:									*/
/*				u_long	n			:ݸ޼ުĂ̲ޯ				*/
/*	F		GsDOBJ2	Ă											*/
/*	ԒlF		u_long	objp		:Ăꂽ޼ު߲					*/
/****************************************************************************/
/* obj ֐̎ */
u_long	gsdobj2_func[] = {
	(u_long)O_GsSortObject4,
	(u_long)O_VGsSortObject4,
	(u_long)O_GsSortObject4_mat,
};

/*--------------------------------------------------------------------------*/
u_long *S_gsdobj2_set(	u_long setfunc, u_long *tmdp,
						u_short pri, int type, u_long n)
{
	GsDOBJ2_W		*objp;

	if((objp = (GsDOBJ2_W *)S_obj_set(setfunc,					/* set֐ */
						(u_long)gsdobj2_func[type],				/* obj֐ */
						(int)sizeof(GsDOBJ2_W),					/* size */
						(u_short)pri)) != NULL) {				/* Dԍ */
		s_gsdobj2_coord_init(objp);
		s_gsdobj2_model_init(objp, tmdp, n);
	}
	return((u_long *)objp);
}

/*---< local function >-----------------------------------------------------*/
/*	`F		S_gsdobj2(objp)												*/
/*	F		GsDOBJ2_W	*objp	:޼ު߲							*/
/*	F																	*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
void S_gsdobj2(GsDOBJ2_W *objp)
{
}

/*---< local function >-----------------------------------------------------*/
/*	`F		s_gsdobj2_coord_init(objp)									*/
/*	F		GsDOBJ2_W 	*objp:	޼ު߲								*/
/*	F		GsDOBJ2ōWnĂ									*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
void s_gsdobj2_coord_init(GsDOBJ2_W *objp)
{
	GsInitCoordinate2(WORLD, &M_gs_coord(objp));		/* Wn̐ݒ */
}

/*---< local function >-----------------------------------------------------*/
/*	`F		s_gsdobj2_model_init(objp, tmdp, n)							*/
/*	F		GsDOBJ2_W 	*objp	:޼ު߲							*/
/*				u_long		*tmdp	:ݸް̱ڽ						*/
/*				u_long		n		:ݸ޼ުĂ̲ޯ				*/
/*	F		޼ުĂPMDްݸ									*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
void s_gsdobj2_model_init(GsDOBJ2_W *objp, u_long *tmdp, u_long n)
{
	tmdp++;										/* ̧ͯނ𽷯 */
	GsMapModelingData(tmdp);					/* ڽϯ */
	tmdp++;										/* ׸ޓǂݔ΂ */
	tmdp++;										/* ޼ުČǂݔ΂ */
	
	GsLinkObject4((u_long)tmdp,
				(GsDOBJ2 *)&M_gs_gsdobj(objp), n);
}


/*---< function >-----------------------------------------------------------*/
/*	`F		s_set_coordinate(GsDOBJ_W *objp)							*/
/*	F		GsDOBJ_W 		*objp	:޼ު߲						*/
/*	F		دvZܰد쐬WnɾĂ				*/
/*	ԂlF	Ȃ														*/
/*--------------------------------------------------------------------------*/
void s_set_coordinate(GsDOBJ_W *objp)
{
	/*-------------------------------------------- Pʍs񂩂vZ͂ */
	tmpm	= GsIDMATRIX;

	/*-------------------------------------------------- WlZbg */
	tmpm.t[0] = objp->x;
	tmpm.t[1] = objp->y;
	tmpm.t[2] = objp->z;

	/*------------------------------------------------- ]دĂ */
	RotMatrix(&(objp->angle), &tmpm);			/* دvZ */
	M_gs_coord_coord(objp) = tmpm;				/* دWnɾ */
	M_gs_coord_flg(objp) = 0;			/* ̂߂̷ׯ */
}


/***< global function >******************************************************/
/*	`F		O_GsSortObject3(objp)										*/
/*	F		GsDOBJ3_W	*objp:޼ު߲								*/
/*	F		دvZ													*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void O_GsSortObject3(GsDOBJ3_W *objp)
{
	PushMatrix();										 	 /* د PUSH */

	GsGetLs(&M_gs_coord(objp),&tmpm);		/* ذ/۰دvZ */
	GsSetLightMatrix(&tmpm);				/* ײدGTEɾĂ */
	GsSetLsMatrix(&tmpm);					/* ذ/۰دGTEɾĂ*/

	if( M_state_ot(objp) == KUGI_OT ){
		GsSortObject3((GsDOBJ3 *)&M_gs_gsdobj(objp),
					(GsOT *)&Wot[M_state_ot(objp)][M_activebuff()],
					14-OT3_LENGTH);
	}
	else{
		GsSortObject3((GsDOBJ3 *)&M_gs_gsdobj(objp),
					(GsOT *)&Wot[M_state_ot(objp)][M_activebuff()],
					14-OT_LENGTH);
	}
	PopMatrix();										 	 /* د PUSH */
}

/***< global function >******************************************************/
/*	`F		O_GsSortObject4(objp)										*/
/*	F		GsDOBJ2_W	*objp:޼ު߲								*/
/*	F		دvZ													*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void O_GsSortObject4(GsDOBJ2_W *objp)
{
#if 0
	s_set_coordinate((GsDOBJ_W *)objp);		/* W̺ިȰ */

	PushMatrix();										 	 /* د PUSH */
	GsGetLs(&M_gs_coord(objp),&tmpm);		/* ذ/۰دvZ */
	GsSetLightMatrix(&tmpm);				/* ײدGTEɾĂ */
	GsSetLsMatrix(&tmpm);					/* ذ/۰دGTEɾĂ*/
	if( M_state_ot(objp) == KUGI_OT ){
		GsSortObject4((GsDOBJ2 *)&M_gs_gsdobj(objp),
					(GsOT *)&Wot[M_state_ot(objp)][M_activebuff()],
					14-OT3_LENGTH,
					getScratchAddr(0));
	}
	else{
		GsSortObject4((GsDOBJ2 *)&M_gs_gsdobj(objp),
					(GsOT *)&Wot[M_state_ot(objp)][M_activebuff()],
					14-OT_LENGTH,
					getScratchAddr(0));
	}
	PopMatrix();										 	 /* د PUSH */
#else
	if( M_state_ot(objp) == KUGI_OT ){
		GsSortObject4((GsDOBJ2 *)&M_gs_gsdobj(objp),
					(GsOT *)&Wot[M_state_ot(objp)][M_activebuff()],
					14-OT3_LENGTH,
					getScratchAddr(0));
	}
	else{
		GsSortObject4((GsDOBJ2 *)&M_gs_gsdobj(objp),
					(GsOT *)&Wot[M_state_ot(objp)][M_activebuff()],
					14-OT_LENGTH,
					getScratchAddr(0));
	}
#endif
}

void O_GsSortObject4_mat(GsDOBJ2_W *objp)
{
	s_set_coordinate((GsDOBJ_W *)objp);		/* W̺ިȰ */

	PushMatrix();										 	 /* د PUSH */
	GsGetLs(&M_gs_coord(objp),&tmpm);		/* ذ/۰دvZ */
	/*GsSetLightMatrix(&tmpm);*/				/* ײدGTEɾĂ */
	GsSetLsMatrix(&tmpm);					/* ذ/۰دGTEɾĂ*/
	if( M_state_ot(objp) == KUGI_OT ){
		GsSortObject4((GsDOBJ2 *)&M_gs_gsdobj(objp),
					(GsOT *)&Wot[M_state_ot(objp)][M_activebuff()],
					14-OT3_LENGTH,
					getScratchAddr(0));
	}
	else{
		GsSortObject4((GsDOBJ2 *)&M_gs_gsdobj(objp),
					(GsOT *)&Wot[M_state_ot(objp)][M_activebuff()],
					14-OT_LENGTH,
					getScratchAddr(0));
	}
	PopMatrix();										 	 /* د PUSH */
}

/***< global function >******************************************************/
/*	`F		O_VGsSortObject4(objp)										*/
/*	F		GsDOBJ2_W	*objp:޼ު߲								*/
/*	F		دvZ													*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void O_VGsSortObject4(GsDOBJ2_W *objp)
{
	GsGetLs(&M_gs_coord(objp),&tmpm);		/* ذ/۰دvZ */
	GsSetLightMatrix(&tmpm);				/* ײدGTEɾĂ */
	GsSetLsMatrix(&tmpm);					/* ذ/۰دGTEɾĂ*/
	if( M_state_ot(objp) == KUGI_OT ){
		GsSortObject4((GsDOBJ2 *)&M_gs_gsdobj(objp),
					(GsOT *)&Wot[M_state_ot(objp)][M_activebuff()],
					14-OT3_LENGTH,
					getScratchAddr(0));
	}
	else{
		GsSortObject4((GsDOBJ2 *)&M_gs_gsdobj(objp),
					(GsOT *)&Wot[M_state_ot(objp)][M_activebuff()],
					14-OT_LENGTH,
					getScratchAddr(0));
	}
}

/***< global function >******************************************************/
/*	`F		O_RotRMD_SV_FT3(objp)									*/
/*	F		GsDOBJ3_W	*objp:޼ު߲								*/
/*	F		دvZ													*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void O_RotRMD_SV_FT3_mat(GsDOBJ3_W *objp)
{
	GsDOBJ3		*gsdobj;
	u_long		*pmdp;
	u_long		offset;
	u_long		offset1;

	s_set_coordinate((GsDOBJ_W*)objp);

	PushMatrix();										 	 /* د PUSH */
	GsGetLs(&M_gs_coord(objp),&tmpm);		/* ذ/۰دvZ */
	GsSetLsMatrix(&tmpm);					/* ذ/۰دGTEɾĂ*/

	gsdobj = (GsDOBJ3 *)&M_gs_gsdobj(objp);
	pmdp = (u_long *)gsdobj->pmd;
	offset = (u_long)((*(pmdp+1))/4);
	offset1 = (u_long)((*(pmdp+2))/4);

	if(objp->gsdobj.attribute>>31==0)
	{
	
		if( M_state_ot(objp) == KUGI_OT ){
			RotRMD_SV_FT3(	(long *)(pmdp+offset),	/* PRIMITIVE Gp擪ڽ */
				(long *)(pmdp+offset1),	/* VERTEX Gp擪ڽ */
				(u_long *)Wot[M_state_ot(objp)][M_activebuff()].org,
				OT3_LENGTH,			/* OT̒(ޯĒ) */
				M_activebuff());					/* ޯ̧ID */
		}
		else{
			RotRMD_SV_FT3(	(long *)(pmdp+offset),	/* PRIMITIVE Gp擪ڽ */
				(long *)(pmdp+offset1),	/* VERTEX Gp擪ڽ */
				(u_long *)Wot[M_state_ot(objp)][M_activebuff()].org,
				OT_LENGTH,			/* OT̒(ޯĒ) */
				M_activebuff());					/* ޯ̧ID */
		}
	}
	
	PopMatrix();										 	 /* د PUSH */

}
void O_RotRMD_SV_FT3(GsDOBJ3_W *objp)
{
	GsDOBJ3		*gsdobj;
	u_long		*pmdp;
	u_long		offset;
	u_long		offset1;

	gsdobj = (GsDOBJ3 *)&M_gs_gsdobj(objp);
	pmdp = (u_long *)gsdobj->pmd;
	offset = (u_long)((*(pmdp+1))/4);
	offset1 = (u_long)((*(pmdp+2))/4);

	if( M_state_ot(objp) == KUGI_OT ){
		RotRMD_SV_FT3(	(long *)(pmdp+offset),	/* PRIMITIVE Gp擪ڽ */
				(long *)(pmdp+offset1),	/* VERTEX Gp擪ڽ */
				(u_long *)Wot[M_state_ot(objp)][M_activebuff()].org,
				OT3_LENGTH,			/* OT̒(ޯĒ) */
				M_activebuff());					/* ޯ̧ID */
	}
	else{
		RotRMD_SV_FT3(	(long *)(pmdp+offset),	/* PRIMITIVE Gp擪ڽ */
				(long *)(pmdp+offset1),	/* VERTEX Gp擪ڽ */
				(u_long *)Wot[M_state_ot(objp)][M_activebuff()].org,
				OT_LENGTH,			/* OT̒(ޯĒ) */
				M_activebuff());					/* ޯ̧ID */
	}

}

/***< global function >******************************************************/
/*	`F		S_pmd_gte_set												*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/****************************************************************************/



/***< global function >******************************************************/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/****************************************************************************/

/*---< local function >-----------------------------------------------------*/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/

