/***< file >*****************************************************************/
/*	Title		:	PS-X System												*/
/*	Version		:	1.00													*/
/*	Code		:	pachinko												*/
/*	Filename	:	s_1.c													*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	04/20/1995												*/
/*	Note		:	C													*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include 		"lt_all.h"
#include 		"s_init.h"
#include		"s_string.h"
#include		"s_item.h"
#include		"s_itemt.h"

/*==========================================================================*/
/*	define																	*/
/*==========================================================================*/

/*==========================================================================*/
/*	Program																	*/
/*==========================================================================*/
void initSystem(void);

/***< function >*************************************************************/
/*	`F	S_cold_reset_init()												*/
/*	F																	*/
/*	F	d̏												*/
/*	ԒlF																	*/
/****************************************************************************/
void S_cold_reset_init( void )
{
    CdInit();					/* CD-ROM VXȅ */
	PadInit( 0 );				/* ۰ׂ̏ */
	ChangeClearPAD(0);
	ResetGraph(0);				/* GPUZbg */

	/*--------------------------------------------------- ޼ުܰ̏ */
	S_obj_init();

	SD_start_up();

	SetMem(2);
	S_sys_w->sound_st_mn = 0;

	srand( 1 );
}


/***< function >*************************************************************/
/*	`F	S_warm_reset_init()												*/
/*	F																	*/
/*	F	\tgEGA[Zbg̏								*/
/*	ԒlF																	*/
/****************************************************************************/
void S_warm_reset_init(void)
{
	RECT 				rect;
	MATRIX 				tmp;
	VECTOR				trans;						/* ʒu */
	SVECTOR				angle;						/* ]p */
	VECTOR				scale;						/* ق̒ */

	initSystem();		/* т̏ */

	tmp   = GsIDMATRIX;							/* Pʍs񂩂o */

	setVector(&trans, 0,  0,  0);
	setVector(&angle, 0,  0,  0);
	setVector(&scale, ONE*(M_graph_x_res()/M_graph_y_res()), ONE, ONE);

	RotMatrix(&angle, &tmp);					/* ] */
	TransMatrix(&tmp, &trans);					/* sړ */
	ScaleMatrixL(&tmp, &scale);					/* g嗦 */
	SetTransMatrix(&tmp);						/* sړ޸ِݒ菉 */
	SetRotMatrix(&tmp);							/* ]دݒ菉 */

	/* ʸر */
	rect.x =    0;
	rect.y =    0;
	rect.w = 1023;
	rect.h = 511;
	ClearImage(&rect,0x0,0x0,0x0);

	/*--------------------------------------------------- ޼ުܰ̏ */
	S_obj_init();

	/*------------------------------------------------- ݸ߲̏ */
	S_string_init();

	S_item_syoribou_init();
	M_item_flag() |= SYORIBOU_F;
	S_sys_w->obj_use_max = 0;
	S_sys_w->max_obj_adr = (u_long)&obj_w;

}

/***< function >*************************************************************/
/*	`F	initSystem()													*/
/*	F																	*/
/*	F	VXe													*/
/*	ԒlF																	*/
/****************************************************************************/
void initSystem(void)
{
	int		i;

	ResetGraph(1); /*...................... Oڰт̕`I */

	/*--------------------------------------------------------- ܰر */
	bzero((char *)S_sys_w,(long)(sizeof(SYS_W)));
	bzero((char *)S_sys0_w,(long)(sizeof(SYS0_W)));
	bzero((char *)&obj_w,sizeof(obj_w));

	S_sys_w->vsync_no = 1;

	SetGraphDebug(0);				/* ޸ق̐ݒ */

	M_joy_id() = PadInit(0);		/* ۰ׂAڑԂۑ */
	ChangeClearPAD(0);
	
	S_disp_sys_init(512, 240);		/* ̨т̏ */
	GsInit3D();						/* 3Dײ؂̏ */

	/* OT̏ */
	for( i=0; i<OT_NUMBER; i++ ){
		if( i == KUGI_OT ){
			Wot[i][0].length = OT3_LENGTH;	/* ޯݸ޽ */
			Wot[i][0].org = (GsOT_TAG *)OT3Tags[0];	/* OT ̐擪ڽ */
			Wot[i][1].length = OT3_LENGTH;	/* ޯݸ޽ */
			Wot[i][1].org = (GsOT_TAG *)OT3Tags[1];	/* OT ̐擪ڽ */
		}
		else{
			Wot[i][0].length = OT_LENGTH;	/* ޯݸ޽ */
			Wot[i][0].org = (GsOT_TAG *)OTTags[i][0];	/* OT ̐擪ڽ */
			Wot[i][1].length = OT_LENGTH;	/* ޯݸ޽ */
			Wot[i][1].org = (GsOT_TAG *)OTTags[i][1];	/* OT ̐擪ڽ */
		}

		Mot[i][0].length = MOT_LENGTH;	/* ޯݸ޽ */
		Mot[i][0].org = (GsOT_TAG *)MOTTags[i][0];		/* OT ̐擪ڽ */
		Mot[i][1].length = MOT_LENGTH;	/* ޯݸ޽ */
		Mot[i][1].org = (GsOT_TAG *)MOTTags[i][1];		/* OT ̐擪ڽ */
	}

	GsSetDrawBuffOffset();		/* `̾Ă̐ݒ */
	ResetGraph(0);		/* GPUZbg */
}

/***< global function >******************************************************/
/*	`F		S_disp_sys_init(x, y)										*/
/*	F		int		x:𑜓x										*/
/*				int		y:𑜓x										*/
/*	F		̨\т̏										*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void S_disp_sys_init(int x, int y)
{
	RECT	clp;

	M_graph_x_res() = x;
	M_graph_y_res() = y;
	GsInitGraph( M_graph_x_res(),
				 M_graph_y_res(),
				 4, 1, 0);				/* ׯ̨т̏ */
										/* GsDISPENV,GsDRAWENVɂďԂ	*/
										/* m邱ƂłB				*/

	/*---------------------------------------------------- ޯ̧̒` */
	M_disp_buff_cx(0) = M_disp_buff_x(0) = 0;	/* ޯ̧ݒWۑ */
	M_disp_buff_cy(0) = M_disp_buff_y(0) = 0;
	M_disp_buff_cx(1) = M_disp_buff_x(1) = 0;
	M_disp_buff_cy(1) = M_disp_buff_y(1) = (&GsDISPENV)->disp.h;
	GsDefDispBuff(M_disp_buff_x(0), M_disp_buff_y(0),
				  M_disp_buff_x(1), M_disp_buff_y(1));	/* ޯ̧̒` */

	/*-------------------------------------------------- ިڲ̸دݸ */
#if 1
	clp.x = 0;
	clp.y = 0x08*2;
	clp.w = M_graph_x_res();
	clp.h = M_graph_y_res()-0x08*4+2;
	GsSetClip2D(&clp);
#endif
}

/***< global function >******************************************************/
/*	`F		S_disp_sys_push()											*/
/*	F		Ȃ														*/
/*	F		̨ъpush									*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void S_disp_sys_push(void)
{
	M_graph_xy_push();
}

/***< global function >******************************************************/
/*	`F		S_disp_sys_pop()											*/
/*	F		Ȃ														*/
/*	F		̨ъpop									*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void S_disp_sys_pop(void)
{
	M_graph_xy_pop();
	S_disp_sys_change(M_graph_x_res(), M_graph_y_res());
}

/***< global function >******************************************************/
/*	`F		S_disp_sys_change(x, y)										*/
/*	F		int		x:𑜓x										*/
/*				int		y:𑜓x										*/
/*	F		̨тύX										*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void S_disp_sys_change(int x, int y)
{
	RECT	clp;
	RECT 	rect;

	ResetGraph(1); /*...................... Oڰт̕`I */

	rect.x =    0;
	rect.y =    0;
	rect.w = x;
	rect.h = y;
	ClearImage(&rect,0x0,0x0,0x0);

	M_graph_x_res() = x;
	M_graph_y_res() = y;
	GsInitGraph( M_graph_x_res(),
				 M_graph_y_res(),
				 4, 1, 0);				/* ׯ̨т̏ */
										/* GsDISPENV,GsDRAWENVɂďԂ	*/
										/* m邱ƂłB				*/

	/*---------------------------------------------------- ޯ̧̒` */
	M_disp_buff_cx(0) = M_disp_buff_x(0) = 0;	/* ޯ̧ݒWۑ */
	M_disp_buff_cy(0) = M_disp_buff_y(0) = 0;
	M_disp_buff_cx(1) = M_disp_buff_x(1) = 0;
	M_disp_buff_cy(1) = M_disp_buff_y(1) = (&GsDISPENV)->disp.h;
	GsDefDispBuff(M_disp_buff_x(0), M_disp_buff_y(0),
				  M_disp_buff_x(1), M_disp_buff_y(1));	/* ޯ̧̒` */

	/*---------------------------------------------------- ذ̵݂̾Ĉʒu */
	M_screen_offsetx() = 0;
	M_screen_offsety() = 0;
	SetGeomOffset(M_screen_offsetx(), M_screen_offsety());

	/*-------------------------------------------------- ިڲ̸دݸ */
	clp.x = 0;
	clp.y = 0x08*2;
	clp.w = M_graph_x_res();
	clp.h = M_graph_y_res()-0x08*4;
	GsSetClip2D(&clp);
	GsInit3D();						/* 3Dײ؂̏ */
	GsSetDrawBuffOffset();		/* `̾Ă̐ݒ */
	ResetGraph(0);		/* GPUZbg */

#ifndef PRINT
	S_sony_print_init();
#endif

	 S_item_syoribou_init();
	
}

/***< global function >******************************************************/
/*	`F		S_sony_print_init()											*/
/*	F		Ȃ														*/
/*	F		ư̫Ă̐ݒ̏									*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
#ifndef PRINT
void S_sony_print_init(void)
{
	FntLoad(960,256);					/* ޸ޗp̫ް̓ǂݍ */
  	SetDumpFnt(FntOpen(	16-M_graph_x_res()/2,
  						16-M_graph_y_res()/2,
  						M_graph_x_res(),
  						M_graph_y_res(),
  						0,M_graph_x_res()-16));
}
#endif

void S_clear_ot()
{
	int		i;

	GsClearOt(0, 0, &Wot[0][M_activebuff()]);			/* OTر */
	GsClearOt(0, OTSIZE-2, &Mot[0][M_activebuff()]);			/* OTر */

	for( i=1; i<OT_NUMBER; i++ ){
/*		GsClearOt(0,1,&Wot[i][M_activebuff()]);*/
		GsClearOt(0,0,&Wot[i][M_activebuff()]);
		GsClearOt(0,0,&Mot[i][M_activebuff()]);
	}
}


void S_sort_ot()
{
	int		i;

	GsSortOt(&Mot[0][M_activebuff()],&Wot[0][M_activebuff()]);

	for( i=1; i<OT_NUMBER; i++ ){
		GsSortOt(&Wot[i][M_activebuff()],&Wot[i-1][M_activebuff()]);
		GsSortOt(&Mot[i][M_activebuff()],&Mot[i-1][M_activebuff()]);
	}
}


/***< global function >******************************************************/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/****************************************************************************/
/*---< local function >-----------------------------------------------------*/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/


