/***< file >*****************************************************************/
/*	Title		:	PS-X System												*/
/*	Version		:	1.00													*/
/*	Code		:	pachinko												*/
/*	Filename	:	s_io.c													*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	04/11/1995												*/
/*	Note		:	hnɊւ֐										*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include	"lt_all.h"
#include 	"s_io.h"

static void check_pad(void);

/***< function >*************************************************************/
/*	`F	S_pad_read()													*/
/*	F	Ȃ															*/
/*	F	Rg[̓ǂݍ											*/
/*			PadRead()ź۰ׂ̏Ԃǂݍ񂾏ꍇAܰނ 1۰ׂ̓	*/
/*			eۑAܰނ 2۰ׂ̓eۑĂB		*/
/*	ԒlFȂ																*/
/*****************************************************************************/
void S_pad_read()
{
	long	joyw1, joyw2;					/* l۰גlܰݸް */

	joyw1 = joyw2 = PadRead(M_joy_id());

	joyw1 &= 0x0000ffff;
	joyw2 = (joyw2 & 0xffff0000) >> 16;

	M_joy_old(0) = M_joy_new(0);
	M_joy_new(0) = joyw1;
	M_joy_trg(0) = (~M_joy_old(0)) & M_joy_new(0);
	M_joy_ntrg(0) = (~M_joy_new(0)) & M_joy_old(0);

	M_joy_old(1) = M_joy_new(1);
	M_joy_new(1) = joyw2;
	M_joy_trg(1) = (~M_joy_old(1)) & M_joy_new(1);
	M_joy_ntrg(1) = (~M_joy_new(1)) & M_joy_old(1);

	check_pad();
	
}

/***< function >*************************************************************/
/*	`F	S_line_rc_resrt()												*/
/*	F																	*/
/*	F A  ٰĶ ؾ											*/
/*	ԒlF																	*/
/****************************************************************************/
void S_line_rc_reset()
{
	ResetRCnt(RCntCNT1);
}

/***< function >*************************************************************/
/*	`F	S_line_rc_get()													*/
/*	F																	*/
/*	F	AٰĶ̕ۑ											*/
/*	ԒlF																	*/
/****************************************************************************/
void S_line_rc_get()
{
	if ((M_pause_fg() == OFF) | (M_joy_trg(0) == PADstart)){
		M_line_rc() = GetRCnt(RCntCNT1);
	}
}


/***< function >*************************************************************/
/*	`F	S_buffer_offset()												*/
/*	F																	*/
/*	F	ޯ̧̓eݒ̈ʒuɖ߂								*/
/*	ԒlF																	*/
/****************************************************************************/
void S_buffer_offset()
{
	GsDefDispBuff(M_disp_buff_x(0), M_disp_buff_y(0),
				  M_disp_buff_x(1), M_disp_buff_y(1));
}

/***< function >*************************************************************/
/*	`F	S_buffer_check()												*/
/*	F																	*/
/*	F	ޯ̧̓e											*/
/*	ԒlF																	*/
/****************************************************************************/
#define	CHECK_SPEED	0x08

void S_buffer_check()
{
	/* ޯ̧ */
	if( M_disp_buff_flug() == ON) 
	{
		if( M_joy_new(1) & PADLleft ) {
			M_disp_buff_cx(0) -= CHECK_SPEED;
		}
		if( M_joy_new(1) & PADLright ) {
			M_disp_buff_cx(0) += CHECK_SPEED;
		}
		if( M_joy_new(1) & PADLup ) {
			M_disp_buff_cy(0) -= CHECK_SPEED;
		}
		if( M_joy_new(1) & PADLdown ) {
			M_disp_buff_cy(0) += CHECK_SPEED;
		}

		limitRange(M_disp_buff_cx(0),0,1024-M_graph_x_res());
		limitRange(M_disp_buff_cy(0),0, 512-M_graph_y_res());

		/* ڰޯ̧̒` */
		GsDefDispBuff(M_disp_buff_cx(0), M_disp_buff_cy(0),
				  M_disp_buff_cx(0), M_disp_buff_cy(0)+M_graph_y_res());
		GsSwapDispBuff();
	}
	else {
		M_disp_buff_cx(0) = M_disp_buff_x(0) = 0;
		M_disp_buff_cy(0) = M_disp_buff_y(0) = 0;
		M_disp_buff_cx(1) = M_disp_buff_x(1) = 0;
		M_disp_buff_cy(1) = M_disp_buff_y(1) = M_graph_y_res();
	}

	/* ޯ̧׸ނ */
	if(M_joy_new(1) == PADselect) {
		if(M_activebuff() == 0) {
			if(M_disp_buff_flug() == OFF) {
				M_disp_buff_flug() = ON;
				M_pause_fg_ON();
			}
		}
	}

	if(M_joy_trg(1) == PADR1) {
		if(M_disp_buff_flug() == ON) {
			M_disp_buff_flug() = OFF;
			M_pause_fg_OFF();
			M_joy_trg(0) = OFF;
		}
	}
}

#define	N_PADWAIT	15			/* ڂ̓͂鶳 */
#define	N_WAIT		4			/* ̫Ă̳Ķ */
#define	NO_WAIT		15			/* ĂȂtO */

static void check_pad(void)
{
	short counter;
	short wait_count = N_WAIT;
	
/*	wait_count = (S_sys_w->pad_w[0].counter==0) ? 
					wait_count:S_sys_w->pad_w[0].counter;
	wait_count = (S_sys_w->pad_w[0].counter==NO_WAIT) ? 0:wait_count;*/
	
	
	for (counter = 0; counter < 2; counter++){
	
	if(M_joy_old(counter) & M_joy_new(counter) & PADLleft) {
		if (S_sys_w->pad_w[counter].pad_l_left != N_PADWAIT) {
			S_sys_w->pad_w[counter].pad_l_left ++;
		} else {
			S_sys_w->pad_w[counter].pad_l_left_flag = (S_sys_w->pad_w[counter].counter == wait_count) ? ON : OFF;
		}
	} else {
		S_sys_w->pad_w[counter].pad_l_left = 0;
		S_sys_w->pad_w[counter].pad_l_left_flag = OFF;
	}
	if(M_joy_old(counter) & M_joy_new(counter) & PADLright) {
		if (S_sys_w->pad_w[counter].pad_l_right != N_PADWAIT) {
			S_sys_w->pad_w[counter].pad_l_right ++;
		} else {
			S_sys_w->pad_w[counter].pad_l_right_flag = (S_sys_w->pad_w[counter].counter == wait_count) ? ON : OFF;
		}
	} else {
		S_sys_w->pad_w[counter].pad_l_right = 0;
		S_sys_w->pad_w[counter].pad_l_right_flag = OFF;
	}
	
	if(M_joy_old(counter) & M_joy_new(counter) & PADLup) {
		if (S_sys_w->pad_w[counter].pad_l_up != N_PADWAIT) {
			S_sys_w->pad_w[counter].pad_l_up ++;
		} else {
			S_sys_w->pad_w[counter].pad_l_up_flag = (S_sys_w->pad_w[counter].counter == wait_count) ? ON : OFF;
		}
	} else {
		S_sys_w->pad_w[counter].pad_l_up = 0;
		S_sys_w->pad_w[counter].pad_l_up_flag = OFF;
	}

	if(M_joy_old(counter) & M_joy_new(counter) & PADLdown) {
		if (S_sys_w->pad_w[counter].pad_l_down != N_PADWAIT) {
			S_sys_w->pad_w[counter].pad_l_down ++;
		} else {
			S_sys_w->pad_w[counter].pad_l_down_flag = (S_sys_w->pad_w[counter].counter == wait_count) ? ON : OFF;
		}
	} else {
		S_sys_w->pad_w[counter].pad_l_down = 0;
		S_sys_w->pad_w[counter].pad_l_down_flag = OFF;
	}


	if(M_joy_old(counter) & M_joy_new(counter) & PADL1) {
		if (S_sys_w->pad_w[counter].pad_L1 != N_PADWAIT) {
			S_sys_w->pad_w[counter].pad_L1 ++;
		} else {
			S_sys_w->pad_w[counter].pad_L1_flag = (S_sys_w->pad_w[counter].counter == wait_count) ? ON : OFF;
		}
	} else {
		S_sys_w->pad_w[counter].pad_L1 = 0;
		S_sys_w->pad_w[counter].pad_L1_flag = OFF;
	}

	if(M_joy_old(counter) & M_joy_new(counter) & PADR1) {
		if (S_sys_w->pad_w[counter].pad_R1 != N_PADWAIT) {
			S_sys_w->pad_w[counter].pad_R1 ++;
		} else {
			S_sys_w->pad_w[counter].pad_R1_flag = (S_sys_w->pad_w[counter].counter == wait_count) ? ON : OFF;
		}
	} else {
		S_sys_w->pad_w[counter].pad_R1 = 0;
		S_sys_w->pad_w[counter].pad_R1_flag = OFF;
	}
	

	if(M_joy_old(counter) & M_joy_new(counter) & PADL2) {
		if (S_sys_w->pad_w[counter].pad_L2 != N_PADWAIT) {
			S_sys_w->pad_w[counter].pad_L2 ++;
		} else {
			S_sys_w->pad_w[counter].pad_L2_flag = (S_sys_w->pad_w[counter].counter == wait_count) ? ON : OFF;
		}
	} else {
		S_sys_w->pad_w[counter].pad_L2 = 0;
		S_sys_w->pad_w[counter].pad_L2_flag = OFF;
	}

	if(M_joy_old(counter) & M_joy_new(counter) & PADR2) {
		if (S_sys_w->pad_w[counter].pad_R2 != N_PADWAIT) {
			S_sys_w->pad_w[counter].pad_R2 ++;
		} else {
			S_sys_w->pad_w[counter].pad_R2_flag = (S_sys_w->pad_w[counter].counter == wait_count) ? ON : OFF;
		}
	} else {
		S_sys_w->pad_w[counter].pad_R2 = 0;
		S_sys_w->pad_w[counter].pad_R2_flag = OFF;
	}
	
		if (S_sys_w->pad_w[counter].counter == wait_count) {
			S_sys_w->pad_w[counter].counter = 0;
		} else {
			S_sys_w->pad_w[counter].counter++;
		}
				
	}
	
}

/***< function >*************************************************************/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/****************************************************************************/

