/***< file >*****************************************************************/
/*	Title		:	PlayStation												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	s_obj.c													*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	1995.06.20												*/
/*	Note		:	޼ުܰرǗ֐Q							*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include 		<stdio.h>

#include 		"lt_all.h"
#include		"s_obj.h"
#include		"s_string.h"

/*==========================================================================*/
/*	define																	*/
/*==========================================================================*/
/*==========================================================================*/
/*	Program																	*/
/*==========================================================================*/
static void s_obj_rmque( struct OBJ_QUEUE_HEAD *rmdata );
static void s_obj_ins_empty( struct OBJ_QUEUE_HEAD *data, int size );
static void s_obj_sort();
static int s_obj_search_movep( struct OBJ_QUEUE_HEAD **data, struct OBJ_QUEUE_HEAD **movep );
static void s_obj_memcpy( u_long *dst, u_long *src, int size );
static struct OBJ_QUEUE_HEAD *s_obj_search_empty( int size );
static void s_obj_free(struct OBJ_QUEUE_HEAD *objp);

/***< global function >******************************************************/
/*	`F		S_obj_init()												*/
/*	F		Ȃ														*/
/*	F		obj_w ر̏											*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void S_obj_init(void)
{
	int		i;

	bzero((char *)&obj_w,sizeof(obj_w));

	for( i=0; i<OBJW_PRI_NUM+1; i++ ){
		obj_w.objw_que_head[i].prev = obj_w.objw_que_head[i].next
									= &obj_w.objw_que_head[i];
	}

	obj_w.objw_empty_head.prev = obj_w.objw_empty_head.next
								= (struct OBJ_QUEUE_HEAD *)&obj_w.objw_area[0];

	((struct OBJ_QUEUE_HEAD *)&obj_w.objw_area[0])->size = sizeof(obj_w.objw_area);
	((struct OBJ_QUEUE_HEAD *)&obj_w.objw_area[0])->prev =
	((struct OBJ_QUEUE_HEAD *)&obj_w.objw_area[0])->next =
									&(obj_w.objw_empty_head);
}

/***< global function >******************************************************/
/*	`F		u_long *S_ObjSet(func, objfunc, size, pri)					*/
/*	F		u_long		func	:Ă֐							*/
/*				u_long		objfunc	:gpobj֐						*/
/*				u_long		size	:gp̻ܰ							*/
/*				int			pri		:ײè								*/
/*	F		size ́Agp޼ު̻ܰނĂB		*/
/*				size  4 ̔{łȂꍇ͕␳܂B					*/
/*				pri ́A̗Dݒ肷邽߂̂̂łB				*/
/*				ݒԍ 0 - 256 ͈̔͂łB								*/
/*				̏Ԃ́A0,1,2,...15 ƂȂĂ܂B					*/
/*				D悪ꍇ́AĂꂽԂŏ܂				*/
/*	ԒlF		u_long		objp	:mۂر̐擪ڽ					*/
/*									:mۂłȂꍇ O					*/
/****************************************************************************/
u_long *S_ObjSet(u_long func, u_long objfunc, u_long size, int pri)
{
	OBJ_W_HEAD	*headp;

	/*-------------------------------------------------------- ײè */
	if((pri > OBJW_PRI_NUM)||(pri < 0)) {						/*  */
		return(0);												/* s */
	}

	if( (headp = (OBJ_W_HEAD *)S_obj_malloc( size )) == NULL ){
		SFntPrint(80, 180, 0, 0, "malloc error : s_obj_set");
		return(0);
	}

	S_obj_insque( &obj_w.objw_que_head[pri], &(headp->queue) );

	/*--------------------------------------------------------- s֐ */
	headp->objfunc = objfunc;
	headp->func = func;

	return((u_long *)headp);								/*  */
}

/***< global function >******************************************************/
/*	`F		S_obj_clear(objp)											*/
/*	F		u_long	*objp	:޼ު߲ܰ							*/
/*	F		w肵޼ު̴ܰرر							*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void S_obj_clear(u_long *objp)
{
	((OBJ_W_HEAD *)objp)->objfunc = NULL;
}

static void s_obj_free(struct OBJ_QUEUE_HEAD *objp)
{
	s_obj_rmque( objp );
	s_obj_ins_empty( objp, objp->size );

}


/***< global function >******************************************************/
/*	`F		S_obj_sys()													*/
/*	F		Ȃ														*/
/*	F		Object System Driver										*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void S_obj_sys(void)
{
	OBJ_W_HEAD *obj_head;
	OBJ_W_HEAD *head_buff;
	int		i;
int obj_num=0;

	if (M_pause_fg() == OFF){
		for( i=0; i<OBJW_PRI_NUM; i++ ){
			for( obj_head = (OBJ_W_HEAD *)obj_w.objw_que_head[i].next;
					obj_head != (OBJ_W_HEAD *)&obj_w.objw_que_head[i];
					obj_head = (OBJ_W_HEAD *)(obj_head->queue.next) ){
obj_num++;
				if( (function = (void *)obj_head->func) != NULL ){
/*printf( "sf=%08x\n", function );*/
					(*function)((u_long *)obj_head);				/* ֐ */
/*printf( "E\n" );*/
				}
			}
		}
	}
NFntPrint("OBJ NUM=%d\n", obj_num );

	for( i=0; i<OBJW_PRI_NUM; i++ ){
		for( obj_head = (OBJ_W_HEAD *)obj_w.objw_que_head[i].next;
				obj_head != (OBJ_W_HEAD *)&obj_w.objw_que_head[i];
				obj_head = (OBJ_W_HEAD *)(obj_head->queue.next) ){

			if( (function = (void *)obj_head->objfunc) != NULL ){
/*printf( "of=%08x\n", function );*/
				(*function)((u_long *)obj_head);			/* ޼ު֐ */
/*printf( "E\n" );*/
			}
			else{
				head_buff = (OBJ_W_HEAD *)(obj_head->queue).prev;
				s_obj_free(&(obj_head->queue));
				obj_head = head_buff;
			}
		}
	}
S_print_unuseobj();
}


								/* queueɓo^			*/
void S_obj_insque( struct OBJ_QUEUE_HEAD *prevdata, struct OBJ_QUEUE_HEAD *insdata )
{
	insdata->next = prevdata->next;
	insdata->prev = prevdata;
	prevdata->next = insdata;
	(insdata->next)->prev = insdata;
}

								/* queue폜			*/
static void s_obj_rmque( struct OBJ_QUEUE_HEAD *rmdata )
{
	(rmdata->next)->prev = rmdata->prev;
	(rmdata->prev)->next = rmdata->next;
}

								/* f[^queueɓo^			*/
static void s_obj_ins_empty( struct OBJ_QUEUE_HEAD *data, int size )
{
	struct OBJ_QUEUE_HEAD *headp;

	data->size = size;

	for( headp = obj_w.objw_empty_head.next;
			headp != &obj_w.objw_empty_head; headp = headp->next ){
		if( (u_long)headp + headp->size == (u_long)data ){
			s_obj_rmque( headp );
			headp->size += data->size;
			data = headp;
		}
		else if( (u_long)data + data->size == (u_long)headp ){
			s_obj_rmque( headp );
			data->size += headp->size;
		}
	}

	S_obj_insque( &obj_w.objw_empty_head, data );
}

								/* ޼ު̗ܰ̈œK	*/
static void s_obj_sort()
{
	struct OBJ_QUEUE_HEAD *headp;
	struct OBJ_QUEUE_HEAD *movep;
	struct OBJ_QUEUE_HEAD *work;
	int		size_work;

	while( s_obj_search_movep( &headp, &movep ) ){
		(headp->prev)->next = movep;
		(headp->next)->prev = movep;

		s_obj_rmque( movep );

		work = (struct OBJ_QUEUE_HEAD *)((int)movep+(int)headp->size);
		size_work = movep->size;

		s_obj_memcpy( (u_long *)movep, (u_long *)headp, headp->size );

		s_obj_ins_empty( work, size_work );

	}
}

static int s_obj_search_movep( struct OBJ_QUEUE_HEAD **data, struct OBJ_QUEUE_HEAD **movep )
{
	struct OBJ_QUEUE_HEAD *headp;
	struct OBJ_QUEUE_HEAD *min_emptyp = NULL;
	int		i;

	for( headp = obj_w.objw_empty_head.next;
		headp != &obj_w.objw_empty_head; headp = headp->next ){
		if( (min_emptyp == NULL) || (min_emptyp > headp) ){
			min_emptyp = headp;
		}
	}

	if( (obj_w.objw_empty_head.next)->next == &obj_w.objw_empty_head ){
		return( 0 );
	}

	for( i=0; i<OBJW_PRI_NUM+1; i++ ){
		for( headp = obj_w.objw_que_head[i].next;
			headp != &obj_w.objw_que_head[i]; headp = headp->next ){
			if( (u_long)headp == (u_long)min_emptyp+min_emptyp->size ){
				*data = headp;
				*movep = min_emptyp;
				return( 1 );
			}
		}
	}

	return( 0 );
}


static void s_obj_memcpy( u_long *dst, u_long *src, int size )
{
	int		i;

	for( i=0; i<size/4; i++ ){
		dst[i] = src[i];
	}
}


								/* ݂̋󂫗̈悩޼ު̗ܰ̈m	*/
static struct OBJ_QUEUE_HEAD *s_obj_search_empty( int size )
{
	struct OBJ_QUEUE_HEAD *headp;

	for( headp = obj_w.objw_empty_head.next;
			headp != &obj_w.objw_empty_head; headp = headp->next ){
		if( headp->size == size ){
			s_obj_rmque( headp );
			return( headp );
		}
		else if( headp->size > size ){
			if( headp->size >= size+sizeof(struct OBJ_QUEUE_HEAD) ){
				s_obj_rmque( headp );
				s_obj_ins_empty( (struct OBJ_QUEUE_HEAD *)((u_long)headp+size),
														headp->size-size );
				headp->size = size;
				return( headp );
			}
			else{
				s_obj_rmque( headp );
				return( headp );
			}
		}
	}

	return(NULL);
}

											/* ޼ު̗ܰ̈m		*/
char *S_malloc( u_long size )
{
	struct OBJ_QUEUE_HEAD	*headp;

	if( (headp = S_obj_malloc( size+sizeof(struct OBJ_QUEUE_HEAD) )) == NULL ){
		SFntPrint(80, 180, 0, 0, "malloc error : s_obj_set");
		printf( "malloc error size=%d\n", size );
		return(0);
	}

	S_obj_insque( &obj_w.objw_que_head[OBJW_PRI_NUM], headp );

	return( ((char *)headp)+sizeof(struct OBJ_QUEUE_HEAD) );		/*  */
}

											/* ޼ު̗ܰ̈J		*/
void S_free( char *address )
{
	s_obj_free( (struct OBJ_QUEUE_HEAD *)((char *)address
									-sizeof(struct OBJ_QUEUE_HEAD)) );
}

											/* ޼ު̗ܰ̈m		*/
struct OBJ_QUEUE_HEAD *S_obj_malloc( int size )
{
	struct OBJ_QUEUE_HEAD *headp;

	/*------------------------------------------------------------ ޕ␳ */
	if( size%4 ) {
		size += 4-(size%4);
	}

/*	IuWF̈̍œK
	Ƃ肠sȂ
	O[oŊmۂIuWF|C^Ƃ̐邽
	if( (headp = s_obj_search_empty( size )) == NULL ){
		s_obj_sort();
		headp = s_obj_search_empty( size );
	}
*/
	headp = s_obj_search_empty( size );

	if( headp != NULL ){
		bzero( (char *)headp+sizeof(struct OBJ_QUEUE_HEAD),
										size - sizeof(struct OBJ_QUEUE_HEAD));
	}

	return(headp);
}


void S_print_unuseobj()
{
	OBJ_W_HEAD *obj_head;
	long		size;
	int			i;

	size = 0;

	for( obj_head = (OBJ_W_HEAD *)obj_w.objw_empty_head.next;
			obj_head != (OBJ_W_HEAD *)&obj_w.objw_empty_head;
			obj_head = (OBJ_W_HEAD *)(obj_head->queue.next) ){
		size += obj_head->queue.size;
	}

	for( i=0; i<OBJW_PRI_NUM; i++ ){
		for( obj_head = (OBJ_W_HEAD *)obj_w.objw_que_head[i].next;
					obj_head != (OBJ_W_HEAD *)&obj_w.objw_que_head[i];
					obj_head = (OBJ_W_HEAD *)(obj_head->queue.next) ){
			if( S_sys_w->max_obj_adr + (u_long)&obj_w <
								(u_long)obj_head + obj_head->queue.size ){
				S_sys_w->max_obj_adr = (u_long)obj_head +
									obj_head->queue.size - (u_long)&obj_w;
			}
		}
	}

	if( (OBJW_AREA_SIZE-size) > S_sys_w->obj_use_max )
		S_sys_w->obj_use_max = OBJW_AREA_SIZE-size;

	NFntPrint( "UNUSE OBJ SIZE=%x\n", size );
	NFntPrint( "USE OBJ_W MAX =%x\n", S_sys_w->obj_use_max );
	NFntPrint( "MAX OBJ_W ADR =%x\n", S_sys_w->max_obj_adr);
}


void S_debug_que_print( int pri )
{
	OBJ_W_HEAD *obj_head;
	int			i;

	if( pri != -1 ){
		if( &(obj_w.objw_que_head[pri]) != obj_w.objw_que_head[pri].next ||
			&(obj_w.objw_que_head[pri]) != obj_w.objw_que_head[pri].prev ){
			printf( "%2d:H=%08x N=%08x P=%08x\n", pri,
				(int)&obj_w.objw_que_head[pri],
				(int)obj_w.objw_que_head[pri].next,
				(int)obj_w.objw_que_head[pri].prev );
		}

		for( obj_head = (OBJ_W_HEAD *)obj_w.objw_que_head[pri].next;
				obj_head != (OBJ_W_HEAD *)&obj_w.objw_que_head[pri];
				obj_head = (OBJ_W_HEAD *)(obj_head->queue.next) ){
			printf( "%2d:Q=%08x N=%08x P=%08x size=%x F=%08x,%08x\n",
						(int)pri, (int)obj_head, (int)obj_head->queue.next,
						(int)obj_head->queue.prev,
						(int)obj_head->queue.size,
						(int)obj_head->func, (int)obj_head->objfunc );
		}
	}
	else{
		if( &(obj_w.objw_empty_head) != obj_w.objw_empty_head.next ||
			&(obj_w.objw_empty_head) != obj_w.objw_empty_head.prev ){
			printf( "E :H=%08x N=%08x P=%08x\n", (int)&obj_w.objw_empty_head,
								(int)obj_w.objw_empty_head.next,
								(int)obj_w.objw_empty_head.prev );
		}

		for( obj_head = (OBJ_W_HEAD *)obj_w.objw_empty_head.next;
				obj_head != (OBJ_W_HEAD *)&obj_w.objw_empty_head;
				obj_head = (OBJ_W_HEAD *)(obj_head->queue.next) ){
			printf( "E :Q=%08x N=%08x P=%08x size=%x\n", (int)obj_head,
						(int)obj_head->queue.next, (int)obj_head->queue.prev,
						(int)obj_head->queue.size );
		}

		for( i=0; i<OBJW_PRI_NUM; i++ ){
			if( &(obj_w.objw_que_head[i]) != obj_w.objw_que_head[i].next ||
				&(obj_w.objw_que_head[i]) != obj_w.objw_que_head[i].prev ){
				printf( "%2d:H=%08x N=%08x P=%08x\n", i,
					(int)&obj_w.objw_que_head[i],
					(int)obj_w.objw_que_head[i].next,
					(int)obj_w.objw_que_head[i].prev );
			}

			for( obj_head = (OBJ_W_HEAD *)obj_w.objw_que_head[i].next;
					obj_head != (OBJ_W_HEAD *)&obj_w.objw_que_head[i];
					obj_head = (OBJ_W_HEAD *)(obj_head->queue.next) ){
				printf( "%2d:Q=%08x N=%08x P=%08x size=%x F=%08x,%08x\n",
							(int)i, (int)obj_head, (int)obj_head->queue.next,
							(int)obj_head->queue.prev,
							(int)obj_head->queue.size,
							(int)obj_head->func, (int)obj_head->objfunc );
			}
		}
	}
}


void S_debug_que_print_monitor( int pri )
{
	OBJ_W_HEAD *obj_head;
	int			i;

	if( pri != -1 ){
		if( &(obj_w.objw_que_head[pri]) != obj_w.objw_que_head[pri].next ||
			&(obj_w.objw_que_head[pri]) != obj_w.objw_que_head[pri].prev ){
			NFntPrint( "%x:H=%x N=%x P=%x\n", pri, &obj_w.objw_que_head[pri],
				obj_w.objw_que_head[pri].next, obj_w.objw_que_head[pri].prev );
		}

		for( obj_head = (OBJ_W_HEAD *)obj_w.objw_que_head[pri].next;
				obj_head != (OBJ_W_HEAD *)&obj_w.objw_que_head[pri];
				obj_head = (OBJ_W_HEAD *)(obj_head->queue.next) ){
			NFntPrint( "%x:Q=%x N=%x P=%x size=%x F=%x,%x\n",
						pri, obj_head, obj_head->queue.next,
						obj_head->queue.prev, obj_head->queue.size,
						obj_head->func, obj_head->objfunc );
		}
	}
	else{
		if( &(obj_w.objw_empty_head) != obj_w.objw_empty_head.next ||
			&(obj_w.objw_empty_head) != obj_w.objw_empty_head.prev ){
			NFntPrint( "E :H=%x N=%x P=%x\n", &obj_w.objw_empty_head,
					obj_w.objw_empty_head.next, obj_w.objw_empty_head.prev );
		}

		for( obj_head = (OBJ_W_HEAD *)obj_w.objw_empty_head.next;
				obj_head != (OBJ_W_HEAD *)&obj_w.objw_empty_head;
				obj_head = (OBJ_W_HEAD *)(obj_head->queue.next) ){
			NFntPrint( "E :Q=%x N=%x P=%x size=%x\n", obj_head,
				obj_head->queue.next, obj_head->queue.prev,
				obj_head->queue.size );
		}

		for( i=0; i<OBJW_PRI_NUM; i++ ){
			if( &(obj_w.objw_que_head[i]) != obj_w.objw_que_head[i].next ||
				&(obj_w.objw_que_head[i]) != obj_w.objw_que_head[i].prev ){
				NFntPrint( "%x:H=%x N=%x P=%x\n", i, &obj_w.objw_que_head[i],
					obj_w.objw_que_head[i].next, obj_w.objw_que_head[i].prev );
			}

			for( obj_head = (OBJ_W_HEAD *)obj_w.objw_que_head[i].next;
					obj_head != (OBJ_W_HEAD *)&obj_w.objw_que_head[i];
					obj_head = (OBJ_W_HEAD *)(obj_head->queue.next) ){
				NFntPrint( "%x:Q=%x N=%x P=%x size=%x F=%x,%x\n",
							i, obj_head, obj_head->queue.next,
							obj_head->queue.prev, obj_head->queue.size,
							obj_head->func, obj_head->objfunc );
			}
		}
	}
}


/*---< local function >-----------------------------------------------------*/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/
