/***< file >*****************************************************************/
/*	Title		:	PS-X System												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	step.c													*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	02/10/1995												*/
/*	Note		:	Ҳݽï												*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/

#define STATIC static

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include 		"lt_all.h"
#include 		"s_step.h"
#include		"s_string.h"
#include		"s_strdat.h"
#include		"s_color.h"
#include		"s_cdhd.h"
#include		"s_ascii.h"
#include		"l_kanji.h"
#include		"jisho.h"
#include		"kouryaku.h"
#include		"kiroku.h"
#include		"udeda.h"
#include		"pachinko.h"
#include		"g_select.h"
#include		"g_etc.h"
#include		"demo.h"
#include		"cd_sect.h"

/*==========================================================================*/
/*	define																	*/
/*==========================================================================*/

#define		STEP_KOURYAKU			0
#define		STEP_UDEDAMESI			1
#define		STEP_KIROKU				2
#define		STEP_JISHO				3
#define		STEP_TEST				4

/*==========================================================================*/
/*	Program																	*/
/*==========================================================================*/
STATIC void s_start(void);
STATIC void s_start_i(void);
STATIC void s_start_m(void);
STATIC void s_start_e(void);

STATIC void s_konami(void);

STATIC void s_mode_select(void);
STATIC void s_mode_select_dr(void);
STATIC void s_mode_select_i(void);
STATIC void s_mode_select_m(void);
STATIC void s_mode_select_e(void);

STATIC void s_sub_load(void);

STATIC void s_demo(void);
STATIC void s_gamemain(void);

STATIC int cd_que_no[2];

/***< global function >******************************************************/
/*	`F		S_main_step()												*/
/*	F		Ȃ														*/
/*	F		Ҳݽï													*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/

/*----- function -----*/
void S_main_step(void)
{
	switch( M_stepw() ){
		case	STEP_START:
			s_start();
			break;
		case	STEP_KONAMI:
			s_konami();
			break;
		case	STEP_DEMO:
			s_demo();
			break;
		case	STEP_MODE_SELECT:
			s_mode_select();
			break;
		case	STEP_SUB_LOAD:
			s_sub_load();
			break;
		case	STEP_MAIN:
			s_gamemain();
			break;
	}
}

/*---< local function >-----------------------------------------------------*/
/*	`F		s_start()													*/
/*	F		Ȃ														*/
/*	F		ïߊ֐												*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC void s_start(void)
{
	switch( M_stepw_s() ){
		case 0:
			s_start_i();
			break;
		case 1:
			s_start_m();
			break;
		case 2:
			s_start_e();
			break;
	}
}

/*---< stepw_s >--------------------------------*/
/*	s_start_i									*/
/*----------------------------------------------*/
STATIC void s_start_i(void)
{
#ifndef	CD_READ
	if((cd_que_no[0] = S_cdhd_que_set(HD_DATA_BLOCK,S_ASCII_TOP,S_ASCII_SIZE,(u_long)S_ASCII_FILE)) != -1 ){
		S_stepw_s_up();
	}
#else
	S_stepw_s_up();
#endif
}

/*---< stepw_s >--------------------------------*/
/*	s_start_m									*/
/*----------------------------------------------*/
STATIC void s_start_m(void)
{
	/*------------- ̫ĂĂASFntPrint() gpłmۂ */
#ifndef	CD_READ
	if(	S_cdhd_que_stat(cd_que_no[0]) == CD_STATUS_END ){
		S_string_set(ASCII_FONT, STRING_TD0);
		S_stepw_s_up();
	}
#else
	S_stepw_s_up();
#endif
}

/*---< stepw_s >--------------------------------*/
/*	s_start_e									*/
/*----------------------------------------------*/
STATIC void s_start_e(void)
{
	S_stepw_set(STEP_KONAMI);
}

/******************************************************************* konami */
/*---< local function >-----------------------------------------------------*/
/*	`F		s_konami()													*/
/*	F		Ȃ														*/
/*	F		ۺޕ\													*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC void s_konami(void)
{
	S_stepw_up();								/* ï߱ */
}


STATIC void s_demo(void)
{
	switch( M_stepw_s() ){
		case 0:
#ifndef	CD_READ
			if((cd_que_no[0] = S_cdhd_que_set(HD_DATA,LoadAddress1,DEMO_SIZE,(u_long)DEMO_FILE)) != -1)
#else
			if((cd_que_no[0] = S_cdhd_que_set(CD_DATA,LoadAddress1,CD_DEMO_SIZE,(u_long)CD_DEMO_SECT)) != -1)
#endif
			{
				S_stepw_s_up();
			}
			break;
		case 1:
			if(S_cdhd_que_stat(cd_que_no[0]) == CD_STATUS_END) {
				S_obj_init();						/* ޼ުܰر */
				S_stepw_s_up();
			}
			else{
				SFntPrint(80, 120, 0, 0, "DEMO LOADING");
			}
			break;
		case 2:
			demo_main();
			break;
		case 3:
			S_stepw_up();
			break;
	}
}


STATIC void s_sub_load(void)
{
#ifndef CD_READ
	static char load_file[][64] = { {KOURYAKU_FILE}, {UDEDA_FILE},  {KIROKU_FILE},{JISHO_FILE}/*, {PACHINKO_FILE}*/ };
	static long load_size[] = { KOURYAKU_SIZE, UDEDA_SIZE,  KIROKU_SIZE,JISHO_SIZE/*, PACHINKO_SIZE*/ };
#else
	static u_long cd_load_sect[] = { CD_KOURYAKU_SECT, CD_UDEDA_SECT, CD_KIROKU_SECT , CD_JISHO_SECT};
	static long cd_load_size[] = { CD_KOURYAKU_SIZE, CD_UDEDA_SIZE, CD_KIROKU_SIZE ,CD_JISHO_SIZE};
#endif
	static u_long load_addr[5];
	
	load_addr[0] = (u_long)LoadAddress1;
	load_addr[1] = (u_long)LoadAddress1;
	load_addr[2] = (u_long)LoadAddress3;
	load_addr[3] = (u_long)LoadAddress3;
/*	load_addr[4] = (u_long)LoadAddress2;*/

	switch( M_gstepw() ){
		case 0:
#ifndef CD_READ
			if( load_file[M_stepw_s()] == NULL )
#else
			if( cd_load_sect[M_stepw_s()] == NULL )
#endif
			{
				S_stepw_up();
				S_stepw_s_set(M_mode_num());
			}
			else{
#ifndef CD_READ
				if((cd_que_no[0] = S_cdhd_que_set(HD_DATA,load_addr[M_stepw_s()],load_size[M_stepw_s()],(u_long)load_file[M_stepw_s()])) != -1)
#else
				if((cd_que_no[0] = S_cdhd_que_set(CD_DATA,load_addr[M_stepw_s()],cd_load_size[M_stepw_s()],(u_long)cd_load_sect[M_stepw_s()])) != -1)
#endif
				{
					S_gstepw_up();
				}
			}
			break;
		default:
			SFntPrint(80, 120, 0, 0, "SUB PROGRAM LOADING");
			SFntPrint(80, 140, 0, 0, "LOAD STATUS %d", S_cdhd_que_stat(cd_que_no[0]));
			if(S_cdhd_que_stat(cd_que_no[0]) == CD_STATUS_END) {
				S_stepw_up();
				S_stepw_s_set(M_mode_num());
			}
			break;
	}
}


STATIC void s_gamemain(void)
{
	switch( M_stepw_s() ){
		case	STEP_KOURYAKU:
			kouryaku_main();
			break;
		case	STEP_UDEDAMESI:
			udeda_main();
			break;
		case	STEP_KIROKU:
			kiroku_main();
			break;
		case	STEP_JISHO:
			jisho_main();
			break;
		case	STEP_TEST:
/*			Pachinko_main();*/
			break;
	}
}


/************************************************************** mode select */
/*---< local function >-----------------------------------------------------*/
/*	`F		s_mode_select()												*/
/*	F		Ȃ														*/
/*	F		ï߂̏												*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC void s_mode_select(void)
{
	switch( M_stepw_s() ){
		case 0:
			s_mode_select_dr();				/* ްǂݍ݁@*/
			break;
		case 1:
			s_mode_select_i();
			break;
		case 2:
			s_mode_select_m();
			break;
		case 3:
			s_mode_select_e();
			break;
	}
}

/*---< stepw_s >--------------------------------*/
/*	s_mode_select_dr							*/
/*----------------------------------------------*/
STATIC void s_mode_select_dr(void)
{
#ifndef CD_READ
	if((cd_que_no[0] = S_cdhd_que_set(HD_DATA,LoadAddress3,G_ETC_SIZE,(u_long)G_ETC_FILE)) != -1)
#else
	if((cd_que_no[0] = S_cdhd_que_set(CD_DATA,LoadAddress3,CD_G_ETC_SIZE,(u_long)CD_G_ETC_SECT)) != -1)
#endif
	{
		S_stepw_s_up();
	}
}

/*---< stepw_s >--------------------------------*/
/*	s_mode_select_i								*/
/*----------------------------------------------*/
STATIC void s_mode_select_i(void)
{
	if(S_cdhd_que_stat(cd_que_no[0]) == CD_STATUS_END) {
		S_obj_init();									/* ޼ުܰر */
		G_mode_select_init();
		/*S_fadein_black();*/								/* ̪޲ */
		S_stepw_s_up();

		S_sys_w->vsync_no = 2;
	}
	else{
		SFntPrint(80, 120, 0, 0, "DEMO LOADING");
	}
}

/*---< stepw_s >--------------------------------*/
/*	s_mode_select_m								*/
/*----------------------------------------------*/
STATIC void s_mode_select_m(void)
{
	G_mode_select_main();

	if(M_gstepw_end() == ON) {
		S_fadeout_black();							/* ̪ޱ */
		S_stepw_s_up();
	}
}

/*---< stepw_s >--------------------------------*/
/*	s_mode_select_e								*/
/*----------------------------------------------*/
STATIC void s_mode_select_e(void)
{

	if(M_fade_flag() == OFF) {
		G_mode_select_end();
		S_stepw_set(STEP_SUB_LOAD);
		S_stepw_s_set(M_mode_num());
	}
	else{
		G_mode_select_main();
	}
}



/***< global function >******************************************************/
/*	`F	S_stepw_up(void)					stepw ̽ï߱ 			*/
/*			S_stepw_set(Ushort st)				stepw ̽ï߾  			*/
/*			S_stepw_s_up(void)					stepw ̽ï߱ 			*/
/*			S_stepw_s_set(Ushort st)			stepw ̽ï߾  			*/
/*			S_gstepw_up(void)					stepw ̽ï߱ 			*/
/*			S_gstepw_set(Ushort st)				stepw ̽ï߾  			*/
/*	F	Xebv[NAbv											*/
/****************************************************************************/
void S_stepw_up(void)
{
    M_stepw()++;
    M_stepw_s() = 0x00;
    M_stepw_end() = OFF;
    M_stepw_s_end() = OFF;
    M_gstepw() = 0x00;
    M_gstepw_end() = OFF;
    M_gstepw_s() = 0x00;
    M_gstepw_s_end() = OFF;
}

/*-------------------------------------*/
void S_stepw_set(u_short st)
{
    M_stepw() = st;
    M_stepw_s() = 0x00;
    M_stepw_end() = OFF;
    M_stepw_s_end() = OFF;
    M_gstepw() = 0x00;
    M_gstepw_end() = OFF;
    M_gstepw_s() = 0x00;
    M_gstepw_s_end() = OFF;
}

/*-------------------------------------*/
void S_stepw_s_up(void)
{
    M_stepw_s()++;
    M_stepw_s_end() = OFF;
    M_gstepw() = 0x00;
    M_gstepw_end() = OFF;
    M_gstepw_s() = 0x00;
    M_gstepw_s_end() = OFF;
}

/*-------------------------------------*/
void S_stepw_s_set(u_short st)
{
    M_stepw_s() = st;
    M_stepw_s_end() = OFF;
    M_gstepw() = 0x00;
    M_gstepw_end() = OFF;
    M_gstepw_s() = 0x00;
    M_gstepw_s_end() = OFF;
}



/*-------------------------------------*/
void S_gstepw_up(void)
{
    M_gstepw()++;
    M_gstepw_end() = OFF;
    M_gstepw_s() = 0x00;
    M_gstepw_s_end() = OFF;
}

/*-------------------------------------*/
void S_gstepw_set(u_short st)
{
    M_gstepw() = st;
    M_gstepw_end() = OFF;
    M_gstepw_s() = 0x00;
    M_gstepw_s_end() = OFF;
}

void S_gstepw_s_up(void)
{
    M_gstepw_s()++;
    M_gstepw_s_end() = OFF;
}

/*-------------------------------------*/
void S_gstepw_s_set(u_short st)
{
    M_gstepw_s() = st;
    M_gstepw_s_end() = OFF;
}



/***< global function >******************************************************/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/****************************************************************************/
/*---< local function >-----------------------------------------------------*/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/

