/***< file >*****************************************************************/
/*	Title		:	PlayStation												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	s_strdat.c												*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	1995.09.22												*/
/*	Note		:															*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include 		"lt_all.h"
#include 		"s_string.h"
#include 		"s_strdat.h"
#include		"s_cdhd.h"
#include		"s_ascii.h"

/*==========================================================================*/
/*		string data															*/
/*==========================================================================*/
STRING_TD ASCII_FONT[] = {
	{	NULL,						/* CDHDް */
		STRING_BIN_TYPE,					/* ̧̫ق */
		S_ASCII_BIN_ASCII_F,				/* ̫Ȱ */
		0x3e0,								/* ̫Ļ x */
		0x100,								/* ̫Ļ y */
		0x08*0x10/4,						/* ̫Ļ w */
		0x08*0x06,							/* ̫Ļ h */
		STRING_BIN_TYPE,					/* װ̧ق */
		S_ASCII_BIN_ASCII_C,				/* װ Ȱ */
		0x100,								/* װ x */
		0x1f0,								/* װ y */
		0x100,								/* װ w */
		0x01,								/* װ h */
		STRING_MODE08,						/* ̫Ļ w */
		STRING_MODE08,						/* ̫Ļ h */
		(u_long)ASCII_08,					/* uvðٱڽ */
	},
};


#if 0
STRING_TD ASCII_FONT16[] = {
	{	S_ASCII_NUM,						/* CDHDް */
		STRING_BIN_TYPE,					/* ̧̫ق */
		S_ASCII_BIN_A16_ROM,				/* ̫Ȱ */
		0x3e0,								/* ̫Ļ x */
		0x000,								/* ̫Ļ y */
		0x08*0x10/4,						/* ̫Ļ w */
		0x08*0x10,							/* ̫Ļ h */
		STRING_BIN_TYPE,					/* װ̧ق */
		S_ASCII_BIN_ASCII_C,				/* װ Ȱ */
		0x100,								/* װ x */
		0x1f0,								/* װ y */
		0x100,								/* װ w */
		0x01,								/* װ h */
		STRING_MODE16,						/* ̫Ļ w */
		STRING_MODE16,						/* ̫Ļ h */
		(u_long)ASCII_16,					/* uvðٱڽ */
	},
};

STRING_TD ASCII_FONT2[] = {
	{	S_ASCII_NUM,						/* CDHDް */
		STRING_CSR_TYPE,					/* ̧̫ق */
		S_ASCII_CSR_AS_01,					/* ̫Ȱ */
		0x3e0,								/* ̫Ļ x */
		0x180,								/* ̫Ļ y */
		0x08*0x10/4,						/* ̫Ļ w */
		0x08*0x06,							/* ̫Ļ h */
		STRING_COL_TYPE,					/* װ̧ق */
		S_ASCII_COL_AS_00,					/* װ Ȱ */
		0x100,								/* װ x */
		0x1f1,								/* װ y */
		0x100,								/* װ w */
		0x01,								/* װ h */
		STRING_MODE08,						/* ̫Ļ w */
		STRING_MODE08,						/* ̫Ļ h */
		(u_long)ASCII_08,					/* uvðٱڽ */
	},
};
#endif


#define		ASCII08		0x08
#define		ASCII16		0x10

STRING_UV ASCII_08[] = {
	{ASCII08*0x00, ASCII08*0x00,},		/* " " */
	{ASCII08*0x01, ASCII08*0x00,},		/* "!" */
	{ASCII08*0x02, ASCII08*0x00,},		/* """ */
	{ASCII08*0x03, ASCII08*0x00,},		/* "#" */
	{ASCII08*0x04, ASCII08*0x00,},		/* "$" */
	{ASCII08*0x05, ASCII08*0x00,},		/* "%" */
	{ASCII08*0x06, ASCII08*0x00,},		/* "&" */
	{ASCII08*0x07, ASCII08*0x00,},		/* "'" */
	{ASCII08*0x08, ASCII08*0x00,},		/* "(" */
	{ASCII08*0x09, ASCII08*0x00,},		/* ")" */
	{ASCII08*0x0a, ASCII08*0x00,},		/* "*" */
	{ASCII08*0x0b, ASCII08*0x00,},		/* "+" */
	{ASCII08*0x0c, ASCII08*0x00,},		/* "," */
	{ASCII08*0x0d, ASCII08*0x00,},		/* "-" */
	{ASCII08*0x0e, ASCII08*0x00,},		/* "." */
	{ASCII08*0x0f, ASCII08*0x00,},		/* "/" */

	{ASCII08*0x00, ASCII08*0x01,},		/* "0" */
	{ASCII08*0x01, ASCII08*0x01,},		/* "1" */
	{ASCII08*0x02, ASCII08*0x01,},		/* "2" */
	{ASCII08*0x03, ASCII08*0x01,},		/* "3" */
	{ASCII08*0x04, ASCII08*0x01,},		/* "4" */
	{ASCII08*0x05, ASCII08*0x01,},		/* "5" */
	{ASCII08*0x06, ASCII08*0x01,},		/* "6" */
	{ASCII08*0x07, ASCII08*0x01,},		/* "7" */
	{ASCII08*0x08, ASCII08*0x01,},		/* "8" */
	{ASCII08*0x09, ASCII08*0x01,},		/* "9" */
	{ASCII08*0x0a, ASCII08*0x01,},		/* ":" */
	{ASCII08*0x0b, ASCII08*0x01,},		/* ";" */
	{ASCII08*0x0c, ASCII08*0x01,},		/* "<" */
	{ASCII08*0x0d, ASCII08*0x01,},		/* "=" */
	{ASCII08*0x0e, ASCII08*0x01,},		/* ">" */
	{ASCII08*0x0f, ASCII08*0x01,},		/* "?" */

	{ASCII08*0x00, ASCII08*0x02,},		/* "@" */
	{ASCII08*0x01, ASCII08*0x02,},		/* "A" */
	{ASCII08*0x02, ASCII08*0x02,},		/* "B" */
	{ASCII08*0x03, ASCII08*0x02,},		/* "C" */
	{ASCII08*0x04, ASCII08*0x02,},		/* "D" */
	{ASCII08*0x05, ASCII08*0x02,},		/* "E" */
	{ASCII08*0x06, ASCII08*0x02,},		/* "F" */
	{ASCII08*0x07, ASCII08*0x02,},		/* "G" */
	{ASCII08*0x08, ASCII08*0x02,},		/* "H" */
	{ASCII08*0x09, ASCII08*0x02,},		/* "I" */
	{ASCII08*0x0a, ASCII08*0x02,},		/* "J" */
	{ASCII08*0x0b, ASCII08*0x02,},		/* "K" */
	{ASCII08*0x0c, ASCII08*0x02,},		/* "L" */
	{ASCII08*0x0d, ASCII08*0x02,},		/* "M" */
	{ASCII08*0x0e, ASCII08*0x02,},		/* "N" */
	{ASCII08*0x0f, ASCII08*0x02,},		/* "O" */

	{ASCII08*0x00, ASCII08*0x03,},		/* "P" */
	{ASCII08*0x01, ASCII08*0x03,},		/* "Q" */
	{ASCII08*0x02, ASCII08*0x03,},		/* "R" */
	{ASCII08*0x03, ASCII08*0x03,},		/* "S" */
	{ASCII08*0x04, ASCII08*0x03,},		/* "T" */
	{ASCII08*0x05, ASCII08*0x03,},		/* "U" */
	{ASCII08*0x06, ASCII08*0x03,},		/* "V" */
	{ASCII08*0x07, ASCII08*0x03,},		/* "W" */
	{ASCII08*0x08, ASCII08*0x03,},		/* "X" */
	{ASCII08*0x09, ASCII08*0x03,},		/* "Y" */
	{ASCII08*0x0a, ASCII08*0x03,},		/* "Z" */
	{ASCII08*0x0b, ASCII08*0x03,},		/* "[" */
	{ASCII08*0x0c, ASCII08*0x03,},		/* "\" */
	{ASCII08*0x0d, ASCII08*0x03,},		/* "]" */
	{ASCII08*0x0e, ASCII08*0x03,},		/* "^" */
	{ASCII08*0x0f, ASCII08*0x03,},		/* "_" */

	{ASCII08*0x00, ASCII08*0x04,},		/* "`" */
	{ASCII08*0x01, ASCII08*0x04,},		/* "a" */
	{ASCII08*0x02, ASCII08*0x04,},		/* "b" */
	{ASCII08*0x03, ASCII08*0x04,},		/* "c" */
	{ASCII08*0x04, ASCII08*0x04,},		/* "d" */
	{ASCII08*0x05, ASCII08*0x04,},		/* "e" */
	{ASCII08*0x06, ASCII08*0x04,},		/* "f" */
	{ASCII08*0x07, ASCII08*0x04,},		/* "g" */
	{ASCII08*0x08, ASCII08*0x04,},		/* "h" */
	{ASCII08*0x09, ASCII08*0x04,},		/* "i" */
	{ASCII08*0x0a, ASCII08*0x04,},		/* "j" */
	{ASCII08*0x0b, ASCII08*0x04,},		/* "k" */
	{ASCII08*0x0c, ASCII08*0x04,},		/* "l" */
	{ASCII08*0x0d, ASCII08*0x04,},		/* "m" */
	{ASCII08*0x0e, ASCII08*0x04,},		/* "n" */
	{ASCII08*0x0f, ASCII08*0x04,},		/* "o" */

	{ASCII08*0x00, ASCII08*0x05,},		/* "p" */
	{ASCII08*0x01, ASCII08*0x05,},		/* "q" */
	{ASCII08*0x02, ASCII08*0x05,},		/* "r" */
	{ASCII08*0x03, ASCII08*0x05,},		/* "s" */
	{ASCII08*0x04, ASCII08*0x05,},		/* "t" */
	{ASCII08*0x05, ASCII08*0x05,},		/* "u" */
	{ASCII08*0x06, ASCII08*0x05,},		/* "v" */
	{ASCII08*0x07, ASCII08*0x05,},		/* "w" */
	{ASCII08*0x08, ASCII08*0x05,},		/* "x" */
	{ASCII08*0x09, ASCII08*0x05,},		/* "y" */
	{ASCII08*0x0a, ASCII08*0x05,},		/* "z" */
	{ASCII08*0x0b, ASCII08*0x05,},		/* "dummy" */
	{ASCII08*0x0c, ASCII08*0x05,},		/* "dummy" */
	{ASCII08*0x0d, ASCII08*0x05,},		/* "dummy" */
	{ASCII08*0x0e, ASCII08*0x05,},		/* "dummy" */
	{ASCII08*0x0f, ASCII08*0x05,},		/* "dummy" */
};

STRING_UV ASCII_16[] = {
	{ASCII16*0x00, ASCII16*0x02,},		/* " " */
	{ASCII16*0x00, ASCII16*0x02,},		/* "!" */
	{ASCII16*0x00, ASCII16*0x02,},		/* """ */
	{ASCII16*0x00, ASCII16*0x02,},		/* "#" */
	{ASCII16*0x00, ASCII16*0x02,},		/* "$" */
	{ASCII16*0x00, ASCII16*0x02,},		/* "%" */
	{ASCII16*0x00, ASCII16*0x02,},		/* "&" */
	{ASCII16*0x00, ASCII16*0x02,},		/* "'" */

	{ASCII16*0x00, ASCII16*0x02,},		/* "(" */
	{ASCII16*0x00, ASCII16*0x02,},		/* ")" */
	{ASCII16*0x00, ASCII16*0x02,},		/* "*" */
	{ASCII16*0x00, ASCII16*0x02,},		/* "+" */
	{ASCII16*0x00, ASCII16*0x02,},		/* "," */
	{ASCII16*0x00, ASCII16*0x02,},		/* "-" */
	{ASCII16*0x00, ASCII16*0x02,},		/* "." */
	{ASCII16*0x00, ASCII16*0x02,},		/* "/" */

	{ASCII16*0x00, ASCII16*0x00,},		/* "0" */
	{ASCII16*0x01, ASCII16*0x00,},		/* "1" */
	{ASCII16*0x02, ASCII16*0x00,},		/* "2" */
	{ASCII16*0x03, ASCII16*0x00,},		/* "3" */
	{ASCII16*0x04, ASCII16*0x00,},		/* "4" */
	{ASCII16*0x05, ASCII16*0x00,},		/* "5" */
	{ASCII16*0x06, ASCII16*0x00,},		/* "6" */
	{ASCII16*0x07, ASCII16*0x00,},		/* "7" */

	{ASCII16*0x00, ASCII16*0x01,},		/* "8" */
	{ASCII16*0x01, ASCII16*0x01,},		/* "9" */
	{ASCII16*0x02, ASCII16*0x01,},		/* ":" */
	{ASCII16*0x03, ASCII16*0x01,},		/* ";" */
	{ASCII16*0x04, ASCII16*0x01,},		/* "<" */
	{ASCII16*0x05, ASCII16*0x01,},		/* "=" */
	{ASCII16*0x06, ASCII16*0x01,},		/* ">" */
	{ASCII16*0x07, ASCII16*0x01,},		/* "?" */

	{ASCII16*0x00, ASCII16*0x02,},		/* "@" */
	{ASCII16*0x01, ASCII16*0x02,},		/* "A" */
	{ASCII16*0x02, ASCII16*0x02,},		/* "B" */
	{ASCII16*0x03, ASCII16*0x02,},		/* "C" */
	{ASCII16*0x04, ASCII16*0x02,},		/* "D" */
	{ASCII16*0x05, ASCII16*0x02,},		/* "E" */
	{ASCII16*0x06, ASCII16*0x02,},		/* "F" */
	{ASCII16*0x07, ASCII16*0x02,},		/* "G" */

	{ASCII16*0x00, ASCII16*0x03,},		/* "H" */
	{ASCII16*0x01, ASCII16*0x03,},		/* "I" */
	{ASCII16*0x02, ASCII16*0x03,},		/* "J" */
	{ASCII16*0x03, ASCII16*0x03,},		/* "K" */
	{ASCII16*0x04, ASCII16*0x03,},		/* "L" */
	{ASCII16*0x05, ASCII16*0x03,},		/* "M" */
	{ASCII16*0x06, ASCII16*0x03,},		/* "N" */
	{ASCII16*0x07, ASCII16*0x03,},		/* "O" */

	{ASCII16*0x00, ASCII16*0x04,},		/* "P" */
	{ASCII16*0x01, ASCII16*0x04,},		/* "Q" */
	{ASCII16*0x02, ASCII16*0x04,},		/* "R" */
	{ASCII16*0x03, ASCII16*0x04,},		/* "S" */
	{ASCII16*0x04, ASCII16*0x04,},		/* "T" */
	{ASCII16*0x05, ASCII16*0x04,},		/* "U" */
	{ASCII16*0x06, ASCII16*0x04,},		/* "V" */
	{ASCII16*0x07, ASCII16*0x04,},		/* "W" */

	{ASCII16*0x00, ASCII16*0x05,},		/* "X" */
	{ASCII16*0x01, ASCII16*0x05,},		/* "Y" */
	{ASCII16*0x02, ASCII16*0x05,},		/* "Z" */
	{ASCII16*0x03, ASCII16*0x05,},		/* "[" */
	{ASCII16*0x04, ASCII16*0x05,},		/* "\" */
	{ASCII16*0x05, ASCII16*0x05,},		/* "]" */
	{ASCII16*0x06, ASCII16*0x05,},		/* "^" */
	{ASCII16*0x07, ASCII16*0x05,},		/* "_" */

	{ASCII16*0x00, ASCII16*0x02,},		/* "`" */
	{ASCII16*0x01, ASCII16*0x02,},		/* "a" */
	{ASCII16*0x02, ASCII16*0x02,},		/* "b" */
	{ASCII16*0x03, ASCII16*0x02,},		/* "c" */
	{ASCII16*0x04, ASCII16*0x02,},		/* "d" */
	{ASCII16*0x05, ASCII16*0x02,},		/* "e" */
	{ASCII16*0x06, ASCII16*0x02,},		/* "f" */
	{ASCII16*0x07, ASCII16*0x02,},		/* "g" */

	{ASCII16*0x00, ASCII16*0x03,},		/* "h" */
	{ASCII16*0x01, ASCII16*0x03,},		/* "i" */
	{ASCII16*0x02, ASCII16*0x03,},		/* "j" */
	{ASCII16*0x03, ASCII16*0x03,},		/* "k" */
	{ASCII16*0x04, ASCII16*0x03,},		/* "l" */
	{ASCII16*0x05, ASCII16*0x03,},		/* "m" */
	{ASCII16*0x06, ASCII16*0x03,},		/* "n" */
	{ASCII16*0x07, ASCII16*0x03,},		/* "o" */

	{ASCII16*0x00, ASCII16*0x04,},		/* "p" */
	{ASCII16*0x01, ASCII16*0x04,},		/* "q" */
	{ASCII16*0x02, ASCII16*0x04,},		/* "r" */
	{ASCII16*0x03, ASCII16*0x04,},		/* "s" */
	{ASCII16*0x04, ASCII16*0x04,},		/* "t" */
	{ASCII16*0x05, ASCII16*0x04,},		/* "u" */
	{ASCII16*0x06, ASCII16*0x04,},		/* "v" */
	{ASCII16*0x07, ASCII16*0x04,},		/* "w" */

	{ASCII16*0x00, ASCII16*0x05,},		/* "x" */
	{ASCII16*0x01, ASCII16*0x05,},		/* "y" */
	{ASCII16*0x02, ASCII16*0x05,},		/* "z" */
	{ASCII16*0x03, ASCII16*0x05,},		/* "dummy" */
	{ASCII16*0x04, ASCII16*0x05,},		/* "dummy" */
	{ASCII16*0x05, ASCII16*0x05,},		/* "dummy" */
	{ASCII16*0x06, ASCII16*0x05,},		/* "dummy" */
	{ASCII16*0x07, ASCII16*0x05,},		/* "dummy" */
};

