/***< file >*****************************************************************/
/*	Title		:	PlayStation												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	s_work2.c												*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	1995.08.08												*/
/*	Note		:															*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include 		"lt_all.h"
#include 		"s_trans.h"

static void OPD_obj_init( POLY_FT4_W *objp, const int ot, const int pri );

/*==========================================================================*/
/*	define																	*/
/*==========================================================================*/

/***< global function >******************************************************/
/*	`F		O_POLY_FT4_W(objp)											*/
/*	F		POLY_FT4_W	objp:	޼ު߲								*/
/*	F		OBJ_Wp޼ު												*/
/*				OBJ_WOPD,ANMȂPOLY_FT4ްɂėpܰł			*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void O_POLY_FT4_W(POLY_FT4_W *objp)
{
	O_poly_ft4_w((POLY_FT4_W *)objp);

}

/***< global function >******************************************************/
/*	`F		O_GsSPRITE_W(objp)											*/
/*	F		GsSPRITE_W	objp:	޼ު߲								*/
/*	F		OBJ_Wp޼ު												*/
/*				OBJ_WOPD,ANMȂGsSPRITEްɂėpܰł			*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void O_GsSPRITE_W(GsSPRITE_W *objp)
{
	O_gssprite_w((GsSPRITE_W *)objp);
}


void O_OPD_W(OPD_W *objp)
{
	OPD_HEAD		*opd_head;
	OPD_COL_DATA	*col_data;
	OPD_CSR_DATA	*csr_data;
	OPD_PAT_DATA	*pat_data;
	OPD_OBJ_DATA	*obj_data;
	OPD_ANM_DATA	*anm_data;
	int				pat_no;
	int				pal_no;
	int				i;

	opd_head = (OPD_HEAD *)(objp->opd_address);

	if( opd_head == NULL )		return;

	if( objp->terminate_flag != 0 ){
		for( i=0; i<opd_head->obj_number; i++ ){
			S_obj_clear((u_long *)(objp->obj_ft4[i]));
		}

		S_obj_clear((u_long *)objp);
	}
	else{
		for( i=0; i<opd_head->obj_number; i++ ){
			M_vect_x_h(objp->obj_ft4[i]) = objp->center_x;
			M_vect_y_h(objp->obj_ft4[i]) = objp->center_y;
		}

		while( objp->timer == 0 ){
			anm_data = (OPD_ANM_DATA *)(*((u_long *)(opd_head->anm_address)
														+ objp->anime_no) );

			pat_no = (anm_data+(objp->pattern_no))->pat_number;
			objp->timer = 0;

			pat_data = (OPD_PAT_DATA *)(opd_head->pat_address) + pat_no;

/*
printf( "cmd=%x, opd=%x, anm=%x, pat_no=%x, pat=%x\n", pat_data->command, opd_head, anm_data, pat_no, pat_data );
*/

			switch( pat_data->command ){
				case	OPD_CMD_DATA:		/*	ʏf[^					*/
					objp->timer = (anm_data+(objp->pattern_no))->time;
					for( i=0; i<opd_head->obj_number; i++ ){
						obj_data = (OPD_OBJ_DATA *)(pat_data->address) + i;

						csr_data = (OPD_CSR_DATA *)(opd_head->csr_address) +
												obj_data->csr_number/0x100;

						if( opd_head->color_mode == 16 ){
							M_vect_u(objp->obj_ft4[i]) =
								(obj_data->csr_number%0x10)*8+(csr_data->x%64)*4;
						}
						else{
							M_vect_u(objp->obj_ft4[i]) =
								(obj_data->csr_number%0x10)*8+(csr_data->x%64)*2;
						}
						M_vect_v(objp->obj_ft4[i]) =
							((obj_data->csr_number/0x10)%0x10)*8+(csr_data->y%256);
						M_vect_w(objp->obj_ft4[i]) = obj_data->w;
						M_vect_h(objp->obj_ft4[i]) = obj_data->h;

						setVector(&M_vect_v0(objp->obj_ft4[i]),
								obj_data->u,
								obj_data->v, 0);
						setVector(&M_vect_v1(objp->obj_ft4[i]),
								obj_data->u+(obj_data->w),
								obj_data->v, 0);
						setVector(&M_vect_v2(objp->obj_ft4[i]),
								obj_data->u,
								obj_data->v+(obj_data->h), 0);
						setVector(&M_vect_v3(objp->obj_ft4[i]),
								obj_data->u+(obj_data->w),
								obj_data->v+(obj_data->h), 0);

						if( opd_head->color_mode == 16 ){
							pal_no = obj_data->palette_number;
						}
						else{
							pal_no = 0;
						}

						col_data = (OPD_COL_DATA *)(opd_head->col_address);
						objp->obj_ft4[i]->prim.clut =
								GetClut(col_data->x+pal_no*16,col_data->y);

						if( opd_head->color_mode == 16 ){
							M_prim_tpage(objp->obj_ft4[i]) =
									GetTPage(0,1,csr_data->x-(csr_data->x)%64,
												csr_data->y-(csr_data->y)%256);
						}
						else{
							M_prim_tpage(objp->obj_ft4[i]) =
									GetTPage(1,1,csr_data->x-(csr_data->x)%64,
												csr_data->y-(csr_data->y)%256);
						}
/*
printf( "No:%d,tp:%d,u:%d,v:%d,w:%d,h:%d\n", i,
						M_prim_tpage(objp->obj_ft4[i]),
						M_vect_u(objp->obj_ft4[i]),
						M_vect_v(objp->obj_ft4[i]),
						M_vect_w(objp->obj_ft4[i]),
						M_vect_h(objp->obj_ft4[i]) );
printf( "pal[%d] x:%d,y:%d,x:%d,y:%d,w:%d,h:%d\n",
						pal_no,col_data->x+pal_no*16,col_data->y,
						obj_data->u, obj_data->v, obj_data->w, obj_data->h );
*/
					}
					objp->pattern_no++;
					break;
				case	OPD_CMD_LOOP:		/*	擪p^[֖߂			*/
					objp->pattern_no = 0;
					break;
				case	OPD_CMD_STOP:		/*	noc̒~			*/
					objp->timer++;
					break;
				case	OPD_CMD_END:		/*	nocI				*/
					for( i=0; i<opd_head->obj_number; i++ ){
						S_obj_clear((u_long *)objp->obj_ft4[i]);
					}
					S_obj_clear((u_long *)objp);
					objp->timer++;
					break;
				case	OPD_CMD_GOTO:		/*	wp^[֔			*/
					objp->pattern_no = pat_data->address;
					break;
				case	OPD_CMD_TR_CSR:		/*	wbrq̓]			*/
					csr_data = (OPD_CSR_DATA *)(opd_head->csr_address) +
															pat_data->address;
					S_trans_set((u_long *)csr_data->address, (u_short)1);
					objp->pattern_no++;
					break;
				case	OPD_CMD_ST_ANIME:	/*	wAj[V̋Jn*/
					objp->anime_no = objp->nextanime_no = pat_data->address;
					objp->pattern_no = 0;
					break;
				case	OPD_CMD_AC_ANIME:	/*	Aj[V̕ύX|Cg*/
					if( objp->anime_no != objp->nextanime_no ){
						objp->anime_no = objp->nextanime_no;
						objp->pattern_no = 0;
					}
					else{
						objp->pattern_no++;
					}
					break;
				case	OPD_CMD_SET_FLAG:	/*	tO̐ݒ*/
					objp->flag = pat_data->address;
					objp->pattern_no++;
					break;
				case	OPD_CMD_REPEAT:		/*	AǰJԂ*/
					if( objp->repeat_no < 0 ){
						objp->repeat_no = pat_data->address;
					}

					objp->repeat_no--;
					if( objp->repeat_no < 0 ){
						objp->pattern_no++;
					}
					else{
						objp->pattern_no = 0;
					}
					break;
			}
		}

		objp->timer--;
	}

/*printf( "timer:%d anime no:%d pattern no:%d\n"
				, objp->timer, objp->anime_no, objp->pattern_no );
*/
}

void O_OPD_W_INIT( OPD_W *objp, int anime_no)
{
	OPD_HEAD		*opd_head;
	OPD_COL_DATA	*col_data;
	int				i;

	opd_head = (OPD_HEAD *)objp->opd_address;

											/*	J[pbg]	*/
	col_data = (OPD_COL_DATA *)(opd_head->col_address);
	S_trans_set( (u_long *)col_data->address, 1 );

											/*	objPOLY_FT4p		*/
	for( i=0; i<opd_head->obj_number; i++ ){
		(u_long *)objp->obj_ft4[i] = S_obj_set( NULL,
				(u_long)O_POLY_FT4_W, (u_long)sizeof(POLY_FT4_W), OBJW_PRI_NUM-1);
		OPD_obj_init( objp->obj_ft4[i], objp->ot, OPD_OBJ_MAX-i+32 );
	}

											/*	anime,patternԍ		*/
	objp->anime_no = anime_no;
	objp->nextanime_no = anime_no;
	objp->pattern_no = 0;
	objp->timer = 0;
	objp->terminate_flag = 0;
}


void O_opd_clear( OPD_W *objp )
{
	OPD_HEAD	*opd_head;
	int			i;

	opd_head = (OPD_HEAD *)(objp->opd_address);

	if( opd_head == NULL )		return;

	for( i=0; i<opd_head->obj_number; i++ ){
		S_obj_clear((u_long *)(objp->obj_ft4[i]));
	}

	S_obj_clear((u_long *)objp);
}


void O_opd_anime_change( OPD_W *objp, int anime_no)
{
	objp->anime_no = anime_no;
	objp->nextanime_no = anime_no;
	objp->pattern_no = 0;
	objp->timer = 0;
}


static void OPD_obj_init( POLY_FT4_W *objp, const int ot, const int pri )
{
	setRGB0(&M_prim(objp), 0x80, 0x80, 0x80);					/* Pxl */

#if 0
	setVector(	&M_vect_scale(objp), ONE*(M_graph_x_res()/M_graph_y_res()),
				ONE, ONE);							/* ޸ */
#endif
	setVector(	&M_vect_scale(objp), ONE, ONE, ONE);		/* ޸ */

	M_vect_angle_x_h(objp) = 0;
	M_vect_angle_y_h(objp) = 0;

	M_vect_z_h(objp) = pri;

	objp->state.ot = ot;
}

/***< global function >******************************************************/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/****************************************************************************/

/*---< local function >-----------------------------------------------------*/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/


