/*===================================================================
 *  Title           : PSX System
 *                  : - Sound MISC PROG -
 *  version         : 0.20
 *
 *  Code            : VX0022
 *  Filename        : SDMISC.C
 *  Creator         : KCE Tokyo (C) S.D  S.Enomoto
 *  First edition   : 1995.04.05
 *
 *  Note            : 
 *                  : 
 *                                      Copyright(C) by KONAMI.Co.LTD
 *===================================================================*/
#include        <libsnd.h>
#include        <libspu.h>
#include        <libcd.h>
#include        <libsn.h>
#include		<sys/file.h>

#include        "SD_VX022.H"
#include        "SDCALL.H"

#define SECTOR          2048				/* bytes in each sector */
#define SCTSIZE	        2048

/*      OQƁ@        */
#ifndef SD_VX001
extern  CdlFILE         fpw;
extern  short           XA_lch,XA_rch;
extern  u_short         XA_size;
extern  char            XA_fno,XA_ch;
extern  XA_POS_S        XA_loc;
extern  XA_POS_S        XA_sts;
extern  char            SD_ispause;
extern  short           cd_retry;
extern  DA_FILE_S       da_file[];
extern  char            f_emu;
extern  char            XA_play;
#endif
/*          foO@pł      */
#define         DS                            /**/
#define         DS1                           /**/
#define         SPEED2                          /**/

/* #define CD_READ        		/*	*/

/*------------------------------------------*/
/*          bc@nodm@            */
/*              P1  file  name              */
/*              P2  fpAhX              */
/*              RET SIZE                    */
/*------------------------------------------*/
int SD_cdopen(char *file_name)
{
#ifdef CD_READ
	int			size , ret;
	u_char		sts [8];
	char		file_name2[30];

	strcpy(file_name2,file_name); strcat(file_name2,";1");
#ifdef DS
	printf("file name = %s | ",file_name2);
#endif
	cd_retry = ret = 0;
	while(CdSearchFile (&fpw, file_name2) == 0) {          /*@b@ZN^@߂*/
		cd_retry++;
		if( cd_retry > MAX_RETRY) {
			ret = -1;
			break;
		}
	}

#ifdef  DS1
	if(ret == -1) printf ("Can not open : %s\n", file_name);
#endif
#ifdef  DS
		printf("loc=%2x.%2x.%2x | size=%d\n",fpw.pos.minute,fpw.pos.second,fpw.pos.sector,fpw.size);
#endif
	if(ret != -1)  ret = CdPosToInt((CdlLOC *)&fpw.pos);
	return ret;
#else
	int			ret;
	char		file_name2[30];

	strcpy(file_name2,"sim:"); strcat(file_name2,file_name); 
#ifdef DS
	printf("file name = %s | ",file_name);
#endif
	ret = open(file_name2, O_RDONLY);
#ifdef  DS1
	if(ret == -1) printf ("Can not open : %s\n", file_name);
#endif
	return ret;
#endif
}

/*------------------------------*/
/*      t@C@qd`c      */
/*------------------------------*/
int SD_cdread(int loc,int size,u_char *adrs)
{
#ifdef CD_READ
	int     status , cnt , ret ;
	u_char  loc2[4];
	int s = size / 2048;

	if(size & 0x7ff)s++;

	cnt = 0;
	CdIntToPos(loc , (CdlLOC *)loc2);
#ifdef  DS
		printf("loc=%2x.%2x.%2x  loc=%d\n",loc2[0],loc2[1],loc2[2], loc);
#endif
	while(CdControlB (CdlSetloc, loc2 , 0 ) == 0) {				/* wbhʒuw */
		cnt++;
		if( cnt > MAX_RETRY) {
			ret = -1;
			break;
		}
	}
	CdSync ( 0 , 0 );
	cnt = 0;
	while(CdRead ( s, (void *) adrs, CdlModeSpeed) == 0) {	/* Read header from CD */
		cnt++;
		if( cnt > MAX_RETRY) {
#ifdef  DS
		printf("CD READ ERR\n");
#endif
			ret = -1;
			break;
		}
	}
	CdReadSync ( 0 , 0 );

	return loc + s;
#else
	return read( loc, adrs, size );
#endif
}

/*------------------------------*/
/*      t@C@bknrd    */
/*------------------------------*/
int SD_cdclose(int loc)
{
#ifdef CD_READ
#else
	close ( loc );
#endif
}
/*--------------------------------------*/
/*          bcc`@ok`x          */
/*--------------------------------------*/
int da_start(int call)
{
	return 0;
}

/*------------------------------------------*/
/*------------------------------------------*/
/*  w`@rs`qs                        */
/*------------------------------------------*/
int xa_start(short inp)
{
	u_char param[2];
	char   atv[4];
	int ret = 0;
	SD_ispause = 0;
	cd_retry = 0;

/*      |h  Zbg      */
/*    param[0] = 0; */

#ifdef  SPEED2
	param[0] = CdlModeSpeed|CdlModeRT|CdlModeDA|CdlModeSF|CdlModeAP;
#else
	param[0] = CdlModeRT|CdlModeDA|CdlModeSF|CdlModeAP;
#endif

/*	CdControlB(CdlSetmode, param, 0);   */
	cd_retry = 0;
	while( CdControlF(CdlSetmode,param) == 0) {
		cd_retry++;
		if( cd_retry > MAX_RETRY) {
			ret = -1;
			break;
		}
	}

/*      ZbgtB^      */
	param[0] = XA_fno; 	                        /* t@C NO */
	param[1] = XA_ch;  	                        /* `l NO */
	cd_retry = 0;
#ifdef  DS
	printf("XA_fno = %d,XA_ch = %d\n",XA_fno,XA_ch);
#endif
	while( CdControlF(CdlSetfilter,param) == 0) {
		cd_retry++;
		if( cd_retry > MAX_RETRY) {
			ret = -1;
			break;
		}
	}
	if(inp == 0) {
#ifdef  DS
		printf("loc = %2x.%2x.%2x \n",XA_loc.pos[0],XA_loc.pos[1],XA_loc.pos[2]);
#endif
		while( CdControlF(CdlReadN,XA_loc.pos ) == 0) {      /* ǂݍ݃X^[g */
			cd_retry++;
			if( cd_retry > MAX_RETRY) {
				ret = -1;
				CdControlB(CdlReset,0,0);                       /* Error Detected */
				XA_play = XA_STOP;
				break;
			}
		}
	} else {
#ifdef  DS
		printf("loc = %2x.%2x.%2x \n",XA_sts.pos[0],XA_sts.pos[1],XA_sts.pos[2]);
#endif
		while( CdControlF(CdlReadN,XA_sts.pos ) == 0) {      /* ǂݍ݃X^[g */
			cd_retry++;
			if( cd_retry > MAX_RETRY) {
				ret = -1;
				CdControlB(CdlReset,0,0);                       /* Error Detected */
				XA_play = XA_STOP;
				break;
			}
		}
	}
	return ret;

}
void xa_phase2(void )
{
	u_char param[2];

	SD_ispause = 0;
#ifdef  SPEED2
	param[0] = CdlModeSpeed|CdlModeRT|CdlModeDA|CdlModeSF|CdlModeAP;
#else
	param[0] = CdlModeRT|CdlModeDA|CdlModeSF|CdlModeAP;
#endif
	CdControlF(CdlSetmode,param);

/*      ZbgtB^      */
	param[0] = XA_fno; 	                        /* t@C NO */
	param[1] = XA_ch;  	                        /* `l NO */
	CdControlF(CdlSetfilter,param);
}

void xa_phase1(void )
{
	CdControlF(CdlReadN,XA_loc.pos );
}

/*------------------------------------------*/
/*  bc@o`trd                        */
/*------------------------------------------*/
int sd_cdpause(void )
{
	unsigned char   sts [8];
	int ret = 0;

	if(SD_ispause != 1) {
		cd_retry = 0;
		while( CdControl(CdlPause,    0, 0) == 0)  {
			cd_retry++;
			if( cd_retry > MAX_RETRY) {
				ret = -1;
				break;
			}
		}
		SD_ispause = 1;                                             /**/
	}
#ifdef DS
	if(ret)printf("cd pause err!\n");
#endif
	return ret;
}

void sd_cdget(void )
{
	int ret = 0;
	cd_retry = 0;
	while(CdControl(CdlGetlocL,  0, (u_char *)&(XA_sts.pos) ) == 0 ){
		cd_retry++;
		if( cd_retry > MAX_RETRY) {
			ret = -1;
			break;
		}
	}
#ifdef  DS
		printf("loc=%2x.%2x.%2x \n",XA_sts.pos[0],XA_sts.pos[1],XA_sts.pos[2]);
#endif
}

