/*===================================================================
 *  Title           : PSX System
 *                  : - Sound SIM MAIN PROG -
 *  version         : 0.10
 *
 *  Code            : VX022
 *  Filename        : STREAM.C
 *  Creator         : KONAMI(C) T.S.D  K.Yamane
 *  First edition   : 1994.08.22
 *
 *  Note            : 
 *                  : 
 *                                      Copyright(C) by KONAMI.Co.LTD
 *===================================================================*/
#include        <libsnd.h>
#include        <libspu.h>
#include        <libcd.h>
#include        <libsn.h>

#include        "sd_vx022.h"
#include        "sdcall.h"

/*------------------------------------------*/
/*              foO@pł              */
/*------------------------------------------*/

/*#define         DS0                             /**/
/*#define         DS                              /**/

/*------------------------------*/
/*  SD_intx̒`Ȃ̂ł     */
/*------------------------------*/

#define	NO_TRANSFER	0
#define	SPU_TRANSFER1		1
#define	SPU_TRANSFER1_WAIT	2
#define	SPU_TRANSFER2		3
#define	SPU_TRANSFER2_WAIT	4
#define	SPU_TRANSFER2_WAIT	4
#define	SPU_STR_START1		5
#define	SPU_STR_START2		6


#define CD_ERROR        -1

#define STR_LOOP        1               /*Xg|[v*/
#define STR_1TIME       0               /*Xg|[vȂ*/

#define SE_PORT1         22
#define SE_PORT2         23

extern SD_STAGE SD_stage[];

/*----------------------------------------------*/
/*      `Ɓ@񂼂Ȃ    */
/*----------------------------------------------*/
#define     STR_SIZE 0x1000
#define     SPU_STR_ADDR    0x1010
#define     SD_STR_VH_SIZE 3124

/*----------------------------------------------*/

#define     READ_SE     24*1024
#define     ADS           0 /*150*/

/*----------------------*/
/*      rdł        */
/*----------------------*/
#define     START_SE_SECTOR    8000 + ADS

char	SD_status [24];
int str_int_flag = 0;

/*----------------------------------------------*/
#define STR_BUFF0   START_MEM                   /**/

#define STR_SIZEA   STR_SIZE / 4
#define STR_ADRSL1  START_SPU                       /* Lch befor */
#define STR_ADRSL2  START_SPU                       /* Lch befor */
/*----------------------------------------------*/


/*------------------------------------------*/
/*              foO@pł              */
/*#define         DS                          /**/
/*#define         DS0                         /**/
/*------------------------------------------*/

int SD_intx ;

SpuIRQCallbackProc spu_intr(void);

static u_char      *str_buf;
unsigned long SD_spu_addr;
u_int     f_str_pause;
int			PcmTblPos;		/*	]tO	*/
unsigned char *vag_addr;
unsigned char *vag_end_addr;
int vag_size;
int str_stop_flag =  0;

/*--------------------------*/
/*      OQƁ@        */
/*--------------------------*/
extern      SD_SE_TBL SD_se_table[];
extern unsigned char sd_str_vh_buf[];
extern unsigned char *sd_str_vb_buf;
extern int SD_stage_no;

/*------------------------------*/
/*      STREM DATA Define       */
/*------------------------------*/

SpuVoiceAttr s_attr;
SpuCommonAttr c_attr;


/*----------------------------------*/
/*    obNOEh]Ȃ̂  */
/*----------------------------------*/
unsigned long SpuDataTransfer_bg(unsigned long spu_addr,unsigned char *main_addr)
{ /* back ground transfer version */
    unsigned long addr;
    unsigned long size;

    addr = SpuSetTransStartAddr(spu_addr);
    size = SpuWrite(main_addr, STR_SIZE);
#ifdef DS
	printf("main=0x%lx spu=0x%lx size=0x%x\n",(long)main_addr,spu_addr,size);
#endif
    return size;
}
/*----------------------------------*/
/*   ]҂Ȃ̂				*/
/*----------------------------------*/
void SpuDataTransferWait(void)
{
    SpuIsTransferCompleted(SPU_TRANSFER_WAIT);
}
/*------------------------------------------------------------------*/
/*          CɍŏɌĂłȂƓ܂ւ񂪂          */
/*------------------------------------------------------------------*/
void SD_stream_init(void )
{
	int     ret , ret2 , i;
	u_char       *sd_buff ;

	SpuSetTransferMode (SpuTransByDMA);

	ResetCallback();
/*----------------------*/
/*      STR ݒ    */
/*----------------------*/

	SD_intx = 0;
	SD_sestr_init();                            /**/
}

void SD_sestr_init(void )
{
	int ret , size ;
	
	SsSetReservedVoice (23);
	SD_spu_addr = SpuMallocWithStartAddr(SPU_STR_ADDR, STR_SIZE*2);
#ifdef DS
	printf("spu addr=0x%lx\n",SD_spu_addr);
#endif
#if 0
	ret = SpuSetTransferStartAddr (SD_spu_addr);                 /*Dummy TRANCE*/
	size = SpuWrite0 (STR_SIZE * 2);				/*	rotOehkk	*/
	SpuIsTransferCompleted(SPU_TRANSFER_WAIT);		/*			*/
#endif


/*----------------------------------*/
/*		    ʑݒ            */
/*----------------------------------*/
	c_attr.mask = ( SPU_COMMON_MVOLL | SPU_COMMON_MVOLR);
	c_attr.mvol.left  = 0x3fff;
	c_attr.mvol.right = 0x3fff;
	SpuSetCommonAttr (&c_attr);
}

/*----------------------------------*/
/*      Xg[~O@ł      */
/*----------------------------------*/
void SD_stream_vint(void )
{
	long stat;
	int	c;

	switch(SD_intx) {
		case SPU_STR_START1:
			if (SpuIsTransferCompleted(SPU_TRANSFER_GLANCE)) SD_intx = SPU_STR_START2;		/* ]I */
		break;
		case SPU_STR_START2:
			str_se_on();
			PcmTblPos = 0;
			if(vag_size <= STR_SIZE){
				SpuSetIRQAddr( SD_spu_addr + vag_size - 0x20);
				str_stop_flag = 1;
			}else{
				*(vag_addr + STR_SIZE - 0xf) = 3;
				SpuDataTransfer_bg(SD_spu_addr + STR_SIZE, vag_addr);
				SpuSetIRQAddr( SD_spu_addr + STR_SIZE - 0x20);
			}
			vag_addr += STR_SIZE;
			SD_intx = SPU_TRANSFER2_WAIT;
			str_int_flag = 0;
			SpuSetIRQ(SpuOn);
		break;
		case NO_TRANSFER:
			stat = SpuGetKeyStatus(SPU_23CH);
			if(stat == SPU_ON_ENV_OFF)	SpuSetKey (SpuOff , SPU_23CH );
		break;
		case SPU_TRANSFER1:
			SD_intx = SPU_TRANSFER1_WAIT;
			SpuDataTransfer_bg(SD_spu_addr, vag_addr);
			vag_addr += STR_SIZE;
		break;
		case SPU_TRANSFER2:
			SD_intx = SPU_TRANSFER2_WAIT;
			SpuDataTransfer_bg(SD_spu_addr + STR_SIZE, vag_addr);
			vag_addr += STR_SIZE;
		break;
		case SPU_TRANSFER1_WAIT:
		case SPU_TRANSFER2_WAIT:
			if (SpuIsTransferCompleted(SPU_TRANSFER_GLANCE)) SD_intx = NO_TRANSFER;		/* ]I */
		break;
	}
}
/*----------------------------*/
/*      荞݂ł        */
/*----------------------------*/
SpuIRQCallbackProc spu_intr(void)
{
	SpuSetIRQ(SpuOff);
	str_int_flag++;
/*	if(SD_intx == SPU_TRANSFER1_WAIT || SD_intx == SPU_TRANSFER1_WAIT)return;	*/
	switch(str_stop_flag){
		case 0:
			if(PcmTblPos){
				if(((long )vag_end_addr - (long)vag_addr) < STR_SIZE){
					if(!str_stop_flag)str_stop_flag = 1;
				}else{
					*(vag_addr + STR_SIZE - 0xf) = 3;
				}
				SpuSetIRQAddr(SD_spu_addr + STR_SIZE - 0x20);
				SD_intx = SPU_TRANSFER2;
			}else{
				if(((long )vag_end_addr - (long)vag_addr) < STR_SIZE){
					if(!str_stop_flag)str_stop_flag = 1;
				}
				SpuSetIRQAddr(SD_spu_addr + (STR_SIZE * 2) - 0x20);
				SD_intx = SPU_TRANSFER1;
			}
		break;
		case 1:
			if(PcmTblPos){
				SpuSetIRQAddr(SD_spu_addr + (vag_size & (STR_SIZE - 1)) - 0x20);
			}else{
				SpuSetIRQAddr(SD_spu_addr + STR_SIZE + (vag_size & (STR_SIZE - 1)) - 0x20);
			}
			str_stop_flag++;
		break;
		case 2:
			str_se_off();
			SD_intx = -1;
		return;
	}
	SpuSetIRQ(SpuOn);
	PcmTblPos++;
	PcmTblPos &=1;
}

/*------------------------------*/
/*      Xg[@~        */
/*------------------------------*/
void SD_str_stop(void )
{
	SpuSetIRQ (SpuOff);                 /* 荞ݏI */
	if(SD_intx == SPU_TRANSFER1_WAIT || SD_intx == SPU_TRANSFER1_WAIT){
		SpuDataTransferWait();
	}
	SD_intx = NO_TRANSFER;
	str_se_off();
}
/*------------------------------*/
/*      Xg[@Jn        */
/*------------------------------*/

typedef struct SD_Vab_H {
	VabHdr vab_h;
	ProgAtr vab_prog[0x80];
	VagAtr vag_atr[0x100];
} SD_VAB_H;

void SD_se_str_start(int sd_prog_no, int sd_tone_no, int sd_svol)
{
	int addr;
	unsigned short *addr_p;
	SD_VAB_H *sd_vh;
	ProgAtr *sd_vab_prog;
	VagAtr *sd_vag_atr;
	int vag_no;
	int sd_lvol, sd_rvol ;
	int no,c,a, tbl;
	int addr_ptr;


	SD_str_stop();
	sd_vh = (SD_VAB_H *)sd_str_vh_buf;

	sd_vab_prog = (ProgAtr *)&(sd_vh->vab_prog[sd_prog_no]);

	tbl = 0;
	for(no = 0;no < sd_prog_no;no++){
		if(sd_vh->vab_prog[no].tones)tbl += 0x10;
	}
	for(no = 0;no < sd_vab_prog->tones;no++){
		sd_vag_atr = (VagAtr *)&(sd_vh->vag_atr[tbl + no]);
		if(sd_vag_atr->min <= sd_tone_no && sd_vag_atr->max >= sd_tone_no)break;
	}

#ifdef DS
	printf("prog %d note %d volr %d no %d\n",sd_prog_no,sd_tone_no,sd_svol >> 6, no);
#endif

	addr_ptr = SD_stage[SD_stage_no].str_vh_size - 0x200;
	addr_p = (short *)(sd_str_vh_buf + addr_ptr);

#ifdef DS
	printf("vh size = 0x%x add_p=0x%x  %x\n",SD_stage[SD_stage_no].str_vh_size, addr_ptr, (int)addr_p);
#endif
	
	vag_size = 0;

	for(c = 0;c <= no; c++){
		vag_size += *addr_p;
		addr_p++;
	}

	vag_size <<= 3;

	vag_addr = sd_str_vb_buf + (vag_size + 0x10);

	vag_size = (int  )(*addr_p) << 3;
	vag_end_addr = vag_addr + vag_size;

#ifdef DS
	printf("ATR NO=%d Tone NO=%d\n",no,sd_vag_atr->vag);
	printf("vag addr=0x%lx end=0x%lx size=0x%lx\n",(long)vag_addr,(long )vag_end_addr,vag_size);
#endif

	sd_lvol = sd_svol * sd_vag_atr->vol;
	sd_rvol = sd_svol * sd_vag_atr->vol;

/*----------------------------------*/
/*          {CX              */
/*----------------------------------*/
	s_attr.mask = (
		SPU_VOICE_VOLL			| SPU_VOICE_VOLR		| 
#if 0
		SPU_VOICE_PITCH	| 
#else
		SPU_VOICE_NOTE	| SPU_VOICE_SAMPLE_NOTE	| 
#endif
		SPU_VOICE_WDSA | SPU_VOICE_ADSR_AMODE	| SPU_VOICE_ADSR_SMODE	| SPU_VOICE_ADSR_RMODE	| SPU_VOICE_ADSR_AR |
		SPU_VOICE_ADSR_DR		| SPU_VOICE_ADSR_SR		| SPU_VOICE_ADSR_RR		| SPU_VOICE_ADSR_SL | SPU_VOICE_LSAX
	);
/*----------------------*/
/*----------------------*/
	s_attr.voice = (SPU_23CH);
	s_attr.volume.left  = sd_lvol;
	s_attr.volume.right = sd_rvol;

	s_attr.note         = sd_tone_no << 8;
	s_attr.sample_note  = (sd_vag_atr->center << 8) | sd_vag_atr->shift;

	s_attr.addr         = SD_spu_addr;
	s_attr.a_mode       = SPU_VOICE_LINEARIncN;
	s_attr.s_mode       = SPU_VOICE_LINEARIncN;
	s_attr.r_mode       = SPU_VOICE_LINEARDecN;
	s_attr.ar           = 0x0;
	s_attr.dr           = 0x0;
	s_attr.sr           = 0x0;
	s_attr.rr           = 0x0;
	s_attr.sl           = 0xf;
	s_attr.loop_addr    = s_attr.addr;
	SpuSetVoiceAttr (&s_attr);


	SpuSetIRQ(SpuOff);

	SpuSetIRQCallback ((void *)spu_intr );
	SpuSetTransferMode (SPU_TRANSFER_BY_DMA);

	SpuDataTransfer_bg(SD_spu_addr, vag_addr);

	SpuSetReverbVoice (SpuOn,SPU_23CH);		/* o[uIݒ*/
	vag_addr += STR_SIZE;
	str_stop_flag = 0;

	SD_intx = SPU_STR_START1;

#if 0
	SpuDataTransferWait();

	str_se_on();
	PcmTblPos = 0;
	if(vag_size <= STR_SIZE){
		SpuSetIRQAddr( SD_spu_addr + vag_size - 0x10);
		str_stop_flag = 1;
	}else{
		*(vag_addr + STR_SIZE - 0xf) |= 3;
		SpuDataTransfer_bg(SD_spu_addr + STR_SIZE, vag_addr);
		SpuSetIRQAddr( SD_spu_addr + STR_SIZE - 0x10);
	}
	vag_addr += STR_SIZE;
	SD_intx = SPU_TRANSFER2_WAIT;
	str_int_flag = 0;
	SpuSetIRQ(SpuOn);
#endif
}
/*------------------------------*/
/*      Xg[@~        */
/*------------------------------*/
void str_se_on(void )
{
	SpuSetKey (SpuOn , SPU_23CH );
}
void str_se_off(void )
{
	SpuSetKey (SpuOff , SPU_23CH );
}

/*--------------------------------------*/
/*      Xg[@||Y@f|[Y    */
/*--------------------------------------*/
void str_pause(void )
{
	f_str_pause = 1;
	SpuSetKey (SpuOff , SPU_23CH );
}
void str_depause(void )
{
	f_str_pause = 0;
}
