/***< file >********************************************************/
/*	Title		:	PlayStation										*/
/*	Version		:	1.00											*/
/*	Code		:	vx022											*/
/*	Filename	:	g_select.c										*/
/*	Author		:	usr01737    oohashi					*/
/*	Date		:	1996.01.26										*/
/*	Note		:													*/
/*******************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include 		"lt_all.h"
#include 		"l_math.h"
#include		"s_work.h"
#include		"s_init.h"
#include		"s_trans.h"
#include 		"s_cdhd.h"
#include 		"g_select.h"
#include 		"modedata.h"
#include		"cd_sect.h"


static OPD_W	*ms_opd_p[8];

enum _ms_opd_obj{ MS_SOUND_OPD, MS_M1_OPD, MS_M2_OPD, MS_M3_OPD, MS_OU_OPD, MS_EYE_OPD };

/*==========================================================================*/
/*	define																	*/
/*==========================================================================*/

static int			cd_que_no;
static int			local_step;
static POLY_G4		*back_line;


static void g_mode_select_init(void);
static void g_mode_select_print(void);
static void g_mode_opd_set( int mode );
static void g_back_unyo( int val, POLY_G4 *poly );

/*==========================================================================*/
/*	Program																	*/
/*==========================================================================*/

/*---< local function >-----------------------------------------------------*/
/*	`F		g_mode_select_init(objp)									*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/
void G_mode_select_init(void)
{
	M_mode_num() = 0;
	local_step = 0;

	/*@n[hfBXNtHgf[^̓ǂݏo			*/
#ifndef CD_READ
	if((cd_que_no = S_cdhd_que_set(HD_DATA,(u_long)MODEDATA_TOP,
						(u_long)MODEDATA_SIZE,(u_long)MODEDATA_FILE)) != -1)
#else
	if((cd_que_no = S_cdhd_que_set(CD_DATA,(u_long)MODEDATA_TOP,
					(u_long)CD_MODEDATA_SIZE,(u_long)CD_MODEDATA_SECT)) != -1)
#endif
	{
		S_disp_sys_change(320,240);
	}
}


/*---< local function >-----------------------------------------------------*/
/*	`F		g_mode_select_main(objp)									*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/
void G_mode_select_main(void)
{
	switch (local_step)
	{
		case 0:/*@bc[h`FbN@*/
			if (S_cdhd_que_stat( cd_que_no ) ==CD_STATUS_END){
				g_mode_select_init();
				back_line = (POLY_G4 *)S_malloc( sizeof(POLY_G4)*320 );

				S_fadein_black();
				local_step++;
			}
			break;
		case 1:/*@tF[h`FbN*/
			g_mode_select_print();
			g_back_unyo( S_sys_w->stimer, back_line );
			if(M_fade_flag() == OFF){
				if( (M_joy_trg(0) & PADRright) && (M_mode_num() != 4) ){
					M_gstepw_end() = ON;	/* ްѽïߏI */
				}
			}
			break;
	}
}


void G_mode_select_end(void)
{
	ms_opd_p[MS_SOUND_OPD]->terminate_flag = ON;
	ms_opd_p[MS_M1_OPD]->terminate_flag = ON;
	ms_opd_p[MS_M2_OPD]->terminate_flag = ON;
	ms_opd_p[MS_M3_OPD]->terminate_flag = ON;
	ms_opd_p[MS_OU_OPD]->terminate_flag = ON;
	ms_opd_p[MS_EYE_OPD]->terminate_flag = ON;
	S_free( (char *)back_line );
}

/*---< local function >-----------------------------------------------------*/
/*	`F		g_mode_select_print()										*/
/*	F		Ȃ														*/
/*	F		Ӱ޾ڸėpؽĕ\											*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
static void g_mode_select_print(void)
{
	if(M_joy_trg(0) & PADLright){
		if( (M_mode_num() == 0) || (M_mode_num() == 2) ){
			M_mode_num()++;
			g_mode_opd_set( M_mode_num() );
		}
	}
	else if(M_joy_trg(0) & PADLleft){
		if( (M_mode_num() == 1) || (M_mode_num() == 3) ){
			M_mode_num()--;
			g_mode_opd_set( M_mode_num() );
		}
	}
	else if(M_joy_trg(0) & PADLdown){
		if( (M_mode_num() == 0) || (M_mode_num() == 1) ){
			M_mode_num() += 2;
			g_mode_opd_set( M_mode_num() );
		}
		else if( M_mode_num() == 4 ){
			M_mode_num() = 0;
			g_mode_opd_set( M_mode_num() );
		}
	}
	else if(M_joy_trg(0) & PADLup){
		if( (M_mode_num() == 2) || (M_mode_num() == 3) ){
			M_mode_num() -= 2;
			g_mode_opd_set( M_mode_num() );
		}
		else if( M_mode_num() == 0 ){
			M_mode_num() = 4;
			g_mode_opd_set( M_mode_num() );
		}
	}
	else if( (M_joy_trg(0) & PADRright) && (M_mode_num() == 4) ){
		S_sys_w->sound_st_mn = !S_sys_w->sound_st_mn;
		g_mode_opd_set( M_mode_num() );
	}

}


static void g_mode_select_init(void)
{
	ms_opd_p[MS_SOUND_OPD] =
			(OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ms_opd_p[MS_SOUND_OPD]->ot = 2;
	ms_opd_p[MS_SOUND_OPD]->opd_address = (u_long)MODEDATA_OPD_M_SOUND;
	ms_opd_p[MS_SOUND_OPD]->center_x = -160;
	ms_opd_p[MS_SOUND_OPD]->center_y = -104;
	O_OPD_W_INIT(ms_opd_p[MS_SOUND_OPD], S_sys_w->sound_st_mn+2);

	ms_opd_p[MS_M1_OPD] =
			(OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ms_opd_p[MS_M1_OPD]->ot = 3;
	ms_opd_p[MS_M1_OPD]->opd_address = (u_long)MODEDATA_OPD_M_1;
	ms_opd_p[MS_M1_OPD]->center_x = -160;
	ms_opd_p[MS_M1_OPD]->center_y = -104;
	O_OPD_W_INIT(ms_opd_p[MS_M1_OPD], M_mode_num()+1);

	ms_opd_p[MS_M2_OPD] =
			(OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ms_opd_p[MS_M2_OPD]->ot = 4;
	ms_opd_p[MS_M2_OPD]->opd_address = (u_long)MODEDATA_OPD_M_2;
	ms_opd_p[MS_M2_OPD]->center_x = -160;
	ms_opd_p[MS_M2_OPD]->center_y = -104;
	O_OPD_W_INIT(ms_opd_p[MS_M2_OPD], M_mode_num()+1);

	ms_opd_p[MS_M3_OPD] =
			(OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ms_opd_p[MS_M3_OPD]->ot = 5;
	ms_opd_p[MS_M3_OPD]->opd_address = (u_long)MODEDATA_OPD_M_3;
	ms_opd_p[MS_M3_OPD]->center_x = -160;
	ms_opd_p[MS_M3_OPD]->center_y = -104;
	O_OPD_W_INIT(ms_opd_p[MS_M3_OPD], M_mode_num()+1);

	ms_opd_p[MS_OU_OPD] =
			(OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ms_opd_p[MS_OU_OPD]->ot = 6;
	ms_opd_p[MS_OU_OPD]->opd_address = (u_long)MODEDATA_OPD_MODE_OU;
	ms_opd_p[MS_OU_OPD]->center_x = -160;
	ms_opd_p[MS_OU_OPD]->center_y = -104;
	O_OPD_W_INIT(ms_opd_p[MS_OU_OPD], 0);

	ms_opd_p[MS_EYE_OPD] =
			(OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ms_opd_p[MS_EYE_OPD]->ot = 7;
	ms_opd_p[MS_EYE_OPD]->opd_address = (u_long)MODEDATA_OPD_MODE_EYE;
	ms_opd_p[MS_EYE_OPD]->center_x = -160;
	ms_opd_p[MS_EYE_OPD]->center_y = -104;
	O_OPD_W_INIT(ms_opd_p[MS_EYE_OPD], M_mode_num()+1);
}


static void g_mode_opd_set( int mode )
{
	switch( M_mode_num() ){
		case 0:
			O_opd_anime_change( ms_opd_p[MS_SOUND_OPD],S_sys_w->sound_st_mn+2);
			O_opd_anime_change( ms_opd_p[MS_M1_OPD], 1 );
			O_opd_anime_change( ms_opd_p[MS_M2_OPD], 1 );
			O_opd_anime_change( ms_opd_p[MS_M3_OPD], 1 );
			O_opd_anime_change( ms_opd_p[MS_EYE_OPD], 1 );
			break;
		case 1:
			O_opd_anime_change( ms_opd_p[MS_SOUND_OPD],S_sys_w->sound_st_mn+2);
			O_opd_anime_change( ms_opd_p[MS_M1_OPD], 2 );
			O_opd_anime_change( ms_opd_p[MS_M2_OPD], 2 );
			O_opd_anime_change( ms_opd_p[MS_M3_OPD], 2 );
			O_opd_anime_change( ms_opd_p[MS_EYE_OPD], 2 );
			break;
		case 2:
			O_opd_anime_change( ms_opd_p[MS_SOUND_OPD],S_sys_w->sound_st_mn+2);
			O_opd_anime_change( ms_opd_p[MS_M1_OPD], 3 );
			O_opd_anime_change( ms_opd_p[MS_M2_OPD], 3 );
			O_opd_anime_change( ms_opd_p[MS_M3_OPD], 3 );
			O_opd_anime_change( ms_opd_p[MS_EYE_OPD], 3 );
			break;
		case 3:
			O_opd_anime_change( ms_opd_p[MS_SOUND_OPD],S_sys_w->sound_st_mn+2);
			O_opd_anime_change( ms_opd_p[MS_M1_OPD], 4 );
			O_opd_anime_change( ms_opd_p[MS_M2_OPD], 4 );
			O_opd_anime_change( ms_opd_p[MS_M3_OPD], 4 );
			O_opd_anime_change( ms_opd_p[MS_EYE_OPD], 4 );
			break;
		case 4:
			O_opd_anime_change( ms_opd_p[MS_SOUND_OPD],S_sys_w->sound_st_mn);
			O_opd_anime_change( ms_opd_p[MS_M1_OPD], 0 );
			O_opd_anime_change( ms_opd_p[MS_M2_OPD], 0 );
			O_opd_anime_change( ms_opd_p[MS_M3_OPD], 0 );
			O_opd_anime_change( ms_opd_p[MS_EYE_OPD], 0 );
			break;
	}
}


static void g_back_unyo( int val, POLY_G4 *poly )
{
	int		i;
	long	sin_val[3];

	sin_val[0] = abs( S_sin(((val+1300)/2)%4096, ONE) );
	sin_val[1] = abs( S_sin(((val+2800)/3)%4096, ONE) );
	sin_val[2] = abs( S_sin(((val+3000)/5)%4096, ONE) );

	for( i=0; i<320; i++ ){
		SetPolyG4( &poly[i] );
		setRGB0( &poly[i],
				sin_val[0]*abs(S_sin((val*12+i*1)%4096,ONE)/64)/4096+0x40,
				sin_val[1]*abs(S_sin((-val*7+i*2)%4096,ONE)/64)/4096+0x40,
				sin_val[2]*abs(S_sin((val*19+i*3)%4096,ONE)/64)/4096+0x40 );
		setRGB1( &poly[i],
				sin_val[0]*abs(S_sin((val*12+i*1)%4096,ONE)/64)/4096+0x40,
				sin_val[1]*abs(S_sin((-val*7+i*2)%4096,ONE)/64)/4096+0x40,
				sin_val[2]*abs(S_sin((val*19+i*3)%4096,ONE)/64)/4096+0x40 );
		setRGB2( &poly[i],
				sin_val[1]*abs(S_sin((-val*5+i*7)%4096,ONE)/64)/4096+0x40,
				sin_val[2]*abs(S_sin((val*11+i)%4096,ONE)/64)/4096+0x40,
				sin_val[0]*abs(S_sin((-val*13+i*4)%4096,ONE)/64)/4096+0x40 );
		setRGB3( &poly[i],
				sin_val[1]*abs(S_sin((-val*5+i*7)%4096,ONE)/64)/4096+0x40,
				sin_val[2]*abs(S_sin((val*11+i)%4096,ONE)/64)/4096+0x40,
				sin_val[0]*abs(S_sin((-val*13+i*4)%4096,ONE)/64)/4096+0x40 );
		setXY4( &poly[i],-160+i,-120,-159+i,-120,-160+i,120,-159+i,120 );
		GsSortPoly( &poly[i], (GsOT *)&Wot[1][M_activebuff()], 60 );
	}
}


/***< global function >******************************************************/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/****************************************************************************/
/*---< local function >-----------------------------------------------------*/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/
