
/***< file >***********************************************************/
/*	Title		:	PlayStation										*/
/*	Version		:	1.00											*/
/*	Code		:	vx022											*/
/*	Filename	:	j_mode.c										*/
/*	Author		:	KONAMI(c) usr01275 	+@勴					*/
/*	Date		:	1995.12.18										*/
/*	Note		:	[hC					*/
/*******************************************************************/

/*==================================================================*/
/*	Include															*/
/*==================================================================*/
#include	"lt_all.h"
#include	"s_obj.h"
#include	"s_work.h"
#include	"s_init.h"
#include	"s_trans.h"
#include	"s_item.h"
#include	"s_objset.h"
#include	"l_kanji.h"
#include	"j_font.h"
#include	"j_mode.h"
#include	"jisho.h"
#include	"j_gdata.h"
#include	"s_color.h"
#include	"s_step.h"
#include	"sd_call.h"
#include	"sd_prot.h"

/*====================================================================*/
/*	define											                  */
/*====================================================================*/

#define STATIC static

#define	J_WIDTH			(132)
#define	J_HEIGHT		(168)

#define	J_COLUMN		(9)		/* 9				*/
#define	J_LINE0			(13)	/* 13siG̖j	*/
#define	J_LINE1			(6)		/*  6siĜ鎞j	*/

#define J_RIGHT_TOP0	(6)	/* G̖			*/
#define J_RIGHT_TOP1	(90)	/* Ĝ鎞@			*/
#define J_G_CENTER		(-38)
#define J_CENTER		(16)
#define J_OUTSIDE		(8)

#define J_GRAPH_WIDTH	(132)
#define J_GRAPH_HEIGHT	(80)

#define J_VRAMX_LEFT_PAGE		576
#define J_VRAMX_RIGHT_PAGE		640
#define J_VRAMX_LEFT_MOJI		320
#define J_VRAMX_RIGHT_MOJI		384
#define J_VRAMX_CENTER_L_MOJI	448
#define J_VRAMX_CENTER_R_MOJI	512
#define J_VRAMX_LEFT_SIDE		704
#define J_VRAMX_RIGHT_SIDE		720
#define J_VRAMX_GRAPH			896
#define J_VRAMY_GRAPH			0
#define J_VRAMX_DIC_U			576
#define J_VRAMY_DIC_U			192

#define J_PAGE_BUFF_SUU		12

#define	J_OBJ_CENTER_MOJI	0
#define	J_OBJ_LEFT_MOJI		1
#define	J_OBJ_RIGHT_MOJI	2
#define	J_OBJ_CENTER_PAGE	3
#define	J_OBJ_LEFT_PAGE		4
#define	J_OBJ_RIGHT_PAGE	5
#define	J_OBJ_GRAPH			6
#define	J_OBJ_CENTER_U		7
#define	J_OBJ_RIGHT_U		8
#define	J_OBJ_LEFT_U		9
#define	J_OBJ_RIGHT_SIDE	10
#define	J_OBJ_LEFT_SIDE		11

#define	J_PAGE_SPEED		128
/*@XvCgv~eBu֌W@*/
#define	JI_00				0
#define	JI_01				1
#define	JI_02				2
#define	JI_03				3
#define	JI_04				4
#define	JI_05				5
#define	JI_06				6
#define	JI_07				7
#define	JI_08				8
#define	JI_09				9
#define	DIC_BA00			10
#define	DIC_BA01			11

/*@\ŎgpeNX`֌W@*/
#define	COV1				0
#define	COV2				1
#define	HYOU_D				2
#define	OBI					3
#define	KIN					4
#define	HYOUSI_MAX			5


/*@wîW@*/
#define	INIT_HAIKEI_Z		62

#define J_SPRITE_MAX		15
/*====================================================================*/
/*  \̂̐錾													  */
/*====================================================================*/
/*@[hp̃XvCgv~eBu̍\́@*/
typedef struct {
	GsSPRITE	sprite;
	SVECTOR		coord;
	short		state;
} J_GsSPRITE_PRIM;


/*==========================================================================*/
/*	vg^Cv錾														*/
/*==========================================================================*/

STATIC void j_mode_init();
STATIC void j_mode_main();
STATIC u_long *j_mode_test_set();
STATIC void j_mode_test(POLY_FT4_W *objp);
STATIC void J_POLY_FT4_W_Init(	POLY_FT4_W *objp, u_long *colp, short x,
								short y, short z, u_char rgb, long scale);

STATIC void j_draw_string(short x, short y, short w, short h, char *string);
STATIC void j_set_space( u_short *work_area );
STATIC int  j_font_draw_left( int flag, int page );
STATIC void j_font_draw_right( int flag, int page, int no );
STATIC void j_ft4_page_init( int no );
STATIC void j_page_set( int flag );
STATIC void j_draw_mokuji( int flag );
STATIC void	j_set_hyousi();
STATIC void	j_set_hyous_init();
STATIC void j_set_jisho();
STATIC void j_set_mokuji();
STATIC void j_tim_trans();
STATIC void j_set_clut();
STATIC void j_ft4_outside_init();
STATIC void j_set_position( int no, int center_flag );

STATIC void J_InitSprite(J_GsSPRITE_PRIM *,u_long *,short);
STATIC void j_set_midasi(short);
STATIC void set_midasi_xy(short ,short ,short );

static void	background_init	(void);


/*==========================================================================*/
/*  ϐ錾																 */
/*==========================================================================*/

static J_GsSPRITE_PRIM	prim[J_SPRITE_MAX];



STATIC int pad_flag;		/*@ꉞO̎pbh̓͂󂯕t邽߂̃tO
								񂾂ǁAXebvǗp̒lۂg
									*/
STATIC int page_angle;		/*	y[W߂鎞̊pxi2048180x]j	*/
STATIC int page_no;			/*	y[Wԍ									*/
STATIC int cur_line;		/*	J[\Ĥsԍ						*/
STATIC int detect_line;		/*	Iꂽsԍ							*/
STATIC int left_line_suu;	/*	y[W̍s								*/
STATIC int pre_midasi;		/*	y[W߂Ǒoԍ				*/
STATIC int next_midasi;		/*	y[W߂̌oԍ				*/
STATIC int max_page;		/*	ŏIy[Wԍ								*/
STATIC POLY_FT4_W *objp_buff[J_PAGE_BUFF_SUU];	/*	IuWFNg			*/
static POLY_FT4_W *mokuji_el[11];
static POLY_FT4_W *hyousi_obj[HYOUSI_MAX];
static POLY_G4 bg;			/*@wiOf[V	*/
STATIC short	hyousi_step = 0;

/*STATIC POLY_FT4_W *objp_buff2;*/	/*	fobOpIuWFNg			*/
STATIC FILE_HEAD *file_head = (FILE_HEAD *)J_GDATA_BIN_JISHODAT;
							/*	f[^̃AhX						*/

/*static char j_mokuji_char[][4] = { "", "", "", "", "",
							"", "", "", "", "" };*/

STATIC int j_y_margin[] = { -16, -12, -9, -6, -3, 0, -3, -6, -9, -12 };
							/*	IuWFNg\̂xړ				*/

STATIC j_graph_datas[] = {	/*	OtBbNf[^̃AhX				*/
	J_GDATA_TIM_ATT,	J_GDATA_TIM_BUK,	J_GDATA_TIM_CHA,
	J_GDATA_TIM_DAI,	J_GDATA_TIM_FUS,	J_GDATA_TIM_HAC,
	J_GDATA_TIM_HAK,	J_GDATA_TIM_HAN,	J_GDATA_TIM_HOR,
	J_GDATA_TIM_INO,	J_GDATA_TIM_JET,	J_GDATA_TIM_JUM,
	J_GDATA_TIM_KAI,	J_GDATA_TIM_KAT,	J_GDATA_TIM_KUL,
	J_GDATA_TIM_LUK,	J_GDATA_TIM_MIG,	J_GDATA_TIM_MIT,
	J_GDATA_TIM_NUM,	J_GDATA_TIM_OTO,	J_GDATA_TIM_RI,
	J_GDATA_TIM_SIT,	J_GDATA_TIM_STA,	J_GDATA_TIM_TAN,
	J_GDATA_TIM_TEK,	J_GDATA_TIM_TEN,	J_GDATA_TIM_TYO,
	J_GDATA_TIM_TYU,	J_GDATA_TIM_UWA,	J_GDATA_TIM_VZO,
	J_GDATA_TIM_WAI,	J_GDATA_TIM_YOL,	J_GDATA_TIM_YOR };

/*----- function -----*/

/***< global function >******************************************************/
/*	`F	void j_mode(USER_W *objp)										*/
/*	F																	*/
/*	F	AvP[Vw												*/
/*			[h														*/
/****************************************************************************/
void j_mode()
{
	short counter;
	
	switch (M_gstepw_s()) {
		case 0:
			M_gstepw_s()++;
			j_mode_init();
			S_fadein_black();
			break;
		case 1:
			if(M_fade_flag() == OFF)
			{
				S_gstepw_s_up();
SD_call(SD_BGM1);
			}
			break;
		case 2:
			j_mode_main();
			break;
		case 3:
			if(M_fade_flag() == OFF)
			{
				for( counter=0; counter<11; counter++ )
				{
					S_obj_clear((u_long*)mokuji_el[counter]);
				}	
			
				S_gstepw_up();
			}
			break;
		
	}
	
	/*	Of[VwiOTo^	*/
	GsSortPoly( &bg, (GsOT *)&Wot[0][M_activebuff()], 63 );
	
	for(counter=0; counter<J_SPRITE_MAX + 1; counter++)
	{
		if(prim[counter].state==ON)
		{
			GsSortFastSprite(&(prim[counter].sprite), 
				(GsOT *)&Wot[0][M_activebuff()], 
					(u_short)prim[counter].coord.vz);
			
		}
	}
}


/***< global function >******************************************************/
/*	`F	void j_mode_init(USER_W *userp)									*/
/*	F																	*/
/*	F	AvP[Vw												*/
/*			[h											*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_mode_init()
{
	RECT	rect;
	int		i;
	u_long mokuji_datas[] = {	/*	OtBbNf[^̃AhX*/
	J_GDATA_TIM_DIC_M0,	J_GDATA_TIM_DIC_M1,	J_GDATA_TIM_DIC_M2,
	J_GDATA_TIM_DIC_M3,	J_GDATA_TIM_DIC_M4,	J_GDATA_TIM_DIC_M5,
	J_GDATA_TIM_DIC_M6,	J_GDATA_TIM_DIC_M7,	J_GDATA_TIM_DIC_M8,
	J_GDATA_TIM_DIC_M9,	J_GDATA_TIM_DIC_ME
	 };
	u_long midasi_datas[] = {	/*	OtBbNf[^̃AhX*/
	J_GDATA_TIM_JI_00,	J_GDATA_TIM_JI_01,	J_GDATA_TIM_JI_02,
	J_GDATA_TIM_JI_03,	J_GDATA_TIM_JI_04,	J_GDATA_TIM_JI_05,
	J_GDATA_TIM_JI_06,	J_GDATA_TIM_JI_07,	J_GDATA_TIM_JI_08,
	J_GDATA_TIM_JI_09
	 };

	/*@f[^̏@*/
	bzero( (char *)prim, sizeof(prim) );	/*  f[^̃NA		*/
	bzero( (char *)objp_buff, sizeof(objp_buff) );	/*  f[^̃NA		*/
	bzero( (char *)mokuji_el, sizeof(mokuji_el) );	/*  f[^̃NA		*/
	

	file_head = (FILE_HEAD *)J_GDATA_BIN_JISHODAT;


	/*@őy[WԍZo@*/
	max_page = file_head->page_no[9] + file_head->page_suu[9];

	pad_flag = 0;
	page_no = -2;
	detect_line = -1;
	pre_midasi = 0;
	next_midasi = 0;

	/*@\ppbg[h		*/
	OLoadImage( 0, 480, 256, 1, (long *)j_col_tbl);
	OLoadImage( 0, 481, 176, 1, (long *)j_col_tbl2);
	/* `̈̏		*/
	rect.x = J_VRAMX_CENTER_R_MOJI;
	rect.y = 0;
	rect.w = J_WIDTH/4;
	rect.h = J_HEIGHT;
	ClearImage( &rect, 0, 0, 0 );
	DrawSync(0);

	/*	shlt@C]	*/
	j_tim_trans();


	for( i=0; i<11; i++ )
	{
		mokuji_el[i] = (POLY_FT4_W*)S_obj_set( (u_long)j_mode_test,
				(u_long)O_POLY_FT4_W, (u_long)sizeof(POLY_FT4_W), 0);
		S_POLY_FT4_W_InitAll(mokuji_el[i],(u_long*)mokuji_datas[i],NULL,
			0,0,10,0x80,ONE);
		setVector(&M_vect_v0(mokuji_el[i]),
			116-16,(i*14 + (i==10)*4 - 87)-8, 0 );
		setVector(&M_vect_v1(mokuji_el[i]),
			116+16,(i*14 + (i==10)*4 - 87)-8, 0 );
		setVector(&M_vect_v2(mokuji_el[i]),
			116-16,(i*14 + (i==10)*4 - 87)+8, 0 );
		setVector(&M_vect_v3(mokuji_el[i]),
			116+16,(i*14 + (i==10)*4 - 87)+8, 0 );
		mokuji_el[i]->state.ot = 1;
		M_disp_OFF(mokuji_el[i]);
	}
		mokuji_el[0]->prim.clut = GetClut(0,492);


	/*	ڎ\	*/
	j_draw_mokuji( 0 );

	/*	IuWFNg	*/
	for( i=0; i<J_PAGE_BUFF_SUU; i++ ){
		(u_long *)objp_buff[i] = j_mode_test_set();
	}
	j_ft4_page_init( J_OBJ_CENTER_MOJI );
	j_ft4_page_init( J_OBJ_LEFT_MOJI );
	j_ft4_page_init( J_OBJ_RIGHT_MOJI );
	j_ft4_page_init( J_OBJ_CENTER_PAGE );
	j_ft4_page_init( J_OBJ_LEFT_PAGE );
	j_ft4_page_init( J_OBJ_LEFT_PAGE );
	j_ft4_page_init( J_OBJ_RIGHT_PAGE );
	j_ft4_page_init( J_OBJ_GRAPH );

	j_ft4_outside_init();

	/* J[pbgݒ					*/
	j_set_clut();

	/*	IuWFNg\W	*/
	j_set_position( 0, 0 );

	cur_line = 0;

	/*@wi\@*/
	setVector(&(prim[DIC_BA00].coord),-160,-104+80,INIT_HAIKEI_Z);
	J_InitSprite(&prim[DIC_BA00],(u_long*)J_GDATA_TIM_DIC_BA00,ONE);
	setVector(&(prim[DIC_BA01].coord),0,-104+80,INIT_HAIKEI_Z);
	J_InitSprite(&prim[DIC_BA01],(u_long*)J_GDATA_TIM_DIC_BA01,ONE);
	
	/*	Of[Vwîhmhs	*/
	background_init();
	
	for( i=JI_00; i<JI_09+1; i++ )
	{
		J_InitSprite(&prim[i],(u_long*)midasi_datas[i],ONE);
		prim[i].state = OFF;
	}

	/*@\̐ݒ@*/
	j_set_hyous_init();

}

/***< global function >******************************************************/
/*	`F	void j_mode_main(USER_W *userp)									*/
/*	F																	*/
/*	F	AvP[Vw												*/
/*			[hC											*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_mode_main()
{

	if( page_no == -2 ){
		/*@\@*/
		j_set_hyousi();
	}
	else if( page_no == -1 ){
		/* ڎ			*/
		j_set_mokuji();
	}
	else{
		/* 			*/
		j_set_jisho();
	}
}


/***< global function >******************************************************/
/*	`F	void j_set_mokuji()												*/
/*	F																	*/
/*	F	AvP[Vw												*/
/*			ڎł̏													*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_set_mokuji()
{
	short counter;
	
	switch( pad_flag ){
		case 0:
							/* \L[iJ[\Ḧړj			*/
			if(M_joy_trg(0) & PADLdown){
				SD_call(SD_CURSOL);
				if( cur_line < 10 ){
					mokuji_el[cur_line]->prim.clut = GetClut(0,493);
					cur_line++;
					mokuji_el[cur_line]->prim.clut = GetClut(0,492);
					
/*					M_prim_clut(objp_buff[J_OBJ_RIGHT_MOJI]) = GetClut(cur_line*16,481);*/
				}
				else{
					mokuji_el[cur_line]->prim.clut = GetClut(0,493);
					cur_line = 0;
					mokuji_el[cur_line]->prim.clut = GetClut(0,492);
		/*			M_prim_clut(objp_buff[J_OBJ_RIGHT_MOJI]) = GetClut(cur_line*16,481);*/
				}
			}
							/* \L[iJ[\Ḧړj			*/
			else if(M_joy_trg(0) & PADLup){
				SD_call(SD_CURSOL);
				if( cur_line > 0 ){
					mokuji_el[cur_line]->prim.clut = GetClut(0,493);
					cur_line--;
					mokuji_el[cur_line]->prim.clut = GetClut(0,492);
		/*			M_prim_clut(objp_buff[J_OBJ_RIGHT_MOJI]) = GetClut(cur_line*16,481);*/
				}
				else{
					mokuji_el[cur_line]->prim.clut = GetClut(0,493);
					cur_line = 10;
					mokuji_el[cur_line]->prim.clut = GetClut(0,492);
/*					M_prim_clut(objp_buff[J_OBJ_RIGHT_MOJI]) = GetClut(cur_line*16,481);*/
				}
			}
							/* {^iojcase1փXebvAbv	*/
			else if(M_joy_trg(0) & PADRright){
				if(cur_line==10) 
				{
					S_fadeout_black();
					S_gstepw_s_up();
				}
				else
				{
				detect_line = cur_line;
				pad_flag = 1;
				page_angle = 0;

				j_font_draw_right( 0, -1, 0 );
				next_midasi =
						j_font_draw_left( 1, file_head->page_no[detect_line] );
				j_draw_mokuji( 0 );
				j_page_set( 1 );
				j_set_position( 0, 1 );

				M_prim_clut(objp_buff[J_OBJ_CENTER_MOJI]) = GetClut(detect_line*16,481);
				M_prim_clut(objp_buff[J_OBJ_RIGHT_MOJI]) = GetClut(240,480);
				M_disp_ON(objp_buff[J_OBJ_CENTER_MOJI]);
				M_disp_ON(objp_buff[J_OBJ_CENTER_PAGE]);
			}
			}
			break;

		case 1:
							/* y[W߂			*/
			if( page_angle < 1024 ){
				page_angle += J_PAGE_SPEED;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_MOJI]) = page_angle;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_PAGE]) = page_angle;
				for(counter=0;counter<11;counter++)
					M_vect_angle_y_h(mokuji_el[counter]) = page_angle;		
				
			}
			else{
							/* XOx]Iicase2փXebvAbvj	*/
				j_page_set( 0 );
				pad_flag = 2;
				M_prim_clut(objp_buff[J_OBJ_CENTER_MOJI]) = GetClut(0,480);
				for(counter=0;counter<11;counter++)
					M_disp_OFF(mokuji_el[counter]);		
				
			}
			j_set_position(((next_midasi+1)*page_angle)/2048, 1);
			break;

		case 2:
							/* y[W߂			*/
			if( page_angle > 0 ){
				j_set_position(((next_midasi+1)*(2048-page_angle))/2048, 0);
				page_angle -= J_PAGE_SPEED;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_MOJI]) = page_angle;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_PAGE]) = page_angle;
			}
			else{
							/* PWOx]Iicase0֖߂j	*/
				page_no = file_head->page_no[detect_line];
				pad_flag = 0;
				detect_line = -1;
				cur_line = 0;
				pre_midasi = next_midasi;
				M_disp_ON(objp_buff[J_OBJ_LEFT_MOJI]);
				M_disp_OFF(objp_buff[J_OBJ_CENTER_MOJI]);
				M_disp_OFF(objp_buff[J_OBJ_CENTER_PAGE]);
				M_prim_clut(objp_buff[J_OBJ_LEFT_MOJI]) = GetClut(0,480);
				(void)j_font_draw_left( 0, page_no );
				j_set_position(next_midasi, 0);
			}
			break;
	}
}


/***< global function >******************************************************/
/*	`F	void j_set_jisho()												*/
/*	F																	*/
/*	F	AvP[Vw												*/
/*			\̏iڎȊÔƂj								*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_set_jisho()
{
	short counter;
	switch( pad_flag ){
		case 0:
							/* \L[iPy[Wiށ@case1ցj		*/
			if(M_joy_new(0) & PADLleft){
				if( page_no < max_page-1 ){
					pad_flag = 1;
					page_angle = 0;

					j_font_draw_right( 0, -1, 0 );
					next_midasi = j_font_draw_left( 1, page_no+1 );
					j_font_draw_right( 1, page_no, detect_line );
					j_page_set( 1 );
					j_set_position( pre_midasi, 1 );

					M_prim_clut(objp_buff[J_OBJ_CENTER_MOJI]) = GetClut(240,480);
					M_disp_ON(objp_buff[J_OBJ_CENTER_MOJI]);
					M_disp_ON(objp_buff[J_OBJ_CENTER_PAGE]);
					M_vect_z_h(objp_buff[J_OBJ_GRAPH]) = 15;
				}
			}
							/* \L[EiPy[W߂@case3ցj			*/
			else if(M_joy_new(0) & PADLright){
				if( page_no > 0 ){
					pad_flag = 3;
					page_angle = 0;

					next_midasi = j_font_draw_left( 0, page_no-1 );
					(void)j_font_draw_left( 1, page_no );
					j_font_draw_right( 1, -1, 0 );
					j_page_set( 0 );
					j_set_position( pre_midasi, 0 );

					M_prim_clut(objp_buff[J_OBJ_CENTER_MOJI]) =	GetClut(cur_line*16,480);
					M_prim_clut(objp_buff[J_OBJ_LEFT_MOJI]) = GetClut(0,480);
					M_disp_ON(objp_buff[J_OBJ_CENTER_MOJI]);
					M_disp_ON(objp_buff[J_OBJ_CENTER_PAGE]);
				}
			}
							/* \L[iJ[\Hړj			*/
			else if(M_joy_trg(0) & PADLdown){
				if( cur_line < left_line_suu-1 ){
					cur_line++;
				}
				else{
					cur_line = 0;
				}
				M_prim_clut(objp_buff[J_OBJ_LEFT_MOJI]) = GetClut(cur_line*16,480);
			}
							/* \L[iJ[\Hړj			*/
			else if(M_joy_trg(0) & PADLup){
				if( cur_line > 0 ){
					cur_line--;
				}
				else{
					cur_line = left_line_suu-1;
				}
				M_prim_clut(objp_buff[J_OBJ_LEFT_MOJI]) = GetClut(cur_line*16,480);
			}
							/* {^ipꌈj			*/
			else if(M_joy_trg(0) & PADRright){
				detect_line = cur_line;
				j_font_draw_right( 0, page_no, detect_line );
			}
							/* ~{^iڎ֖߂@case-1ցj			*/
			else if(M_joy_trg(0) & PADRdown){
				pad_flag = -1;
				page_angle = 0;
				next_midasi = 0;

				(void)j_font_draw_left( 1, page_no );
				j_draw_mokuji( 1 );
				j_page_set( 0 );
				j_set_position( pre_midasi, 0 );
				M_disp_OFF(objp_buff[J_OBJ_LEFT_MOJI]);

				M_prim_clut(objp_buff[J_OBJ_CENTER_MOJI]) =	GetClut(cur_line*16,480);
				M_prim_clut(objp_buff[J_OBJ_LEFT_MOJI]) = GetClut(160,481);
				M_disp_ON(objp_buff[J_OBJ_CENTER_MOJI]);
				M_disp_ON(objp_buff[J_OBJ_CENTER_PAGE]);
				
			}
			break;

		case -1:
							/* y[W߂			*/
			if( page_angle < 1024 ){
				page_angle += J_PAGE_SPEED;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_MOJI]) = page_angle;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_PAGE]) = page_angle;

			}
			else{
							/* PWOx]Iicase-2ցj	*/
				j_page_set( 1 );
				pad_flag = -2;
				M_prim_clut(objp_buff[J_OBJ_CENTER_MOJI]) =	GetClut(0,481);
			}
			j_set_position(((pre_midasi+1)*(2048-page_angle))/2048, 0);
			break;

		case -2:
							/* y[W߂			*/
			if( page_angle > 0 ){
				j_set_position(((pre_midasi+1)*page_angle)/2048, 1);
				page_angle -= J_PAGE_SPEED;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_MOJI]) = page_angle;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_PAGE]) = page_angle;
				for( counter=0; counter<11; counter++ )
					M_vect_angle_y_h(mokuji_el[counter]) = page_angle;		


			}
			else{
							/* PWOx]Iicase0֖߂j	*/
				j_draw_mokuji( 0 );
				M_prim_clut(objp_buff[J_OBJ_RIGHT_MOJI]) = GetClut(0,481);

				cur_line = 0;
				pad_flag = 0;
				page_no = -1;
				detect_line = -1;
				pre_midasi = next_midasi;
				M_disp_OFF(objp_buff[J_OBJ_CENTER_MOJI]);
				M_disp_OFF(objp_buff[J_OBJ_CENTER_PAGE]);
				M_disp_OFF(objp_buff[J_OBJ_GRAPH]);
				j_set_position(next_midasi, 1);
			}
			break;

		case 1:
							/* y[W߂			*/
			if( page_angle < 1024 ){
				page_angle += J_PAGE_SPEED;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_MOJI]) = page_angle;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_PAGE]) = page_angle;
				M_vect_angle_y_h(objp_buff[J_OBJ_GRAPH]) = page_angle;
			}
			else{
							/* XOx]Iicase2ցj	*/
				j_page_set( 0 );
				pad_flag = 2;
				M_prim_clut(objp_buff[J_OBJ_CENTER_MOJI]) = GetClut(0,480);
				M_disp_OFF(objp_buff[J_OBJ_GRAPH]);
				j_set_position(next_midasi, 0);
			}
			break;

		case 2:
							/* y[W߂			*/
			if( page_angle > 0 ){
				page_angle -= J_PAGE_SPEED;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_MOJI]) = page_angle;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_PAGE]) = page_angle;
			}
			else{
							/* PWOx]Iicase0֖߂j	*/
				pad_flag = 0;
				page_no ++;
				cur_line = 0;
				detect_line = -1;
				pre_midasi = next_midasi;
				M_disp_OFF(objp_buff[J_OBJ_CENTER_MOJI]);
				M_disp_OFF(objp_buff[J_OBJ_CENTER_PAGE]);
				M_prim_clut(objp_buff[J_OBJ_LEFT_MOJI]) = GetClut(0,480);
				(void)j_font_draw_left( 0, page_no );
			}
			break;

		case 3:
							/* y[W߂			*/
			if( page_angle < 1024 ){
				page_angle += J_PAGE_SPEED;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_MOJI]) = page_angle;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_PAGE]) = page_angle;
			}
			else{
							/* XOx]Iicase4ցj	*/
				j_page_set( 1 );
				pad_flag = 4;
				M_prim_clut(objp_buff[J_OBJ_CENTER_MOJI]) =	GetClut(240,480);
				j_set_position(next_midasi, 1);
			}
			break;

		case 4:
							/* y[W߂			*/
			if( page_angle > 0 ){
				page_angle -= J_PAGE_SPEED;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_MOJI]) = page_angle;
				M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_PAGE]) = page_angle;
			}
			else{
							/* PWOx]Iicase0֖߂j	*/
				j_font_draw_right( 0, -1, 0 );
				pad_flag = 0;
				page_no --;
				cur_line = 0;
				detect_line = -1;
				pre_midasi = next_midasi;
				M_disp_OFF(objp_buff[J_OBJ_CENTER_MOJI]);
				M_disp_OFF(objp_buff[J_OBJ_CENTER_PAGE]);
				M_disp_OFF(objp_buff[J_OBJ_GRAPH]);
				(void)j_font_draw_left( 0, page_no );
			}
			break;
	}
}


/***< global function >******************************************************/
/*	`F	u_long *j_mode_test_set(USER_W *userp)							*/
/*	F																	*/
/*	F	AvP[Vw												*/
/*			iey[Wj\p|S̏						*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC u_long *j_mode_test_set()
{
	u_long	*objp;
	objp = S_obj_set( (u_long)j_mode_test,
				(u_long)O_POLY_FT4_W, (u_long)sizeof(POLY_FT4_W), 0);
	return(objp);
}


/***< global function >******************************************************/
/*	`F	void j_mode_test(POLY_FT4_W *objp)								*/
/*	F																	*/
/*	F	AvP[Vw												*/
/*			_~[֐														*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_mode_test(POLY_FT4_W *objp)
{
}


/***< global function >******************************************************/
/*	`F	void j_draw_mokuji( int flag )									*/
/*	F	flag	OFEy[Wɐݒ										*/
/*					PFi߂jy[Wɐݒ						*/
/*	F	AvP[Vw												*/
/*			ڎ̃eNX`ݒ											*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_draw_mokuji( int flag )
{

	static int tpage_tbl[][2] = {	{J_VRAMX_RIGHT_MOJI,0},
									{J_VRAMX_CENTER_R_MOJI,0} };
	int		i;
	RECT	rect;

	/* `̈̏		*/
	rect.x = tpage_tbl[flag][0];
	rect.y = tpage_tbl[flag][1];
	rect.w = J_WIDTH/4;
	rect.h = J_HEIGHT;
	ClearImage( &rect, 0, 0, 0 );
	DrawSync(0);

#if 0
	u_short *ptr;
	static u_short work_area[L_FONT_SIZE*L_FONT_SIZE/4];

	for( i=0; i<10; i++ ){
		ptr = GetKanjiAddress((u_char *)j_mokuji_char[i],
										(u_short *)FONT_DATA_ADDRESS);
		ExpandKanji(ptr, work_area, i+1, 0);
		OLoadImage(tpage_tbl[flag][0]+(J_WIDTH/L_FONT_SIZE-1)*L_FONT_SIZE/4 - 4/4,
							tpage_tbl[flag][1]+i*15+(i!=0) + 10,
							L_FONT_SIZE/4, L_FONT_SIZE, (u_long *)work_area);
		
		DrawSync(0);
	}
#endif

	if(flag==1){
		for( i=0; i<11; i++ )
		{
			mokuji_el[i]->prim.clut = GetClut(0,493);
			M_disp_ON(mokuji_el[i]);
		}
		mokuji_el[0]->prim.clut = GetClut(0,492);
	}
	else 
	{
		for( i=0; i<11; i++ )
		{
			M_disp_ON(mokuji_el[i]);
		}
	}
	
}


/***< global function >******************************************************/
/*	`F	void j_font_draw_left( int flag, int page )						*/
/*	F	flag	OFy[Wɐݒ										*/
/*					PFi߂jy[Wɐݒ						*/
/*			page	y[Wԍ												*/
/*	F	AvP[Vw												*/
/*			y[W̕]											*/
/*	ԒlF	oԍ														*/
/****************************************************************************/
STATIC int j_font_draw_left( int flag, int page )
{
	static int tpage_tbl[][2] =	{ {J_VRAMX_LEFT_MOJI,0},
								{J_VRAMX_CENTER_L_MOJI,0} };
	char	string_buff[512];
	struct	_info{
		short	word_length;
		short	imi_length;
		short	graph_no;
	}	*info_address = NULL;
	int		i,j,k;
	RECT	rect;
	int		rtn = -1;

	/* `̈̏		*/
	rect.x = tpage_tbl[flag][0];
	rect.y = tpage_tbl[flag][1];
	rect.w = J_WIDTH/4;
	rect.h = J_HEIGHT;
	ClearImage( &rect, 0, 0, 0 );
	DrawSync(0);

	for( i=0; i<10; i++ ){
		if( (file_head->page_no[i] <= page) && 
				(file_head->page_no[i] + file_head->page_suu[i] > page) ){

			left_line_suu = file_head->yougo_suu[i] - (page-file_head->page_no[i])*J_LINE0;
			if( left_line_suu > J_LINE0 )	left_line_suu = J_LINE0;

			info_address = (struct _info *)(J_GDATA_BIN_JISHODAT
													+ file_head->address[i]);
			for( j=0; j<(page-file_head->page_no[i])*J_LINE0; j++ ){
				(char *)info_address += (info_address->word_length
											+ info_address->imi_length + 6);
			}

			k=0;
			for( j=0; j<left_line_suu; j++ ){
				memcpy( &string_buff[k], (char *)info_address+6, info_address->word_length );
				k += info_address->word_length;
				memcpy( &string_buff[k], "\n", 1 );
				k++;

				(char *)info_address += (info_address->word_length
											+ info_address->imi_length + 6);
			}
			string_buff[k] = '\0';
			rtn = i;
			break;
		}
	}

	if( page != -1 ){
		j_draw_string(tpage_tbl[flag][0]+J_OUTSIDE/4,
						tpage_tbl[flag][1]+J_RIGHT_TOP0,
						J_COLUMN, J_LINE0, string_buff );
	}

	return rtn;
}


/***< global function >******************************************************/
/*	`F	void j_font_draw_right(int flag, int page, int no)				*/
/*	F	flag	OFEy[Wɐݒ										*/
/*					PFi߂jy[Wɐݒ						*/
/*			page	y[Wԍ												*/
/*			no		P̍sԍ											*/
/*	F	AvP[Vw												*/
/*			Ey[W̃eNX`ݒ										*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_font_draw_right( int flag, int page, int no )
{
	static int tpage_tbl[][2] = {	{J_VRAMX_RIGHT_MOJI,0},
									{J_VRAMX_CENTER_R_MOJI,0} };

	char	string_buff[512];
	struct	_info{
		short	word_length;
		short	imi_length;
		short	graph_no;
	}	*info_address = NULL;
	int		i,j;
	RECT	rect;

	/* `̈̏		*/
	rect.x = tpage_tbl[flag][0];
	rect.y = tpage_tbl[flag][1];
	rect.w = J_WIDTH/4;
	rect.h = J_HEIGHT;
	ClearImage( &rect, 0, 0, 0 );
	DrawSync(0);

	for( i=0; i<10; i++ ){
		if( (file_head->page_no[i] <= page) && 
				(file_head->page_no[i] + file_head->page_suu[i] > page) ){

			info_address = (struct _info *)(J_GDATA_BIN_JISHODAT
													+ file_head->address[i]);
			for( j=0; j<(page-file_head->page_no[i])*J_LINE0; j++ ){
				(char *)info_address += (info_address->word_length
											+ info_address->imi_length + 6);
			}

			for( j=0; j<no; j++ ){
				(char *)info_address += (info_address->word_length
											+ info_address->imi_length + 6);
			}

			memcpy( string_buff, (char *)info_address+info_address->word_length+6, info_address->imi_length );
			string_buff[info_address->imi_length] = '\0';
			break;
		}
	}

	if( (page != -1) && (no != -1) ){
		if( info_address->graph_no != -1 ){
			j_draw_string(tpage_tbl[flag][0]+J_CENTER/4,
							tpage_tbl[flag][1]+J_RIGHT_TOP1,
							J_COLUMN, J_LINE1, string_buff );
			if( flag == 0 ){
				S_TimSetVRAM((u_long *)j_graph_datas[info_address->graph_no]);
				DrawSync(0);
				M_prim_clut(objp_buff[J_OBJ_GRAPH]) = GetClut(0, 483);
				M_disp_ON(objp_buff[J_OBJ_GRAPH]);
				M_vect_angle_y_h(objp_buff[J_OBJ_GRAPH]) = 0;
				M_vect_z_h(objp_buff[J_OBJ_GRAPH]) = 25;
			}
		}
		else{
			j_draw_string(tpage_tbl[flag][0]+J_CENTER/4,
							tpage_tbl[flag][1]+J_RIGHT_TOP0,
							J_COLUMN, J_LINE0, string_buff );
			if( flag == 0 ){
				M_disp_OFF(objp_buff[J_OBJ_GRAPH]);
			}
		}
	}
}


/***< global function >******************************************************/
/*	`F	void j_ft4_page_init(USER_W *userp)								*/
/*	F	no	FIuWFNgԍ											*/
/*	F	AvP[Vw												*/
/*			|S													*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_ft4_page_init( int no )
{
	static volatile int tpage_tbl[][2] = {	{J_VRAMX_LEFT_MOJI,0},
									{J_VRAMX_LEFT_MOJI,0},
									{J_VRAMX_RIGHT_MOJI,0},
									{J_VRAMX_LEFT_PAGE,0},
									{J_VRAMX_LEFT_PAGE,0},
									{J_VRAMX_RIGHT_PAGE,0},
									{J_VRAMX_GRAPH,J_VRAMY_GRAPH} };
	static int z_tbl[] = { 15, 25, 25, 20, 30, 30, 5 };
	static int disp_flag[] = { 0, 1, 1, 0, 1, 1, 0 };

	J_POLY_FT4_W_Init(objp_buff[no], NULL, 0, 0, 0, 0x80, ONE);

	/*	tu̐ݒ				*/
	M_vect_u(objp_buff[no]) = (tpage_tbl[no][0]%64)*4;
	M_vect_v(objp_buff[no]) = tpage_tbl[no][1]%256;

	/*	vgƃeNX`y[W̐ݒ				*/
	if( no != J_OBJ_GRAPH ){
		M_vect_w(objp_buff[no]) = J_WIDTH/*+1*/;
		M_vect_h(objp_buff[no]) = J_HEIGHT/*+1*/;
		M_prim_tpage(objp_buff[no]) =
			GetTPage(0,1,(tpage_tbl[no][0]/64)*64,(tpage_tbl[no][1]/256)*256);
	}
	else{
		M_vect_w(objp_buff[no]) = J_GRAPH_WIDTH/*+1*/;
		M_vect_h(objp_buff[no]) = J_GRAPH_HEIGHT/*+1*/;
		M_prim_tpage(objp_buff[no]) =
			GetTPage(1,1,(tpage_tbl[no][0]/128)*128,(tpage_tbl[no][1]/256)*256);
	}

	/*	xN^[̐ݒ				*/
	if( no == J_OBJ_CENTER_MOJI ){
		setVector(&M_vect_v0(objp_buff[J_OBJ_CENTER_MOJI]),
						-J_WIDTH, -J_HEIGHT/2, 0 );
		setVector(&M_vect_v1(objp_buff[J_OBJ_CENTER_MOJI]),
						       0, -J_HEIGHT/2, 0 );
		setVector(&M_vect_v2(objp_buff[J_OBJ_CENTER_MOJI]),
						-J_WIDTH,  J_HEIGHT/2, 0 );
		setVector(&M_vect_v3(objp_buff[J_OBJ_CENTER_MOJI]),
						       0,  J_HEIGHT/2, 0 );
	}

	if( no == J_OBJ_CENTER_PAGE ){
		setVector(&M_vect_v0(objp_buff[J_OBJ_CENTER_PAGE]),
						-J_WIDTH, -J_HEIGHT/2, 0 );
		setVector(&M_vect_v1(objp_buff[J_OBJ_CENTER_PAGE]),
						       0, -J_HEIGHT/2, 0 );
		setVector(&M_vect_v2(objp_buff[J_OBJ_CENTER_PAGE]),
						-J_WIDTH,  J_HEIGHT/2, 0 );
		setVector(&M_vect_v3(objp_buff[J_OBJ_CENTER_PAGE]),
						       0,  J_HEIGHT/2, 0 );
	}

	M_vect_angle_y_h(objp_buff[no]) = 0;
	M_vect_z_h(objp_buff[no]) = z_tbl[no];
	/*ڎOTǂŐݒ肳Ă邩킩Ȃ̂ŃRgAEg*/
#if 0
	objp_buff[no]->state.ot = 2;
#endif
	
	/*	\̂nm^nee		*/
	if( disp_flag[no] == 0 ){
		M_disp_OFF(objp_buff[no]);
	}
	else{
		M_disp_ON(objp_buff[no]);
	}
}


/***< global function >******************************************************/
/*	`F	void j_ft4_outside_init(USER_W *userp)							*/
/*	F																	*/
/*	F	AvP[Vw												*/
/*			ʂ̃|S										*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_ft4_outside_init()
{
	/*	̃IuWF	*/
	J_POLY_FT4_W_Init(objp_buff[J_OBJ_CENTER_U], NULL, 0, 0, 0, 0x80, ONE);

	M_vect_w(objp_buff[J_OBJ_CENTER_U]) = 64-1;
	M_vect_h(objp_buff[J_OBJ_CENTER_U]) = 40/*+1*/;

	M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_U]) = 0;
	M_vect_z_h(objp_buff[J_OBJ_CENTER_U]) = 40;

	setVector(&M_vect_v0(objp_buff[J_OBJ_CENTER_U]), -31, 62     , 0 );
	setVector(&M_vect_v1(objp_buff[J_OBJ_CENTER_U]),  32, 62     , 0 );
	setVector(&M_vect_v2(objp_buff[J_OBJ_CENTER_U]), -31, 62+40, 0 );
	setVector(&M_vect_v3(objp_buff[J_OBJ_CENTER_U]),  32, 62+40, 0 );

	M_disp_ON(objp_buff[J_OBJ_CENTER_U]);

	/*	ẼIuWF	*/
	J_POLY_FT4_W_Init(objp_buff[J_OBJ_RIGHT_U], NULL, 0, 0, 0, 0x80, ONE);

	M_vect_w(objp_buff[J_OBJ_RIGHT_U]) = 128/*+1*/;
	M_vect_h(objp_buff[J_OBJ_RIGHT_U]) = 32/*+1*/;

	M_vect_angle_y_h(objp_buff[J_OBJ_RIGHT_U]) = 0;
	M_vect_z_h(objp_buff[J_OBJ_RIGHT_U]) = 50;
	M_prim_tpage(objp_buff[J_OBJ_RIGHT_U]) =
			GetTPage(0,1,(J_VRAMX_DIC_U/64)*64,(J_VRAMY_DIC_U/256)*256);
	M_vect_u(objp_buff[J_OBJ_RIGHT_U]) = (J_VRAMX_DIC_U%64)*4;
	M_vect_v(objp_buff[J_OBJ_RIGHT_U]) = J_VRAMY_DIC_U%256;

	M_disp_ON(objp_buff[J_OBJ_RIGHT_U]);

	/*	̃IuWF	*/
	J_POLY_FT4_W_Init(objp_buff[J_OBJ_LEFT_U], NULL, 0, 0, 0, 0x80, ONE);

	M_vect_w(objp_buff[J_OBJ_LEFT_U]) = 128/*+1*/;
	M_vect_h(objp_buff[J_OBJ_LEFT_U]) = 32/*+1*/;

	M_vect_angle_y_h(objp_buff[J_OBJ_LEFT_U]) = 0;
	M_vect_z_h(objp_buff[J_OBJ_LEFT_U]) = 50;
	M_prim_tpage(objp_buff[J_OBJ_LEFT_U]) =
			GetTPage(0,1,(J_VRAMX_DIC_U/64)*64,(J_VRAMY_DIC_U/256)*256);
	M_vect_u(objp_buff[J_OBJ_LEFT_U]) = (J_VRAMX_DIC_U%64)*4;
	M_vect_v(objp_buff[J_OBJ_LEFT_U]) = J_VRAMY_DIC_U%256;

	M_disp_ON(objp_buff[J_OBJ_LEFT_U]);

	/*	ẼIuWF	*/
	J_POLY_FT4_W_Init(objp_buff[J_OBJ_RIGHT_SIDE], NULL, 0, 0, 0, 0x80, ONE);

	M_vect_w(objp_buff[J_OBJ_RIGHT_SIDE]) = 24/*+1*/;
	M_vect_h(objp_buff[J_OBJ_RIGHT_SIDE]) = 184/*+1*/;

	M_vect_angle_y_h(objp_buff[J_OBJ_RIGHT_SIDE]) = 0;
	M_vect_z_h(objp_buff[J_OBJ_RIGHT_SIDE]) = 40;
	M_prim_tpage(objp_buff[J_OBJ_RIGHT_SIDE]) =
			GetTPage(0,1,(J_VRAMX_RIGHT_SIDE/64)*64,0);
	M_vect_u(objp_buff[J_OBJ_RIGHT_SIDE]) = (J_VRAMX_RIGHT_SIDE%64)*4;
	M_vect_v(objp_buff[J_OBJ_RIGHT_SIDE]) = 0;

	M_disp_ON(objp_buff[J_OBJ_RIGHT_SIDE]);

	/*	̃IuWF	*/
	J_POLY_FT4_W_Init(objp_buff[J_OBJ_LEFT_SIDE], NULL, 0, 0, 0, 0x80, ONE);

	M_vect_w(objp_buff[J_OBJ_LEFT_SIDE]) = 24/*+1*/;
	M_vect_h(objp_buff[J_OBJ_LEFT_SIDE]) = 184/*+1*/;

	M_vect_angle_y_h(objp_buff[J_OBJ_LEFT_SIDE]) = 0;
	M_vect_z_h(objp_buff[J_OBJ_LEFT_SIDE]) = 40;
	M_prim_tpage(objp_buff[J_OBJ_LEFT_SIDE]) =
			GetTPage(0,1,(J_VRAMX_LEFT_SIDE/64)*64,0);
	M_vect_u(objp_buff[J_OBJ_LEFT_SIDE]) = (J_VRAMX_LEFT_SIDE%64)*4;
	M_vect_v(objp_buff[J_OBJ_LEFT_SIDE]) = 0;

	M_disp_ON(objp_buff[J_OBJ_LEFT_SIDE]);
}


/***< global function >******************************************************/
/*	`F	void j_set_position( int no, int center_flag )					*/
/*	F	no	:oԍ													*/
/*			center_flag	O:i߂Ăjy[W					*/
/*						P:i߂Ăjy[WE					*/
/*	F	AvP[Vw												*/
/*			ʂ̃|S										*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_set_position( int no, int center_flag )
{
	static volatile int tpage_tbl[][2] =
				{	{736,0},	{752,0},	{768,0},	{784,0},	{800,0},
					{816,0},	{832,0},	{848,0},	{864,0},	{880,0}	};
	static int	dic_u[][2][2] = { { {-7,38},{8,68} },	{ {-10,44},{11,68} },
								{ {-13,50},{14,68} },	{ {-16,56},{17,68} },
								{ {-19,62},{20,68} },	{ {-22,68},{23,68} },
								{ {-19,68},{20,62} },	{ {-16,68},{17,56} },
								{ {-13,68},{14,50} },	{ {-10,68},{11,44} } };
	static int	dic_s[][2][2] = { { {-135,14},{136,12} },
				{ {-138,12},{139,12} },	{ {-141,9},{142,9} },
				{ {-144,6},{145,6} },		{ {-147,3},{148,3} },
				{ {-150,0},{151,0} },		{ {-147,3},{148,3} },
				{ {-144,6},{145,6} },		{ {-141,9},{142,9} },
				{ {-138,12},{139,12} } };

	/*	tu̐ݒ				*/
	M_vect_u(objp_buff[J_OBJ_CENTER_U]) = (tpage_tbl[no][0]%64)*4;
	M_vect_v(objp_buff[J_OBJ_CENTER_U]) = tpage_tbl[no][1]%256;

	/*	̃IuWF	*/
	M_prim_tpage(objp_buff[J_OBJ_CENTER_U]) =
			GetTPage(0,1,(tpage_tbl[no][0]/64)*64,(tpage_tbl[no][1]/256)*256);

	/*	̃IuWF	*/
	setVector(&M_vect_v0(objp_buff[J_OBJ_LEFT_U]),
							dic_u[no][0][0]-128,	dic_u[no][0][1],	0 );
	setVector(&M_vect_v1(objp_buff[J_OBJ_LEFT_U]),
							dic_u[no][0][0],		dic_u[no][0][1],	0 );
	setVector(&M_vect_v2(objp_buff[J_OBJ_LEFT_U]),
							dic_u[no][0][0]-128,	dic_u[no][0][1]+32,	0 );
	setVector(&M_vect_v3(objp_buff[J_OBJ_LEFT_U]),
							dic_u[no][0][0],		dic_u[no][0][1]+32,	0 );

	/*	ẼIuWF	*/
	setVector(&M_vect_v0(objp_buff[J_OBJ_RIGHT_U]),
							dic_u[no][1][0],		dic_u[no][1][1],	0 );
	setVector(&M_vect_v1(objp_buff[J_OBJ_RIGHT_U]),
							dic_u[no][1][0]+128,	dic_u[no][1][1],	0 );
	setVector(&M_vect_v2(objp_buff[J_OBJ_RIGHT_U]),
							dic_u[no][1][0],		dic_u[no][1][1]+32,	0 );
	setVector(&M_vect_v3(objp_buff[J_OBJ_RIGHT_U]),
							dic_u[no][1][0]+128,	dic_u[no][1][1]+32,	0 );
#if 0
	objp_buff[J_OBJ_RIGHT_U]->state.ot = 2;
#endif
	
	/*	[̃IuWF	*/
	M_vect_v(objp_buff[J_OBJ_LEFT_SIDE]) = dic_s[no][0][1];
	
	setVector(&M_vect_v0(objp_buff[J_OBJ_LEFT_SIDE]),
					dic_s[no][0][0],	-J_HEIGHT/2+j_y_margin[no],		0 );
	setVector(&M_vect_v1(objp_buff[J_OBJ_LEFT_SIDE]),
					dic_s[no][0][0]+24,	-J_HEIGHT/2+j_y_margin[no],		0 );
	setVector(&M_vect_v2(objp_buff[J_OBJ_LEFT_SIDE]),
					dic_s[no][0][0],	-J_HEIGHT/2+j_y_margin[no]+184,	0 );
	setVector(&M_vect_v3(objp_buff[J_OBJ_LEFT_SIDE]),
					dic_s[no][0][0]+24,	-J_HEIGHT/2+j_y_margin[no]+184,	0 );
	
	/*	E[̃IuWF	*/
	M_vect_v(objp_buff[J_OBJ_RIGHT_SIDE]) = dic_s[no][1][1];
	
	setVector(&M_vect_v0(objp_buff[J_OBJ_RIGHT_SIDE]),
					dic_s[no][1][0]-24,	-J_HEIGHT/2+j_y_margin[no],		0 );
	setVector(&M_vect_v1(objp_buff[J_OBJ_RIGHT_SIDE]),
					dic_s[no][1][0],	-J_HEIGHT/2+j_y_margin[no],		0 );
	setVector(&M_vect_v2(objp_buff[J_OBJ_RIGHT_SIDE]),
					dic_s[no][1][0]-24,	-J_HEIGHT/2+j_y_margin[no]+184,	0 );
	setVector(&M_vect_v3(objp_buff[J_OBJ_RIGHT_SIDE]),
					dic_s[no][1][0],	-J_HEIGHT/2+j_y_margin[no]+184,	0 );
	
	/*	OtBbÑIuWF	*/
	setVector(&M_vect_v0(objp_buff[J_OBJ_GRAPH]),
			            0, J_G_CENTER-J_GRAPH_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v1(objp_buff[J_OBJ_GRAPH]),
			J_GRAPH_WIDTH, J_G_CENTER-J_GRAPH_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v2(objp_buff[J_OBJ_GRAPH]),
			            0, J_G_CENTER+J_GRAPH_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v3(objp_buff[J_OBJ_GRAPH]),
			J_GRAPH_WIDTH, J_G_CENTER+J_GRAPH_HEIGHT/2+j_y_margin[no], 0 );
	
	/*	Ẽ̕IuWF	*/
	setVector(&M_vect_v0(objp_buff[J_OBJ_RIGHT_MOJI]),
								      0, -J_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v1(objp_buff[J_OBJ_RIGHT_MOJI]),
								J_WIDTH, -J_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v2(objp_buff[J_OBJ_RIGHT_MOJI]),
								      0,  J_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v3(objp_buff[J_OBJ_RIGHT_MOJI]),
								J_WIDTH,  J_HEIGHT/2+j_y_margin[no], 0 );
	
	/*	E̎ʂ̃IuWF	*/
	setVector(&M_vect_v0(objp_buff[J_OBJ_RIGHT_PAGE]),
								      0, -J_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v1(objp_buff[J_OBJ_RIGHT_PAGE]),
								J_WIDTH, -J_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v2(objp_buff[J_OBJ_RIGHT_PAGE]),
								      0,  J_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v3(objp_buff[J_OBJ_RIGHT_PAGE]),
								J_WIDTH,  J_HEIGHT/2+j_y_margin[no], 0 );
	
	/*	̃̕IuWF	*/
	setVector(&M_vect_v0(objp_buff[J_OBJ_LEFT_MOJI]),
								-J_WIDTH, -J_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v1(objp_buff[J_OBJ_LEFT_MOJI]),
								       0, -J_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v2(objp_buff[J_OBJ_LEFT_MOJI]),
								-J_WIDTH,  J_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v3(objp_buff[J_OBJ_LEFT_MOJI]),
								       0,  J_HEIGHT/2+j_y_margin[no], 0 );
	
	/*	̎ʂ̃IuWF	*/
	setVector(&M_vect_v0(objp_buff[J_OBJ_LEFT_PAGE]),
								-J_WIDTH, -J_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v1(objp_buff[J_OBJ_LEFT_PAGE]),
								       0, -J_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v2(objp_buff[J_OBJ_LEFT_PAGE]),
								-J_WIDTH,  J_HEIGHT/2+j_y_margin[no], 0 );
	setVector(&M_vect_v3(objp_buff[J_OBJ_LEFT_PAGE]),
								       0,  J_HEIGHT/2+j_y_margin[no], 0 );
	
	/*	̕Ǝʂ̃IuWF	*/
	if( center_flag == 1 ){
		setVector(&M_vect_v0(objp_buff[J_OBJ_CENTER_MOJI]),
								      0, -J_HEIGHT/2+j_y_margin[no], 0 );
		setVector(&M_vect_v1(objp_buff[J_OBJ_CENTER_MOJI]),
								J_WIDTH, -J_HEIGHT/2+j_y_margin[no], 0 );
		setVector(&M_vect_v2(objp_buff[J_OBJ_CENTER_MOJI]),
								      0,  J_HEIGHT/2+j_y_margin[no], 0 );
		setVector(&M_vect_v3(objp_buff[J_OBJ_CENTER_MOJI]),
								J_WIDTH,  J_HEIGHT/2+j_y_margin[no], 0 );
	
		setVector(&M_vect_v0(objp_buff[J_OBJ_CENTER_PAGE]),
								      0, -J_HEIGHT/2+j_y_margin[no], 0 );
		setVector(&M_vect_v1(objp_buff[J_OBJ_CENTER_PAGE]),
								J_WIDTH, -J_HEIGHT/2+j_y_margin[no], 0 );
		setVector(&M_vect_v2(objp_buff[J_OBJ_CENTER_PAGE]),
								      0,  J_HEIGHT/2+j_y_margin[no], 0 );
		setVector(&M_vect_v3(objp_buff[J_OBJ_CENTER_PAGE]),
								J_WIDTH,  J_HEIGHT/2+j_y_margin[no], 0 );
	}
	else{
		setVector(&M_vect_v0(objp_buff[J_OBJ_CENTER_MOJI]),
								-J_WIDTH, -J_HEIGHT/2+j_y_margin[no], 0 );
		setVector(&M_vect_v1(objp_buff[J_OBJ_CENTER_MOJI]),
								       0, -J_HEIGHT/2+j_y_margin[no], 0 );
		setVector(&M_vect_v2(objp_buff[J_OBJ_CENTER_MOJI]),
								-J_WIDTH,  J_HEIGHT/2+j_y_margin[no], 0 );
		setVector(&M_vect_v3(objp_buff[J_OBJ_CENTER_MOJI]),
								       0,  J_HEIGHT/2+j_y_margin[no], 0 );
	
		setVector(&M_vect_v0(objp_buff[J_OBJ_CENTER_PAGE]),
								-J_WIDTH, -J_HEIGHT/2+j_y_margin[no], 0 );
		setVector(&M_vect_v1(objp_buff[J_OBJ_CENTER_PAGE]),
								       0, -J_HEIGHT/2+j_y_margin[no], 0 );
		setVector(&M_vect_v2(objp_buff[J_OBJ_CENTER_PAGE]),
								-J_WIDTH,  J_HEIGHT/2+j_y_margin[no], 0 );
		setVector(&M_vect_v3(objp_buff[J_OBJ_CENTER_PAGE]),
								       0,  J_HEIGHT/2+j_y_margin[no], 0 );
	}
	
	j_set_midasi(no);
}


/***< global function >******************************************************/
/*	`F	void j_page_set( int flag )										*/
/*	F	flag	OF													*/
/*					PFE													*/
/*	F	AvP[Vw												*/
/*			߂Ăy[W̍E̐ݒ									*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_page_set( int flag )
{
	static int tpage_tbl[][2] = { {J_VRAMX_CENTER_L_MOJI,0},
										{J_VRAMX_CENTER_R_MOJI,0} };

	static int tpage_tbl2[][2] = { {J_VRAMX_LEFT_PAGE,0},
										{J_VRAMX_RIGHT_PAGE,0} };

	M_prim_tpage(objp_buff[J_OBJ_CENTER_MOJI]) =
						GetTPage(0,1,tpage_tbl[flag][0],tpage_tbl[flag][1]);

	M_prim_tpage(objp_buff[J_OBJ_CENTER_PAGE]) =
						GetTPage(0,1,tpage_tbl2[flag][0],tpage_tbl2[flag][1]);
}


/***< global function >******************************************************/
/*	`F	void J_POLY_FT4_W_Init(POLY_FT4_W *objp, u_long *colp, short x,	*/
/*	F						short y, short z, u_char rgb, long scale)	*/
/*	F	AvP[Vw												*/
/*			|S̏												*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void J_POLY_FT4_W_Init(	POLY_FT4_W *objp, u_long *colp, short x,
								short y, short z, u_char rgb, long scale)
{
	M_vect_x_h(objp) = x;									/* W */
	M_vect_y_h(objp) = y;									/* W */
	M_vect_z_h(objp) = z;									/* W */
	setRGB0(&M_prim(objp), rgb, rgb, rgb);					/* Pxl */
	setVector(	&M_vect_scale(objp), scale*(M_graph_x_res()/M_graph_y_res()),
				scale, scale);							/* ޸ */
}

/***< global function >******************************************************/
/*	`F	void j_set_space( u_short *work_area)							*/
/*	F	擪AhX													*/
/*	F	AvP[Vw												*/
/*			󔒕̐ݒ													*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_set_space( u_short *work_area )
{
	int		i;

	for( i=0; i<12*L_FONT_SIZE/4; i++ ){
		work_area[i] = 0x00;
	}
}

/***< global function >******************************************************/
/*	`F	void j_draw_string(short x, short y, short w, short h,			*/
/*														char *string)		*/
/*	F	x	F[hʒûwW										*/
/*			y	F[hʒûxW										*/
/*			w	F[ḧ̕											*/
/*			h	F[ḧ̍											*/
/*			string	F												*/
/*	F	AvP[Vw												*/
/*			tHg̃[h											*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_draw_string(short x, short y, short w, short h, char *string)
{
	u_short *ptr;
	int line = 0;
	int colum = 0;
	static u_short work_area[L_FONT_SIZE*L_FONT_SIZE/4];

	if( string != NULL ){
		while ( *string != '\0' ) {
			if ( (*string == '\n') || (*string == 'n') ) {
				if( colum != 0 ){
					colum = 0;
					line++;
				}
				if( line >= h )		break;
				if( *string == 'n' )	string++;
				string++;
			}
			else{
				if( colum >= w ){
					colum = 0;
					line++;
					if( line >= h )		break;
				}
				ptr = GetKanjiAddress((u_char *)string,
										(u_short *)J_GDATA_BIN_FONT_TBL);
				if( ptr == NULL ){
					j_set_space(work_area);
				}
				else{
					ExpandKanji(ptr, work_area, line+1, 0);
				}
				OLoadImage(x+colum*L_FONT_SIZE/4, y+line*L_FONT_SIZE,
							L_FONT_SIZE/4, L_FONT_SIZE, (u_long *)work_area);
				DrawSync(0);
				string += 2;
				colum ++;
			}
		}
	}
}

/***< global function >******************************************************/
/*	`F	void j_set_clut()												*/
/*	F																	*/
/*	F	AvP[Vw												*/
/*			bkts̐ݒ													*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_set_clut()
{
	M_prim_clut(objp_buff[J_OBJ_LEFT_MOJI]) = GetClut(160,481);
	M_prim_clut(objp_buff[J_OBJ_RIGHT_MOJI]) = GetClut(0,481);
	M_prim_clut(objp_buff[J_OBJ_LEFT_PAGE]) = GetClut(0,482);
	M_prim_clut(objp_buff[J_OBJ_RIGHT_PAGE]) = GetClut(0,482);
	M_prim_clut(objp_buff[J_OBJ_CENTER_PAGE]) = GetClut(0,482);
	M_prim_clut(objp_buff[J_OBJ_CENTER_U]) = GetClut(0,482);
	M_prim_clut(objp_buff[J_OBJ_RIGHT_U]) = GetClut(0,482);
	M_prim_clut(objp_buff[J_OBJ_LEFT_U]) = GetClut(0,482);
	M_prim_clut(objp_buff[J_OBJ_LEFT_SIDE]) = GetClut(0,482);
	M_prim_clut(objp_buff[J_OBJ_RIGHT_SIDE]) = GetClut(0,482);
}


/***< global function >******************************************************/
/*	`F	void j_tim_trans()												*/
/*	F																	*/
/*	F	AvP[Vw												*/
/*			shl̓]													*/
/*	ԒlF																	*/
/****************************************************************************/
STATIC void j_tim_trans()
{
	S_trans_set((u_long *)J_GDATA_TIM_DIC_FR, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_DIC_FL, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_DIC_SL, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_DIC_SR, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_DIC_U, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_A_DIC, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_KA_DIC, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_SA_DIC, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_TA_DIC, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_NA_DIC, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_HA_DIC, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_MA_DIC, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_YA_DIC, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_RA_DIC, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_WA_DIC, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_JI_00, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_JI_00, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_JI_01, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_JI_02, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_JI_03, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_JI_04, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_JI_05, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_JI_06, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_JI_07, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_JI_08, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_JI_09, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_DIC_BA00, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_DIC_BA01, 1 );
	S_trans_set((u_long *)J_GDATA_COL_DIC_M, 1 );

	/*@\֌W@*/
	S_trans_set((u_long *)J_GDATA_TIM_DIC_COV1, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_DIC_COV2, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_HYOU_D, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_DIC_KIN, 1 );
	S_trans_set((u_long *)J_GDATA_TIM_DIC_OBI, 1 );


}

static void J_InitSprite(J_GsSPRITE_PRIM *prim,u_long *address,short scale)
{
	#define	_4BITCLUT	0
	#define	_8BITCLUT	1
	GsIMAGE 	tim;
	u_short		w;
	u_char		u;
	
	address++;
	GsGetTimInfo(address, &tim);		/* TIM̫ϯĂ̧ͯނ𒲂ׂ */

	prim->state = ON;
	prim->sprite.attribute = ((tim.pmode&0x03)<<24);
	prim->sprite.x = (short)(prim->coord.vx);
	prim->sprite.y = (short)(prim->coord.vy);
	prim->sprite.scalex = (short)scale;
	prim->sprite.scaley = (short)scale;
	prim->sprite.rotate = 0;
	prim->sprite.r = 0x80;
	prim->sprite.g = 0x80;
	prim->sprite.b = 0x80;
	prim->sprite.tpage = GetTPage(tim.pmode&0x01,0,tim.px, tim.py);
	prim->sprite.cx = tim.cx;
	prim->sprite.cy = tim.cy;

	if ( (tim.pmode&0x01) == _4BITCLUT ) {
		u = tim.px % 64;
		u *= 4;
		w = tim.pw * 4;
	} else {
		if ( (tim.pmode&0x01) == _8BITCLUT ) {
			u = tim.px % 64;
			u *= 2;
			w = tim.pw * 2;
	} else {
		}
	}
	
	prim->sprite.u = u;
	prim->sprite.v = tim.py % 256;
	prim->sprite.w = w;
	prim->sprite.h = tim.ph;

	prim->sprite.mx = 0;
	prim->sprite.my = 0;


}
/***< global function >***************************************************/
/*	`F	void set_midasi_xy()										*/
/*	F																*/
/*	F												*/
/*			w肵XvCgv~eBuxystateZbg	*/
/*	ԒlF																*/
/*************************************************************************/
STATIC void set_midasi_xy(short number,short x,short y)
{
	prim[number].sprite.x = x;
	prim[number].sprite.y = y;
	prim[number].state = ON;
}


/***< local function >***************************************************/
/*	`F	void j_set_midasi								*/
/*	F																*/
/*	F	ʂ̌o̕\Ǘ				*/
/*				*/
/*	ԒlF																*/
/*************************************************************************/

STATIC void j_set_midasi(short midasi_no)
{
	short i;
	short right_x,right_y,left_x,left_y;
	
	for( i=JI_00; i<JI_09+1; i++ )
		prim[i].state = OFF;

	right_x = objp_buff[J_OBJ_RIGHT_SIDE]->vector.vect[0].vx;
	right_y = objp_buff[J_OBJ_RIGHT_SIDE]->vector.vect[0].vy;
	left_x = objp_buff[J_OBJ_LEFT_SIDE]->vector.vect[0].vx;
	left_y = objp_buff[J_OBJ_LEFT_SIDE]->vector.vect[0].vy;

		
			switch (midasi_no)
			{
				case 1:
					set_midasi_xy(JI_00,left_x+3,left_y+22);
					set_midasi_xy(JI_05,right_x+18,right_y+39);
					break;
				case 2:
					set_midasi_xy(JI_00,left_x+3,left_y+23);
					set_midasi_xy(JI_01,left_x+6,left_y+23+13);
					set_midasi_xy(JI_05,right_x+15,right_y+53);
					set_midasi_xy(JI_06,right_x+18,right_y+53+17);
				break;
				case 3:
					set_midasi_xy(JI_00,left_x+3,left_y+23);
					set_midasi_xy(JI_01,left_x+6,left_y+23+13);
					set_midasi_xy(JI_02,left_x+9,left_y+23+13+13);
					set_midasi_xy(JI_05,right_x+12,right_y+66);
					set_midasi_xy(JI_06,right_x+15,right_y+66+17);
					set_midasi_xy(JI_07,right_x+18,right_y+66+17+17);
				break;
				case 4:
					set_midasi_xy(JI_00,left_x+3,left_y+23);
					set_midasi_xy(JI_01,left_x+6,left_y+23+13);
					set_midasi_xy(JI_02,left_x+9,left_y+23+13+13);
					set_midasi_xy(JI_03,left_x+12,left_y+23+13+13+13);
					set_midasi_xy(JI_05,right_x+9,right_y+79);
					set_midasi_xy(JI_06,right_x+12,right_y+79+17);
					set_midasi_xy(JI_07,right_x+15,right_y+79+17+17);
					set_midasi_xy(JI_08,right_x+18,right_y+79+17+17+17);
				break;
				case 5:
					set_midasi_xy(JI_00,left_x+3,left_y+23);
					set_midasi_xy(JI_01,left_x+6,left_y+23+13);
					set_midasi_xy(JI_02,left_x+9,left_y+23+13+13);
					set_midasi_xy(JI_03,left_x+12,left_y+23+13+13+13);
					set_midasi_xy(JI_04,left_x+15,left_y+23+13+13+13+13);
					set_midasi_xy(JI_05,right_x+6,right_y+89);
					set_midasi_xy(JI_06,right_x+9,right_y+89+17);
					set_midasi_xy(JI_07,right_x+12,right_y+89+17+17);
					set_midasi_xy(JI_08,right_x+15,right_y+89+17+17+17);
					set_midasi_xy(JI_09,right_x+18,right_y+89+17+17+17+17);
				break;
				case 6:
					set_midasi_xy(JI_01,left_x+3,left_y+50);
					set_midasi_xy(JI_02,left_x+6,left_y+50+13);
					set_midasi_xy(JI_03,left_x+9,left_y+50+13+13);
					set_midasi_xy(JI_04,left_x+12,left_y+50+13+13+13);
					set_midasi_xy(JI_06,right_x+9,right_y+106);
					set_midasi_xy(JI_07,right_x+12,right_y+106+17);
					set_midasi_xy(JI_08,right_x+15,right_y+106+17+17);
					set_midasi_xy(JI_09,right_x+18,right_y+106+17+17+17);
				break;
				case 7:
					set_midasi_xy(JI_02,left_x+3,left_y+80);
					set_midasi_xy(JI_03,left_x+6,left_y+80+13);
					set_midasi_xy(JI_04,left_x+9,left_y+80+13+13);
					set_midasi_xy(JI_07,right_x+12,right_y+123);
					set_midasi_xy(JI_08,right_x+15,right_y+123+17);
					set_midasi_xy(JI_09,right_x+18,right_y+123+17+17);
				break;
				case 8:
					set_midasi_xy(JI_03,left_x+3,left_y+110);
					set_midasi_xy(JI_04,left_x+6,left_y+110+13);
					set_midasi_xy(JI_08,right_x+15,right_y+140);
					set_midasi_xy(JI_09,right_x+18,right_y+140+17);
				break;
				case 9:
					set_midasi_xy(JI_04,left_x+3,left_y+140);
					set_midasi_xy(JI_09,right_x+18,right_y+157);
				break;
			}
			 
			
}


/***< local function >***************************************************/
/*	`F	void j_set_hyousi_init()										*/
/*	F																*/
/*	F	ʂ̌o̕\Ǘ				*/
/*				*/
/*	ԒlF																*/
/*************************************************************************/
static void	j_set_hyous_init()
{
	short counter;
	
	M_disp_OFF(objp_buff[J_OBJ_LEFT_PAGE]);
	M_disp_OFF(objp_buff[J_OBJ_LEFT_MOJI]);
	M_disp_OFF(objp_buff[J_OBJ_LEFT_SIDE]);
	M_disp_OFF(objp_buff[J_OBJ_LEFT_U]);
	M_disp_OFF(objp_buff[J_OBJ_CENTER_U]);

	
	
	/*@\Ŏgp|S̏@*/
	for(counter = 0;counter<HYOUSI_MAX;counter++)
	{
		hyousi_obj[counter] = (POLY_FT4_W*)j_mode_test_set();
	} 
	
	
	S_POLY_FT4_W_InitAll(hyousi_obj[COV1],(u_long*)J_GDATA_TIM_DIC_COV1,
				NULL,0,0,10,0x80,ONE);
	hyousi_obj[COV1]->state.ot = 5;
	/*	E̎ʂ̃IuWF	*/
	setVector(&M_vect_v0(hyousi_obj[COV1]),
							      0, -88 -12, 0 );
	setVector(&M_vect_v1(hyousi_obj[COV1]),
								144, -88 -12, 0 );
	setVector(&M_vect_v2(hyousi_obj[COV1]),
							      0, 88 -12, 0 );
	setVector(&M_vect_v3(hyousi_obj[COV1]),
								144,  88-12, 0 );
	
	
	/*	{̔w	*/
	S_POLY_FT4_W_InitAll(hyousi_obj[COV2],(u_long*)J_GDATA_TIM_DIC_COV2,
				NULL,0,0,10,0x80,ONE);
	hyousi_obj[COV2]->state.ot = 0;
	setVector(&M_vect_v0(hyousi_obj[COV2]),
							      -7, -88 -12, 0 );
	setVector(&M_vect_v1(hyousi_obj[COV2]),
								1, -88 -12, 0 );
	setVector(&M_vect_v2(hyousi_obj[COV2]),
							      -7, 88 -12, 0 );
	setVector(&M_vect_v3(hyousi_obj[COV2]),
								1,  88-12, 0 );
	
	/*	{̒	*/
		S_POLY_FT4_W_InitAll(hyousi_obj[HYOU_D],(u_long*)J_GDATA_TIM_HYOU_D,
				NULL,0,0,10,0x80,ONE);
	hyousi_obj[HYOU_D]->state.ot = 0;
	setVector(&M_vect_v0(hyousi_obj[HYOU_D]), -31, 62   , 0 );
	setVector(&M_vect_v1(hyousi_obj[HYOU_D]),  32, 62   , 0 );
	setVector(&M_vect_v2(hyousi_obj[HYOU_D]), -31, 62+48, 0 );
	setVector(&M_vect_v3(hyousi_obj[HYOU_D]),  32, 62+48, 0 );
	
	/*	\̋F̕	*/
	S_POLY_FT4_W_InitAll(hyousi_obj[KIN],(u_long*)J_GDATA_TIM_DIC_KIN,
				NULL,0,0,8,0x80,ONE);
	hyousi_obj[KIN]->state.ot = 8;
	setVector(&M_vect_v0(hyousi_obj[KIN]), 0, -88 -12  , 0 );
	setVector(&M_vect_v1(hyousi_obj[KIN]), 144, -88 -12  , 0 );
	setVector(&M_vect_v2(hyousi_obj[KIN]), 0, -8 -12, 0 );
	setVector(&M_vect_v3(hyousi_obj[KIN]),  144, -8 -12, 0 );

	/*		*/
	S_POLY_FT4_W_InitAll(hyousi_obj[OBI],(u_long*)J_GDATA_TIM_DIC_OBI,
				NULL,0,0,8,0x80,ONE);
	hyousi_obj[OBI]->state.ot = 8;
	setVector(&M_vect_v0(hyousi_obj[OBI]), 0, -28 -12 +107 -60, 0 );
	setVector(&M_vect_v1(hyousi_obj[OBI]), 144, -28 -12 +107 -60, 0 );
	setVector(&M_vect_v2(hyousi_obj[OBI]), 0, 28 -12 +107 -60, 0 );
	setVector(&M_vect_v3(hyousi_obj[OBI]),  144, 28 -12 +107 -60, 0 );



	for(counter = J_OBJ_CENTER_MOJI;counter<=J_OBJ_LEFT_SIDE;counter++)
	{
		M_vect_x_h(objp_buff[counter]) += 25/*15*/;
	}
	for( counter=0; counter<11; counter++ )
	{
		M_vect_x_h(mokuji_el[counter]) += 25/*15*/;
	}
	for( counter=0; counter<HYOUSI_MAX; counter++ )
	{
		M_vect_x_h(hyousi_obj[counter]) += 25/*15*/;
	}

	hyousi_step = 0;
}

/***< local function >***************************************************/
/*	`F	void j_set_hyousi()										*/
/*	F																*/
/*	F	ʂ̌o̕\Ǘ				*/
/*				*/
/*	ԒlF																*/
/*************************************************************************/
static void	j_set_hyousi()
{
	#define	WAIT1	20
	#define	MOVE	WAIT1+15
	#define	WAIT2	MOVE+20
	#define	ROTATE1	WAIT2+30
	#define	ROTATE2	ROTATE1+30
	
	short counter;
	if(hyousi_step<WAIT1)
	{
		hyousi_step++;
	}
	if(hyousi_step<MOVE)
	{
		hyousi_step++;
		for(counter = J_OBJ_CENTER_MOJI;counter<=J_OBJ_LEFT_SIDE;counter++)
		{
			M_vect_x_h(objp_buff[counter])--;
		}
		for( counter=0; counter<11; counter++ )
		{
			M_vect_x_h(mokuji_el[counter])--;
		}
		for( counter=0; counter<HYOUSI_MAX; counter++ )
		{
			M_vect_x_h(hyousi_obj[counter])--;
		}
	}
	else if(hyousi_step<WAIT2)
	{
		hyousi_step++;
	}
	else if(hyousi_step<ROTATE1)
	{
		hyousi_step++;
		
		M_vect_angle_y_h(hyousi_obj[COV1]) += 3*(ONE/360);
		M_vect_angle_y_h(hyousi_obj[KIN]) += 3*(ONE/360);
		M_vect_angle_y_h(hyousi_obj[OBI]) += 3*(ONE/360);
		/*̃oN_hyousi_obj[HYOU_D]*/
		hyousi_obj[HYOU_D]->state.ot = 0;
	}
	else if(hyousi_step==ROTATE1)
	{
		hyousi_step++;
		
		M_disp_ON(objp_buff[J_OBJ_LEFT_PAGE]);
		M_vect_angle_y_h(objp_buff[J_OBJ_LEFT_PAGE]) = -90*(ONE/360);
		M_vect_angle_y_h(objp_buff[J_OBJ_LEFT_MOJI]) = -90*(ONE/360);
		M_vect_angle_y_h(objp_buff[J_OBJ_LEFT_U]   ) = -90*(ONE/360);
		/*
		M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_U] ) = -90*(ONE/360);
		*/
		objp_buff[J_OBJ_LEFT_PAGE]->state.ot = 3;
		hyousi_obj[COV1]->state.ot = 2;
		hyousi_obj[KIN]->state.ot = 2;
		hyousi_obj[OBI]->state.ot = 2;
		
		M_disp_ON(objp_buff[J_OBJ_LEFT_PAGE]);
		M_disp_ON(objp_buff[J_OBJ_LEFT_MOJI]);
		M_disp_ON(objp_buff[J_OBJ_CENTER_U]);
		
		for( counter=0; counter<HYOUSI_MAX; counter++ )
		{
			M_disp_OFF(hyousi_obj[counter]);
		}
	}
	else if(hyousi_step<ROTATE2)
	{
		hyousi_step++;
		M_vect_angle_y_h(hyousi_obj[COV1]) += 3*(ONE/360);
		M_vect_angle_y_h(hyousi_obj[KIN]) += 3*(ONE/360);
		M_vect_angle_y_h(hyousi_obj[OBI]) += 3*(ONE/360);
		M_vect_angle_y_h(objp_buff[J_OBJ_LEFT_PAGE]) += 3*(ONE/360);
		M_vect_angle_y_h(objp_buff[J_OBJ_LEFT_MOJI]) += 3*(ONE/360);
		M_vect_angle_y_h(objp_buff[J_OBJ_LEFT_U]   ) += 3*(ONE/360);
		/*
		M_vect_angle_y_h(objp_buff[J_OBJ_CENTER_U] ) += 3*(ONE/360);
		*/
		
		M_disp_ON(objp_buff[J_OBJ_LEFT_U]);
	}
	else
	{
		page_no = -1;
		
		objp_buff[J_OBJ_LEFT_PAGE]->state.ot = 0;
		M_disp_ON(objp_buff[J_OBJ_LEFT_SIDE]);
		
	}
#if 0
#endif
}

/*------------------------------------------------------------------*/
/*		Of[Vwîhmhs								*/
/*------------------------------------------------------------------*/
static void background_init ()
{
	SetPolyG4( &bg );
	setRGB0( &bg, 0x00, 0x4f, 0xa1 );
	setRGB1( &bg, 0x00, 0x4f, 0xa1 );
	setRGB2( &bg, 0x31, 0x6b, 0x94 );
	setRGB3( &bg, 0x31, 0x6b, 0x94 );
	setXY4(  &bg, -160,-104, 160,-104, -160,8, 160,8 );
}

