#include	"lt_all.h"
#include	"s_color.h"
#include	"s_trans.h"
#include	"l_kanji.h"
#include	"kou_sub.h"
#include	"kous_dat.h"
#include	"pachinko.h"
#include	"ks_hyoji.h"
#include	"p_data.h"
#include	"p_datas.h"

#define		INIT_SHORI			0
#define		DATA_SELECT			1
#define		KOUMOKU_SELECT		2
#define		END_SHORI			3
#define		END_				4

#define		KANJI_VRAM_X		320
#define		KANJI_VRAM_Y		256


enum	_ks_hy_opd_num{	SENTAKU_ANIME=5,		ICHIRAN_ANIME	};

static void p_hyouji_data_select_i();
static void p_hyouji_data_select_m0();
static void p_hyouji_data_select_m1();
static void p_hyouji_data_select_e();
static void p_set_data_koumoku_l( int num );
static void p_set_data_koumoku_r( int num, int data );
static void p_mes_sprite_init();
static void p_mes_sprite_hyouji();

static int			hyouji_select_num;
static int			hyouji_select_data;
static GsSPRITE		data_r[4];
static GsSPRITE		data_l[11];


int P_hyouji_data_select()
{
	switch( p_sys_w.main_step ){
		case INIT_SHORI:
			p_hyouji_data_select_i();
			S_fadein_black();							/* ̪ޱ */
			break;
		case DATA_SELECT:
			p_hyouji_data_select_m0();
			break;
		case KOUMOKU_SELECT:
			p_hyouji_data_select_m1();
			break;
		case END_SHORI:
			p_hyouji_data_select_e();
			break;
		case END_:
			return( 1 );
			break;
	}

	p_mes_sprite_hyouji();

	return( 0 );
}

static void p_hyouji_data_select_i()
{
	int		i;
	RECT rect;

	S_trans_set((u_long *)KOUS_DAT_COL_HYOJI, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HY_DATA, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HYOJI_1, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HYOJI_2, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HYOJI_3, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HYOJI_4, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HYOJI_5, (u_short)1);


	ks_w.opd_p[SENTAKU_ANIME]= (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ks_w.opd_p[SENTAKU_ANIME]->ot = 5;
	ks_w.opd_p[SENTAKU_ANIME]->opd_address = (u_long)KOUS_DAT_OPD_HY_SENT;
	ks_w.opd_p[SENTAKU_ANIME]->center_x = -160;
	ks_w.opd_p[SENTAKU_ANIME]->center_y = -104;
	O_OPD_W_INIT(ks_w.opd_p[SENTAKU_ANIME], 0);

	ks_w.opd_p[ICHIRAN_ANIME]= (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ks_w.opd_p[ICHIRAN_ANIME]->ot = 4;
	ks_w.opd_p[ICHIRAN_ANIME]->opd_address = (u_long)KOUS_DAT_OPD_HY_OJI;
	ks_w.opd_p[ICHIRAN_ANIME]->center_x = -160;
	ks_w.opd_p[ICHIRAN_ANIME]->center_y = -104;
	O_OPD_W_INIT(ks_w.opd_p[ICHIRAN_ANIME], 0);

	hyouji_select_num = 0;
	hyouji_select_data = 0;

	rect.x = KANJI_VRAM_X;
	rect.y = KANJI_VRAM_Y;
	rect.w = 192;
	rect.h = 256;
	ClearImage( &rect, 0, 0, 0 );
	DrawSync(0);

	p_set_data_koumoku_l( hyouji_select_data );
	for( i=0; i<4; i++)
		p_set_data_koumoku_r( i, p_sys_w.hyouji_data[i] );

	p_mes_sprite_init();

	P_main_step_set(DATA_SELECT);
}

static void p_hyouji_data_select_m0()
{
	if(M_fade_flag() == OFF) {
		if(S_PAD_LU0){
			hyouji_select_num = (hyouji_select_num+4)%5;
			O_opd_anime_change( ks_w.opd_p[SENTAKU_ANIME], hyouji_select_num );
		}
		else if(S_PAD_LD0){
			hyouji_select_num = (hyouji_select_num+1)%5;
			O_opd_anime_change( ks_w.opd_p[SENTAKU_ANIME], hyouji_select_num );
		}
		else if(S_PAD_RR1){
			if( hyouji_select_num == 4 ){
				P_main_step_set(END_SHORI);
				S_fadeout_black();							/* ̪ޱ */
			}
			else{
				O_opd_anime_change( ks_w.opd_p[SENTAKU_ANIME], hyouji_select_num+5 );
				P_main_step_set(KOUMOKU_SELECT);
			}
		}
	}
}

static void p_hyouji_data_select_m1()
{
	if(S_PAD_RR1){
		p_sys_w.hyouji_data[hyouji_select_num] = hyouji_select_data;
		p_set_data_koumoku_r( hyouji_select_num, p_sys_w.hyouji_data[hyouji_select_num] );
		O_opd_anime_change( ks_w.opd_p[SENTAKU_ANIME], hyouji_select_num );
		P_main_step_set(DATA_SELECT);
	}
	else if(S_PAD_LU0){
		hyouji_select_data--;
		if( hyouji_select_data < 0 )
			hyouji_select_data = 0;
		p_set_data_koumoku_l( hyouji_select_data );
	}
	else if(S_PAD_LD0){
		hyouji_select_data++;
		if( p_data_list[p_pachi_shubetu[S_sys_w->pachinkow.pach_num]][hyouji_select_data] == -1 )
			hyouji_select_data--;
		p_set_data_koumoku_l( hyouji_select_data );
	}
}

static void p_hyouji_data_select_e()
{
	if(M_fade_flag() == OFF) {
		ks_w.opd_p[SENTAKU_ANIME]->terminate_flag = ON;
		ks_w.opd_p[ICHIRAN_ANIME]->terminate_flag = ON;
		P_main_step_set(END_);
	}
}


static void p_set_data_koumoku_l( int num )
{
	int		i;
	int		data_id;
	int		data_end;

	data_end = 0;
	for( i=0; i<11; i++ ){

		if( (num+i-5 < 0) || (data_end == 1) ){
			Kanji12_load2( "",
					(u_short *)KOUS_DAT_BIN_FONT_TBL, 28, RGB5(0x03,0x0a,0x13),
					KANJI_VRAM_X+24, KANJI_VRAM_Y+i*12, 0 );
		}
		else if( p_data_list[p_pachi_shubetu[S_sys_w->pachinkow.pach_num]][num+i-5] == -1 ){
			Kanji12_load2( "",
					(u_short *)KOUS_DAT_BIN_FONT_TBL, 28, RGB5(0x03,0x0a,0x13),
					KANJI_VRAM_X+24, KANJI_VRAM_Y+i*12, 0 );
			data_end = 1;
		}
		else{
			data_id = p_data_list[p_pachi_shubetu[S_sys_w->pachinkow.pach_num]][num+i-5];

			Kanji12_load2( p_hyouji_list[data_id].message,
					(u_short *)KOUS_DAT_BIN_FONT_TBL, 28, RGB5(0x03,0x0a,0x13),
					KANJI_VRAM_X+24, KANJI_VRAM_Y+i*12, 0 );
		}
	}
}


static void p_set_data_koumoku_r( int num, int data )
{
	int		data_id;

	data_id = p_data_list[p_pachi_shubetu[S_sys_w->pachinkow.pach_num]][data];

	Kanji12_load2( p_hyouji_list[data_id].message,
					(u_short *)KOUS_DAT_BIN_FONT_TBL, 16, RGB5(0x1b,0x02,0x12),
					KANJI_VRAM_X, KANJI_VRAM_Y+132+24*num, 0 );

	if( strlen(p_hyouji_list[data_id].message) > 16 ){
		Kanji12_load2( &p_hyouji_list[data_id].message[16],
					(u_short *)KOUS_DAT_BIN_FONT_TBL, 16, RGB5(0x1b,0x02,0x12),
					KANJI_VRAM_X, KANJI_VRAM_Y+132+24*num+12, 0 );
	}
	else{
		Kanji12_load2( "",
					(u_short *)KOUS_DAT_BIN_FONT_TBL, 16, RGB5(0x1b,0x02,0x12),
					KANJI_VRAM_X, KANJI_VRAM_Y+132+24*num+12, 0 );
	}
}


static void p_mes_sprite_init()
{
	int		i;

	for( i=0; i<11; i++ ){
		data_l[i].attribute = (2<<24);
		data_l[i].tpage = GetTPage( 2, 1, KANJI_VRAM_X, KANJI_VRAM_Y );

		data_l[i].scalex = ONE;
		data_l[i].scaley = ONE;
		data_l[i].rotate = 0;
		data_l[i].r = 0x80;
		data_l[i].g = 0x80;
		data_l[i].b = 0x80;
		data_l[i].mx = 0;
		data_l[i].my = 0;

		data_l[i].x = -145;
		data_l[i].y = -81+15*i;
		data_l[i].u = 0;
		data_l[i].v = 12*i;
		data_l[i].w = 192;
		data_l[i].h = 12;
	}


	for( i=0; i<4; i++ ){
		data_r[i].attribute = (2<<24);
		data_r[i].tpage = GetTPage( 2, 1, KANJI_VRAM_X, KANJI_VRAM_Y );

		data_r[i].scalex = ONE;
		data_r[i].scaley = ONE;
		data_r[i].rotate = 0;
		data_r[i].r = 0x80;
		data_r[i].g = 0x80;
		data_r[i].b = 0x80;
		data_r[i].mx = 0;
		data_r[i].my = 0;

		data_r[i].x = 50;
		data_r[i].y = -76+40*i;
		data_r[i].u = 0;
		data_r[i].v = 132+24*i;
		data_r[i].w = 96;
		data_r[i].h = 24;
	}
}

static void p_mes_sprite_hyouji()
{
	int		i;

	for( i=0; i<11; i++ ){
		GsSortSprite(&data_l[i], (GsOT *)&Wot[5][M_activebuff()], 
		(u_short)10);
	}

	for( i=0; i<4; i++ ){
		GsSortSprite(&data_r[i], (GsOT *)&Wot[5][M_activebuff()], 
		(u_short)10);
	}
}
