/***< file >**********************************************************
 *	Title		:	PlayStation										 *
 *	Version		:	1.00										     *
 *	Code		:	vx022											 *
 *	Filename	:   kouryaku.c										 *
 *	Author		:	KONAMI(c) usr01737 oohashi						 *
 *	Date		:	1995.11.28										 *
 *	Note		:	UIiW͂j			         *
 *********************************************************************/

#include	"lt_all.h"
#include	"s_memory.h"
#include	"s_color.h"
#include	"s_step.h"
#include	"l_kanji.h"
#include	"kouryaku.h"
#include	"kou_sub.h"
#include	"kous_dat.h"
#include	"ks_kaise.h"

#define		KS_INIT			0
#define		KS_KAISEKI		1
#define		KS_EXIT			2

static	POLY_FT4		mess_ft4[16][2];
static	POLY_F4			poly_f4[16];
static	POLY_FT4		poly_ft4[16];
static	GsSPRITE		sprite[4];

/*===================================================================*/
/*	Include															 */
/*===================================================================*/
static void k_kaiseki_init();
static int  k_filename_disp( char file_name[16][32], int flag );
static void k_set_cursor();
static void k_message( char message[], int timer );


static char		file_name[2][16][32];
static int		top_line[2];
static int		cur_line[2];

void K_kaiseki()
{
	int		i;
	static int	mes_timer;
	static int	mes_no;

	static char		message[8][160] = {
				/*	PPȏWO			*/
				"@@@@@͂f[^IłBQ܂őIׂ܂",
				"@@@@@[J[h܂",
				"@@@@@{^ŉ͂Jnł܂",
	};

	switch (M_gstepw_s()) {
		case KS_INIT:
			S_sys_w->vsync_no = 2;
			ks_w.back_line = (POLY_G4 *)S_malloc( sizeof(POLY_G4)*320 );
			top_line[0] = top_line[1] = 0;
			cur_line[0] = cur_line[1] = 0;
			mes_no = 0;
			mes_timer = 0;

			s_memory_file( file_name[0], 0 );
			s_memory_file( file_name[1], 1 );
			k_kaiseki_init();

			k_filename_disp( file_name[0], 0 );
			k_filename_disp( file_name[1], 1 );

			S_gstepw_s_set(KS_KAISEKI);
			k_back_unyo( S_sys_w->stimer, ks_w.back_line );
			S_fadein_black();
			break;
		case KS_KAISEKI:
			/* `èނOTɓo^ */

			if(M_fade_flag() == OFF){
				if(M_joy_trg(0) & PADRdown){
					S_fadeout_black();
					S_gstepw_s_set(KS_EXIT);
				}
				else if(M_joy_trg(0) & PADRright){
					mes_no++;
					mes_no %= 2;
				}
			}

			k_filename_disp( file_name[0], 0 );
			k_filename_disp( file_name[1], 1 );
			k_message( message[mes_no], mes_timer++ );

			k_back_unyo( S_sys_w->stimer, ks_w.back_line );

			break;
		case KS_EXIT:
			k_back_unyo( S_sys_w->stimer, ks_w.back_line );

			if(M_fade_flag() == OFF){
				ks_w.opd_p[0]->terminate_flag = ON;
				ks_w.opd_p[1]->terminate_flag = ON;
				ks_w.opd_p[2]->terminate_flag = ON;
				ks_w.opd_p[3]->terminate_flag = ON;
				ks_w.opd_p[4]->terminate_flag = ON;
				S_free( (char *)ks_w.back_line );
				S_gstepw_set( K_SELECT );
			}

			break;
	}
	for( i=0; i<10; i++ ){
		if( i < 2 )
			GsSortPoly( &poly_f4[i], (GsOT *)&Wot[2][M_activebuff()], 60 );
		else
			GsSortPoly( &poly_f4[i], (GsOT *)&Wot[3][M_activebuff()], 60 );
	}

	k_set_cursor();

}


static int k_filename_disp( char file_name[16][32], int flag )
{
#define		LINE_NO		7
	setXY4( &poly_ft4[0],  -106,-91,  -10,-91,  -106,-2,  -10,-2 );
	GsSortPoly( &poly_ft4[0], (GsOT *)&Wot[4][M_activebuff()], 30 );
	setXY4( &poly_ft4[1],  46,-91,  142,-91,  46,-2,  142,-2 );
	GsSortPoly( &poly_ft4[1], (GsOT *)&Wot[4][M_activebuff()], 30 );

	return(0);
}

static void k_kaiseki_init()
{
	GsIMAGE 	tim;
	int			i, j;
	RECT	rect;

	rect.x = 320;
	rect.y = 256;
	rect.w = 320;
	rect.h = 256;
	ClearImage( &rect, 0, 0, 0 );

	for( i=0,j=0; i<16; i++ ){
		if( file_name[0][i][0] != 0 ){
			Kanji12_load2( file_name[0][i], (u_short *)KOUS_DAT_BIN_FONT_TBL,
						16, RGB5(0x05,0x06,0x08), 320, 256+13*j, 0 );
			j++;
		}
	}

	for( i=0,j=0; i<16; i++ ){
		if( file_name[1][i][0] != 0 ){
			Kanji12_load2( file_name[1][i], (u_short *)KOUS_DAT_BIN_FONT_TBL,
						16, RGB5(0x05,0x06,0x08), 320+192, 256+13*j, 0 );
			j++;
		}
	}

#if 0
	S_trans_set((u_long *)KOUS_DAT_TIM_K_BACK1, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_TIM_K_BACK2, (u_short)1);

	for( i=0; i<2; i++ ){
		sprite[i].attribute = (1<<24);
		sprite[i].scalex = ONE;
		sprite[i].scaley = ONE;
		sprite[i].rotate = 0;
		sprite[i].r = 0x80;
		sprite[i].g = 0x80;
		sprite[i].b = 0x80;
		sprite[i].y = -104;
		sprite[i].u = 0;
		sprite[i].v = 0;
		sprite[i].w = 160;
		sprite[i].h = 208;
		sprite[i].mx = 0;
		sprite[i].my = 0;
	}
#endif

	for( i=0; i<10; i++ ){
		SetPolyF4( &poly_f4[i] );

		if( i < 2 )
			setRGB0( &poly_f4[i], 145, 145, 190 );
		else
			setRGB0( &poly_f4[i], 95, 70, 17 );
	}

	setXY4( &poly_f4[0], -135,-97,   -7,-97, -135,  4,   -7,  4 );
	setXY4( &poly_f4[1],   17,-97,  145,-97,   17,  4,  145,  4 );
	setXY4( &poly_f4[2], -135,-97,   -7,-97, -135,-96,   -7,-96 );
	setXY4( &poly_f4[3], -135,  3,   -7,  3, -135,  4,   -7,  4 );
	setXY4( &poly_f4[4], -135,-97, -134,-97, -135,  4, -134,  4 );
	setXY4( &poly_f4[5],   -8,-97,   -7,-97,   -8,  4,   -7,  4 );
	setXY4( &poly_f4[6],   17,-97,  145,-97,   17,-96,  145,-96 );
	setXY4( &poly_f4[7],   17,  3,  145,  3,   17,  4,  145,  4 );
	setXY4( &poly_f4[8],   17,-97,   18,-97,   17,  4,   18,  4 );
	setXY4( &poly_f4[9],  144,-97,  145,-97,  144,  4,  145,  4 );

											/* J[\						*/
	SetPolyF4( &poly_f4[10] );
	setRGB0( &poly_f4[10], 200, 210, 217 );

											/* t@C FONT				*/
	SetPolyFT4( &poly_ft4[0] );
	setRGB0( &poly_ft4[0], 41, 48, 64 );
	poly_ft4[0].tpage = GetTPage( 2, 1, 256, 256 );
	setUVWH( &poly_ft4[0], 64, 0, 96, 89 );
	SetPolyFT4( &poly_ft4[1] );
	poly_ft4[1].tpage = GetTPage( 2, 1, 512, 256 );
	setRGB0( &poly_ft4[1], 41, 48, 64 );
	setUVWH( &poly_ft4[1], 0, 0, 96, 89 );

											/* bZ[W					*/
	for( i=0; i<16; i++ ){
		for( j=0; j<2; j++ ){
			SetPolyFT4( &mess_ft4[i][j] );
			mess_ft4[i][j].tpage = GetTPage( 2, 1, 256, 256 );
			setRGB0( &mess_ft4[i][j], 255, 255, 255 );
		}
	}

											/* TIM̫ϯĂ̧ͯނ𒲂ׂ */
	GsGetTimInfo(((u_long *)KOUS_DAT_TIM_K_BACK1)+1, &tim);
	sprite[0].x = -160;
	sprite[0].tpage = GetTPage( 1, 1, tim.px, tim.py );
	sprite[0].cx = tim.cx;
	sprite[0].cy = tim.cy;

	GsGetTimInfo(((u_long *)KOUS_DAT_TIM_K_BACK2)+1, &tim);
	sprite[1].x = 0;
	sprite[1].tpage = GetTPage( 1, 1, tim.px, tim.py );
	sprite[1].cx = tim.cx;
	sprite[1].cy = tim.cy;

	ks_w.opd_p[0]= (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ks_w.opd_p[0]->ot = 4;
	ks_w.opd_p[0]->opd_address = (u_long)KOUS_DAT_OPD_K_MEMO1;
	ks_w.opd_p[0]->center_x = -160;
	ks_w.opd_p[0]->center_y = -104;
	O_OPD_W_INIT(ks_w.opd_p[0], 0);

	ks_w.opd_p[1]= (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ks_w.opd_p[1]->ot = 4;
	ks_w.opd_p[1]->opd_address = (u_long)KOUS_DAT_OPD_K_MEMO2;
	ks_w.opd_p[1]->center_x = -160;
	ks_w.opd_p[1]->center_y = -104;
	O_OPD_W_INIT(ks_w.opd_p[1], 0);

	ks_w.opd_p[2]= (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ks_w.opd_p[2]->ot = 4;
	ks_w.opd_p[2]->opd_address = (u_long)KOUS_DAT_OPD_K_LDATA;
	ks_w.opd_p[2]->center_x = -160;
	ks_w.opd_p[2]->center_y = -104;
	O_OPD_W_INIT(ks_w.opd_p[2], 0);

	ks_w.opd_p[3]= (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ks_w.opd_p[3]->ot = 4;
	ks_w.opd_p[3]->opd_address = (u_long)KOUS_DAT_OPD_K_RDATA;
	ks_w.opd_p[3]->center_x = -160;
	ks_w.opd_p[3]->center_y = -104;
	O_OPD_W_INIT(ks_w.opd_p[3], 0);

	ks_w.opd_p[4]= (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	ks_w.opd_p[4]->ot = 4;
	ks_w.opd_p[4]->opd_address = (u_long)KOUS_DAT_OPD_MESSAGE;
	ks_w.opd_p[4]->center_x = -160;
	ks_w.opd_p[4]->center_y = -104;
	O_OPD_W_INIT(ks_w.opd_p[4], 0);

}


static void k_set_cursor()
{
	setXY4( &poly_f4[10],  -133,-91,  -10,-91,  -133,-79,  -10,-79 );
	GsSortPoly( &poly_f4[10], (GsOT *)&Wot[3][M_activebuff()], 30 );
}

static void k_message( char message[], int timer )
{
	static char		cur_message[160];
	static int		len_message;
	int				i;
	int				len;
	int				char_no, char_shift, line, colum;

	if( (timer == 0) || strcmp(cur_message,message) ){
		strcpy( cur_message, message );
		len_message = strlen( cur_message )/2;

		for( i=0,len=len_message; len>0; i++,len-=5 ){
			Kanji12_load2( &cur_message[(len_message-len)*2],
					(u_short *)KOUS_DAT_BIN_FONT_TBL,
					(len_message<5)?len_message*2:5*2, RGB5(0x31,0x31,0x31),
					448, 256+i*12, 0 );
		}
	}

	timer /= 1;
	timer %= (len_message*12);

	char_no = timer/12;
	char_shift = timer%12;

	for( i=0; i<14; i++ ){
		colum = char_no%5;
		line = char_no/5;

		setUVWH( &mess_ft4[i][0], 192+colum*12, 12*line,
										char_shift, 11 );
		setUVWH( &mess_ft4[i][1], 192+colum*12+char_shift, 12*line,
										12-char_shift, 11 );
		setXY4( &mess_ft4[i][0], -78+i*12-char_shift,27, -78+i*12,27,
									-78+i*12-char_shift,38, -78+i*12,38 );
		setXY4( &mess_ft4[i][1], -78+i*12,27, -78+i*12+12-char_shift,27,
									-78+i*12,38, -78+i*12+12-char_shift,38 );

		if( i != 0 )
			GsSortPoly( &mess_ft4[i][0], (GsOT *)&Wot[5][M_activebuff()], 30 );

		if( i != 13 )
			GsSortPoly( &mess_ft4[i][1], (GsOT *)&Wot[5][M_activebuff()], 30 );

		char_no = (char_no+1)%len_message;
	}
}


