/***< file >**********************************************************
 *	Title		:	PlayStation										 *
 *	Version		:	1.00										     *
 *	Code		:	vx022											 *
 *	Filename	:   kouryaku.c										 *
 *	Author		:	KONAMI(c) usr01737 oohashi						 *
 *	Date		:	1995.11.28										 *
 *	Note		:	UIiW͂j			         *
 *********************************************************************/

#include	<libmath.h>
#include	<memory.h>
#include	"lt_all.h"
#include	"s_init.h"
#include	"s_color.h"
#include	"s_step.h"
#include	"s_trans.h"
#include	"l_kanji.h"
#include	"l_math.h"
#include	"kouryaku.h"
#include	"kou_sub.h"
#include	"kous_dat.h"
#include	"ks_shush.h"
#include	"ks_hyoji.h"
#include	"pachinko.h"

#define		KS_INIT					0
#define		KS_DAIO_TOUJOU			1
#define		KS_SENTAKU				2
#define		KS_SENTAKU_WAIT			3
#define		KS_CHANGE				4
#define		KS_KIHON				5
#define		KS_KUGI_CHOUSEI			6
#define		KS_HYOUJI_DATA			7
#define		KS_EXIT					8

#define		KS_KIHON_1				0
#define		KS_KIHON_2				1
#define		KS_KIHON_3				2
#define		KS_KIHON_4				3
#define		KS_KIHON_5				4
#define		KS_KIHON_6				5
#define		KS_KIHON_EXIT			6

#define		KS_DAI_X_LARGE			96
#define		KS_DAI_Y_LARGE			40
#define		KS_DAI_W_LARGE			127
#define		KS_DAI_H_LARGE			127
#define		KS_DAI_X_SMALL			50
#define		KS_DAI_Y_SMALL			21
#define		KS_DAI_W_SMALL			80
#define		KS_DAI_H_SMALL			80

#define		KS_BACK_X_LARGE			10
#define		KS_BACK_Y_LARGE			8
#define		KS_BACK_W_LARGE			300
#define		KS_BACK_H_LARGE			192
#define		KS_BACK_X_SMALL			10
#define		KS_BACK_Y_SMALL			8
#define		KS_BACK_W_SMALL			160
#define		KS_BACK_H_SMALL			108


/*===================================================================*/
/*	Include															 */
/*===================================================================*/

static void k_shushu_init();
static void k_shushu_back( int val );
static void k_shushu_waku( int flag );
static void k_shushu_dai( int no, int flag, int timer );
static void k_shushu_kihon( int mode );
static void k_kihon_data_load( int num );
static void k_kihon_message( int num, int timer );
static void k_kihon_line_message( int no, char message[], int timer,
													int vram_x, int vram_y );
static void k_kihon_data();

static	POLY_FT4		mess_ft4[4][16][2];
static	GsSPRITE		shushu_back[3][3];
static	GsSPRITE		shushu_waku[2];
static	POLY_FT4		shushu_dai[2];
static	int				kous_s_step;
static int		const_no;

enum	_ks_opd_num{	DAIO_ANIME,		YAJIRUSI_ANIME,		NAMAE_ANIME,
						KIHON_ANIME,	CONST_ANIME	};

enum	_ks_dai_flag{	DAI_MIGIE=-1,		DAI_TUUJOU,		DAI_HIDARIE,
						DAI_SMALL	};

#define	KS_KISHU_NO			(6)
#define	KS_CHANGE_TIME1		(20)
#define	KS_CHANGE_TIME2		(8)
#define	KS_CHANGE_INTERVAL	(256)


void K_shushu()
{
	static int		change_timer;
	static int		change_flag;

	switch (M_gstepw_s()) {
		case KS_INIT:
			bzero( (char *)&ks_w.opd_p, sizeof(ks_w.opd_p) );
			S_sys_w->pachinkow.pach_num = 0;
			S_sys_w->vsync_no = 2;
			k_shushu_init();
			S_gstepw_s_set(KS_DAIO_TOUJOU);
			S_fadein_black();
			break;
		case KS_DAIO_TOUJOU:
			k_shushu_back( S_sys_w->stimer );
			k_shushu_waku( 0 );
			k_shushu_dai( S_sys_w->pachinkow.pach_num, DAI_TUUJOU, 0 );

			if(M_fade_flag() == OFF){
				ks_w.opd_p[DAIO_ANIME] = (OPD_W*)S_obj_set( NULL, (u_long)O_OPD_W,
													sizeof(OPD_W), (u_short)1);
				ks_w.opd_p[DAIO_ANIME]->ot = 5;
				ks_w.opd_p[DAIO_ANIME]->opd_address = (u_long)KOUS_DAT_OPD_SCENE_1;
				ks_w.opd_p[DAIO_ANIME]->center_x = -160;
				ks_w.opd_p[DAIO_ANIME]->center_y = -104;
				O_OPD_W_INIT(ks_w.opd_p[DAIO_ANIME], 0);
				S_gstepw_s_set(KS_SENTAKU);
			}
			break;
		case KS_SENTAKU:
			k_shushu_back( S_sys_w->stimer );
			k_shushu_waku( 0 );
			k_shushu_dai( S_sys_w->pachinkow.pach_num, DAI_TUUJOU, 0 );

			if( ks_w.opd_p[DAIO_ANIME]->flag == 1 ){
				if(M_joy_trg(0) & PADRdown){
					S_fadeout_black();
					S_gstepw_s_set(KS_EXIT);
				}
				else if(S_PAD_RR1){
					ks_w.opd_p[DAIO_ANIME]->flag = 0;
					O_opd_anime_change( ks_w.opd_p[DAIO_ANIME], 2 );
					O_opd_anime_change( ks_w.opd_p[NAMAE_ANIME],
											7+S_sys_w->pachinkow.pach_num );
					ks_w.opd_p[YAJIRUSI_ANIME]->terminate_flag = ON;
					k_kihon_data_load( S_sys_w->pachinkow.pach_num );

					bzero( (char *)&p_sys_w, sizeof(p_sys_w) );
					p_sys_w.p_chousei_data =
								&p_chousei_data[S_sys_w->pachinkow.pach_num];
					p_sys_w.hyouji_data[0] = 0;
					p_sys_w.hyouji_data[1] = 1;
					p_sys_w.hyouji_data[2] = 2;
					p_sys_w.hyouji_data[3] = 3;
					p_sys_w.chousei_number = 0;
					p_sys_w.pachi_data.moti_tama_graph_y[0] = 0;
					p_sys_w.pachi_data.moti_tama_range_x = 1;
					p_sys_w.pachi_data.moti_tama_yuukou_x = 1;
					P_kugi_init();

					S_gstepw_s_set(KS_KIHON);
					kous_s_step = KS_KIHON_1;
				}
				else if(S_PAD_LR0){
					change_timer = 0;
					change_flag = DAI_MIGIE;
					S_gstepw_s_set(KS_CHANGE);
					O_opd_anime_change( ks_w.opd_p[YAJIRUSI_ANIME], 2 );
				}
				else if(S_PAD_LL0){
					change_timer = 0;
					change_flag = DAI_HIDARIE;
					S_gstepw_s_set(KS_CHANGE);
					O_opd_anime_change( ks_w.opd_p[YAJIRUSI_ANIME], 1 );
				}
			}
			break;
		case KS_SENTAKU_WAIT:
			k_shushu_back( S_sys_w->stimer );
			k_shushu_waku( 0 );
			k_shushu_dai( S_sys_w->pachinkow.pach_num, DAI_TUUJOU, 0 );

			if( M_fade_flag() == OFF ){
				S_gstepw_s_set(KS_SENTAKU);
			}

			break;
		case KS_CHANGE:
			k_shushu_back( S_sys_w->stimer );
			k_shushu_waku( 0 );

			k_shushu_dai( S_sys_w->pachinkow.pach_num, change_flag, change_timer );
			change_timer++;

			if( change_timer == KS_CHANGE_TIME1 ){
#ifdef CD_READ
if( S_sys_w->pachinkow.pach_num == 0 )	S_sys_w->pachinkow.pach_num = 2;
else									S_sys_w->pachinkow.pach_num = 0;
#else
				if( change_flag == DAI_HIDARIE ){
					S_sys_w->pachinkow.pach_num ++;
					S_sys_w->pachinkow.pach_num %= KS_KISHU_NO;
				}
				else if( change_flag == DAI_MIGIE ){
					S_sys_w->pachinkow.pach_num += KS_KISHU_NO-1;
					S_sys_w->pachinkow.pach_num %= KS_KISHU_NO;
				}
#endif
				O_opd_anime_change( ks_w.opd_p[YAJIRUSI_ANIME], 0 );
				O_opd_anime_change( ks_w.opd_p[NAMAE_ANIME], S_sys_w->pachinkow.pach_num );
				S_gstepw_s_set(KS_SENTAKU);
			}

			break;

		case KS_KIHON:
			k_kihon_data();
			break;
		case KS_KUGI_CHOUSEI:
			k_shushu_waku( 2 );
			if( P_kugi_chousei_main() ){
				S_disp_sys_change(320, 240);
				O_opd_anime_change( ks_w.opd_p[DAIO_ANIME], 0x0a );
				O_opd_anime_change( ks_w.opd_p[NAMAE_ANIME], S_sys_w->pachinkow.pach_num );
				O_opd_anime_change( ks_w.opd_p[CONST_ANIME], const_no );
				S_fadein_black();
				kous_s_step = KS_KIHON_4;
				S_gstepw_s_set(KS_KIHON);
			}
			break;
		case KS_HYOUJI_DATA:
			k_shushu_waku( 0 );

			if( P_hyouji_data_select() ){
				O_opd_anime_change( ks_w.opd_p[DAIO_ANIME], 0x0a );
				O_opd_anime_change( ks_w.opd_p[NAMAE_ANIME], S_sys_w->pachinkow.pach_num );
				O_opd_anime_change( ks_w.opd_p[CONST_ANIME], const_no );
				S_fadein_black();
				kous_s_step = KS_KIHON_4;
				S_gstepw_s_set(KS_KIHON);
			}
			break;
		case KS_EXIT:
			k_shushu_back( S_sys_w->stimer );
			k_shushu_waku( 0 );
			k_shushu_dai( S_sys_w->pachinkow.pach_num, DAI_TUUJOU, 0 );
			if(M_fade_flag() == OFF){
				ks_w.opd_p[DAIO_ANIME]->terminate_flag = ON;
				ks_w.opd_p[YAJIRUSI_ANIME]->terminate_flag = ON;
				ks_w.opd_p[NAMAE_ANIME]->terminate_flag = ON;
				S_gstepw_set( K_SELECT );
			}
			break;
	}

}



static void k_shushu_init()
{
	static	u_long back_csr[] = {	KOUS_DAT_CSR_SORA,	KOUS_DAT_CSR_SORA2,
				KOUS_DAT_CSR_SORA3,	KOUS_DAT_CSR_SORA4,	KOUS_DAT_CSR_SORA5,
				KOUS_DAT_CSR_SORA6,	KOUS_DAT_CSR_SORA7,	KOUS_DAT_CSR_SORA8,
				KOUS_DAT_CSR_SORA9 };
	int		i, j;

/*
	S_trans_set((u_long *)KOUS_DAT_CSR_LIP_0, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_EYES_0, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_EYES_1, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_EYES_16, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_EYES_17, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HANDR_0, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_LIP_1, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_LIP_5, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HANDL_2, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HANDL_3, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_OUKAN_1, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_OUKAN_2, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_EYES_3, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_EYES_4, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HANDL_0, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HANDL_6, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_EYES_21, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HANDL_1, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HANDL_4, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HANDR_1, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HANDR_2, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_EYES_2, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_EYES_18, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HANDR_3, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HANDR_4, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_HANDR_6, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_BODY_1, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_BODY_4, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_BODY_2, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_BODY_3, (u_short)1);

	S_trans_set((u_long *)KOUS_DAT_CSR_K_KASORU, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_NAME_F, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_CSR_NAME_P, (u_short)1);
*/

	S_trans_set((u_long *)KOUS_DAT_TIM_KOU_BA00, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_TIM_KOU_BA01, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_TIM_KOU_BA02, (u_short)1);

	S_trans_set((u_long *)KOUS_DAT_TIM_SENTA1, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_TIM_SENTA2, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_TIM_SENTA3, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_TIM_SENTA4, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_TIM_SENTA5, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_TIM_SENTA6, (u_short)1);

	S_trans_set((u_long *)KOUS_DAT_COL_SORA, (u_short)1);

	S_trans_set((u_long *)KOUS_DAT_COL_KASORU, (u_short)1);
	S_trans_set((u_long *)KOUS_DAT_COL_NAME, (u_short)1);

	for( i=0; i<9; i++ ){
		S_trans_set((u_long *)back_csr[i], (u_short)1);
	}

	for( i=0; i<3; i++ ){
		for( j=0; j<3; j++ ){
			shushu_back[i][j].attribute = (1<<24);

			shushu_back[i][j].scalex = ONE;
			shushu_back[i][j].scaley = ONE;
			shushu_back[i][j].rotate = 0;
			shushu_back[i][j].r = 0x80;
			shushu_back[i][j].g = 0x80;
			shushu_back[i][j].b = 0x80;
			shushu_back[i][j].cx = 0;
			shushu_back[i][j].cy = 480;
			shushu_back[i][j].mx = 0;
			shushu_back[i][j].my = 0;
		}
	}

	for( i=0; i<2; i++ ){
		shushu_waku[i].attribute = (0<<24);

		shushu_waku[i].y = -104;
		shushu_waku[i].u = 0;
		shushu_waku[i].v = 0;
		shushu_waku[i].w = 160;
		shushu_waku[i].h = 208;
		shushu_waku[i].scaley = ONE;
		shushu_waku[i].rotate = 0;
		shushu_waku[i].r = 0x80;
		shushu_waku[i].g = 0x80;
		shushu_waku[i].b = 0x80;
		shushu_waku[i].cx = 0;
		shushu_waku[i].cy = 491;
		shushu_waku[i].mx = 0;
		shushu_waku[i].my = 0;
	}

	for( i=0; i<2; i++ ){
		SetPolyFT4( &shushu_dai[i] );
		setRGB0( &shushu_dai[i], 0x80, 0x80, 0x80 );
	}

	ks_w.opd_p[YAJIRUSI_ANIME] = (OPD_W*)S_obj_set( NULL, (u_long)O_OPD_W,
												sizeof(OPD_W), (u_short)1);
	ks_w.opd_p[YAJIRUSI_ANIME]->ot = 4;
	ks_w.opd_p[YAJIRUSI_ANIME]->opd_address = (u_long)KOUS_DAT_OPD_K_YAJI;
	ks_w.opd_p[YAJIRUSI_ANIME]->center_x = -160;
	ks_w.opd_p[YAJIRUSI_ANIME]->center_y = -104;
	O_OPD_W_INIT(ks_w.opd_p[YAJIRUSI_ANIME], 0);

	ks_w.opd_p[NAMAE_ANIME] = (OPD_W*)S_obj_set( NULL, (u_long)O_OPD_W,
												sizeof(OPD_W), (u_short)1);
	ks_w.opd_p[NAMAE_ANIME]->ot = 4;
	ks_w.opd_p[NAMAE_ANIME]->opd_address = (u_long)KOUS_DAT_OPD_K_NAME;
	ks_w.opd_p[NAMAE_ANIME]->center_x = -160;
	ks_w.opd_p[NAMAE_ANIME]->center_y = -104;
	O_OPD_W_INIT(ks_w.opd_p[NAMAE_ANIME], 0);
}


static void k_shushu_dai( int no, int flag, int timer )
{
	unsigned short	tpage[2];
	unsigned short	clut[2];
	GsIMAGE 	tim[2];
	static u_long *dai_tim[] = {	(u_long *)KOUS_DAT_TIM_SENTA1,
				(u_long *)KOUS_DAT_TIM_SENTA2,	(u_long *)KOUS_DAT_TIM_SENTA3,
				(u_long *)KOUS_DAT_TIM_SENTA4,	(u_long *)KOUS_DAT_TIM_SENTA5,
				(u_long *)KOUS_DAT_TIM_SENTA6 };

	GsGetTimInfo( dai_tim[no]+1, &tim[0]);

	tpage[0] = S_TimGetTPage( dai_tim[no], 1 );
	clut[0] = S_TimGetClut( dai_tim[no] );

	shushu_dai[0].tpage = tpage[0];
	shushu_dai[0].clut = clut[0];

	setUVWH( &shushu_dai[0], (tim[0].px%128)*2, tim[0].py%256, 127, 127 );

	if( flag == DAI_SMALL ){
		setXY4( &shushu_dai[0], -98,-80, -1,-80, -98,17, -1,17 );
	}
	else{
		setXY4( &shushu_dai[0],
		 		-113-flag*timer*KS_CHANGE_INTERVAL/KS_CHANGE_TIME1, -69,
				  15-flag*timer*KS_CHANGE_INTERVAL/KS_CHANGE_TIME1, -69,
				-113-flag*timer*KS_CHANGE_INTERVAL/KS_CHANGE_TIME1,  59,
				  15-flag*timer*KS_CHANGE_INTERVAL/KS_CHANGE_TIME1,  59 );
	}

	GsSortPoly( &shushu_dai[0], (GsOT *)&Wot[2][M_activebuff()], 30 );

	if( timer != 0 ){
		GsGetTimInfo( dai_tim[(no+flag+KS_KISHU_NO)%KS_KISHU_NO]+1, &tim[1]);
		tpage[1] = S_TimGetTPage( dai_tim[(no+flag+KS_KISHU_NO)%KS_KISHU_NO], 1 );
		clut[1] = S_TimGetClut( dai_tim[(no+flag+KS_KISHU_NO)%KS_KISHU_NO] );

		shushu_dai[1].tpage = tpage[1];
		shushu_dai[1].clut = clut[1];

		setUVWH( &shushu_dai[1], (tim[1].px%128)*2, tim[1].py%256, 127, 127 );
		setXY4( &shushu_dai[1],
			-113+flag*KS_CHANGE_INTERVAL-flag*timer*KS_CHANGE_INTERVAL
												/KS_CHANGE_TIME1,	-69,
			  15+flag*KS_CHANGE_INTERVAL-flag*timer*KS_CHANGE_INTERVAL
			  									/KS_CHANGE_TIME1,	-69,
			-113+flag*KS_CHANGE_INTERVAL-flag*timer*KS_CHANGE_INTERVAL
												/KS_CHANGE_TIME1,	59,
			  15+flag*KS_CHANGE_INTERVAL-flag*timer*KS_CHANGE_INTERVAL
			  									/KS_CHANGE_TIME1,	59 );

		GsSortPoly( &shushu_dai[1], (GsOT *)&Wot[2][M_activebuff()], 30 );
	}
}


static void k_shushu_back( int val )
{
	int		i, j;
	int		zahyou_x[3];
	int		amari_x[3];

	zahyou_x[0] = (val/2) % 320;
	zahyou_x[1] = (val/5) % 320;
	zahyou_x[2] = (val/7) % 320;

	amari_x[0] = zahyou_x[0]%2;
	amari_x[1] = zahyou_x[1]%2;
	amari_x[2] = zahyou_x[2]%2;
	zahyou_x[0] -= amari_x[0];
	zahyou_x[1] -= amari_x[1];
	zahyou_x[2] -= amari_x[2];

	for( i=0; i<3; i++ ){
		shushu_back[0][i].y = -104;
		shushu_back[0][i].v = 0;
		shushu_back[0][i].h = 48;

		shushu_back[1][i].y = -104+48;
		shushu_back[1][i].v = 48;
		shushu_back[1][i].h = 96;

		shushu_back[2][i].y = -104+48+96;
		shushu_back[2][i].v = 48+96;
		shushu_back[2][i].h = 64;

	}

	for( i=0; i<3; i++ ){
		if( zahyou_x[i] < 256 ){
			shushu_back[i][0].x = -160-amari_x[i];
			shushu_back[i][0].tpage = GetTPage( 1, 1, 512, 256 );
			shushu_back[i][0].u = zahyou_x[i];
			shushu_back[i][0].w = 256-zahyou_x[i];

			shushu_back[i][1].x = -160+256-zahyou_x[i]-amari_x[i];
			shushu_back[i][1].tpage = GetTPage( 1, 1, 640, 256 );
			shushu_back[i][1].u = 0;
			shushu_back[i][1].w = 64;

			shushu_back[i][2].x = -160+320-zahyou_x[i]-amari_x[i];
			shushu_back[i][2].tpage = GetTPage( 1, 1, 512, 256 );
			shushu_back[i][2].u = 0;
			shushu_back[i][2].w = zahyou_x[i];
		}
		else{
			shushu_back[i][0].x = -160-amari_x[i];
			shushu_back[i][0].tpage = GetTPage( 1, 1, 640, 256 );
			shushu_back[i][0].u = zahyou_x[i]-256;
			shushu_back[i][0].w = 64-(zahyou_x[i]-256);

			shushu_back[i][1].x = -160+64-(zahyou_x[i]-256)-amari_x[i];
			shushu_back[i][1].tpage = GetTPage( 1, 1, 512, 256 );
			shushu_back[i][1].u = 0;
			shushu_back[i][1].w = 256;

			shushu_back[i][2].x = -160+320-(zahyou_x[i]-256)-amari_x[i];
			shushu_back[i][2].tpage = GetTPage( 1, 1, 640, 256 );
			shushu_back[i][2].u = 0;
			shushu_back[i][2].w = zahyou_x[i]-256;
		}
	}

	for( i=0; i<3; i++ ){
		for( j=0; j<3; j++ ){
			GsSortSprite(&shushu_back[i][j], (GsOT *)&Wot[1][M_activebuff()], 
			(u_short)10-i);
		}
	}
}


static void k_shushu_waku( int flag )
{
	int		i;

	switch( flag ){
		case 0:
			shushu_waku[0].tpage = GetTPage( 0, 1, 704, 256 );
			shushu_waku[0].scalex = ONE;
			shushu_waku[0].x = -160;
			shushu_waku[1].tpage = GetTPage( 0, 1, 768, 256 );
			shushu_waku[1].scalex = ONE;
			shushu_waku[1].x = 0;
			break;
		case 1:
			shushu_waku[0].tpage = GetTPage( 0, 1, 704, 256 );
			shushu_waku[0].scalex = ONE;
			shushu_waku[0].x = -160;
			shushu_waku[1].tpage = GetTPage( 0, 1, 832, 256 );
			shushu_waku[1].scalex = ONE;
			shushu_waku[1].x = 0;
			break;
		case 2:
			shushu_waku[0].tpage = GetTPage( 0, 1, 704, 256 );
			shushu_waku[0].scalex = ONE*513/320;
			shushu_waku[0].x = -256;
			shushu_waku[1].tpage = GetTPage( 0, 1, 832, 256 );
			shushu_waku[1].scalex = ONE*512/320;
			shushu_waku[1].x = 0;
			break;
	}

	for( i=0; i<2; i++ ){
		GsSortSprite(&shushu_waku[i], (GsOT *)&Wot[3][M_activebuff()], 
		(u_short)10);
	}
}


typedef struct _KS_KIHON_DATA{
	char	kakuritu[240];		/* 120ȉ			*/
	char	dedama[30];			/* 15ȉ			*/
	char	shoukyuu[30];		/* 15ȉ			*/
	char	bikou[300];			/* 150ȉ			*/
} KS_KIHON_DATA;

static KS_KIHON_DATA ks_kihon_data[] = {
		{ 	"P^QQO",
			"QOOO",
			"UPR",
			"@@@@@CœƎɑ哖肪܂œd`[J₷Ȃ܂" },
		{ 	"P^RRO",
			"QSOO",
			"TPT",
			"@@@@@OiAiAlAœƂƂQ񓖂܂ŊmAbv܂Bipj" },
		{ 	"P^QQP",
			"QOOO",
			"UPR",
			"@@@@@CœƎɑ哖肪܂œd`[J₷Ȃ܂" },
		{ 	"P^QWW",
			"UOOO",
			"VPT",
			"@@@@@R񃏃ZbǧmB" },
		{ 	"HHHHH",
			"QSOO",
			"VPT",
			"@@@@@bqfWp`B" },
		{ 	"HHHHH",
			"QSOO",
			"VPT",
			"@@@@@bqfWp`B" },
};


static void k_shushu_kihon( int mode )
{
	static long		timer;

	switch( mode ){
		case	0:
			timer = 0;

			ks_w.opd_p[KIHON_ANIME]= (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
			ks_w.opd_p[KIHON_ANIME]->ot = 6;
			ks_w.opd_p[KIHON_ANIME]->opd_address = (u_long)KOUS_DAT_OPD_K_KIHON;
			ks_w.opd_p[KIHON_ANIME]->center_x = -160;
			ks_w.opd_p[KIHON_ANIME]->center_y = -104;
			O_OPD_W_INIT(ks_w.opd_p[KIHON_ANIME], 0);

			break;
		case	1:
			k_kihon_message( S_sys_w->pachinkow.pach_num, timer++ );
			break;
	}
}



#define		KIHON_MESS_X		320
#define		KIHON_MESS_Y1		80
#define		KIHON_MESS_Y2		96
#define		KIHON_MESS_Y3		108
#define		KIHON_MESS_Y4		120

static void k_kihon_data_load( int num )
{
	int		i, j, k;
	int		len_message;
	int		len;

	for( i=0; i<4; i++ ){
		for( j=0; j<16; j++ ){
			for( k=0; k<2; k++ ){
				SetPolyFT4( &mess_ft4[i][j][k] );
				mess_ft4[i][j][k].tpage = GetTPage( 0, 1,
							(KIHON_MESS_X/64)*64, (KIHON_MESS_Y1/256)*256 );
				mess_ft4[i][j][k].clut = GetClut( 0, 489 );
				setRGB0( &mess_ft4[i][j][k], 0x80, 0x80, 0x80 );
			}
		}
	}

	len_message = strlen( ks_kihon_data[num].kakuritu )/2;

	for( i=0,len=len_message; len>0; i++,len-=15 ){
		Kanji12_load( &ks_kihon_data[num].kakuritu[(len_message-len)*2],
					(u_short *)KOUS_DAT_BIN_FONT_TBL,
					(len_message<15)?len_message*2:15*2, 0xf,
					KIHON_MESS_X, KIHON_MESS_Y1+i*12, 0 );
	}

	len_message = strlen( ks_kihon_data[num].dedama )/2;

	for( i=0,len=len_message; len>0; i++,len-=15 ){
		Kanji12_load( &ks_kihon_data[num].dedama[(len_message-len)*2],
					(u_short *)KOUS_DAT_BIN_FONT_TBL,
					(len_message<15)?len_message*2:15*2, 0x0f,
					KIHON_MESS_X, KIHON_MESS_Y2+i*12, 0 );
	}

	len_message = strlen( ks_kihon_data[num].shoukyuu )/2;

	for( i=0,len=len_message; len>0; i++,len-=15 ){
		Kanji12_load( &ks_kihon_data[num].shoukyuu[(len_message-len)*2],
					(u_short *)KOUS_DAT_BIN_FONT_TBL,
					(len_message<15)?len_message*2:15*2, 0x0f,
					KIHON_MESS_X, KIHON_MESS_Y3+i*12, 0 );
	}

	len_message = strlen( ks_kihon_data[num].bikou )/2;

	for( i=0,len=len_message; len>0; i++,len-=15 ){
		Kanji12_load( &ks_kihon_data[num].bikou[(len_message-len)*2],
					(u_short *)KOUS_DAT_BIN_FONT_TBL,
					(len_message<15)?len_message*2:15*2, 0x0f,
					KIHON_MESS_X, KIHON_MESS_Y4+i*12, 0 );
	}
}


static void k_kihon_message( int num, int timer )
{
	k_kihon_line_message( 0, ks_kihon_data[num].kakuritu, timer,
										KIHON_MESS_X, KIHON_MESS_Y1 );
	k_kihon_line_message( 1, ks_kihon_data[num].dedama, timer,
										KIHON_MESS_X, KIHON_MESS_Y2 );
	k_kihon_line_message( 2, ks_kihon_data[num].shoukyuu, timer,
										KIHON_MESS_X, KIHON_MESS_Y3 );
	k_kihon_line_message( 3, ks_kihon_data[num].bikou, timer,
										KIHON_MESS_X, KIHON_MESS_Y4 );

}


static void k_kihon_line_message( int no, char message[], int timer,
													int vram_x, int vram_y )
{
	int		len_message;
	int		i;
	int		char_no, char_shift, line, colum;

	len_message = strlen( message )/2;

	if( len_message > 15 ){
		timer /= 1;
		timer %= (len_message*12);

		char_no = timer/12;
		char_shift = timer%12;

		for( i=0; i<16; i++ ){
			colum = char_no%15;
			line = char_no/15;

			setUVWH( &mess_ft4[no][i][0], (vram_x%64)+colum*12,
							(vram_y%256)+12*line, char_shift, 11 );
			setUVWH( &mess_ft4[no][i][1], (vram_x%64)+colum*12+char_shift,
							(vram_y%256)+12*line, 12-char_shift, 11 );
			setXY4( &mess_ft4[no][i][0],
							-49+i*12-char_shift,	33+no*14,
							-49+i*12,				33+no*14,
							-49+i*12-char_shift,	44+no*14,
							-49+i*12,				44+no*14 );
			setXY4( &mess_ft4[no][i][1],
							-49+i*12,				33+no*14,
							-49+i*12+12-char_shift,	33+no*14,
							-49+i*12,				44+no*14,
							-49+i*12+12-char_shift,	44+no*14 );

			if( i != 0 )
				GsSortPoly( &mess_ft4[no][i][0],
									(GsOT *)&Wot[6][M_activebuff()], 30 );

			if( i != 15 )
				GsSortPoly( &mess_ft4[no][i][1],
									(GsOT *)&Wot[6][M_activebuff()], 30 );

			char_no = (char_no+1)%len_message;
		}
	}
	else{
		setUVWH( &mess_ft4[no][0][0], vram_x%64,
							vram_y%256, len_message*12, 11 );
		setXY4( &mess_ft4[no][0][0],
							-49,				33+no*14,
							-49+len_message*12,	33+no*14,
							-49,				44+no*14,
							-49+len_message*12,	44+no*14 );

		GsSortPoly( &mess_ft4[no][0][0],
									(GsOT *)&Wot[6][M_activebuff()], 30 );
	}
}


static void k_kihon_data()
{
	switch( kous_s_step ){
		case KS_KIHON_1:
			k_shushu_dai( S_sys_w->pachinkow.pach_num, DAI_TUUJOU, 0 );

			if( ks_w.opd_p[DAIO_ANIME]->flag == 2 ){
				k_shushu_kihon( 0 );
				ks_w.opd_p[DAIO_ANIME]->flag = 0;
				kous_s_step = KS_KIHON_2;
			}
			break;
		case KS_KIHON_2:
			k_shushu_dai( S_sys_w->pachinkow.pach_num, DAI_SMALL, 0 );

			k_shushu_kihon( 1 );

			if(S_PAD_RR1){
				O_opd_anime_change( ks_w.opd_p[DAIO_ANIME], 4 );
				ks_w.opd_p[KIHON_ANIME]->terminate_flag = ON;
				ks_w.opd_p[KIHON_ANIME] = (OPD_W *)0;
				kous_s_step = KS_KIHON_3;
			}
			break;
		case KS_KIHON_3:
			k_shushu_dai( S_sys_w->pachinkow.pach_num, DAI_TUUJOU, 0 );

			if( ks_w.opd_p[DAIO_ANIME]->flag == 3 ){
				const_no = 0;
				ks_w.opd_p[DAIO_ANIME]->flag = 0;
				ks_w.opd_p[CONST_ANIME] = (OPD_W*)S_obj_set( NULL, (u_long)O_OPD_W,
													sizeof(OPD_W), (u_short)1);
				ks_w.opd_p[CONST_ANIME]->ot = 5;
				ks_w.opd_p[CONST_ANIME]->opd_address = (u_long)KOUS_DAT_OPD_K_CONST;
				ks_w.opd_p[CONST_ANIME]->center_x = -160;
				ks_w.opd_p[CONST_ANIME]->center_y = -104;
				O_OPD_W_INIT(ks_w.opd_p[CONST_ANIME], 0);
				kous_s_step = KS_KIHON_5;
			}
			break;
		case KS_KIHON_4:
			k_shushu_dai( S_sys_w->pachinkow.pach_num, DAI_TUUJOU, 0 );

			if( M_fade_flag() == OFF ){
				kous_s_step = KS_KIHON_5;
			}
			break;
		case KS_KIHON_5:
			k_shushu_dai( S_sys_w->pachinkow.pach_num, DAI_TUUJOU, 0 );

			if(S_PAD_RR1){
				O_opd_anime_change( ks_w.opd_p[DAIO_ANIME], 7 );
				O_opd_anime_change( ks_w.opd_p[CONST_ANIME], const_no+3 );
				S_fadeout_black();
				kous_s_step = KS_KIHON_6;
			}
			else if(S_PAD_LD0){
				const_no = (const_no+1)%3;
				O_opd_anime_change( ks_w.opd_p[CONST_ANIME], const_no );
			}
			else if(S_PAD_LU0){
				const_no = (const_no+2)%3;
				O_opd_anime_change( ks_w.opd_p[CONST_ANIME], const_no );
			}
			break;
		case KS_KIHON_6:
			k_shushu_dai( S_sys_w->pachinkow.pach_num, DAI_TUUJOU, 0 );

			if( M_fade_flag() == OFF ){
				switch( const_no ){
					case 0:
						P_main_step_set( 0 );
						O_opd_anime_change( ks_w.opd_p[DAIO_ANIME], 8 );
						O_opd_anime_change( ks_w.opd_p[NAMAE_ANIME], 0x10 );
						O_opd_anime_change( ks_w.opd_p[CONST_ANIME], 0x0a );
						S_gstepw_s_set(KS_HYOUJI_DATA);
						break;
					case 1:
						P_main_step_set( 0 );
						O_opd_anime_change( ks_w.opd_p[DAIO_ANIME], 8 );
						O_opd_anime_change( ks_w.opd_p[NAMAE_ANIME], 0x10 );
						O_opd_anime_change( ks_w.opd_p[CONST_ANIME], 0x0a );
						S_gstepw_s_set(KS_KUGI_CHOUSEI);
						P_kugi_chousei_main();
						break;
					case 2:
						ks_w.opd_p[DAIO_ANIME]->terminate_flag = ON;
						ks_w.opd_p[NAMAE_ANIME]->terminate_flag = ON;
						ks_w.opd_p[CONST_ANIME]->terminate_flag = ON;
						P_main_step_set( 0 );
						S_gstepw_set(K_DAI_PLAY);
						break;
				}
			}
			break;
		case KS_KIHON_EXIT:
			k_shushu_dai( S_sys_w->pachinkow.pach_num, DAI_TUUJOU, 0 );
			if( M_fade_flag() == OFF ){
				if( ks_w.opd_p[KIHON_ANIME] != 0 )
					ks_w.opd_p[KIHON_ANIME]->terminate_flag = ON;
				if( ks_w.opd_p[CONST_ANIME] != 0 )
					ks_w.opd_p[CONST_ANIME]->terminate_flag = ON;
				S_free( (char *)p_sys_w.poly_address_kugi );
				S_free( (char *)p_sys_w.poly_address_mkugi );
				O_opd_anime_change( ks_w.opd_p[DAIO_ANIME], 1 );
				O_opd_anime_change( ks_w.opd_p[YAJIRUSI_ANIME], 0 );

				ks_w.opd_p[YAJIRUSI_ANIME] = (OPD_W*)S_obj_set( NULL,
								(u_long)O_OPD_W, sizeof(OPD_W), (u_short)1);
				ks_w.opd_p[YAJIRUSI_ANIME]->ot = 4;
				ks_w.opd_p[YAJIRUSI_ANIME]->opd_address =
												(u_long)KOUS_DAT_OPD_K_YAJI;
				ks_w.opd_p[YAJIRUSI_ANIME]->center_x = -160;
				ks_w.opd_p[YAJIRUSI_ANIME]->center_y = -104;
				O_OPD_W_INIT(ks_w.opd_p[YAJIRUSI_ANIME], 0);

				S_gstepw_s_set(KS_SENTAKU_WAIT);
				S_fadein_black();
			}
			break;
	}

	k_shushu_back( S_sys_w->stimer );
	k_shushu_waku( 0 );

	if( (kous_s_step!=KS_KIHON_EXIT) && (kous_s_step!=KS_KIHON_4)
										&& (kous_s_step!=KS_KIHON_6) ){
		if(S_PAD_RD1){
			S_fadeout_black();
			kous_s_step = KS_KIHON_EXIT;
		}
	}
}

