/***< file >***********************************************************/
/*	Title		:	PlayStation										*/
/*	Code		:	vx022											*/
/*	Filename	:	p2_toku.c										*/
/*	Note		:@X^[CgNC[ʐ}					*/
/*	Author		:	oohashi						*/
/*	Date		:	1996.4.8										*/
/********************************************************/

/*===============================================================*/
/*include														*/
/*===============================================================*/
#include		"lt_all.h"
#include		"pachinko.h"
#include		"p_ekisho.h"
#include		"p2_toku.h"
/*====================================================================*/
/*	define											                  */
/*====================================================================*/


/*====================================================================*/
/*  \̂̐錾													  */
/*====================================================================*/
typedef struct _P2_DIGITAL_DATA {
	POLY_FT4		prim;				/* è */
	SVECTOR			vect[4];			/* ޸ */
	POLY_FT4		fbuf[2][4];			/* draw buffer for divide */
}P2_DIGITAL_DATA;

typedef	struct _FUTU_W {
	OBJ_W_HEAD			header;		/*	޼ުܰͯް */
} FUTU_W;


/*====================================================================*/
/*  ϐ錾														  */
/*====================================================================*/
static P2_DIGITAL_DATA	p2_digital_lr[2][5][2];
static P2_DIGITAL_DATA	p2_digital_ct[8];

static short	flag_print = 0;
/*====================================================================*/
/*	vg^Cv錾												  */
/*====================================================================*/



void P2_digital_inc( int no, int seisuu, int shousuu )
{
	p_sys_w.digital[no][1] += shousuu;
	if( no == 0 ){
		p_sys_w.digital[no][0] += 15-(seisuu+p_sys_w.digital[no][1]/64);
	}
	else{
		p_sys_w.digital[no][0] += seisuu+p_sys_w.digital[no][1]/64;
	}
	p_sys_w.digital[no][1] %= 64;
	if( no != 2 ){
		p_sys_w.digital[no][0] %= 15;
	}
	else{
		p_sys_w.digital[no][0] %= 45;
	}
}

void P2_tokuzu_init()
{
	int		i, j, k;

	for( i=0; i<2; i++ ){
		for( j=0; j<5; j++ ){
			for( k=0; k<2; k++ ){
				SetPolyFT4( &(p2_digital_lr[i][j][k].prim) );
				setRGB0( &(p2_digital_lr[i][j][k].prim), 0x80, 0x80, 0x80 );
			}
		}
	}

	for( i=0; i<8; i++ ){
		SetPolyFT4( &(p2_digital_ct[i].prim) );
		setRGB0( &(p2_digital_ct[i].prim), 0x80, 0x80, 0x80 );
	}

	p2_digital_lr[0][0][0].prim.clut = p2_digital_lr[1][0][0].prim.clut =
	p2_digital_lr[0][1][0].prim.clut = p2_digital_lr[1][1][0].prim.clut =
	p2_digital_lr[0][2][0].prim.clut = p2_digital_lr[1][2][0].prim.clut =
	p2_digital_lr[0][3][0].prim.clut = p2_digital_lr[1][3][0].prim.clut =
	p2_digital_lr[0][4][0].prim.clut = p2_digital_lr[1][4][0].prim.clut =
	p2_digital_lr[0][0][1].prim.clut = p2_digital_lr[1][0][1].prim.clut =
	p2_digital_lr[0][1][1].prim.clut = p2_digital_lr[1][1][1].prim.clut =
	p2_digital_lr[0][2][1].prim.clut = p2_digital_lr[1][2][1].prim.clut =
	p2_digital_lr[0][3][1].prim.clut = p2_digital_lr[1][3][1].prim.clut =
	p2_digital_lr[0][4][1].prim.clut = p2_digital_lr[1][4][1].prim.clut =
															GetClut(2*16,483);

	 P2_digital_ct_color(483);

	(void)S_obj_set( (u_long)NULL,
						 (u_long)P2_tokuzu_main, (u_long)sizeof(FUTU_W), 0);


	/*\tOZbg*/
	flag_print = 1;

}

void P2_digital_lr_color(short color)
{
	p2_digital_lr[0][2][1].prim.clut = p2_digital_lr[1][2][1].prim.clut =
															GetClut(2*16,color);
}
void P2_digital_ct_color(short color)
{
	p2_digital_ct[0].prim.clut = 
	p2_digital_ct[1].prim.clut = GetClut(48,color);
	p2_digital_ct[2].prim.clut = GetClut(0,color);
	p2_digital_ct[3].prim.clut = GetClut(16,color);
	p2_digital_ct[4].prim.clut = GetClut(32,color);
	p2_digital_ct[5].prim.clut = GetClut(48,color);
	p2_digital_ct[6].prim.clut = GetClut(64,color);
	p2_digital_ct[7].prim.clut = GetClut(64,color);

}
void P2_tokuzu_on()
{
	flag_print = 1;
}
void P2_tokuzu_off()
{
	flag_print = 0;
}
void P2_tokuzu_main()
{
	int		i, j, k;
	static u_short		chara_coor[][2] = {
			864,256,	878,256,		864,320,	878,320,
			864,384,	878,384,		896,256,	910,256,
			896,320,	910,320,		896,384,	910,384,
			928,256,	942,256,		928,320,	942,320		};
	int		digital[2];
	DIVPOLYGON4 	*divp = (DIVPOLYGON4*)(SCRATCH);/* divide buffer */

/*
NFntPrint( "LEFT  %d : %d\n", p_sys_w.digital[0][0], p_sys_w.digital[0][1] );
NFntPrint( "RIGHT %d : %d\n", p_sys_w.digital[1][0], p_sys_w.digital[1][1] );
*/

	if(flag_print==OFF)
	{
		return;
	}

	for( i=0; i<2; i++ ){
		for( j=0; j<5; j++ ){
			if( i==0 )
				digital[0] = (p_sys_w.digital[i][0]+13+j)%15;
			else
				digital[0] = (p_sys_w.digital[i][0]+17-j)%15;

			setUVWH( &(p2_digital_lr[i][j][0].prim),
					(chara_coor[digital[0]][0]%64)*4,
					chara_coor[digital[0]][1]%256, 55, 7 );
			setUVWH( &(p2_digital_lr[i][j][1].prim),
					(chara_coor[digital[0]][0]%64)*4,
					chara_coor[digital[0]][1]%256+8, 55, 55 );

			p2_digital_lr[i][j][0].prim.tpage =
			p2_digital_lr[i][j][1].prim.tpage =	GetTPage(0,1,
					chara_coor[digital[0]][0]-(chara_coor[digital[0]][0]%64),
					chara_coor[digital[0]][1]-(chara_coor[digital[0]][1]%256));

			setVector(&(p2_digital_lr[i][j][0].vect[0]),
						P_E_SCALE_CHANGE_X(-92+i*128),
						P_E_SCALE_CHANGE_Y(-164+p_sys_w.digital[i][1]+64*j),
						p_sys_w.model_vect[0].vz );
			setVector(&(p2_digital_lr[i][j][0].vect[1]),
						P_E_SCALE_CHANGE_X(-36+i*128),
						P_E_SCALE_CHANGE_Y(-164+p_sys_w.digital[i][1]+64*j),
						p_sys_w.model_vect[0].vz );
			setVector(&(p2_digital_lr[i][j][0].vect[2]),
						P_E_SCALE_CHANGE_X(-92+i*128),
						P_E_SCALE_CHANGE_Y(-156+p_sys_w.digital[i][1]+64*j),
						p_sys_w.model_vect[0].vz );
			setVector(&(p2_digital_lr[i][j][0].vect[3]),
						P_E_SCALE_CHANGE_X(-36+i*128),
						P_E_SCALE_CHANGE_Y(-156+p_sys_w.digital[i][1]+64*j),
						p_sys_w.model_vect[0].vz );

			setVector(&(p2_digital_lr[i][j][1].vect[0]),
						P_E_SCALE_CHANGE_X(-92+i*128),
						P_E_SCALE_CHANGE_Y(-156+p_sys_w.digital[i][1]+64*j),
						p_sys_w.model_vect[0].vz );
			setVector(&(p2_digital_lr[i][j][1].vect[1]),
						P_E_SCALE_CHANGE_X(-36+i*128),
						P_E_SCALE_CHANGE_Y(-156+p_sys_w.digital[i][1]+64*j),
						p_sys_w.model_vect[0].vz );
			setVector(&(p2_digital_lr[i][j][1].vect[2]),
						P_E_SCALE_CHANGE_X(-92+i*128),
						P_E_SCALE_CHANGE_Y(-100+p_sys_w.digital[i][1]+64*j),
						p_sys_w.model_vect[0].vz );
			setVector(&(p2_digital_lr[i][j][1].vect[3]),
						P_E_SCALE_CHANGE_X(-36+i*128),
						P_E_SCALE_CHANGE_Y(-100+p_sys_w.digital[i][1]+64*j),
						p_sys_w.model_vect[0].vz );


			for( k=0; k<2; k++ ){
				divp->ndiv=1;
				divp->pih=512;
				divp->piv=240;

				(void)DivideFT4(&(p2_digital_lr[i][j][k].vect[0]),
							&(p2_digital_lr[i][j][k].vect[1]),
							&(p2_digital_lr[i][j][k].vect[2]),
							&(p2_digital_lr[i][j][k].vect[3]),
							 (u_long *)&(p2_digital_lr[i][j][k].prim.u0),
							 (u_long *)&(p2_digital_lr[i][j][k].prim.u1),
							 (u_long *)&(p2_digital_lr[i][j][k].prim.u2),
							 (u_long *)&(p2_digital_lr[i][j][k].prim.u3),
							 &(p2_digital_lr[i][j][k].prim.r0),
							 &(p2_digital_lr[i][j][k].fbuf[M_activebuff()][0]),
							 (u_long *)(Mot[1][M_activebuff()].org + 10),
							 divp);
			}
		}
	}

	for( i=0; i<8; i++ ){
		digital[0] = p_sys_w.digital[2][0]+(p_sys_w.digital[2][1]+56-i*8)/64;
		digital[0] = ((digital[0]%3)?(15):((digital[0]/3+15)%15));
		digital[1] = ((64-(p_sys_w.digital[2][1]/8)*8)+8*i)%64;

		setUVWH(&(p2_digital_ct[i].prim),(chara_coor[digital[0]][0]%64)*4,
						(chara_coor[digital[0]][1]+digital[1])%256, 55, 7 );
		p2_digital_ct[i].prim.tpage =	GetTPage(0,1,
					chara_coor[digital[0]][0]-(chara_coor[digital[0]][0]%64),
					chara_coor[digital[0]][1]-(chara_coor[digital[0]][1]%256));

		setVector(&(p2_digital_ct[i].vect[0]),
						P_E_SCALE_CHANGE_X(-28),
						P_E_SCALE_CHANGE_Y(-36+i*8+(p_sys_w.digital[2][1]%8)),
						p_sys_w.model_vect[0].vz );
		setVector(&(p2_digital_ct[i].vect[1]),
						P_E_SCALE_CHANGE_X(28),
						P_E_SCALE_CHANGE_Y(-36+i*8+(p_sys_w.digital[2][1]%8)),
						p_sys_w.model_vect[0].vz );
		setVector(&(p2_digital_ct[i].vect[2]),
						P_E_SCALE_CHANGE_X(-28),
						P_E_SCALE_CHANGE_Y(-28+i*8+(p_sys_w.digital[2][1]%8)),
						p_sys_w.model_vect[0].vz );
		setVector(&(p2_digital_ct[i].vect[3]),
						P_E_SCALE_CHANGE_X(28),
						P_E_SCALE_CHANGE_Y(-28+i*8+(p_sys_w.digital[2][1]%8)),
						p_sys_w.model_vect[0].vz );


		divp->ndiv=1;			/* divide depth */
		divp->pih=512;		/* horizontal resolution */
		divp->piv=240;		/* vertical resolution */

		(void)DivideFT4(&(p2_digital_ct[i].vect[0]),
							&(p2_digital_ct[i].vect[1]),
							&(p2_digital_ct[i].vect[2]),
							&(p2_digital_ct[i].vect[3]),
							 (u_long *)&(p2_digital_ct[i].prim.u0),
							 (u_long *)&(p2_digital_ct[i].prim.u1),
							 (u_long *)&(p2_digital_ct[i].prim.u2),
							 (u_long *)&(p2_digital_ct[i].prim.u3),
							 &(p2_digital_ct[i].prim.r0),
							 &(p2_digital_ct[i].fbuf[M_activebuff()][0]),
							 (u_long *)(Mot[1][M_activebuff()].org + 10),
							 divp);
	}
}
