#include		"lt_all.h"
#include		"s_cdhd.h"
#include		"l_math.h"
#include		"pachinko.h"
#include		"p_tama.h"
#include		"p2_yaku.h"
#include		"p2_data.h"
#include		"p2_load2.h"

static void p2_denchuu_atari( P_DATATARI_W *atari_data,
										TAMA_W *objp, long *rot_atari );
static int p_denchuu_hit_search( long *rot_atari, TAMA_W *objp  );
static void P2_denchuu_atari_set( P_DATATARI_W *atari_data, long *rot_atari,
										short *kugi_data, long angle_z );

void P2_tamadome1( GsDOBJ3_W *objp )
{
	if( p_sys_w.tamadome_flag == ON ){
		objp->gsdobj.attribute |= ATTR31;
	}
	else{
		objp->gsdobj.attribute &= ~ATTR31;
	}
}


void P2_tamadome2( GsDOBJ3_W *objp )
{
	if( p_sys_w.tamadome_flag == OFF ){
		objp->gsdobj.attribute |= ATTR31;
	}
	else{
		objp->gsdobj.attribute &= ~ATTR31;
	}
}


#define		DENCHUU_ANGLE_MAX	48
#define		DENCHUU_ANGLE_SPD	1

void P2_denchuu1_rot( GsDOBJ2_W *objp )
{
	if( p_sys_w.denchuu_flag == ON ){
		if( objp->angle.vz > -DENCHUU_ANGLE_MAX*ONE/360 ){
			objp->angle.vz -= DENCHUU_ANGLE_SPD*TAMA_CALC_TIME*ONE/360;
		}
	}
	else{
		if( objp->angle.vz < 0 ){
			objp->angle.vz += DENCHUU_ANGLE_SPD*TAMA_CALC_TIME*ONE/360;
		}
	}
}


void P2_denchuu2_rot( GsDOBJ2_W *objp )
{
	if( p_sys_w.denchuu_flag == ON ){
		if( objp->angle.vz < DENCHUU_ANGLE_MAX*ONE/360 ){
			objp->angle.vz += DENCHUU_ANGLE_SPD*TAMA_CALC_TIME*ONE/360;
		}
	}
	else{
		if( objp->angle.vz >0 ){
			objp->angle.vz -= DENCHUU_ANGLE_SPD*TAMA_CALC_TIME*ONE/360;
		}
	}
}


#define		ATTACKER_ANGLE_MAX	64
#define		ATTACKER_ANGLE_SPD	1

void P2_attacker_rot( GsDOBJ2_W *objp )
{
	if( p_sys_w.attacker_flag == ON ){
		if( objp->angle.vx < ATTACKER_ANGLE_MAX*ONE/360 ){
			objp->angle.vx += ATTACKER_ANGLE_SPD*TAMA_CALC_TIME*ONE/360;
		}
	}
	else{
		if( objp->angle.vx > 0 ){
			objp->angle.vx -= ATTACKER_ANGLE_SPD*TAMA_CALC_TIME*ONE/360;
		}
	}
}


void P2_denchuu_atari1( P_DATATARI_W *atari_data, TAMA_W *objp )
{
	long	angle_z;
	short	*kugi_data;

	objp->status = TAMA_BANMEN;

	if( p_sys_w.denchuu_flag == ON ){
		if( ((GsDOBJ2_W *)atari_data->tmd_objp)->angle.vz >
										-DENCHUU_ANGLE_MAX*ONE/360 ){
			angle_z = ((GsDOBJ2_W *)atari_data->tmd_objp)->angle.vz -
							DENCHUU_ANGLE_SPD*p_sys_w.calc_no*ONE/360;
		}
		else{
			angle_z = -DENCHUU_ANGLE_MAX*ONE/360;
		}
	}
	else{
		if( ((GsDOBJ2_W *)atari_data->tmd_objp)->angle.vz < 0 ){
			angle_z = ((GsDOBJ2_W *)atari_data->tmd_objp)->angle.vz +
							DENCHUU_ANGLE_SPD*p_sys_w.calc_no*ONE/360;
		}
		else{
			angle_z = 0;
		}
	}

	if( p_sys_w.rot_atari[0] == NULL ){
		kugi_data = (short *)P2_LOAD2_KUGI_P2_A_CH1;

		p_sys_w.rot_atari[0] = (long *)S_malloc( (*((long *)kugi_data))*8+8 );

		P2_denchuu_atari_set( atari_data, p_sys_w.rot_atari[0],
													kugi_data, angle_z );
	}
	else if( p_sys_w.rot_atari[0][0] != angle_z ){
		kugi_data = (short *)P2_LOAD2_KUGI_P2_A_CH1;

		P2_denchuu_atari_set( atari_data, p_sys_w.rot_atari[0],
													kugi_data, angle_z );
	}

	p2_denchuu_atari( atari_data, objp, p_sys_w.rot_atari[0] );
}

void P2_denchuu_atari2( P_DATATARI_W *atari_data, TAMA_W *objp )
{
	long	angle_z;
	short	*kugi_data;

	objp->status = TAMA_BANMEN;

	if( p_sys_w.denchuu_flag == ON ){
		if( ((GsDOBJ2_W *)atari_data->tmd_objp)->angle.vz <
										DENCHUU_ANGLE_MAX*ONE/360 ){
			angle_z = ((GsDOBJ2_W *)atari_data->tmd_objp)->angle.vz +
							DENCHUU_ANGLE_SPD*p_sys_w.calc_no*ONE/360;
		}
		else{
			angle_z = DENCHUU_ANGLE_MAX*ONE/360;
		}
	}
	else{
		if( ((GsDOBJ2_W *)atari_data->tmd_objp)->angle.vz > 0 ){
			angle_z = ((GsDOBJ2_W *)atari_data->tmd_objp)->angle.vz -
							DENCHUU_ANGLE_SPD*p_sys_w.calc_no*ONE/360;
		}
		else{
			angle_z = 0;
		}
	}

	if( p_sys_w.rot_atari[1] == NULL ){
		kugi_data = (short *)P2_LOAD2_KUGI_P2_A_CH2;

		p_sys_w.rot_atari[1] = (long *)S_malloc( (*((long *)kugi_data))*8+8 );

		P2_denchuu_atari_set( atari_data, p_sys_w.rot_atari[1],
														kugi_data, angle_z );
	}
	else if( p_sys_w.rot_atari[1][0] != angle_z ){
		kugi_data = (short *)P2_LOAD2_KUGI_P2_A_CH2;

		P2_denchuu_atari_set( atari_data, p_sys_w.rot_atari[1],
														kugi_data, angle_z );
	}

	p2_denchuu_atari( atari_data, objp, p_sys_w.rot_atari[1] );
}

void P2_move_attacker( TAMA_W *objp )
{
	if( p_sys_w.attacker_flag == OFF )		(void *)objp->cz = 320;

	if( objp->vx > 8*ONE )		objp->vx = 8*ONE;
	if( objp->vx < -8*ONE )		objp->vx = -8*ONE;

	if( objp->cy >= 0x1020*ONE ){
		if( objp->cz == TAMA_POLY_Z ){
			objp->cy = 0x1020*ONE;

			if( objp->vy > 0x21*ONE ){
				objp->cz += 8;
			}
			else{
				objp->vx -= ONE;
				objp->cx += objp->vx;

				if( objp->cx < -1024*ONE ){
					objp->cx = -1024*ONE;
					objp->vx = 0;
					objp->cz += 8;
				}

				if( objp->cx > 1024*ONE ){
					objp->cx = 1024*ONE;
					objp->vx = 0;
				}
			}
		}
		else{

			if(	objp->cz < 320 ){
				if( objp->cy < 0x1200*ONE )		objp->cy += 0x2*ONE;
				if( objp->cy > 0x1200*ONE )		objp->cy = 0x1200*ONE;

				objp->cz += 8;
			}
			else{
				if( objp->cy < 0x1200*ONE )		objp->cy += 0x4*ONE;
				if( objp->cy > 0x1200*ONE )		objp->cy = 0x1200*ONE;

				if( objp->cx < -1000*ONE )	p_sys_w.v_zone_flag = ON;
				objp->vx += ONE;
				objp->cx += objp->vx;
				objp->pri = 0;
			}

			if( objp->cx < -1024*ONE ){
				objp->cx = -1024*ONE;
				objp->vx = 0;
			}

			if( objp->cx > 1600*ONE ){
				objp->status = TAMA_NYUUSHOU13;
				p_sys_w.attacker_nyuushou++;
			}
		}
	}
	else{
		objp->vy += TAMA_G;

		objp->cx += objp->vx;
		objp->cy += objp->vy;
	}
}


void P2_attacker_atari( P_DATATARI_W *atari_data, TAMA_W *objp )
{
	long	angle_x;

	if( ((objp->cx/ONE) > atari_data->x) &&
		((objp->cx/ONE) < atari_data->x + atari_data->w) &&
		((objp->cy/ONE) > atari_data->y) &&
		((objp->cy/ONE) < atari_data->y + atari_data->h) ){

		if( p_sys_w.attacker_flag == ON ){
			if( ((GsDOBJ2_W *)atari_data->tmd_objp)->angle.vx <
											ATTACKER_ANGLE_MAX*ONE/360 ){
				angle_x = ((GsDOBJ2_W *)atari_data->tmd_objp)->angle.vx +
								ATTACKER_ANGLE_SPD*p_sys_w.calc_no*ONE/360;
			}
			else{
				angle_x = ATTACKER_ANGLE_MAX*ONE/360;
			}
		}
		else{
			if( ((GsDOBJ2_W *)atari_data->tmd_objp)->angle.vx > 0 ){
				angle_x = ((GsDOBJ2_W *)atari_data->tmd_objp)->angle.vz -
								ATTACKER_ANGLE_SPD*p_sys_w.calc_no*ONE/360;
			}
			else{
				angle_x = 0;
			}
		}

		if( angle_x > 45*ONE/360 )	(void *)objp->status = P2_move_attacker;
		else						objp->status = TAMA_BANMEN;
	}
	else{
		objp->status = TAMA_BANMEN;
	}
}


static void P2_denchuu_atari_set( P_DATATARI_W *atari_data, long *rot_atari,
										short *kugi_data, long angle_z )
{
	int		i;
	long	theta;
	u_long	dist;

	rot_atari[0] = angle_z;
	rot_atari[1] = *((long *)kugi_data);

	for( i=0; i<*((long *)kugi_data); i++ ){
		theta = angle_z + ratan2( kugi_data[i*2+3], kugi_data[i*2+2] );

		dist = p_culc_distance( kugi_data[i*2+2], kugi_data[i*2+3], 0, 0 );

		rot_atari[i*2+2] = atari_data->point_x*ONE+dist*S_cos(theta,ONE);
		rot_atari[i*2+3] = atari_data->point_y*ONE+dist*S_sin(theta,ONE);
	}
}


static int p_denchuu_hit_search( long *rot_atari, TAMA_W *objp  )
{
	int		i;
	int		shift;
	u_long	dist_square;

	for( i=0; i<rot_atari[1] ; i++ ){
		if( (objp->cx < rot_atari[i*2+2]+TAMA_POLY_R*ONE) &&
			(objp->cx > rot_atari[i*2+2]-TAMA_POLY_R*ONE) &&
			(objp->cy < rot_atari[i*2+3]+TAMA_POLY_R*ONE) &&
			(objp->cy > rot_atari[i*2+3]-TAMA_POLY_R*ONE) ){
			dist_square = p_culc_square( &shift, objp->cx, objp->cy,
									rot_atari[i*2+2], rot_atari[i*2+3] );
			if( dist_square < TAMA_POLY_R*TAMA_POLY_R*(ONE>>shift)*(ONE>>shift) ){
				return( i );
			}
		}
	}

	return( -1 );
}

static void p2_denchuu_atari( P_DATATARI_W *atari_data,
										TAMA_W *objp, long *rot_atari )
{
	long	theta;
	long	speed_theta;
	long	speed_abs;
	int		kugi_number = 0;
	long	x0, y0;
	u_long	abs_buff[2];
	int		shift;
	long	sin_a, cos_a;

	if( (kugi_number = p_denchuu_hit_search( rot_atari, objp )) != -1 ){
		theta = ratan2( rot_atari[kugi_number*2+3] - objp->cy,
						rot_atari[kugi_number*2+2] - objp->cx );

		speed_abs = p_culc_distance( objp->vx, objp->vy, 0, 0 );
		speed_theta = ratan2( objp->vy, objp->vx );

		shift = 0;
		while( (speed_abs>>shift) > 0x7fffffff/ONE )		shift++;

		speed_abs >>= shift;

		x0 = (speed_abs * S_sin(theta-speed_theta,ONE))/(ONE>>shift);
		y0 = (speed_abs * S_cos(theta-speed_theta,ONE))/(ONE>>shift);

		abs_buff[0] = abs( x0 );
		abs_buff[1] = abs( y0 );

		shift = 0;
		while( ((abs_buff[0]>>shift) > 0x7fffffff/ONE) ||
				((abs_buff[1]>>shift) > 0x7fffffff/ONE) )		shift++;

		x0 >>= shift;
		y0 >>= shift;

		sin_a = S_sin(theta,ONE);
		cos_a = S_cos(theta,ONE);

											/* W␳		*/
		objp->cx = rot_atari[kugi_number*2+2]-cos_a*(TAMA_POLY_R+KUGI_POLY_R);
		objp->cy = rot_atari[kugi_number*2+3]-sin_a*(TAMA_POLY_R+KUGI_POLY_R);

		objp->vx = (sin_a*x0 - ((cos_a*y0)/ONE)*KUGI_E) / (ONE>>shift);
		objp->vy = ((-cos_a)*x0 - ((sin_a*y0)/ONE)*KUGI_E) / (ONE>>shift);
	}
}
