#include "lt_all.h"
#include "l_kanji.h"
#include "pachinko.h"
#include "p_dlist.h"
#include "p_datas.h"
#include "p_data.h"


static GsSPRITE		char_prim[10][10];
static GsSPRITE		comment_prim[10];

#define P_TANNI_NASHI		0
#define P_SPACE				1
#define P_COMMA				2
#define P_SLUSH				3
#define P_HYPHEN			4
#define P_JIKAN_H			10
#define P_JIKAN_M			11
#define P_PERCENT			12
#define P_KAI				13
#define P_KO				14


static void p_data_line_print0( int id, int data_num, long val, int tanni );
static void p_data_line_print1( int id, int data_num, long val1, int tanni1,
												long val2, int tanni2 );
static void p_data_line_print2( int id, int data_num, long val1, int tanni1,
								long val2, int tanni2, long val3, int tanni3 );
static void p_set_number_uvwh( GsSPRITE *prim, int val );
static void p_set_space_uvwh( GsSPRITE *prim );
static void p_set_tanni_uvwh( GsSPRITE *prim, int val );


void P_data_print()
{
	int		data_num;
	int		data_id;

	for( data_num = 0; data_num<4; data_num++ ){

		data_id = p_data_list[p_pachi_shubetu[S_sys_w->pachinkow.pach_num]][p_sys_w.hyouji_data[data_num]];

		P_data_line_print( 0, data_num, data_id );

	}
}


void P_data_line_print( int id, int data_num, int data_id )
{
	long	val[2];

	switch( data_id ){
		case  0:		/*	ʐ							*/
			val[0] =	p_sys_w.pachi_data.haraidasi[P_TUUJOU_STAT]
						+ p_sys_w.pachi_data.haraidasi[P_KAKUHEN_STAT]
						+ p_sys_w.pachi_data.haraidasi[P_ATARI_STAT]
						- p_sys_w.pachi_data.tounyuu[P_TUUJOU_STAT]
						- p_sys_w.pachi_data.tounyuu[P_KAKUHEN_STAT]
						- p_sys_w.pachi_data.tounyuu[P_ATARI_STAT];
			p_data_line_print0( id, data_num, val[0], P_KO );
			break;
		case  1:		/*	ʐ							*/
			val[0] =	p_sys_w.pachi_data.tounyuu[P_TUUJOU_STAT]
						+ p_sys_w.pachi_data.tounyuu[P_KAKUHEN_STAT]
						+ p_sys_w.pachi_data.tounyuu[P_ATARI_STAT];
			p_data_line_print0( id, data_num, val[0], P_KO );
			break;
		case  2:		/*	oʐ						*/
			val[0] =	p_sys_w.pachi_data.haraidasi[P_TUUJOU_STAT]
						+ p_sys_w.pachi_data.haraidasi[P_KAKUHEN_STAT]
						+ p_sys_w.pachi_data.haraidasi[P_ATARI_STAT];
			p_data_line_print0( id, data_num, val[0], P_KO );
			break;
		case  3:		/*	vC							*/
			val[0] =	p_sys_w.pachi_data.play_jikan[P_TUUJOU_STAT]
						+ p_sys_w.pachi_data.play_jikan[P_KAKUHEN_STAT]
						+ p_sys_w.pachi_data.play_jikan[P_ATARI_STAT];
			p_data_line_print1( id, data_num, val[0]/72000, P_JIKAN_H,
										(val[0]%72000)/1200, P_JIKAN_M );
			break;
		case  4:		/*	oʗ								*/
			if( p_sys_w.pachi_data.tounyuu[P_TUUJOU_STAT] +
				p_sys_w.pachi_data.tounyuu[P_KAKUHEN_STAT] +
				p_sys_w.pachi_data.tounyuu[P_ATARI_STAT] != 0 ){
				val[0] = ( p_sys_w.pachi_data.haraidasi[P_TUUJOU_STAT] +
							p_sys_w.pachi_data.haraidasi[P_KAKUHEN_STAT] +
							p_sys_w.pachi_data.haraidasi[P_ATARI_STAT] )*100 /
						( p_sys_w.pachi_data.tounyuu[P_TUUJOU_STAT] +
							p_sys_w.pachi_data.tounyuu[P_KAKUHEN_STAT] +
							p_sys_w.pachi_data.tounyuu[P_ATARI_STAT]);
			}
			else{
				val[0] = 0;
			}
			p_data_line_print0( id, data_num, val[0], P_PERCENT );
			break;
		case  5:		/*	]							*/
			val[0] = p_sys_w.pachi_data.tuujou_kaiten_suu +
						p_sys_w.pachi_data.kakuhen_kaiten_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case  6:		/*	ʏ펞@]						*/
			val[0] = p_sys_w.pachi_data.tuujou_kaiten_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case  7:		/*	mώ@]						*/
			val[0] = p_sys_w.pachi_data.kakuhen_kaiten_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case  8:		/*	Z@]						*/
			val[0] = p_sys_w.pachi_data.kakuhen_kaiten_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case  9:		/*	哖萔						*/
			val[0] = p_sys_w.pachi_data.kakuhen_ooatari_suu +
						p_sys_w.pachi_data.hatu_atari_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case 10:		/*	ʏ펞@哖萔i萔j	*/
			val[0] = p_sys_w.pachi_data.hatu_atari_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case 11:		/*	mώ@哖萔					*/
			val[0] = p_sys_w.pachi_data.kakuhen_ooatari_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case 12:		/*	Z@哖萔					*/
			val[0] = p_sys_w.pachi_data.kakuhen_ooatari_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case 13:		/*	O哖肩̉]			*/
			val[0] = p_sys_w.pachi_data.konkai_kaiten_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case 14:		/*	O哖肩̃vC		*/
			val[0] = p_sys_w.pachi_data.konkai_jikan;
			p_data_line_print1( id, data_num, val[0]/72000, P_JIKAN_H,
										(val[0]%72000)/1200, P_JIKAN_M );
			break;
		case 15:		/*	POOO~̉]			*/
			if( (p_sys_w.pachi_data.tounyuu[P_TUUJOU_STAT] - p_sys_w.pachi_data.haraidasi[P_TUUJOU_STAT]) > 0 ){
				val[0] = (p_sys_w.pachi_data.tuujou_kaiten_suu * 250) /
						(p_sys_w.pachi_data.tounyuu[P_TUUJOU_STAT] -
						p_sys_w.pachi_data.haraidasi[P_TUUJOU_STAT]);
			}
			else{
				if( p_sys_w.pachi_data.tuujou_kaiten_suu == 0 )
					val[0] = 0;
				else
					val[0] = 999999;
			}
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case 16:		/*	ʏ펞oʗix[Xj				*/
			if( p_sys_w.pachi_data.tounyuu[P_TUUJOU_STAT] != 0 ){
				val[0] = p_sys_w.pachi_data.haraidasi[P_TUUJOU_STAT] *
						100 / p_sys_w.pachi_data.tounyuu[P_TUUJOU_STAT];
			}
			else{
				val[0] = 0;
			}
			p_data_line_print0( id, data_num, val[0], P_PERCENT );
			break;
		case 17:		/*	ϑ哖m					*/
			if( p_sys_w.pachi_data.hatu_atari_suu +
						p_sys_w.pachi_data.kakuhen_ooatari_suu > 0 ){
				val[0] = ( p_sys_w.pachi_data.tuujou_kaiten_suu +
							p_sys_w.pachi_data.kakuhen_kaiten_suu ) /
							( p_sys_w.pachi_data.hatu_atari_suu +
							p_sys_w.pachi_data.kakuhen_ooatari_suu );
				p_data_line_print1( id, data_num, 1, P_SLUSH, val[0], P_TANNI_NASHI );
			}
			else{
				p_data_line_print0( id, data_num, 0, P_TANNI_NASHI );
			}
			break;
		case 18:		/*	ʏ펞@哖m				*/
			if( p_sys_w.pachi_data.hatu_atari_suu != 0 ){
				val[0] = p_sys_w.pachi_data.tuujou_kaiten_suu /
							p_sys_w.pachi_data.hatu_atari_suu;
				p_data_line_print1( id, data_num, 1, P_SLUSH, val[0], P_TANNI_NASHI );
			}
			else{
				p_data_line_print0( id, data_num, 0, P_TANNI_NASHI );
			}
			break;
		case 19:		/*	mώ@哖m				*/
			if( p_sys_w.pachi_data.kakuhen_ooatari_suu != 0 ){
				val[0] = p_sys_w.pachi_data.kakuhen_kaiten_suu /
						p_sys_w.pachi_data.kakuhen_ooatari_suu;
				p_data_line_print1( id, data_num, 1, P_SLUSH, val[0], P_TANNI_NASHI );
			}
			else{
				p_data_line_print0( id, data_num, 0, P_TANNI_NASHI );
			}
			break;
		case 20:		/*	Z@哖m				*/
			if( p_sys_w.pachi_data.kakuhen_ooatari_suu != 0 ){
				val[0] = p_sys_w.pachi_data.kakuhen_kaiten_suu /
						p_sys_w.pachi_data.kakuhen_ooatari_suu;
				p_data_line_print1( id, data_num, 1, P_SLUSH, val[0], P_TANNI_NASHI );
			}
			else{
				p_data_line_print0( id, data_num, 0, P_TANNI_NASHI );
			}
			break;
		case 21:		/*	哖܂ł̕ώ				*/
			if( p_sys_w.pachi_data.hatu_atari_suu +
							p_sys_w.pachi_data.kakuhen_ooatari_suu != 0 ){
				val[0] = ( p_sys_w.pachi_data.play_jikan[P_TUUJOU_STAT] +
						p_sys_w.pachi_data.play_jikan[P_KAKUHEN_STAT] ) /
						( p_sys_w.pachi_data.hatu_atari_suu +
							p_sys_w.pachi_data.kakuhen_ooatari_suu );
			}
			else{
				val[0] = 0;
			}
			p_data_line_print1( id, data_num, val[0]/72000, P_JIKAN_H,
										(val[0]%72000)/1200, P_JIKAN_M );
			break;
		case 22:		/*	ʏ펞@哖܂ł̕ώ		*/
			if( p_sys_w.pachi_data.hatu_atari_suu != 0 ){
				val[0] = p_sys_w.pachi_data.play_jikan[P_TUUJOU_STAT] /
						p_sys_w.pachi_data.hatu_atari_suu;
			}
			else{
				val[0] = 0;
			}
			p_data_line_print1( id, data_num, val[0]/72000, P_JIKAN_H,
										(val[0]%72000)/1200, P_JIKAN_M );
			break;
		case 23:		/*	mώ@哖܂ł̕ώ		*/
			if( p_sys_w.pachi_data.kakuhen_ooatari_suu != 0 ){
				val[0] = p_sys_w.pachi_data.play_jikan[P_KAKUHEN_STAT] /
						p_sys_w.pachi_data.kakuhen_ooatari_suu;
			}
			else{
				val[0] = 0;
			}
			p_data_line_print1( id, data_num, val[0]/72000, P_JIKAN_H,
										(val[0]%72000)/1200, P_JIKAN_M );
			break;
		case 24:		/*	Z@哖܂ł̕ώ		*/
			if( p_sys_w.pachi_data.kakuhen_ooatari_suu != 0 ){
				val[0] = p_sys_w.pachi_data.play_jikan[P_KAKUHEN_STAT] /
						p_sys_w.pachi_data.kakuhen_ooatari_suu;
			}
			else{
				val[0] = 0;
			}
			p_data_line_print1( id, data_num, val[0]/72000, P_JIKAN_H,
										(val[0]%72000)/1200, P_JIKAN_M );
			break;
		case 25:		/*	哖萔^[`				*/
			val[0] = p_sys_w.pachi_data.kakuhen_ooatari_suu +
						p_sys_w.pachi_data.hatu_atari_suu;
			val[1] = p_sys_w.pachi_data.tuujou_reach_suu +
						p_sys_w.pachi_data.kakuhen_reach_suu;
			p_data_line_print1( id, data_num, val[0], P_SLUSH,
												val[1], P_TANNI_NASHI );
			break;
		case 26:		/*	ʏ펞@哖萔^[`		*/
			val[0] = p_sys_w.pachi_data.hatu_atari_suu;
			val[1] = p_sys_w.pachi_data.tuujou_reach_suu;
			p_data_line_print1( id, data_num, val[0], P_SLUSH,
												val[1], P_TANNI_NASHI );
			break;
		case 27:		/*	mώ@哖萔^[`		*/
			val[0] = p_sys_w.pachi_data.kakuhen_ooatari_suu;
			val[1] = p_sys_w.pachi_data.kakuhen_reach_suu;
			p_data_line_print1( id, data_num, val[0], P_SLUSH,
												val[1], P_TANNI_NASHI );
			break;
		case 28:		/*	ʏ펞@哖萔^r[`		*/
			val[0] = p_sys_w.pachi_data.tuujou_s_r_atari_suu;
			val[1] = p_sys_w.pachi_data.tuujou_s_reach_suu;
			p_data_line_print1( id, data_num, val[0], P_SLUSH,
												val[1], P_TANNI_NASHI );
			break;
		case 29:		/*	mώ@哖萔^r[`		*/
			val[0] = p_sys_w.pachi_data.kakuhen_s_r_atari_suu;
			val[1] = p_sys_w.pachi_data.kakuhen_s_reach_suu;
			p_data_line_print1( id, data_num, val[0], P_SLUSH,
												val[1], P_TANNI_NASHI );
			break;
		case 30:		/*	P̑哖ł̕Ϗo			*/
			if( p_sys_w.pachi_data.hatu_atari_suu +
				p_sys_w.pachi_data.kakuhen_ooatari_suu != 0 ){
				val[0] = (p_sys_w.pachi_data.haraidasi[P_ATARI_STAT] -
							p_sys_w.pachi_data.tounyuu[P_ATARI_STAT]) / 
							(p_sys_w.pachi_data.hatu_atari_suu +
							p_sys_w.pachi_data.kakuhen_ooatari_suu);
			}
			else{
				val[0] = 0;
			}
			p_data_line_print0( id, data_num, val[0], P_KO );
			break;
		case 31:		/*	pN							*/
			val[0] = p_sys_w.pachi_data.punc_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case 32:		/*	őn}]					*/
			val[0] = p_sys_w.pachi_data.hamari_kaiten_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case 33:		/*	ϘA							*/
			if( p_sys_w.pachi_data.kakuhen_totunyuu_suu != 0 ){
				val[0] = (p_sys_w.pachi_data.kakuhen_ooatari_suu +
						p_sys_w.pachi_data.kakuhen_totunyuu_suu) * 100 /
						p_sys_w.pachi_data.kakuhen_totunyuu_suu;
			}
			else{
				val[0] = 0;
			}
			p_data_line_print1( id, data_num, val[0]/100, P_COMMA,
												val[0]%100, P_KAI );
			break;
		case 34:		/*	ōA							*/
			val[0] = p_sys_w.pachi_data.renchan_max_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case 35:		/*	mϓ˓							*/
			val[0] = p_sys_w.pachi_data.kakuhen_totunyuu_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case 36:		/*	mώϏo						*/
			if( p_sys_w.pachi_data.kakuhen_totunyuu_suu != 0 ){
				val[0] = (p_sys_w.pachi_data.haraidasi[P_KAKUHEN_STAT]-
						p_sys_w.pachi_data.tounyuu[P_KAKUHEN_STAT]+
						(p_sys_w.pachi_data.haraidasi[P_ATARI_STAT] / 
							(p_sys_w.pachi_data.hatu_atari_suu +
							p_sys_w.pachi_data.kakuhen_ooatari_suu)) *
						(p_sys_w.pachi_data.kakuhen_ooatari_suu +
						p_sys_w.pachi_data.kakuhen_totunyuu_suu)) /
						p_sys_w.pachi_data.kakuhen_totunyuu_suu;
			}
			else{
				val[0] = 0;
			}
			p_data_line_print0( id, data_num, val[0], P_KO );
			break;
		case 37:		/*	fW^m					*/
			if( p_sys_w.pachi_data.tuujou_shou_atari_suu +
						p_sys_w.pachi_data.kakuhen_shou_atari_suu != 0 ){
				val[0] = ( p_sys_w.pachi_data.tuujou_shou_kaiten +
						p_sys_w.pachi_data.kakuhen_shou_kaiten ) * 100 /
					( p_sys_w.pachi_data.tuujou_shou_atari_suu +
						p_sys_w.pachi_data.kakuhen_shou_atari_suu );
				p_data_line_print2( id, data_num, 1, P_SLUSH, val[0]/100, P_COMMA,
									val[0]%100, P_TANNI_NASHI );
			}
			else{
				p_data_line_print0( id, data_num, 0, P_TANNI_NASHI );
			}
			break;
		case 38:		/*	ʏ펞@fW^m			*/
			if( p_sys_w.pachi_data.tuujou_shou_atari_suu != 0 ){
				val[0] = p_sys_w.pachi_data.tuujou_shou_kaiten * 100 /
						p_sys_w.pachi_data.tuujou_shou_atari_suu;
				p_data_line_print2( id, data_num, 1, P_SLUSH, val[0]/100, P_COMMA,
									val[0]%100, P_TANNI_NASHI );
			}
			else{
				p_data_line_print0( id, data_num, 0, P_TANNI_NASHI );
			}
			break;
		case 39:		/*	mώ@fW^m			*/
			if( p_sys_w.pachi_data.kakuhen_shou_atari_suu != 0 ){
				val[0] = p_sys_w.pachi_data.kakuhen_shou_kaiten * 100 /
						p_sys_w.pachi_data.kakuhen_shou_atari_suu;
				p_data_line_print2( id, data_num, 1, P_SLUSH, val[0]/100, P_COMMA,
									val[0]%100, P_TANNI_NASHI );
			}
			else{
				p_data_line_print0( id, data_num, 0, P_TANNI_NASHI );
			}
			break;
		case 40:		/*	哖萔^r[`				*/
			val[0] = p_sys_w.pachi_data.tuujou_s_r_atari_suu +
						p_sys_w.pachi_data.kakuhen_s_r_atari_suu;
			val[1] = p_sys_w.pachi_data.tuujou_s_reach_suu +
						p_sys_w.pachi_data.kakuhen_s_reach_suu;
			p_data_line_print1( id, data_num, val[0], P_SLUSH,
												val[1], P_TANNI_NASHI );
			break;
		case 41:		/*	Z@fW^m			*/
			if( p_sys_w.pachi_data.kakuhen_shou_atari_suu != 0 ){
				val[0] = p_sys_w.pachi_data.kakuhen_shou_kaiten * 100 /
						p_sys_w.pachi_data.kakuhen_shou_atari_suu;
				p_data_line_print2( id, data_num, 1, P_SLUSH, val[0]/100, P_COMMA,
									val[0]%100, P_TANNI_NASHI );
			}
			else{
				p_data_line_print0( id, data_num, 0, P_TANNI_NASHI );
			}
			break;
		case 42:		/*	Z˓							*/
			val[0] = p_sys_w.pachi_data.kakuhen_totunyuu_suu;
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
		case 43:		/*	őn}ʐ						*/
			val[0] = p_sys_w.pachi_data.hamari_tama_suu;
			p_data_line_print0( id, data_num, val[0], P_KO );
			break;
		case 44:		/*	O哖肩̋ʂ̑	*/
			val[0] = p_sys_w.pachi_data.konkai_tama_suu;
			p_data_line_print0( id, data_num, val[0], P_KO );
			break;
		case 45:		/*	mϓ˓	*/
			val[0] = p_sys_w.pachi_data.kakuhen_totunyuu_suu;
			val[1] = p_sys_w.pachi_data.hatu_atari_suu;
			p_data_line_print1( id, data_num, val[0], P_SLUSH,
												val[1], P_TANNI_NASHI );
			break;
		case 46:		/*	ʏ펞PԂ̉]	*/
			if( p_sys_w.pachi_data.play_jikan[P_TUUJOU_STAT] != 0 ){
				val[0] = p_sys_w.pachi_data.tuujou_kaiten_suu*72000 /
						p_sys_w.pachi_data.play_jikan[P_TUUJOU_STAT];
			}
			else{
				val[0] = 0;
			}
			p_data_line_print0( id, data_num, val[0], P_KAI );
			break;
	}
}


static void p_data_line_print0( int id, int data_num, long val, int tanni )
{
	int		i;

						/*	}CiX			*/
	if( id == 0 ){
		char_prim[data_num][7].x = 151;
		char_prim[data_num][7].y = -104+15+24*data_num;
	}
	else{
		char_prim[data_num][7].x = 92;
		char_prim[data_num][7].y = -104+64+16*data_num;
	}

	if( val < 0 ){
		p_set_tanni_uvwh( &char_prim[data_num][7], P_HYPHEN );
		val *= -1;
	}
	else{
		p_set_tanni_uvwh( &char_prim[data_num][7], P_SPACE );
	}

	if( val > 9999999 )		val = 9999999;		

	for( i=0; i<7; i++ ){
		if( id == 0 ){
			char_prim[data_num][i].x = 214-9*i;
			char_prim[data_num][i].y = -104+15+24*data_num;
		}
		else{
			char_prim[data_num][i].x = 155-9*i;
			char_prim[data_num][i].y = -104+64+16*data_num;
		}
		p_set_number_uvwh( &char_prim[data_num][i], val%10 );
		if( (val /= 10) == 0 ){
			i++;
			break;
		}
	}

	for( ; i<7; i++ ){				/*	Xy[X		*/
		if( id == 0 ){
			char_prim[data_num][i].x = 214-9*i;
			char_prim[data_num][i].y = -104+15+24*data_num;
		}
		else{
			char_prim[data_num][i].x = 155-9*i;
			char_prim[data_num][i].y = -104+64+16*data_num;
		}

		p_set_space_uvwh( &char_prim[data_num][i] );
	}

												/*	P		*/
	if( id == 0 ){
		char_prim[data_num][8].x = 223;
		char_prim[data_num][8].y = -104+15+24*data_num;
	}
	else{
		char_prim[data_num][8].x = 164;
		char_prim[data_num][8].y = -104+64+16*data_num;
	}

	p_set_tanni_uvwh( &char_prim[data_num][8], tanni );

	if( id == 0 ){
		for( i=0; i<9; i++ ){
			GsSortSprite(&char_prim[data_num][i],
					(GsOT *)&Wot[8][M_activebuff()], (u_short)2);
		}
	}
	else{
		for( i=0; i<9; i++ ){
			GsSortSprite(&char_prim[data_num][i],
					(GsOT *)&Wot[9][M_activebuff()], (u_short)2);
		}
	}
}

static void p_data_line_print1( int id, int data_num, long val1, int tanni1,
												long val2, int tanni2 )
{
	int		i, j;
	long 	max;

	if( val2 > 999999 )		val2 = 999999;

	for( i=0; i<6; i++ ){
		if( id == 0 ){
			char_prim[data_num][i].x = 214-9*i;
			char_prim[data_num][i].y = -104+15+24*data_num;
		}
		else{
			char_prim[data_num][i].x = 155-9*i;
			char_prim[data_num][i].y = -104+64+16*data_num;
		}
		p_set_number_uvwh( &char_prim[data_num][i], val2%10 );
		if( (val2 /= 10) == 0 ){
			i++;
			break;
		}
	}

	if( id == 0 ){
		char_prim[data_num][i].x = 214-9*i;
		char_prim[data_num][i].y = -104+15+24*data_num;
	}
	else{
		char_prim[data_num][i].x = 155-9*i;
		char_prim[data_num][i].y = -104+64+16*data_num;
	}

	p_set_tanni_uvwh( &char_prim[data_num][i], tanni1 );
	i++;

	max = 99999999;

	for( j=0; j<i; j++ ){
		max /=10;
	}

	if( val1 > max )		val1 = max;		

	for( ; i<8; i++ ){
		if( id == 0 ){
			char_prim[data_num][i].x = 214-9*i;
			char_prim[data_num][i].y = -104+15+24*data_num;
		}
		else{
			char_prim[data_num][i].x = 155-9*i;
			char_prim[data_num][i].y = -104+64+16*data_num;
		}
		p_set_number_uvwh( &char_prim[data_num][i], val1%10 );
		if( (val1 /= 10) == 0 ){
			i++;
			break;
		}
	}

	for( ; i<8; i++ ){				/*	Xy[X		*/
		if( id == 0 ){
			char_prim[data_num][i].x = 214-9*i;
			char_prim[data_num][i].y = -104+15+24*data_num;
		}
		else{
			char_prim[data_num][i].x = 155-9*i;
			char_prim[data_num][i].y = -104+64+16*data_num;
		}

		p_set_space_uvwh( &char_prim[data_num][i] );
	}

												/*	P		*/
	if( id == 0 ){
		char_prim[data_num][8].x = 223;
		char_prim[data_num][8].y = -104+15+24*data_num;
	}
	else{
		char_prim[data_num][8].x = 164;
		char_prim[data_num][8].y = -104+64+16*data_num;
	}

	p_set_tanni_uvwh( &char_prim[data_num][8], tanni2 );

	if( id == 0 ){
		for( i=0; i<9; i++ ){
			GsSortSprite(&char_prim[data_num][i],
					(GsOT *)&Wot[8][M_activebuff()], (u_short)2);
		}
	}
	else{
		for( i=0; i<9; i++ ){
			GsSortSprite(&char_prim[data_num][i],
					(GsOT *)&Wot[9][M_activebuff()], (u_short)2);
		}
	}
}


static void p_data_line_print2( int id, int data_num, long val1, int tanni1,
								long val2, int tanni2, long val3, int tanni3 )
{
	int		i, j;
	long 	max;

	if( val3 > 9999 )		val3 = 9999;

	for( i=0; i<4; i++ ){
		if( id == 0 ){
			char_prim[data_num][i].x = 214-9*i;
			char_prim[data_num][i].y = -104+15+24*data_num;
		}
		else{
			char_prim[data_num][i].x = 155-9*i;
			char_prim[data_num][i].y = -104+64+16*data_num;
		}
		p_set_number_uvwh( &char_prim[data_num][i], val3%10 );
		if( (val3 /= 10) == 0 ){
			i++;
			break;
		}
	}

	if( id == 0 ){
		char_prim[data_num][i].x = 214-9*i;
		char_prim[data_num][i].y = -104+15+24*data_num;
	}
	else{
		char_prim[data_num][i].x = 155-9*i;
		char_prim[data_num][i].y = -104+64+16*data_num;
	}

	p_set_tanni_uvwh( &char_prim[data_num][i], tanni2 );
	i++;

	max = 999999;

	for( j=0; j<i; j++ ){
		max /=10;
	}

	if( val2 > max )		val2 = max;		

	for( ; i<6; i++ ){
		if( id == 0 ){
			char_prim[data_num][i].x = 214-9*i;
			char_prim[data_num][i].y = -104+15+24*data_num;
		}
		else{
			char_prim[data_num][i].x = 155-9*i;
			char_prim[data_num][i].y = -104+64+16*data_num;
		}
		p_set_number_uvwh( &char_prim[data_num][i], val2%10 );
		if( (val2 /= 10) == 0 ){
			i++;
			break;
		}
	}

	if( id == 0 ){
		char_prim[data_num][i].x = 214-9*i;
		char_prim[data_num][i].y = -104+15+24*data_num;
	}
	else{
		char_prim[data_num][i].x = 155-9*i;
		char_prim[data_num][i].y = -104+64+16*data_num;
	}

	p_set_tanni_uvwh( &char_prim[data_num][i], tanni1 );
	i++;

	max = 99999999;

	for( j=0; j<i; j++ ){
		max /=10;
	}

	if( val1 > max )		val1 = max;		

	for( ; i<8; i++ ){
		if( id == 0 ){
			char_prim[data_num][i].x = 214-9*i;
			char_prim[data_num][i].y = -104+15+24*data_num;
		}
		else{
			char_prim[data_num][i].x = 155-9*i;
			char_prim[data_num][i].y = -104+64+16*data_num;
		}
		p_set_number_uvwh( &char_prim[data_num][i], val1%10 );
		if( (val1 /= 10) == 0 ){
			i++;
			break;
		}
	}

	for( ; i<8; i++ ){				/*	Xy[X		*/
		if( id == 0 ){
			char_prim[data_num][i].x = 214-9*i;
			char_prim[data_num][i].y = -104+15+24*data_num;
		}
		else{
			char_prim[data_num][i].x = 155-9*i;
			char_prim[data_num][i].y = -104+64+16*data_num;
		}

		p_set_space_uvwh( &char_prim[data_num][i] );
	}

												/*	P		*/
	if( id == 0 ){
		char_prim[data_num][8].x = 223;
		char_prim[data_num][8].y = -104+15+24*data_num;
	}
	else{
		char_prim[data_num][8].x = 164;
		char_prim[data_num][8].y = -104+64+16*data_num;
	}

	p_set_tanni_uvwh( &char_prim[data_num][8], tanni3 );

	if( id == 0 ){
		for( i=0; i<9; i++ ){
			GsSortSprite(&char_prim[data_num][i],
					(GsOT *)&Wot[8][M_activebuff()], (u_short)2);
		}
	}
	else{
		for( i=0; i<9; i++ ){
			GsSortSprite(&char_prim[data_num][i],
					(GsOT *)&Wot[9][M_activebuff()], (u_short)2);
		}
	}
}



void P_data_print_init()
{
	int		i, j;

	for( i=0; i<10; i++ ){
		for( j=0; j<10; j++ ){
			char_prim[i][j].attribute = (0<<24);

			char_prim[i][j].tpage = GetTPage( 0, 1, 960, 256 );
			char_prim[i][j].scalex = ONE;
			char_prim[i][j].scaley = ONE;
			char_prim[i][j].rotate = 0;
			char_prim[i][j].r = 0x80;
			char_prim[i][j].g = 0x80;
			char_prim[i][j].b = 0x80;
			char_prim[i][j].mx = 0;
			char_prim[i][j].my = 0;
		}
	}
}


static void p_set_number_uvwh( GsSPRITE *prim, int val )
{
	prim->v = 48;
	prim->w = 8;
	prim->h = 16;
	prim->u = 8*(val%10);
	prim->cx = 256;
	prim->cy = 505;
}


static void p_set_space_uvwh( GsSPRITE *prim )
{
	prim->u = 8*10;
	prim->v = 48;
	prim->w = 8;
	prim->h = 16;
	prim->cx = 256;
	prim->cy = 505;
}


static void p_set_tanni_uvwh( GsSPRITE *prim, int val )
{

	switch( val ){
		case P_TANNI_NASHI:
			prim->u = 0;
			prim->v = 48;
			prim->w = 0;
			prim->h = 0;
			prim->cx = 256;
			prim->cy = 505;
			break;
		case P_SPACE:
			prim->u = 8*10;
			prim->v = 48;
			prim->w = 8;
			prim->h = 16;
			prim->cx = 256;
			prim->cy = 505;
			break;
		case P_COMMA:
			prim->u = 8*11;
			prim->v = 48;
			prim->w = 8;
			prim->h = 16;
			prim->cx = 256;
			prim->cy = 505;
			break;
		case P_SLUSH:
			prim->u = 8*12;
			prim->v = 48;
			prim->w = 8;
			prim->h = 16;
			prim->cx = 272;
			prim->cy = 505;
			break;
		case P_HYPHEN:
			prim->u = 8*13;
			prim->v = 48;
			prim->w = 8;
			prim->h = 16;
			prim->cx = 256;
			prim->cy = 505;
			break;
		case P_JIKAN_H:
			prim->u = 112+0;
			prim->v = 48;
			prim->w = 8;
			prim->h = 16;
			prim->cx = 272;
			prim->cy = 505;
			break;
		case P_JIKAN_M:
			prim->u = 112+8;
			prim->v = 48;
			prim->w = 12;
			prim->h = 16;
			prim->cx = 272;
			prim->cy = 505;
			break;
		case P_PERCENT:
			prim->u = 112+20;
			prim->v = 48;
			prim->w = 16;
			prim->h = 16;
			prim->cx = 272;
			prim->cy = 505;
			break;
		case P_KAI:
			prim->u = 112+36;
			prim->v = 48;
			prim->w = 16;
			prim->h = 16;
			prim->cx = 272;
			prim->cy = 505;
			break;
		case P_KO:
			prim->u = 112+52;
			prim->v = 48;
			prim->w = 16;
			prim->h = 16;
			prim->cx = 272;
			prim->cy = 505;
			break;
	}
}

void P_data_comment_init()
{
	int		data_num;
	int		data_id;

	for( data_num = 0; data_num<4; data_num++ ){
		data_id = p_data_list[p_pachi_shubetu[S_sys_w->pachinkow.pach_num]][p_sys_w.hyouji_data[data_num]];

		Kanji12_load( p_hyouji_list[data_id].message,
					(u_short *)P_DATA_BIN_FONT_TBL, 28, 0x0f,
					960, 256+184+data_num*12, 1 );

		comment_prim[data_num].attribute = (0<<24);

		comment_prim[data_num].tpage = GetTPage( 0, 1, 960, 256 );
		comment_prim[data_num].scalex = ONE;
		comment_prim[data_num].scaley = ONE;
		comment_prim[data_num].rotate = 0;
		comment_prim[data_num].r = 0x80;
		comment_prim[data_num].g = 0x80;
		comment_prim[data_num].b = 0x80;
		comment_prim[data_num].mx = 0;
		comment_prim[data_num].my = 0;
		comment_prim[data_num].x = -34;
		comment_prim[data_num].y = -104+14+24*data_num;
		comment_prim[data_num].u = 0;
		comment_prim[data_num].v = 184+data_num*12;
		comment_prim[data_num].w = 14*12;
		comment_prim[data_num].h = 12;
		comment_prim[data_num].cx = 256;
		comment_prim[data_num].cy = 505;
	}

}

void P_data_comment_print()
{
	int		i;

	for( i=0; i<4; i++ ){
		GsSortSprite(&comment_prim[i], (GsOT *)&Wot[8][M_activebuff()], 
		(u_short)2);
	}
}


