/***< file >*****************************************************************/
/*	Title		:	PlayStation												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	s_work2.c												*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	1995.08.08												*/
/*	Note		:															*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include 		"lt_all.h"
#include 		"s_trans.h"
#include 		"pachinko.h"
#include 		"p_ekisho.h"


/*==========================================================================*/
/*	define																	*/
/*==========================================================================*/


void O_EKISHO_W(EKISHO_W *objp)
{
	OPD_HEAD		*opd_head;
	OPD_COL_DATA	*col_data;
	OPD_CSR_DATA	*csr_data;
	OPD_PAT_DATA	*pat_data;
	OPD_OBJ_DATA	*obj_data;
	OPD_ANM_DATA	*anm_data;
	int				pat_no;
	int				pal_no;
	int				i;
	int				u, v, w, h;
	DIVPOLYGON4 	*divp = (DIVPOLYGON4*)(SCRATCH);	/* divide buffer */

	opd_head = (OPD_HEAD *)(objp->opd_address);

	if( opd_head == NULL )		return;

	if( p_sys_w.pause_flag != 0 ){
		goto HYOUJI_NOMI;
	}

	if( objp->terminate_flag != 0 ){
		S_obj_clear((u_long *)objp);
		S_free( (char *)objp->pmd_data.data );
		S_free( (char *)objp->pmd_data.fbuf );
	}
	else{
											/* pbg̋ύX		*/
		if( opd_head->color_mode == 16 ){
			if( objp->palette_number != -1 ){
				pal_no = objp->palette_number;

				col_data = (OPD_COL_DATA *)(opd_head->col_address);

				for( i=0; i<opd_head->obj_number && i<EKISHO_OBJ_MAX; i++ ){
					objp->pmd_data.data[i].prim.clut =
								GetClut(col_data->x+pal_no*16,col_data->y);
				}
			}
		}

		while( objp->timer == 0 ){
			anm_data = (OPD_ANM_DATA *)(*((u_long *)(opd_head->anm_address)
														+ objp->anime_no) );

			pat_no = (anm_data+(objp->pattern_no))->pat_number;
			objp->timer = 0;

			pat_data = (OPD_PAT_DATA *)(opd_head->pat_address) + pat_no;

/*
printf( "cmd=%x, opd=%x, anm=%x, pat_no=%x, pat=%x\n", pat_data->command, opd_head, anm_data, pat_no, pat_data );
*/

			switch( pat_data->command ){
				case	OPD_CMD_DATA:		/*	ʏf[^					*/
					objp->timer = (anm_data+(objp->pattern_no))->time;
					for( i=0; i<opd_head->obj_number && i<EKISHO_OBJ_MAX; i++ ){
						obj_data = (OPD_OBJ_DATA *)(pat_data->address) + i;

						csr_data = (OPD_CSR_DATA *)(opd_head->csr_address) +
												obj_data->csr_number/0x100;

						if( opd_head->color_mode == 16 ){
							u=(obj_data->csr_number%0x10)*8+(csr_data->x%64)*4;
						}
						else{
							u=(obj_data->csr_number%0x10)*8+(csr_data->x%64)*2;
						}
						v = ((obj_data->csr_number/0x10)%0x10)*8+(csr_data->y%256);
						w = obj_data->w;
						h = obj_data->h;

						setUVWH(&(objp->pmd_data.data[i].prim),
																u,v,w-1,h-1);

						setVector(&(objp->pmd_data.data[i].vect[0]),
								P_E_SCALE_CHANGE_X(obj_data->u),
								P_E_SCALE_CHANGE_Y(obj_data->v),
								p_sys_w.model_vect[0].vz );
						setVector(&(objp->pmd_data.data[i].vect[1]),
/*								P_E_SCALE_CHANGE_X(obj_data->u+obj_data->w-1),*/
								P_E_SCALE_CHANGE_X(obj_data->u+obj_data->w),
								P_E_SCALE_CHANGE_Y(obj_data->v),
								p_sys_w.model_vect[0].vz );
						setVector(&(objp->pmd_data.data[i].vect[2]),
								P_E_SCALE_CHANGE_X(obj_data->u),
/*								P_E_SCALE_CHANGE_Y(obj_data->v+obj_data->h-1),*/
								P_E_SCALE_CHANGE_Y(obj_data->v+obj_data->h),
								p_sys_w.model_vect[0].vz );
						setVector(&(objp->pmd_data.data[i].vect[3]),
/*								P_E_SCALE_CHANGE_X(obj_data->u+obj_data->w-1),
								P_E_SCALE_CHANGE_Y(obj_data->v+obj_data->h-1),*/
								P_E_SCALE_CHANGE_X(obj_data->u+obj_data->w),
								P_E_SCALE_CHANGE_Y(obj_data->v+obj_data->h),
								p_sys_w.model_vect[0].vz );

						if( opd_head->color_mode == 16 ){
							if( objp->palette_number != -1 )
								pal_no = objp->palette_number;
							else
								pal_no = obj_data->palette_number;
						}
						else{
							pal_no = 0;
						}

						col_data = (OPD_COL_DATA *)(opd_head->col_address);

						objp->pmd_data.data[i].prim.clut =
								GetClut(col_data->x+pal_no*16,col_data->y);

						if( opd_head->color_mode == 16 ){
							objp->pmd_data.data[i].prim.tpage =
									GetTPage(0,1,csr_data->x-(csr_data->x)%64,
												csr_data->y-(csr_data->y)%256);
						}
						else{
							objp->pmd_data.data[i].prim.tpage =
									GetTPage(1,1,csr_data->x-(csr_data->x)%64,
												csr_data->y-(csr_data->y)%256);
						}
					}
					objp->pattern_no++;
					break;
				case	OPD_CMD_LOOP:		/*	擪p^[֖߂			*/
					objp->pattern_no = 0;
					break;
				case	OPD_CMD_STOP:		/*	noc̒~			*/
					objp->timer++;
					break;
				case	OPD_CMD_END:		/*	nocI				*/
					S_obj_clear((u_long *)objp);
					objp->timer++;
					break;
				case	OPD_CMD_GOTO:		/*	wp^[֔			*/
					objp->pattern_no = pat_data->address;
					break;
				case	OPD_CMD_TR_CSR:		/*	wbrq̓]			*/
					csr_data = (OPD_CSR_DATA *)(opd_head->csr_address) +
															pat_data->address;
					S_trans_set((u_long *)csr_data->address, (u_short)1);
					objp->pattern_no++;
					break;
				case	OPD_CMD_ST_ANIME:	/*	wAj[V̋Jn*/
					objp->anime_no = objp->nextanime_no = pat_data->address;
					objp->pattern_no = 0;
					break;
				case	OPD_CMD_AC_ANIME:	/*	Aj[V̕ύX|Cg*/
					if( objp->anime_no != objp->nextanime_no ){
						objp->anime_no = objp->nextanime_no;
						objp->pattern_no = 0;
					}
					else{
						objp->pattern_no++;
					}
					break;
				case	OPD_CMD_SET_FLAG:	/*	tO̐ݒ*/
					objp->flag = pat_data->address;
					objp->pattern_no++;
					break;
				case	OPD_CMD_REPEAT:		/*	AǰJԂ*/
					if( objp->repeat_no < 0 ){
						objp->repeat_no = pat_data->address;
					}

					objp->repeat_no--;
					if( objp->repeat_no < 0 ){
						objp->pattern_no++;
					}
					else{
						objp->pattern_no = 0;
					}
					break;
			}
		}

		objp->timer--;
	}

/*
printf( "tpage:%x  ", objp->pmd_data.data[1].prim[0].tpage );
printf( "clut:%x  ", objp->pmd_data.data[1].prim[0].clut );
printf( "uv:%x,%x\n",
	objp->pmd_data.data[1].prim[0].u0, objp->pmd_data.data[1].prim[0].v0 );
*/

HYOUJI_NOMI:

#if 0
	RotRMD_FT4( (long *)&(objp->pmd_data),
				(u_long *)Mot[objp->ot][M_activebuff()].org,
				(int)MOT_LENGTH,(int)M_activebuff());
	RotRMD_FT4( (long *)&(objp->pmd_data),
				(u_long *)Wot[0][M_activebuff()].org,
				(int)MOT_LENGTH,(int)M_activebuff());
#else

	for( i=0; i<opd_head->obj_number && i<EKISHO_OBJ_MAX; i++ ){
		divp->ndiv=1;			/* divide depth */
		divp->pih=512;		/* horizontal resolution */
		divp->piv=240;		/* vertical resolution */

/*
	NFntPrint( "%d:%x,%x %x,%x %x,%x %x,%x\n", i,
		objp->pmd_data.data[i].vect[0].vx, objp->pmd_data.data[i].vect[0].vy,
		objp->pmd_data.data[i].vect[1].vx, objp->pmd_data.data[i].vect[1].vy,
		objp->pmd_data.data[i].vect[2].vx, objp->pmd_data.data[i].vect[2].vy,
		objp->pmd_data.data[i].vect[3].vx, objp->pmd_data.data[i].vect[3].vy);
	NFntPrint( "%d:%x,%x %x,%x %x,%x %x,%x\n", i,
						 objp->pmd_data.data[i].prim.u0,
						 objp->pmd_data.data[i].prim.v0,
						 objp->pmd_data.data[i].prim.u1,
						 objp->pmd_data.data[i].prim.v1,
						 objp->pmd_data.data[i].prim.u2,
						 objp->pmd_data.data[i].prim.v2,
						 objp->pmd_data.data[i].prim.u3,
						 objp->pmd_data.data[i].prim.v3);
*/

		(void)DivideFT4(&(objp->pmd_data.data[i].vect[0]),
						&(objp->pmd_data.data[i].vect[1]),
						&(objp->pmd_data.data[i].vect[2]),
						&(objp->pmd_data.data[i].vect[3]),
						 (u_long *)&(objp->pmd_data.data[i].prim.u0),
						 (u_long *)&(objp->pmd_data.data[i].prim.u1),
						 (u_long *)&(objp->pmd_data.data[i].prim.u2),
						 (u_long *)&(objp->pmd_data.data[i].prim.u3),
						 &(objp->pmd_data.data[i].prim.r0),
						 &(objp->pmd_data.fbuf[(i*2+M_activebuff())*4]),
						 (u_long *)(Mot[objp->ot][M_activebuff()].org
						 								+ EKISHO_OBJ_MAX-i),
						 divp);
	}
#endif
/*
printf( "timer:%d anime no:%d pattern no:%d\n"
				, objp->timer, objp->anime_no, objp->pattern_no );
*/
}


void O_EKISHO_W_INIT( EKISHO_W *objp, int anime_no, int ot )
{
	OPD_HEAD		*opd_head;
	OPD_COL_DATA	*col_data;
	int				i;

	opd_head = (OPD_HEAD *)objp->opd_address;

											/*	J[pbg]	*/
	col_data = (OPD_COL_DATA *)(opd_head->col_address);
	S_trans_set( (u_long *)col_data->address, 1 );

	objp->pmd_data.data =
			S_malloc( sizeof(EKISHO_PMD_DATA)*opd_head->obj_number );
	objp->pmd_data.fbuf =
			S_malloc( sizeof(POLY_FT4)*opd_head->obj_number*2*4 );

	objp->pmd_data.type = 0x00010000 |
							(opd_head->obj_number<EKISHO_OBJ_MAX)?
							opd_head->obj_number:EKISHO_OBJ_MAX;
	objp->ot = ot;

	for( i=0; i<opd_head->obj_number && i<EKISHO_OBJ_MAX; i++ ){
		SetPolyFT4( &(objp->pmd_data.data[i].prim) );
		setRGB0( &(objp->pmd_data.data[i].prim), 0x80, 0x80, 0x80 );
	}

											/*	anime,patternԍ		*/
	objp->anime_no = anime_no;
	objp->nextanime_no = anime_no;
	objp->pattern_no = 0;
	objp->timer = 0;
	objp->terminate_flag = 0;
	objp->palette_number = -1;
	objp->repeat_no = -1;
}

void P_ekisho_init(u_long *model, long dotx, long doty)
{
	TMD_PRIM		tprim;

	OpenTMD(model,0);
	if(ReadTMD(&tprim) != NULL) {
		p_sys_w.model_vect[0].vx =
						((tprim.x0.vx<tprim.x1.vx)?tprim.x0.vx:tprim.x1.vx);
		p_sys_w.model_vect[0].vy =
						((tprim.x0.vy<tprim.x2.vy)?tprim.x0.vy:tprim.x2.vy);
		p_sys_w.model_vect[0].vz = tprim.x0.vz;
		p_sys_w.model_vect[1].vx =
						((tprim.x0.vx>tprim.x1.vx)?tprim.x0.vx:tprim.x1.vx);
		p_sys_w.model_vect[1].vy =
						((tprim.x0.vy<tprim.x2.vy)?tprim.x0.vy:tprim.x2.vy);
		p_sys_w.model_vect[1].vz = tprim.x0.vz;
		p_sys_w.model_vect[2].vx =
						((tprim.x0.vx<tprim.x1.vx)?tprim.x0.vx:tprim.x1.vx);
		p_sys_w.model_vect[2].vy =
						((tprim.x0.vy>tprim.x2.vy)?tprim.x0.vy:tprim.x2.vy);
		p_sys_w.model_vect[2].vz = tprim.x0.vz;
		p_sys_w.model_vect[3].vx =
						((tprim.x0.vx>tprim.x1.vx)?tprim.x0.vx:tprim.x1.vx);
		p_sys_w.model_vect[3].vy =
						((tprim.x0.vy>tprim.x2.vy)?tprim.x0.vy:tprim.x2.vy);
		p_sys_w.model_vect[3].vz = tprim.x0.vz;
	}

	p_sys_w.dotx = dotx;
	p_sys_w.doty = doty;
}


void P_anime_clear( EKISHO_W *objp )
{
	S_obj_clear((u_long *)objp);
	S_free( (char *)objp->pmd_data.data );
	S_free( (char *)objp->pmd_data.fbuf );
}


void P_anime_change(EKISHO_W *objp, int no)
{
	objp->anime_no = no;
	objp->nextanime_no = no;
	objp->pattern_no = 0;
	objp->timer = 0;
}

/***< global function >******************************************************/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/****************************************************************************/

/*---< local function >-----------------------------------------------------*/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/


