/***< file >*****************************************************************/
/*	Title		:	PlayStation												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	p_kugi.c												*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	1995.07.06												*/
/*	Note		:	ݺ̓B												*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include		"lt_all.h"
#include		"s_trans.h"
#include		"pachinko.h"
#include		"p_kugi.h"
#include		"p_tama.h"

/*==========================================================================*/
/*	define																	*/
/*==========================================================================*/

static void kugi_vector_set(KUGI_POLY *polyp, int n,
										short vx, short vy, short vz);
static void kugi_prim_set(	u_long *timp, KUGI_POLY *polyp,
										u_char r, u_char g, u_char b);
static void kugi_poly_set( int flag, long *kugi_pmd, int kugi_num,
														short *kugi_data );
static void mkugi_poly_set( int flag, long *kugi_pmd, int kugi_num,
														short *kugi_data );
static void p_kugi_move_init( int kugi_number );
static void p_kugi_move_inc( int kugi_number, int xy, int val );
static int p_kugi_chousei_check( int kuugi_number );

static	short	p_chousei_table[][16] = {
		{ 4, 6, 2, 3, 9, 8, 7, 1, 10, 0, 5 },
		{ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 },
		{ 6, 0, 9, 5, 2, 10, 8, 7, 3, 4, 1 },
		{ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 },
		{ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 },
		{ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 },
	};


/*==========================================================================*/
/*	Program																	*/
/*==========================================================================*/

/*=================================================================== B */
/***< global function >******************************************************/
/*	`F		P_kugi_set(pri)												*/
/*	F		u_short		pri:ײè									*/
/*				int			flag:P̂Ƃ̓NMpf[^Q				*/
/*	F		ݺ̓B												*/
/*	ԒlF		u_long	*objp:޼ު߲									*/
/*				0 ̎́AĎs											*/
/****************************************************************************/
u_long *P_kugi_set(u_short pri, int flag)
{

	if((p_sys_w.kugi_objp = (KUGI_W *)S_obj_set((u_long)NULL,	/* set֐ */
					(u_long)O_KUGI,								/* obj֐ */
					(u_long)sizeof(KUGI_W),						/* size */
					(int)pri)) != NULL) {						/* Dԍ */
		p_kugi_convert( flag );				/* B */
	}
	return((u_long *)p_sys_w.kugi_objp);
}

/***< global function >******************************************************/
/*	`F		P_kugi(objp)												*/
/*	F		USER_W	*objp:޼ު߲									*/
/*	F		ݺB														*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
#define		KUGI_INIT		0
#define		KUGI_MAIN		1

/*---< local function >-----------------------------------------------------*/
/*	`F		p_kugi_convert()											*/
/*	F		Ȃ														*/
/*	F		B̒ʒuްBèް쐬				*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
void p_kugi_convert( int flag )
{
	long		kugi_num[2];	/* kugi,mkugi̖{		*/
	short		*kugi_data;
	short		*mkugi_data;

								/* NM̖{ǂݏo				*/
	if( flag == 0 ){
		kugi_num[0] = *((long *)(p_sys_w.p_data->kugi_data));
		kugi_num[1] = *((long *)(p_sys_w.p_data->mkugi_data));
	}
	else{
		kugi_num[0] = *((long *)(p_sys_w.p_chousei_data->kugi_data));
		kugi_num[1] = *((long *)(p_sys_w.p_chousei_data->mkugi_data));
	}

	if( flag == 0 ){
		S_trans_set( p_sys_w.p_data->kugi_timA, 1);				/* ø */
		S_trans_set( p_sys_w.p_data->kugi_timB, 1);				/* ø */

		kugi_data = p_sys_w.p_data->kugi_data;
		mkugi_data = p_sys_w.p_data->mkugi_data;
	}
	else{
		S_trans_set(p_sys_w.p_chousei_data->kugi_timA, 1);		/* ø */
		S_trans_set(p_sys_w.p_chousei_data->kugi_timB, 1);		/* ø */
		S_trans_set(p_sys_w.p_chousei_data->kugi_timA1, 1);		/* ø */
		S_trans_set(p_sys_w.p_chousei_data->kugi_timB1, 1);		/* ø */
		S_trans_set(p_sys_w.p_chousei_data->kugi_timA2, 1);		/* ø */
		S_trans_set(p_sys_w.p_chousei_data->kugi_timB2, 1);		/* ø */

		kugi_data = p_sys_w.p_chousei_data->kugi_data;
		mkugi_data = p_sys_w.p_chousei_data->mkugi_data;
	}

												/* ȂNM̕\	*/
	kugi_poly_set( flag, p_sys_w.poly_address_kugi,
											kugi_num[0], &kugi_data[2] );

												/* NM̕\	*/
	mkugi_poly_set( flag, p_sys_w.poly_address_mkugi,
											kugi_num[1], &mkugi_data[2] );

}

void P_kugi_init()
{
	long		kugi_num[2];	/* kugi,mkugi̖{		*/

								/* NM̖{ǂݏo				*/
	kugi_num[0] = *((long *)(p_sys_w.p_chousei_data->kugi_data));
	p_sys_w.mkugi_number = kugi_num[1] =
						*((long *)(p_sys_w.p_chousei_data->mkugi_data));

								/* NM̃|SPMD̈m		*/
	p_sys_w.poly_address_kugi =
					(long *)S_malloc(sizeof(KUGI_POLY)*kugi_num[0]*3+4);
	p_sys_w.poly_address_mkugi =
					(long *)S_malloc(sizeof(KUGI_POLY)*kugi_num[1]*3+4);
}

void P_kugi_maxmin_set()
{
	short		*kugi_data;
	int			i;
	short		coor[2];

	kugi_data = &p_sys_w.p_data->kugi_data[2];

	p_sys_w.kugi_x_max = kugi_data[0]+KUGI_POLY_R+TAMA_POLY_R;
	p_sys_w.kugi_x_min = kugi_data[0]-KUGI_POLY_R-TAMA_POLY_R;
	p_sys_w.kugi_y_max = kugi_data[1]+KUGI_POLY_R+TAMA_POLY_R;
	p_sys_w.kugi_y_min = kugi_data[1]-KUGI_POLY_R-TAMA_POLY_R;

	for( i=1; i<*((long *)(p_sys_w.p_data->kugi_data)); i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

		if( coor[0]+KUGI_POLY_R+TAMA_POLY_R > p_sys_w.kugi_x_max )
			p_sys_w.kugi_x_max = coor[0]+KUGI_POLY_R+TAMA_POLY_R;
		else if( coor[0]-KUGI_POLY_R-TAMA_POLY_R < p_sys_w.kugi_x_min )
			p_sys_w.kugi_x_min = coor[0]-KUGI_POLY_R-TAMA_POLY_R;

		if( coor[1]+KUGI_POLY_R+TAMA_POLY_R > p_sys_w.kugi_y_max )
			p_sys_w.kugi_y_max = coor[1]+KUGI_POLY_R+TAMA_POLY_R;
		else if( coor[1]-KUGI_POLY_R-TAMA_POLY_R < p_sys_w.kugi_y_min )
			p_sys_w.kugi_y_min = coor[1]-KUGI_POLY_R-TAMA_POLY_R;
	}

	kugi_data = &p_sys_w.p_data->mkugi_data[2];

	for( i=0; i<*((long *)(p_sys_w.p_data->mkugi_data)); i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

		if( coor[0]+KUGI_POLY_R+TAMA_POLY_R > p_sys_w.kugi_x_max )
			p_sys_w.kugi_x_max = coor[0]+KUGI_POLY_R+TAMA_POLY_R+KUGI_CHOUSEI_MAX;
		else if( coor[0]-KUGI_POLY_R-TAMA_POLY_R < p_sys_w.kugi_x_min )
			p_sys_w.kugi_x_min = coor[0]-KUGI_POLY_R-TAMA_POLY_R-KUGI_CHOUSEI_MAX;

		if( coor[1]+KUGI_POLY_R+TAMA_POLY_R > p_sys_w.kugi_y_max )
			p_sys_w.kugi_y_max = coor[1]+KUGI_POLY_R+TAMA_POLY_R+KUGI_CHOUSEI_MAX;
		else if( coor[1]-KUGI_POLY_R-TAMA_POLY_R < p_sys_w.kugi_y_min )
			p_sys_w.kugi_y_min = coor[1]-KUGI_POLY_R-TAMA_POLY_R-KUGI_CHOUSEI_MAX;
	}

	kugi_data = &p_sys_w.p_data->yaku_data[2];

	for( i=0; i<*((long *)(p_sys_w.p_data->yaku_data)); i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

		if( coor[0]+KUGI_POLY_R+TAMA_POLY_R > p_sys_w.kugi_x_max )
			p_sys_w.kugi_x_max = coor[0]+KUGI_POLY_R+TAMA_POLY_R;
		else if( coor[0]-KUGI_POLY_R-TAMA_POLY_R < p_sys_w.kugi_x_min )
			p_sys_w.kugi_x_min = coor[0]-KUGI_POLY_R-TAMA_POLY_R;

		if( coor[1]+KUGI_POLY_R+TAMA_POLY_R > p_sys_w.kugi_y_max )
			p_sys_w.kugi_y_max = coor[1]+KUGI_POLY_R+TAMA_POLY_R;
		else if( coor[1]-KUGI_POLY_R-TAMA_POLY_R < p_sys_w.kugi_y_min )
			p_sys_w.kugi_y_min = coor[1]-KUGI_POLY_R-TAMA_POLY_R;
	}
}


void P_atari_kugi_set()
{
	int			kugi_no[KUGI_DIV_NO][KUGI_DIV_NO];
	int			i, j, k;
	short		coor[2];
	short		*kugi_data;
	long		kugi_num;

	for( j=0; j<KUGI_DIV_NO; j++ ){
		for( k=0; k<KUGI_DIV_NO; k++ ){
			kugi_no[j][k] = 0;
		}
	}

	kugi_data = &p_sys_w.p_data->kugi_data[2];
	kugi_num = *((long *)(p_sys_w.p_data->kugi_data));

	for( i=0; i<kugi_num; i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

		for( j=0; j<KUGI_DIV_NO; j++ ){
			if( (coor[0] > p_sys_w.kugi_x_min
				+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*j/KUGI_DIV_NO
				-KUGI_POLY_R-TAMA_POLY_R) &&
				(coor[0] < p_sys_w.kugi_x_min+
				+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*(j+1)/KUGI_DIV_NO
				+KUGI_POLY_R+TAMA_POLY_R) ){
				for( k=0; k<KUGI_DIV_NO; k++ ){
					if( (coor[1] > p_sys_w.kugi_y_min
						+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*k/KUGI_DIV_NO
						-KUGI_POLY_R-TAMA_POLY_R) &&
						(coor[1] < p_sys_w.kugi_y_min
						+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*(k+1)/KUGI_DIV_NO
						+KUGI_POLY_R+TAMA_POLY_R) ){
						kugi_no[j][k]++;
					}
				}
			}
		}
	}

	for( j=0; j<KUGI_DIV_NO; j++ ){
		for( k=0; k<KUGI_DIV_NO; k++ ){
			p_sys_w.kugi_divide[j][k] = (short *)S_malloc((kugi_no[j][k]+1)*2);
			p_sys_w.kugi_divide[j][k][0] = kugi_no[j][k];
			kugi_no[j][k] = 0;
		}
	}

	for( i=0; i<kugi_num; i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

		for( j=0; j<KUGI_DIV_NO; j++ ){
			if( (coor[0] > p_sys_w.kugi_x_min
				+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*j/KUGI_DIV_NO
				-KUGI_POLY_R-TAMA_POLY_R) &&
				(coor[0] < p_sys_w.kugi_x_min+
				+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*(j+1)/KUGI_DIV_NO
				+KUGI_POLY_R+TAMA_POLY_R) ){
				for( k=0; k<KUGI_DIV_NO; k++ ){
					if( (coor[1] > p_sys_w.kugi_y_min
						+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*k/KUGI_DIV_NO
						-KUGI_POLY_R-TAMA_POLY_R) &&
						(coor[1] < p_sys_w.kugi_y_min
						+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*(k+1)/KUGI_DIV_NO
						+KUGI_POLY_R+TAMA_POLY_R) ){
						kugi_no[j][k]++;
						p_sys_w.kugi_divide[j][k][kugi_no[j][k]] = i;
					}
				}
			}
		}
	}

	kugi_data = &p_sys_w.p_data->mkugi_data[2];
	kugi_num = *((long *)(p_sys_w.p_data->mkugi_data));

	for( j=0; j<KUGI_DIV_NO; j++ ){
		for( k=0; k<KUGI_DIV_NO; k++ ){
			kugi_no[j][k] = 0;
		}
	}

	for( i=0; i<kugi_num; i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

		for( j=0; j<KUGI_DIV_NO; j++ ){
			if( (coor[0] > p_sys_w.kugi_x_min
				+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*j/KUGI_DIV_NO
				-KUGI_POLY_R-TAMA_POLY_R-KUGI_CHOUSEI_MAX) &&
				(coor[0] < p_sys_w.kugi_x_min+
				+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*(j+1)/KUGI_DIV_NO
				+KUGI_POLY_R+TAMA_POLY_R+KUGI_CHOUSEI_MAX) ){
				for( k=0; k<KUGI_DIV_NO; k++ ){
					if( (coor[1] > p_sys_w.kugi_y_min
						+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*k/KUGI_DIV_NO
						-KUGI_POLY_R-TAMA_POLY_R-KUGI_CHOUSEI_MAX) &&
						(coor[1] < p_sys_w.kugi_y_min
						+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*(k+1)/KUGI_DIV_NO
						+KUGI_POLY_R+TAMA_POLY_R+KUGI_CHOUSEI_MAX) ){
						kugi_no[j][k]++;
					}
				}
			}
		}
	}

	for( j=0; j<KUGI_DIV_NO; j++ ){
		for( k=0; k<KUGI_DIV_NO; k++ ){
			p_sys_w.mkugi_divide[j][k] = (short *)S_malloc((kugi_no[j][k]+1)*2);
			p_sys_w.mkugi_divide[j][k][0] = kugi_no[j][k];
			kugi_no[j][k] = 0;
		}
	}

	for( i=0; i<kugi_num; i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

		for( j=0; j<KUGI_DIV_NO; j++ ){
			if( (coor[0] > p_sys_w.kugi_x_min
				+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*j/KUGI_DIV_NO
				-KUGI_POLY_R-TAMA_POLY_R-KUGI_CHOUSEI_MAX) &&
				(coor[0] < p_sys_w.kugi_x_min+
				+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*(j+1)/KUGI_DIV_NO
				+KUGI_POLY_R+TAMA_POLY_R+KUGI_CHOUSEI_MAX) ){
				for( k=0; k<KUGI_DIV_NO; k++ ){
					if( (coor[1] > p_sys_w.kugi_y_min
						+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*k/KUGI_DIV_NO
						-KUGI_POLY_R-TAMA_POLY_R-KUGI_CHOUSEI_MAX) &&
						(coor[1] < p_sys_w.kugi_y_min
						+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*(k+1)/KUGI_DIV_NO
						+KUGI_POLY_R+TAMA_POLY_R+KUGI_CHOUSEI_MAX) ){
						kugi_no[j][k]++;
						p_sys_w.mkugi_divide[j][k][kugi_no[j][k]] = i;
					}
				}
			}
		}
	}

	for( j=0; j<KUGI_DIV_NO; j++ ){
		for( k=0; k<KUGI_DIV_NO; k++ ){
			kugi_no[j][k] = 0;
		}
	}

	kugi_data = &p_sys_w.p_data->yaku_data[2];
	kugi_num = *((long *)(p_sys_w.p_data->yaku_data));

	for( i=0; i<kugi_num; i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

		for( j=0; j<KUGI_DIV_NO; j++ ){
			if( (coor[0] > p_sys_w.kugi_x_min
				+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*j/KUGI_DIV_NO
				-KUGI_POLY_R-TAMA_POLY_R) &&
				(coor[0] < p_sys_w.kugi_x_min+
				+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*(j+1)/KUGI_DIV_NO
				+KUGI_POLY_R+TAMA_POLY_R) ){
				for( k=0; k<KUGI_DIV_NO; k++ ){
					if( (coor[1] > p_sys_w.kugi_y_min
						+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*k/KUGI_DIV_NO
						-KUGI_POLY_R-TAMA_POLY_R) &&
						(coor[1] < p_sys_w.kugi_y_min
						+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*(k+1)/KUGI_DIV_NO
						+KUGI_POLY_R+TAMA_POLY_R) ){
						kugi_no[j][k]++;
					}
				}
			}
		}
	}

	for( j=0; j<KUGI_DIV_NO; j++ ){
		for( k=0; k<KUGI_DIV_NO; k++ ){
			p_sys_w.yaku_divide[j][k] = (short *)S_malloc((kugi_no[j][k]+1)*2);
			p_sys_w.yaku_divide[j][k][0] = kugi_no[j][k];
			kugi_no[j][k] = 0;
		}
	}

	for( i=0; i<kugi_num; i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

		for( j=0; j<KUGI_DIV_NO; j++ ){
			if( (coor[0] > p_sys_w.kugi_x_min
				+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*j/KUGI_DIV_NO
				-KUGI_POLY_R-TAMA_POLY_R) &&
				(coor[0] < p_sys_w.kugi_x_min+
				+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*(j+1)/KUGI_DIV_NO
				+KUGI_POLY_R+TAMA_POLY_R) ){
				for( k=0; k<KUGI_DIV_NO; k++ ){
					if( (coor[1] > p_sys_w.kugi_y_min
						+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*k/KUGI_DIV_NO
						-KUGI_POLY_R-TAMA_POLY_R) &&
						(coor[1] < p_sys_w.kugi_y_min
						+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*(k+1)/KUGI_DIV_NO
						+KUGI_POLY_R+TAMA_POLY_R) ){
						kugi_no[j][k]++;
						p_sys_w.yaku_divide[j][k][kugi_no[j][k]] = i;
					}
				}
			}
		}
	}
}


static void kugi_poly_set( int flag, long *kugi_pmd,
									int kugi_num, short *kugi_data )
{
	KUGI_POLY	*kugi_poly;
	int			i;
	short		coor[2];

	kugi_pmd[0] = 0x00010000 | (kugi_num*3);
	kugi_poly = (KUGI_POLY *)&(kugi_pmd[1]);

#if 0
	if( flag == 0 ){
		for( j=0; j<KUGI_DIV_NO; j++ ){
			for( k=0; k<KUGI_DIV_NO; k++ ){
				kugi_no[j][k] = 0;
			}
		}
	}
#endif

	for( i=0; i<kugi_num; i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

#if 0
		if( flag == 0 ){
			for( j=0; j<KUGI_DIV_NO; j++ ){
				if( (coor[0] > p_sys_w.kugi_x_min
					+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*j/KUGI_DIV_NO
					-KUGI_POLY_R-TAMA_POLY_R) &&
					(coor[0] < p_sys_w.kugi_x_min+
					+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*(j+1)/KUGI_DIV_NO
					+KUGI_POLY_R+TAMA_POLY_R) ){
					for( k=0; k<KUGI_DIV_NO; k++ ){
						if( (coor[1] > p_sys_w.kugi_y_min
							+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*k/KUGI_DIV_NO
							-KUGI_POLY_R-TAMA_POLY_R) &&
							(coor[1] < p_sys_w.kugi_y_min
							+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*(k+1)/KUGI_DIV_NO
							+KUGI_POLY_R+TAMA_POLY_R) ){
							kugi_no[j][k]++;
						}
					}
				}
			}
		}
#endif

		if( flag == 0 ){
			kugi_prim_set(p_sys_w.p_data->kugi_timA,&kugi_poly[i],
														0x80,0x80,0x80);
		}
		else{
			kugi_prim_set(p_sys_w.p_chousei_data->kugi_timA,&kugi_poly[i],
														0x80,0x80,0x80);
		}
		kugi_vector_set(&kugi_poly[i],0,
						coor[0]-KUGI_POLY_T,coor[1]-KUGI_POLY_T,KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[i],1,
						coor[0]+KUGI_POLY_T,coor[1]-KUGI_POLY_T,KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[i],2,
						coor[0]-KUGI_POLY_T,coor[1]+KUGI_POLY_T,KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[i],3,
						coor[0]+KUGI_POLY_T,coor[1]+KUGI_POLY_T,KUGI_POLY_H);

	}

#if 0
	if( flag == 0 ){
		for( j=0; j<KUGI_DIV_NO; j++ ){
			for( k=0; k<KUGI_DIV_NO; k++ ){
				p_sys_w.kugi_divide[j][k] = (short *)S_malloc((kugi_no[j][k]+1)*2);
				p_sys_w.kugi_divide[j][k][0] = kugi_no[j][k];
				kugi_no[j][k] = 0;
			}
		}
	}
#endif

	for( i=0; i<kugi_num; i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

#if 0
		if( flag == 0 ){
			for( j=0; j<KUGI_DIV_NO; j++ ){
				if( (coor[0] > p_sys_w.kugi_x_min
					+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*j/KUGI_DIV_NO
					-KUGI_POLY_R-TAMA_POLY_R) &&
					(coor[0] < p_sys_w.kugi_x_min+
					+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*(j+1)/KUGI_DIV_NO
					+KUGI_POLY_R+TAMA_POLY_R) ){
					for( k=0; k<KUGI_DIV_NO; k++ ){
						if( (coor[1] > p_sys_w.kugi_y_min
							+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*k/KUGI_DIV_NO
							-KUGI_POLY_R-TAMA_POLY_R) &&
							(coor[1] < p_sys_w.kugi_y_min
							+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*(k+1)/KUGI_DIV_NO
							+KUGI_POLY_R+TAMA_POLY_R) ){
							kugi_no[j][k]++;
							p_sys_w.kugi_divide[j][k][kugi_no[j][k]] = i;
						}
					}
				}
			}
		}
#endif

		/*---------------------------------------------------------- poly 1 */
		if( flag == 0 ){
			kugi_prim_set(p_sys_w.p_data->kugi_timB,
							&kugi_poly[kugi_num+i*2+0], 0x80,0x80,0x80);
		}
		else{
			kugi_prim_set(p_sys_w.p_chousei_data->kugi_timB,
							&kugi_poly[kugi_num+i*2+0], 0x80,0x80,0x80);
		}
		kugi_vector_set(&kugi_poly[kugi_num+i*2+0],0,
						coor[0]-KUGI_POLY_R,coor[1],KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[kugi_num+i*2+0],1,
						coor[0]-KUGI_POLY_R,coor[1],0);
		kugi_vector_set(&kugi_poly[kugi_num+i*2+0],2,
						coor[0]+KUGI_POLY_R,coor[1],KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[kugi_num+i*2+0],3,
						coor[0]+KUGI_POLY_R,coor[1],0);

		if( flag == 0 ){
			kugi_prim_set(p_sys_w.p_data->kugi_timB,
							&kugi_poly[kugi_num+i*2+1], 0x80,0x80,0x80);
		}
		else{
			kugi_prim_set(p_sys_w.p_chousei_data->kugi_timB,
							&kugi_poly[kugi_num+i*2+1], 0x80,0x80,0x80);
		}
		kugi_vector_set(&kugi_poly[kugi_num+i*2+1],0,
						coor[0],coor[1]-KUGI_POLY_R,KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[kugi_num+i*2+1],1,
						coor[0],coor[1]-KUGI_POLY_R,0);
		kugi_vector_set(&kugi_poly[kugi_num+i*2+1],2,
						coor[0],coor[1]+KUGI_POLY_R,KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[kugi_num+i*2+1],3,
						coor[0],coor[1]+KUGI_POLY_R,0);
	}
}

static void mkugi_poly_set( int flag, long *kugi_pmd, int kugi_num,
														short *kugi_data )
{
	KUGI_POLY	*kugi_poly;
	int			i;
	short		coor[2];

	kugi_pmd[0] = 0x00010000 | (kugi_num*3);
	kugi_poly = (KUGI_POLY *)&(kugi_pmd[1]);

#if 0
	if( flag != 1 ){
		for( j=0; j<KUGI_DIV_NO; j++ ){
			for( k=0; k<KUGI_DIV_NO; k++ ){
				kugi_no[j][k] = 0;
			}
		}
	}
#endif

	for( i=0; i<kugi_num; i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

#if 0
		if( flag != 1 ){
			for( j=0; j<KUGI_DIV_NO; j++ ){
				if( (coor[0] > p_sys_w.kugi_x_min
					+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*j/KUGI_DIV_NO
					-KUGI_POLY_R-TAMA_POLY_R-KUGI_CHOUSEI_MAX) &&
					(coor[0] < p_sys_w.kugi_x_min+
					+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*(j+1)/KUGI_DIV_NO
					+KUGI_POLY_R+TAMA_POLY_R+KUGI_CHOUSEI_MAX) ){
					for( k=0; k<KUGI_DIV_NO; k++ ){
						if( (coor[1] > p_sys_w.kugi_y_min
							+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*k/KUGI_DIV_NO
							-KUGI_POLY_R-TAMA_POLY_R-KUGI_CHOUSEI_MAX) &&
							(coor[1] < p_sys_w.kugi_y_min
							+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*(k+1)/KUGI_DIV_NO
							+KUGI_POLY_R+TAMA_POLY_R+KUGI_CHOUSEI_MAX) ){
							kugi_no[j][k]++;
						}
					}
				}
			}
		}
#endif

		if( flag == 0 ){
			kugi_prim_set(p_sys_w.p_data->kugi_timA,&kugi_poly[i],
														0x80,0x80,0x80);
		}
		else if( flag == 2 ){
			kugi_prim_set(p_sys_w.p_chousei_data->kugi_timA,&kugi_poly[i],
														0x80,0x80,0x80);
		}
		else if( i == p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number] ){
			kugi_prim_set(p_sys_w.p_chousei_data->kugi_timA1,&kugi_poly[i],
														0x80,0x80,0x80);
		}
		else{
			kugi_prim_set(p_sys_w.p_chousei_data->kugi_timA2,&kugi_poly[i],
														0x80,0x80,0x80);
		}
		kugi_vector_set(&kugi_poly[i],0,
					coor[0]+p_sys_w.pachi_data.mkugi_data[i][0]-KUGI_POLY_T,
					coor[1]+p_sys_w.pachi_data.mkugi_data[i][1]-KUGI_POLY_T,
					KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[i],1,
					coor[0]+p_sys_w.pachi_data.mkugi_data[i][0]+KUGI_POLY_T,
					coor[1]+p_sys_w.pachi_data.mkugi_data[i][1]-KUGI_POLY_T,
					KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[i],2,
					coor[0]+p_sys_w.pachi_data.mkugi_data[i][0]-KUGI_POLY_T,
					coor[1]+p_sys_w.pachi_data.mkugi_data[i][1]+KUGI_POLY_T,
					KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[i],3,
					coor[0]+p_sys_w.pachi_data.mkugi_data[i][0]+KUGI_POLY_T,
					coor[1]+p_sys_w.pachi_data.mkugi_data[i][1]+KUGI_POLY_T,
					KUGI_POLY_H);
	}

#if 0
	if( flag != 1 ){
		for( j=0; j<KUGI_DIV_NO; j++ ){
			for( k=0; k<KUGI_DIV_NO; k++ ){
				p_sys_w.mkugi_divide[j][k] = (short *)S_malloc((kugi_no[j][k]+1)*2);
				p_sys_w.mkugi_divide[j][k][0] = kugi_no[j][k];
				kugi_no[j][k] = 0;
			}
		}
	}
#endif

	for( i=0; i<kugi_num; i++ ){
		coor[0] = kugi_data[i*2];
		coor[1] = kugi_data[i*2+1];

#if 0
		if( flag != 1 ){
			for( j=0; j<KUGI_DIV_NO; j++ ){
				if( (coor[0] > p_sys_w.kugi_x_min
					+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*j/KUGI_DIV_NO
					-KUGI_POLY_R-TAMA_POLY_R-KUGI_CHOUSEI_MAX) &&
					(coor[0] < p_sys_w.kugi_x_min+
					+(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min)*(j+1)/KUGI_DIV_NO
					+KUGI_POLY_R+TAMA_POLY_R+KUGI_CHOUSEI_MAX) ){
					for( k=0; k<KUGI_DIV_NO; k++ ){
						if( (coor[1] > p_sys_w.kugi_y_min
							+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*k/KUGI_DIV_NO
							-KUGI_POLY_R-TAMA_POLY_R-KUGI_CHOUSEI_MAX) &&
							(coor[1] < p_sys_w.kugi_y_min
							+(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min)*(k+1)/KUGI_DIV_NO
							+KUGI_POLY_R+TAMA_POLY_R+KUGI_CHOUSEI_MAX) ){
							kugi_no[j][k]++;
							p_sys_w.mkugi_divide[j][k][kugi_no[j][k]] = i;
						}
					}
				}
			}
		}
#endif

		if( flag == 0 ){
			kugi_prim_set(p_sys_w.p_data->kugi_timB,&kugi_poly[kugi_num+i*2],
														0x80,0x80,0x80);
			kugi_prim_set(p_sys_w.p_data->kugi_timB,&kugi_poly[kugi_num+i*2+1],
														0x80,0x80,0x80);
		}
		else if( flag == 2 ){
			kugi_prim_set(p_sys_w.p_chousei_data->kugi_timB,
							&kugi_poly[kugi_num+i*2], 0x80,0x80,0x80);
			kugi_prim_set(p_sys_w.p_chousei_data->kugi_timB,
							&kugi_poly[kugi_num+i*2+1], 0x80,0x80,0x80);
		}
		else if( i == p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number] ){
			kugi_prim_set(p_sys_w.p_chousei_data->kugi_timB1,
							&kugi_poly[kugi_num+i*2], 0x80,0x80,0x80);
			kugi_prim_set(p_sys_w.p_chousei_data->kugi_timB1,
							&kugi_poly[kugi_num+i*2+1], 0x80,0x80,0x80);
		}
		else{
			kugi_prim_set(p_sys_w.p_chousei_data->kugi_timB2,
							&kugi_poly[kugi_num+i*2], 0x80,0x80,0x80);
			kugi_prim_set(p_sys_w.p_chousei_data->kugi_timB2,
							&kugi_poly[kugi_num+i*2+1], 0x80,0x80,0x80);
		}

		kugi_vector_set(&kugi_poly[kugi_num+i*2+0],0,
					coor[0]+p_sys_w.pachi_data.mkugi_data[i][0]-KUGI_POLY_R,
					coor[1]+p_sys_w.pachi_data.mkugi_data[i][1],KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[kugi_num+i*2+0],1,
					coor[0]-KUGI_POLY_R,coor[1],0);
		kugi_vector_set(&kugi_poly[kugi_num+i*2+0],2,
					coor[0]+p_sys_w.pachi_data.mkugi_data[i][0]+KUGI_POLY_R,
					coor[1]+p_sys_w.pachi_data.mkugi_data[i][1],KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[kugi_num+i*2+0],3,
					coor[0]+KUGI_POLY_R,coor[1],0);

		kugi_vector_set(&kugi_poly[kugi_num+i*2+1],0,
					coor[0]+p_sys_w.pachi_data.mkugi_data[i][0],
					coor[1]+p_sys_w.pachi_data.mkugi_data[i][1]-KUGI_POLY_R,
					KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[kugi_num+i*2+1],1,
					coor[0],coor[1]-KUGI_POLY_R,0);
		kugi_vector_set(&kugi_poly[kugi_num+i*2+1],2,
					coor[0]+p_sys_w.pachi_data.mkugi_data[i][0],
					coor[1]+p_sys_w.pachi_data.mkugi_data[i][1]+KUGI_POLY_R,
					KUGI_POLY_H);
		kugi_vector_set(&kugi_poly[kugi_num+i*2+1],3,
					coor[0],coor[1]+KUGI_POLY_R,0);
	}
}

/*---< local function >-----------------------------------------------------*/
/*	`F		kugi_prim_set(timp, polyp)									*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/
static void kugi_prim_set(	u_long *timp, KUGI_POLY *polyp,
										u_char r, u_char g, u_char b)
{
	/*-------------------------------------------------------- POLY_FT4  */
	SetPolyFT4(&(polyp->prim[0]));
	SetPolyFT4(&(polyp->prim[1]));

	/*------------------------------------------------------------- RGB  */
	setRGB0(&(polyp->prim[0]), r, g, b);
	setRGB0(&(polyp->prim[1]), r, g, b);

	polyp->prim[0].tpage = polyp->prim[1].tpage = S_TimGetTPage(timp, 0);
	polyp->prim[0].clut = polyp->prim[1].clut = S_TimGetClut(timp);

	S_TimSetUVWH(timp, &(polyp->prim[0]));
	S_TimSetUVWH(timp, &(polyp->prim[1]));
}

/*---< local function >-----------------------------------------------------*/
/*	`F		kugi_vector_set(polyp, n, vx, vy, vz)						*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/
static void kugi_vector_set(KUGI_POLY *polyp, int n,
												short vx, short vy, short vz)
{
	polyp->v[n].vx = vx;
	polyp->v[n].vy = vy;
	polyp->v[n].vz = vz;
}

/***< global function >******************************************************/
/*	`F		O_KUGI(objp)												*/
/*	F		USER_W	*objp:޼ު߲									*/
/*	F		B̵޼ުď											*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void O_KUGI(KUGI_W *objp)
{
	RotRMD_FT4( (long *)(p_sys_w.poly_address_mkugi),
				(u_long *)Wot[KUGI_OT][M_activebuff()].org,
				(int)OT3_LENGTH,(int)M_activebuff());
	RotRMD_FT4( (long *)(p_sys_w.poly_address_kugi),
				(u_long *)Wot[KUGI_OT][M_activebuff()].org,
				(int)OT3_LENGTH,(int)M_activebuff());
}


void P_kugi_chousei()
{
	if(	!((M_joy_new(0) & PADRdown) || (M_joy_new(0) & PADRright) ||
		(M_joy_new(0) & PADRup) || (M_joy_new(0) & PADRleft)) ){
		if( (M_joy_trg(0) & PADLdown) || (M_joy_trg(0) & PADLright) ){
			p_sys_w.chousei_number++;
			p_sys_w.chousei_number %= p_sys_w.mkugi_number;
		}
		else if( (M_joy_trg(0) & PADLup) || (M_joy_trg(0) & PADLleft) ){
			p_sys_w.chousei_number += p_sys_w.mkugi_number-1;
			p_sys_w.chousei_number %= p_sys_w.mkugi_number;
		}
	}
	else if( M_joy_trg(0) & PADRdown ){
		p_kugi_move_init( p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number] );
	}
	else if( (M_joy_new(0) & PADRdown) && !((M_joy_new(0) & PADRright) ||
		(M_joy_new(0) & PADRup) || (M_joy_new(0) & PADRleft)) ){
		if( M_joy_new(0) & PADLright ){
			p_kugi_move_inc( p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number], 0, 4 );
			if( p_kugi_chousei_check(p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number]) ){
				p_kugi_move_inc( p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number], 0, -4 );
			}
		}
		if( M_joy_new(0) & PADLleft ){
			p_kugi_move_inc( p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number], 0, -4 );
			if( p_kugi_chousei_check(p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number]) ){
				p_kugi_move_inc( p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number], 0, 4 );
			}
		}
		if( M_joy_new(0) & PADLdown ){
			p_kugi_move_inc( p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number], 1, 4 );
			if( p_kugi_chousei_check(p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number]) ){
				p_kugi_move_inc( p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number], 1, -4 );
			}
		}
		if( M_joy_new(0) & PADLup ){
			p_kugi_move_inc( p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number], 1, -4 );
			if( p_kugi_chousei_check(p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number]) ){
				p_kugi_move_inc( p_chousei_table[S_sys_w->pachinkow.pach_num][p_sys_w.chousei_number], 1, 4 );
			}
		}
	}

	mkugi_poly_set( 1, p_sys_w.poly_address_mkugi,
				p_sys_w.mkugi_number, &p_sys_w.p_chousei_data->mkugi_data[2] );
}

void p_kugi_move_init( int kugi_number )
{
	p_sys_w.pachi_data.mkugi_data[kugi_number][0] =
	p_sys_w.pachi_data.mkugi_data[kugi_number][1] = 0;
}

void p_kugi_move_inc( int kugi_number, int xy, int val )
{
	if( xy == 0 ){
		p_sys_w.pachi_data.mkugi_data[kugi_number][0] += val;
NFntPrint( "VAL=%d\n", p_sys_w.pachi_data.mkugi_data[kugi_number][0] );
	}
	else{
		p_sys_w.pachi_data.mkugi_data[kugi_number][1] += val;
	}
}

static int p_kugi_chousei_check( int kuugi_number )
{
	return( 0 );
}

/***< global function >******************************************************/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/****************************************************************************/

/*---< local function >-----------------------------------------------------*/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԒlF																	*/
/*--------------------------------------------------------------------------*/
