/***< file >*****************************************************************/
/*	Title		:	PlayStation												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	p_kugi.c												*/
/*	Creator		:	KONAMI(c) usr00819 Koji Komata							*/
/*	Date		:	1995.07.06												*/
/*	Note		:	ݺ̓B												*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/****************************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include		<rand.h>
#include		<libmath.h>

#include		"lt_all.h"
#include		"l_math.h"
#include		"s_trans.h"
#include		"pachinko.h"
#include		"sd_call.h"
#include		"sd_prot.h"
#include		"p_tama.h"

/*==========================================================================*/
/*	define																	*/
/*==========================================================================*/
#define		ZAHYOU_LARGE		1
#define		ZAHYOU_SMALL		0
#define		HANDLE_MAX			(0x1000)

typedef	struct _NYUUSHOU_W {
	OBJ_W_HEAD			header;			/* ޼ުܰͯް */
	short				haraidasi;
	short				timer;
	int					pachi_status;
} NYUUSHOU_W;

static long		p_tama_handle;

/*==========================================================================*/
/*	Program																	*/
/*==========================================================================*/

static void	p_tama_move(TAMA_W *objp);
static void p_tama_move_rail( TAMA_W *objp );
static void p_tama_move_banmen( TAMA_W *objp );
static void p_tama_circle_hit( TAMA_W *objp );
static void p_tama_kugi_hit( TAMA_W *objp );
static void p_tama_pobj_hit( TAMA_W *objp );
static int p_kugi_hit_search( TAMA_W *objp );
static int p_mkugi_hit_search( TAMA_W *objp );
static int p_yaku_hit_search( TAMA_W *objp );
P_DATATARI_W *p_tama_atari_check( TAMA_W *objp );
static int	p_tama_set_check();
static void p_tama_set();
static void p_tama_init( TAMA_W *objp );
static void tama_prim_set( u_long *timp, POLY_FT4 *prim);
static long p_circle_xy( long xy, long cen0, long cen1, long r, int fugou );
unsigned long p_tama_root( unsigned long val );
static void p_hit_fuusha1( TAMA_W *objp, P_DATATARI_W *obj_f );
static void p_hit_fuusha2( TAMA_W *objp, P_DATATARI_W *obj_f );
static void O_TAMA(TAMA_W *objp);
static void O_NYUUSHOU( NYUUSHOU_W *objp );

/*=================================================================== B */
/***< global function >******************************************************/
/*	`F		P_kugi_set(pri)												*/
/*	F		u_short		pri:ײè									*/
/*				int			flag:P̂Ƃ̓NMpf[^Q				*/
/*	F		ݺ̓B												*/
/*	ԒlF		u_long	*objp:޼ު߲									*/
/*				0 ̎́AĎs											*/
/****************************************************************************/

void P_tama_op_init()
{
	int		i;

	p_sys_w.tama.power = 0x74*ONE;
	p_sys_w.tama.handle_flag = 0;

	for( i=0; i<TAMA_MAX; i++ ){
		p_sys_w.tama_objp[i] = NULL;
	}

	p_sys_w.hassha_y = p_sys_w.p_data->hassha_y*ONE;
	p_sys_w.hassha_x = p_circle_xy( p_sys_w.hassha_y,
							p_sys_w.p_data->cenAy*ONE,
							p_sys_w.p_data->cenAx*ONE,
							(p_sys_w.p_data->cenAr-TAMA_POLY_R)*ONE,
							ZAHYOU_SMALL );

	S_trans_set( p_sys_w.p_data->tama_tim, 1 );
}

static int	p_tama_set_check()
{
	if( M_joy_trg(0) & PADRright ){
		p_sys_w.tama.handle_flag = !p_sys_w.tama.handle_flag;

		if( p_sys_w.uchidasi_time < p_sys_w.play_timer ){
			p_sys_w.uchidasi_time = p_sys_w.play_timer;
		}
	}

	if( (p_sys_w.tama.handle_flag != 0) && (!(M_joy_new(0) & PADRdown))
							&& (p_sys_w.play_timer >= p_sys_w.uchidasi_time) ){
		p_sys_w.uchidasi_time = p_sys_w.play_timer + 12;
		return( 1 );
	}
	else{
		return( NULL );
	}
}


void P_tama_op_main()
{
	int		i;
	int		j;

	if( p_tama_set_check() != NULL ){				/* ݺʾ */
		p_tama_set();
	}

NFntPrint( "POWER = %x\n", p_sys_w.tama.power );

	if( (M_joy_new(0) & PADLright) &&
			!(M_joy_new(0)&(PADRright|PADRright|PADRleft|PADRup|PADRdown)) ){
		p_tama_handle += 0x40;
		if( p_tama_handle > HANDLE_MAX )		p_tama_handle = HANDLE_MAX;
		p_sys_w.tama.power += p_tama_handle;
	}
	else if( (M_joy_new(0) & PADLleft) &&
			!(M_joy_new(0)&(PADRright|PADRright|PADRleft|PADRup|PADRdown)) ){
		p_tama_handle += 0x40;
		if( p_tama_handle > HANDLE_MAX )		p_tama_handle = HANDLE_MAX;
		p_sys_w.tama.power -= p_tama_handle;
	}
	else{
		p_tama_handle = 0;
	}

	if( p_sys_w.tama.power > TAMA_POWER_MAX )
		p_sys_w.tama.power = TAMA_POWER_MAX;
	else if( p_sys_w.tama.power < TAMA_POWER_MIN )
		p_sys_w.tama.power = TAMA_POWER_MIN;

	p_sys_w.v_zone_flag = OFF;

	for(p_sys_w.calc_no=0; p_sys_w.calc_no<TAMA_CALC_TIME; p_sys_w.calc_no++){
		for( i=0; i<TAMA_MAX; i++ ){
			if( p_sys_w.tama_objp[i] == NULL )		continue;

			p_tama_move( p_sys_w.tama_objp[i] );

			if( p_sys_w.tama_objp[i]->header.objfunc == NULL ){
				p_sys_w.tama_objp[i] = NULL;
			}
		}
	}

	for( j=0, i=0; i<TAMA_MAX; i++ ){
		if( p_sys_w.tama_objp[i] != NULL )		j++;
	}

	NFntPrint( "TAMA NO=%d\n", j );
}


static void p_tama_set()
{
	int		i;

	for( i=0; i<TAMA_MAX; i++ ){
		if( p_sys_w.tama_objp[i] == NULL ){
			if((p_sys_w.tama_objp[i] = (TAMA_W *)S_obj_set((u_long)NULL,
					(u_long)O_TAMA,								/* obj֐ */
					(u_long)sizeof(TAMA_W),						/* size */
					(int)3)) != NULL) {						/* Dԍ */
				p_tama_init( p_sys_w.tama_objp[i] );
				break;
			}
		}
	}
}

/***< global function >******************************************************/
/*	`F		P_kugi(objp)												*/
/*	F		USER_W	*objp:޼ު߲									*/
/*	F		ݺB														*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
static void p_tama_init( TAMA_W *objp )
{
	long	theta;
	long	first_speed;	/* ʂ̏							*/

	objp->status = TAMA_RAIL;

	objp->cx = p_sys_w.hassha_x;
	objp->cy = p_sys_w.hassha_y;
	objp->cz = TAMA_POLY_Z;

	objp->main_ch_flag = OFF;
	objp->sub_ch_flag = OFF;

	SD_call( SD_SHOT );

	theta = ratan2( objp->cy - p_sys_w.p_data->cenAy*ONE,
					objp->cx - p_sys_w.p_data->cenAx*ONE );

	first_speed = p_sys_w.tama.power;
	objp->vx = -(first_speed/ONE)*S_sin(theta,ONE);
	objp->vy = (first_speed/ONE)*S_cos(theta,ONE);
	objp->pri = KUGI_OT;

	objp->timer = 0;


	tama_prim_set(p_sys_w.p_data->tama_tim, &objp->prim );

	p_sys_w.pachi_data.tounyuu[p_sys_w.pachi_status] ++;
	if( p_sys_w.pachi_status != P_ATARI_STAT ){
		p_sys_w.pachi_data.konkai_tama_suu--;
	}
}


static void	p_tama_move( TAMA_W *objp )
{
	NYUUSHOU_W		*nyuushou_obj;
	void			(*function)();

	switch( objp->status ){
		case	TAMA_RAIL:
			p_tama_move_rail(objp);
			break;
		case	TAMA_BANMEN:
			p_tama_move_banmen(objp);
			break;
		case	TAMA_OUT:
			S_obj_clear( (u_long *)objp );
			break;
		case	TAMA_MODORI:
			p_sys_w.pachi_data.tounyuu[p_sys_w.pachi_status] --;
			if( p_sys_w.pachi_status != P_ATARI_STAT ){
				p_sys_w.pachi_data.konkai_tama_suu++;
			}
			S_obj_clear( (u_long *)objp );
			break;
		case	TAMA_NYUUSHOU15:
			if((nyuushou_obj = (NYUUSHOU_W *)S_obj_set((u_long)NULL,
				(u_long)O_NYUUSHOU,
				(u_long)sizeof(NYUUSHOU_W), (int)3)) != NULL){
			}
			nyuushou_obj->haraidasi = 15;
			nyuushou_obj->pachi_status = p_sys_w.pachi_status;
			S_obj_clear( (u_long *)objp );
			break;
		case	TAMA_NYUUSHOU13:
			if((nyuushou_obj = (NYUUSHOU_W *)S_obj_set((u_long)NULL,
				(u_long)O_NYUUSHOU,
				(u_long)sizeof(NYUUSHOU_W), (int)3)) != NULL){
			}
			nyuushou_obj->haraidasi = 13;
			nyuushou_obj->pachi_status = p_sys_w.pachi_status;
			S_obj_clear( (u_long *)objp );
			break;
		case	TAMA_NYUUSHOU6:
			if((nyuushou_obj = (NYUUSHOU_W *)S_obj_set((u_long)NULL,
				(u_long)O_NYUUSHOU,
				(u_long)sizeof(NYUUSHOU_W), (int)3)) != NULL){
			}
			nyuushou_obj->haraidasi = 6;
			nyuushou_obj->pachi_status = p_sys_w.pachi_status;
			S_obj_clear( (u_long *)objp );
			break;
		case	TAMA_NYUUSHOU5:
			if((nyuushou_obj = (NYUUSHOU_W *)S_obj_set((u_long)NULL,
				(u_long)O_NYUUSHOU,
				(u_long)sizeof(NYUUSHOU_W), (int)3)) != NULL){
			}
			nyuushou_obj->haraidasi = 5;
			nyuushou_obj->pachi_status = p_sys_w.pachi_status;
			S_obj_clear( (u_long *)objp );
			break;
		default:
			function = (void *)objp->status;
			(*function)( objp );
			break;
	}
}


static void p_tama_move_rail( TAMA_W *objp )
{
	long	theta;
	long	speed_abs;
	long	shift;

	objp->cx += objp->vx;
	objp->cy += objp->vy;

												/* ~ɍW␳		*/
	if( objp->cy > p_sys_w.p_data->chABy*ONE ){
		theta = ratan2( objp->cy - p_sys_w.p_data->cenAy*ONE,
						objp->cx - p_sys_w.p_data->cenAx*ONE );

		objp->cx = ((p_sys_w.p_data->cenAr-TAMA_POLY_R)*S_cos(theta,ONE))
							+ p_sys_w.p_data->cenAx*ONE;
		objp->cy = ((p_sys_w.p_data->cenAr-TAMA_POLY_R)*S_sin(theta,ONE))
							+ p_sys_w.p_data->cenAy*ONE;
	}
	else{
		theta = ratan2( objp->cy - p_sys_w.p_data->cenBy*ONE,
						objp->cx - p_sys_w.p_data->cenBx*ONE );
		objp->cx = ((p_sys_w.p_data->cenBr-TAMA_POLY_R)*S_cos(theta,ONE))
							+ p_sys_w.p_data->cenBx*ONE;
		objp->cy = ((p_sys_w.p_data->cenBr-TAMA_POLY_R)*S_sin(theta,ONE))
							+ p_sys_w.p_data->cenBy*ONE;
	}

	speed_abs = p_culc_distance( objp->vx, objp->vy-(TAMA_G*S_cos(theta,ONE))/ONE,
																		0, 0 );

	shift = 0;
	while( (speed_abs>>shift) > 0x7fffffff/ONE )		shift++;

	speed_abs >>= shift;

	if( objp->cy < p_sys_w.p_data->uchidashiBy*ONE ){
		objp->status = TAMA_BANMEN;

							/* ݒi덷܂ށjrand̒l͂O`RQVUV	*/
		srand( rand() + p_sys_w.timer+p_sys_w.play_timer+S_sys_w->stimer+speed_abs );

		speed_abs += rand()>>shift;

/*speed_abs = 0x30b06;*/
/*speed_abs = 0x1f7af;*/
objp->first_speed = speed_abs<<shift;

		objp->vx = -(speed_abs*S_sin(theta,ONE))/(ONE>>shift);
		objp->vy = (speed_abs*S_cos(theta,ONE))/(ONE>>shift);
	}
	else{
		if( objp->cy < (p_sys_w.p_data->uchidashiBy+TAMA_POLY_R*3)*ONE ){
			p_sys_w.tamadome_flag = ON;
		}

		if( objp->vy+TAMA_G > 0 ){
			objp->vx = (speed_abs*S_sin(theta,ONE))/(ONE>>shift);
			objp->vy = -(speed_abs*S_cos(theta,ONE))/(ONE>>shift);
		}
		else{
			speed_abs -= (speed_abs/0x1000);
			objp->vx = -(speed_abs*S_sin(theta,ONE))/(ONE>>shift);
			objp->vy = (speed_abs*S_cos(theta,ONE))/(ONE>>shift);
		}

		if( objp->cy > p_sys_w.p_data->hassha_y*ONE ){
			objp->status = TAMA_MODORI;
		}
	}
}


static void p_tama_move_banmen( TAMA_W *objp )
{
/*printf( "1:X=%x,Y=%x,VX=%x,VY=%x\n", objp->cx,objp->cy,objp->vx,objp->vy );*/

	objp->vy += TAMA_G;

/*	if( abs(objp->vx) < 0x*/

	objp->cx += objp->vx;
	objp->cy += objp->vy;

	p_tama_circle_hit( objp );

/*printf( "2:X=%lx,Y=%lx,VX=%lx,VY=%lx\n", objp->cx,objp->cy,objp->vx,objp->vy );*/
	p_tama_kugi_hit( objp );

	p_tama_pobj_hit( objp );
}


static void p_tama_circle_hit( TAMA_W *objp )
{
	long	theta;
	long	speed_theta;
	long	speed_abs;
	long	sin_a, cos_a;
	long	sin_b, cos_b;
	int		shift;
	u_long	dist_square;

	if( objp->cy < 0 ){
		if( objp->cx < 0 ){
			dist_square = p_culc_square( &shift, objp->cx, objp->cy,
								p_sys_w.p_data->cenBx*ONE,
								p_sys_w.p_data->cenBy*ONE );
			if( dist_square > (p_sys_w.p_data->cenBr-TAMA_POLY_R) *
							(p_sys_w.p_data->cenBr-TAMA_POLY_R) *
							(ONE>>shift)*(ONE>>shift) ){
												/* ~ʂa			*/
				theta = ratan2( objp->cy - p_sys_w.p_data->cenBy*ONE,
								objp->cx - p_sys_w.p_data->cenBx*ONE );
				objp->cx = ((p_sys_w.p_data->cenBr-TAMA_POLY_R)*S_cos(theta,ONE))
								+ p_sys_w.p_data->cenBx*ONE;
				objp->cy = ((p_sys_w.p_data->cenBr-TAMA_POLY_R)*S_sin(theta,ONE))
								+ p_sys_w.p_data->cenBy*ONE;

				speed_abs = p_culc_distance( objp->vx, objp->vy, 0, 0 );
				speed_theta = ratan2( objp->vy, objp->vx );

				sin_a = S_sin( 1024 - theta + speed_theta, ONE );
				cos_a = S_cos( 1024 - theta + speed_theta, ONE );

				sin_b = S_sin(theta, ONE);
				cos_b = S_cos(theta, ONE);

				objp->vx = (((sin_a * (-cos_b))/ONE * RAIL_E)/ONE +
								(cos_a * sin_b)/ONE) * speed_abs/ONE;
				objp->vy = (((sin_a * (-sin_b))/ONE * RAIL_E)/ONE+
								(cos_a * (-cos_b))/ONE) * speed_abs/ONE;
				objp->vx = objp->vx * RAIL_TEIKO/ONE;
				objp->vy = objp->vy * RAIL_TEIKO/ONE;
			}
		}
		else{
			dist_square = p_culc_square( &shift, objp->cx, objp->cy,
							p_sys_w.p_data->cenCx*ONE,
							p_sys_w.p_data->cenCy*ONE );
			if( dist_square > (p_sys_w.p_data->cenCr-TAMA_POLY_R) *
						(p_sys_w.p_data->cenCr-TAMA_POLY_R) *
						(ONE>>shift)*(ONE>>shift) ){
												/* ~ʂb			*/
				theta = ratan2( objp->cy - p_sys_w.p_data->cenCy*ONE,
							objp->cx - p_sys_w.p_data->cenCx*ONE );
				objp->cx = ((p_sys_w.p_data->cenCr-TAMA_POLY_R)*S_cos(theta, ONE))
							+ p_sys_w.p_data->cenCx*ONE;
				objp->cy = ((p_sys_w.p_data->cenCr-TAMA_POLY_R)*S_sin(theta, ONE))
							+ p_sys_w.p_data->cenCy*ONE;

				speed_abs = p_culc_distance( objp->vx, objp->vy, 0, 0 );
				speed_theta = ratan2( objp->vy, objp->vx );

				sin_a = S_sin( 1024 - theta + speed_theta, ONE );
				cos_a = S_cos( 1024 - theta + speed_theta, ONE );

				sin_b = S_sin(theta, ONE);
				cos_b = S_cos(theta, ONE);

				objp->vx = (((sin_a * (-cos_b))/ONE * RAIL_E)/ONE +
							(cos_a * sin_b)/ONE) * speed_abs/ONE;
				objp->vy = (((sin_a * (-sin_b))/ONE * RAIL_E)/ONE+
							(cos_a * (-cos_b))/ONE) * speed_abs/ONE;
				objp->vx = objp->vx * RAIL_TEIKO/ONE;
				objp->vy = objp->vy * RAIL_TEIKO/ONE;
			}
		}
	}
	else{
			dist_square = p_culc_square( &shift, objp->cx, objp->cy,
							p_sys_w.p_data->cenEx*ONE,
							p_sys_w.p_data->cenEy*ONE );
			if( dist_square > (p_sys_w.p_data->cenEr-TAMA_POLY_R) *
						(p_sys_w.p_data->cenEr-TAMA_POLY_R) *
						(ONE>>shift)*(ONE>>shift) ){
												/* ~ʂd			*/
			theta = ratan2( objp->cy - p_sys_w.p_data->cenEy*ONE,
						objp->cx - p_sys_w.p_data->cenEx*ONE );
			objp->cx = ((p_sys_w.p_data->cenEr-TAMA_POLY_R)*S_cos(theta, ONE))
						+ p_sys_w.p_data->cenEx*ONE;
			objp->cy = ((p_sys_w.p_data->cenEr-TAMA_POLY_R)*S_sin(theta, ONE))
						+ p_sys_w.p_data->cenEy*ONE;

			speed_abs = p_culc_distance( objp->vx, objp->vy, 0, 0 );

			if( (speed_abs < 0x20*ONE)
					&& (objp->cx<TAMA_POLY_R*4*ONE)
					&& (objp->cx>-TAMA_POLY_R*4*ONE) ){
				if( (objp->cx<TAMA_POLY_R*2*ONE)
					&& (objp->cx>-TAMA_POLY_R*2*ONE) ){
					objp->cy += TAMA_POLY_R*2*ONE-abs(objp->cx);
				}

				if( objp->cx > 0 )		objp->vx = -8*ONE;
				else					objp->vx = 8*ONE;

				if( (objp->cx<TAMA_POLY_R*ONE)
					&& (objp->cx>-TAMA_POLY_R*ONE) ){
					objp->status = TAMA_OUT;
				}
			}
			else{
				speed_theta = ratan2( objp->vy, objp->vx );
				sin_a = S_sin( 1024 - theta + speed_theta, ONE );
				cos_a = S_cos( 1024 - theta + speed_theta, ONE );

				sin_b = S_sin(theta, ONE);
				cos_b = S_cos(theta, ONE);

				objp->vx = (((sin_a * (-cos_b))/ONE * RAIL_E)/ONE +
							(cos_a * sin_b)/ONE) * speed_abs/ONE;
				objp->vy = (((sin_a * (-sin_b))/ONE * RAIL_E)/ONE+
							(cos_a * (-cos_b))/ONE) * speed_abs/ONE;

				objp->vx = objp->vx * RAIL_TEIKO/ONE;
				objp->vy = objp->vy * RAIL_TEIKO/ONE;
			}
		}
	}
}


static void p_tama_kugi_hit( TAMA_W *objp )
{
	long	theta;
	long	speed_theta;
	long	speed_abs;
	long	kugi_number = 0;
	short	*kugi_data;
	long	x0, y0;
	u_long	abs_buff[2];
	int		shift;
	long	sin_a, cos_a;

	if( (kugi_number = p_kugi_hit_search( objp )) != -1 ){
		kugi_data = p_sys_w.p_data->kugi_data;

		theta = ratan2( kugi_data[kugi_number*2+3]*ONE - objp->cy,
						kugi_data[kugi_number*2+2]*ONE - objp->cx );

		speed_abs = p_culc_distance( objp->vx, objp->vy, 0, 0 );
		speed_theta = ratan2( objp->vy, objp->vx );

		shift = 0;
		while( (speed_abs>>shift) > 0x7fffffff/ONE )		shift++;

		speed_abs >>= shift;

		x0 = (speed_abs * S_sin(theta-speed_theta, ONE))/(ONE>>shift);
		y0 = (speed_abs * S_cos(theta-speed_theta, ONE))/(ONE>>shift);

		abs_buff[0] = abs( x0 );
		abs_buff[1] = abs( y0 );

		shift = 0;
		while( ((abs_buff[0]>>shift) > 0x7fffffff/ONE) ||
				((abs_buff[1]>>shift) > 0x7fffffff/ONE) )		shift++;

		x0 >>= shift;
		y0 >>= shift;

#if 0
		objp->vx = ((S_cos(theta-1024,ONE)*x0) - ((S_cos(theta,ONE)*y0)/ONE)*KUGI_E)
															/ (ONE>>shift);
		objp->vy = ((S_sin(theta-1024,ONE)*x0) - ((S_sin(theta,ONE)*y0)/ONE)*KUGI_E)
															/ (ONE>>shift);
#else
		sin_a = S_sin(theta, ONE);
		cos_a = S_cos(theta, ONE);

											/* W␳		*/
		objp->cx = kugi_data[kugi_number*2+2]*ONE -
										cos_a*(TAMA_POLY_R+KUGI_POLY_R);
		objp->cy = kugi_data[kugi_number*2+3]*ONE -
										sin_a*(TAMA_POLY_R+KUGI_POLY_R);

		objp->vx = (sin_a*x0 - ((cos_a*y0)/ONE)*KUGI_E) / (ONE>>shift);
		objp->vy = ((-cos_a)*x0 - ((sin_a*y0)/ONE)*KUGI_E) / (ONE>>shift);
#endif
	}
	else if( (kugi_number = p_mkugi_hit_search( objp )) != -1 ){
		kugi_data = p_sys_w.p_data->mkugi_data;

		theta = ratan2( (kugi_data[kugi_number*2+3]
			+ p_sys_w.pachi_data.mkugi_data[kugi_number][1]/2)*ONE - objp->cy,
					(kugi_data[kugi_number*2+2]
			+ p_sys_w.pachi_data.mkugi_data[kugi_number][0]/2)*ONE - objp->cx );

		speed_abs = p_culc_distance( objp->vx, objp->vy, 0, 0 );
		speed_theta = ratan2( objp->vy, objp->vx );

		shift = 0;
		while( (speed_abs>>shift) > 0x7fffffff/ONE )		shift++;

		speed_abs >>= shift;

		x0 = (speed_abs * S_sin(theta-speed_theta, ONE))/(ONE>>shift);
		y0 = (speed_abs * S_cos(theta-speed_theta, ONE))/(ONE>>shift);

		abs_buff[0] = abs( x0 );
		abs_buff[1] = abs( y0 );

		shift = 0;
		while( ((abs_buff[0]>>shift) > 0x7fffffff/ONE) ||
				((abs_buff[1]>>shift) > 0x7fffffff/ONE) )		shift++;

		x0 >>= shift;
		y0 >>= shift;

#if 0
		objp->vx = ((S_cos(theta-1024, ONE)*x0) - ((S_cos(theta, ONE)*y0)/ONE)*KUGI_E)
															/ (ONE>>shift);
		objp->vy = ((S_sin(theta-1024, ONE)*x0) - ((S_sin(theta, ONE)*y0)/ONE)*KUGI_E)
															/ (ONE>>shift);
#else
		sin_a = S_sin(theta, ONE);
		cos_a = S_cos(theta, ONE);

											/* W␳		*/
		objp->cx = (kugi_data[kugi_number*2+2]
				+ p_sys_w.pachi_data.mkugi_data[kugi_number][0]/2)*ONE
				- cos_a*(TAMA_POLY_R+KUGI_POLY_R);
		objp->cy = (kugi_data[kugi_number*2+3]
				+ p_sys_w.pachi_data.mkugi_data[kugi_number][1]/2)*ONE
				- sin_a*(TAMA_POLY_R+KUGI_POLY_R);

		objp->vx = (sin_a*x0 - ((cos_a*y0)/ONE)*KUGI_E) / (ONE>>shift);
		objp->vy = ((-cos_a)*x0 - ((sin_a*y0)/ONE)*KUGI_E) / (ONE>>shift);
#endif
	}
	else if( (kugi_number = p_yaku_hit_search( objp )) != -1 ){
		kugi_data = p_sys_w.p_data->yaku_data;

		theta = ratan2( kugi_data[kugi_number*2+3]*ONE - objp->cy,
						kugi_data[kugi_number*2+2]*ONE - objp->cx );

		speed_abs = p_culc_distance( objp->vx, objp->vy, 0, 0 );
		speed_theta = ratan2( objp->vy, objp->vx );

		shift = 0;
		while( (speed_abs>>shift) > 0x7fffffff/ONE )		shift++;

		speed_abs >>= shift;

		x0 = (speed_abs * S_sin(theta-speed_theta, ONE))/(ONE>>shift);
		y0 = (speed_abs * S_cos(theta-speed_theta, ONE))/(ONE>>shift);

		abs_buff[0] = abs( x0 );
		abs_buff[1] = abs( y0 );

		shift = 0;
		while( ((abs_buff[0]>>shift) > 0x7fffffff/ONE) ||
				((abs_buff[1]>>shift) > 0x7fffffff/ONE) )		shift++;

		x0 >>= shift;
		y0 >>= shift;

#if 0
		objp->vx = ((S_cos(theta-1024,ONE)*x0) - ((S_cos(theta,ONE)*y0)/ONE)*YAKU_E)
															/ (ONE>>shift);
		objp->vy = ((S_sin(theta-1024,ONE)*x0) - ((S_sin(theta,ONE)*y0)/ONE)*YAKU_E)
															/ (ONE>>shift);
#else
		sin_a = S_sin(theta, ONE);
		cos_a = S_cos(theta, ONE);

		objp->vx = (sin_a*x0 - ((cos_a*y0)/ONE)*YAKU_E) / (ONE>>shift);
		objp->vy = ((-cos_a)*x0 - ((sin_a*y0)/ONE)*YAKU_E) / (ONE>>shift);
#endif
	}
}


static void p_tama_pobj_hit( TAMA_W *objp )
{
	P_DATATARI_W	*atari_data;
	short i;
	void			(*function)();

	atari_data = p_tama_atari_check(objp);

	switch( atari_data->atari_status ){
		case ATARI_MAIN_CH:
			if( objp->main_ch_flag == OFF ){
				objp->main_ch_flag = ON;
				objp->status = atari_data->tama_status;
				p_sys_w.main_ch_counter++;

	/*  $$$ */
				if( p_sys_w.memory_no < P_MEMORY_MAX ){
					srand(S_sys_w->stimer + p_sys_w.timer);
					for(i=0;i<P_RAND_MAX;i++)
					{
						p_sys_w.memory[p_sys_w.memory_no].rand[i] = rand();
						srand(p_sys_w.memory[p_sys_w.memory_no].rand[i]);
					}

					p_sys_w.memory_no++;
				}
	/*  $$$ @*/

			}
			break;
		case ATARI_SUB_CH:
			if( objp->sub_ch_flag == OFF ){
				objp->sub_ch_flag = ON;
				objp->status = atari_data->tama_status;

	/*  $$$ vƃ^Cv@*/
				if( p_sys_w.memory_s_no < P_MEMORY_MAX ){
					srand(S_sys_w->stimer+p_sys_w.play_timer);
					
				for(i=0;i<P_RAND_MAX;i++)
				{
					p_sys_w.memory_s[p_sys_w.memory_s_no].rand[i] = rand();
					srand(p_sys_w.memory_s[p_sys_w.memory_s_no].rand[i]);
				}
					p_sys_w.memory_s_no++;
				}
	/*  $$$ ܂Ł@*/

			}
			break;
		case ATARI_FUUSHA_1:
			objp->status = atari_data->tama_status;
			p_hit_fuusha1( objp, atari_data );
			break;
		case ATARI_FUUSHA_2:
			objp->status = atari_data->tama_status;
			p_hit_fuusha2( objp, atari_data );
			break;
		case ATARI_NYUUSHOU:
			objp->status = atari_data->tama_status;
			break;
		case ATARI_NASI:
			break;
		default:
			function = (void *)atari_data->atari_status;
			(*function)( atari_data, objp );
			break;
	}
}


static void p_hit_fuusha1( TAMA_W *objp, P_DATATARI_W *obj_f)
{
	long	theta;
	long	speed_theta;
	long	speed_abs;
	long	x0, y0;
	u_long	abs_buff[2];
	int		shift;
	long	sin_a, cos_a;

				/*	point_x,point_y:Ԃ̍W   atari_r:Ԃ̃A^a
					tmd_objp:ԂTMDf[^AhX				*/
	theta = ratan2( obj_f->point_y*ONE - objp->cy,
					obj_f->point_x*ONE - objp->cx );

	speed_abs = p_culc_distance( objp->vx, objp->vy, 0, 0 );
	speed_theta = ratan2( objp->vy, objp->vx );

	((GsDOBJ2_W *)(obj_f->tmd_objp))->z_rotate =
						(((GsDOBJ2_W *)(obj_f->tmd_objp))->z_rotate+
						speed_abs*S_sin(speed_theta-theta,ONE)*8/ONE)/2;

	shift = 0;
	while( (speed_abs>>shift) > 0x7fffffff/ONE )		shift++;

	speed_abs >>= shift;

	x0 = (speed_abs * S_sin(theta-speed_theta,ONE))/(ONE>>shift);
	y0 = (speed_abs * S_cos(theta-speed_theta,ONE))/(ONE>>shift);

	abs_buff[0] = abs( x0 );
	abs_buff[1] = abs( y0 );

	shift = 0;
	while( ((abs_buff[0]>>shift) > 0x7fffffff/ONE) ||
			((abs_buff[1]>>shift) > 0x7fffffff/ONE) )		shift++;

	x0 >>= shift;
	y0 >>= shift;

	sin_a = S_sin(theta,ONE);
	cos_a = S_cos(theta,ONE);

	objp->cx = obj_f->point_x*ONE - cos_a*(obj_f->atari_r+TAMA_POLY_R);
	objp->cy = obj_f->point_y*ONE - sin_a*(obj_f->atari_r+TAMA_POLY_R);

	objp->vx = (sin_a*x0 - ((cos_a*y0)/ONE)*YAKU_E) / (ONE>>shift);
	objp->vy = ((-cos_a)*x0 - ((sin_a*y0)/ONE)*YAKU_E) / (ONE>>shift);

}


static void p_hit_fuusha2( TAMA_W *objp, P_DATATARI_W *obj_f )
{
	long	theta;
	long	speed_theta;
	long	speed_abs;
	long	x0, y0;
	u_long	abs_buff[2];
	int		shift;
	long	sin_a, cos_a;
	u_long	dist_square;

	theta = ratan2( obj_f->point_y*ONE - objp->cy,
					obj_f->point_x*ONE - objp->cx );

	speed_abs = p_culc_distance( objp->vx, objp->vy, 0, 0 );
	speed_theta = ratan2( objp->vy, objp->vx );

	((GsDOBJ2_W *)(obj_f->tmd_objp))->z_rotate =
						(((GsDOBJ2_W *)(obj_f->tmd_objp))->z_rotate+
						speed_abs*S_sin(speed_theta-theta,ONE)*8/ONE)/2;

	dist_square = p_culc_square( &shift, objp->cx, objp->cy,
					obj_f->point_x*ONE, obj_f->point_y*ONE );
	if( dist_square < (TAMA_POLY_R+TAMA_POLY_R/2)*(TAMA_POLY_R+TAMA_POLY_R/2) *
												(ONE>>shift)*(ONE>>shift) ){
		shift = 0;
		while( (speed_abs>>shift) > 0x7fffffff/ONE )		shift++;

		speed_abs >>= shift;

		x0 = (speed_abs * S_sin(theta-speed_theta,ONE))/(ONE>>shift);
		y0 = (speed_abs * S_cos(theta-speed_theta,ONE))/(ONE>>shift);

		abs_buff[0] = abs( x0 );
		abs_buff[1] = abs( y0 );

		shift = 0;
		while( ((abs_buff[0]>>shift) > 0x7fffffff/ONE) ||
				((abs_buff[1]>>shift) > 0x7fffffff/ONE) )		shift++;

		x0 >>= shift;
		y0 >>= shift;

		sin_a = S_sin(theta,ONE);
		cos_a = S_cos(theta,ONE);

		objp->vx = (sin_a*x0 - ((cos_a*y0)/ONE)*YAKU_E) / (ONE>>shift);
		objp->vy = ((-cos_a)*x0 - ((sin_a*y0)/ONE)*YAKU_E) / (ONE>>shift);

		objp->cx = obj_f->point_x*ONE - cos_a*(TAMA_POLY_R+TAMA_POLY_R/2);
		objp->cy = obj_f->point_y*ONE - sin_a*(TAMA_POLY_R+TAMA_POLY_R/2);
	}

}


P_DATATARI_W *p_tama_atari_check( TAMA_W *objp )
{
	int		i;
	u_long	dist_square;
	int		shift;

	for(i=0; (long)(p_sys_w.p_data)->atari_data[i].data!=ATARI_DATA_END; i++){
		if( ((objp->cx/ONE) > (p_sys_w.p_data)->atari_data[i].x-TAMA_POLY_R) &&
			((objp->cx/ONE) < (p_sys_w.p_data)->atari_data[i].x +
							(p_sys_w.p_data)->atari_data[i].w+TAMA_POLY_R) &&
			((objp->cy/ONE) > (p_sys_w.p_data)->atari_data[i].y-TAMA_POLY_R) &&
			((objp->cy/ONE) < (p_sys_w.p_data)->atari_data[i].y +
							(p_sys_w.p_data)->atari_data[i].h+TAMA_POLY_R) ){
			if( ((p_sys_w.p_data)->atari_data[i].atari_status == ATARI_FUUSHA_1) ||
				((p_sys_w.p_data)->atari_data[i].atari_status == ATARI_FUUSHA_2) ){
				dist_square = p_culc_square( &shift, objp->cx, objp->cy,
								(p_sys_w.p_data)->atari_data[i].point_x*ONE,
								(p_sys_w.p_data)->atari_data[i].point_y*ONE );
				if( dist_square <
							((p_sys_w.p_data)->atari_data[i].atari_r+TAMA_POLY_R) *
							((p_sys_w.p_data)->atari_data[i].atari_r+TAMA_POLY_R) *
							(ONE>>shift)*(ONE>>shift) ){
					break;
				}
			}
			else if( (p_sys_w.p_data)->atari_data[i].atari_status < ATARI_END ){
				if( ((objp->cx/ONE) > (p_sys_w.p_data)->atari_data[i].x) &&
				((objp->cx/ONE) < (p_sys_w.p_data)->atari_data[i].x +
									(p_sys_w.p_data)->atari_data[i].w) &&
				((objp->cy/ONE) > (p_sys_w.p_data)->atari_data[i].y) &&
				((objp->cy/ONE) < (p_sys_w.p_data)->atari_data[i].y +
									(p_sys_w.p_data)->atari_data[i].h) ){
					break;
				}
			}
			else{
				break;
			}
		}
	}

	return( &((p_sys_w.p_data)->atari_data[i]) );
}


static int p_kugi_hit_search( TAMA_W *objp )
{
	int		i;
	int		line, row;
	short	*div_data;
	short	*kugi_data;
	int		shift;
	u_long	dist_square;

	kugi_data = p_sys_w.p_data->kugi_data;

	if( (objp->cx/ONE > p_sys_w.kugi_x_min) &&
							(objp->cx/ONE < p_sys_w.kugi_x_max) &&
							(objp->cy/ONE > p_sys_w.kugi_y_min) &&
							(objp->cy/ONE < p_sys_w.kugi_y_max) ){
		row = ((objp->cx/ONE-p_sys_w.kugi_x_min)*KUGI_DIV_NO) /
					(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min);
		line = ((objp->cy/ONE-p_sys_w.kugi_y_min)*KUGI_DIV_NO) /
					(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min);


		div_data = p_sys_w.kugi_divide[row][line];

		for( i=0; i<div_data[0] ; i++ ){
			if( (objp->cx/ONE > (kugi_data[div_data[i+1]*2+2]
											-(TAMA_POLY_R+KUGI_POLY_R)) ) &&
				(objp->cx/ONE < (kugi_data[div_data[i+1]*2+2]
											+(TAMA_POLY_R+KUGI_POLY_R)) ) &&
				(objp->cy/ONE > (kugi_data[div_data[i+1]*2+3]
											-(TAMA_POLY_R+KUGI_POLY_R)) ) &&
				(objp->cy/ONE < (kugi_data[div_data[i+1]*2+3]
											+(TAMA_POLY_R+KUGI_POLY_R)) ) ){

#if 0
				if( p_culc_distance(kugi_data[div_data[i+1]*2+2]*ONE,
								kugi_data[div_data[i+1]*2+3]*ONE,
						objp->cx, objp->cy) < (TAMA_POLY_R+KUGI_POLY_R)*ONE ){
#else
				dist_square = p_culc_square( &shift, objp->cx, objp->cy,
									kugi_data[div_data[i+1]*2+2]*ONE,
									kugi_data[div_data[i+1]*2+3]*ONE );
				if( dist_square < (TAMA_POLY_R+KUGI_POLY_R) *
									(TAMA_POLY_R+KUGI_POLY_R) *
									(ONE>>shift)*(ONE>>shift) ){
#endif
					return( div_data[i+1] );
				}
			}
		}
	}

	return( -1 );
}

static int p_mkugi_hit_search( TAMA_W *objp )
{
	int		i;
	int		line, row;
	short	*div_data;
	short	*kugi_data;
	int		shift;
	u_long	dist_square;

	kugi_data = p_sys_w.p_data->mkugi_data;

	if( (objp->cx/ONE > p_sys_w.kugi_x_min) &&
							(objp->cx/ONE < p_sys_w.kugi_x_max) &&
							(objp->cy/ONE > p_sys_w.kugi_y_min) &&
							(objp->cy/ONE < p_sys_w.kugi_y_max) ){
		row = ((objp->cx/ONE-p_sys_w.kugi_x_min)*KUGI_DIV_NO) /
					(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min);
		line = ((objp->cy/ONE-p_sys_w.kugi_y_min)*KUGI_DIV_NO) /
					(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min);


		div_data = p_sys_w.mkugi_divide[row][line];

		for( i=0; i<div_data[0] ; i++ ){
			if( (objp->cx/ONE > (kugi_data[div_data[i+1]*2+2]
						+ p_sys_w.pachi_data.mkugi_data[div_data[i+1]][0]/2
						- (TAMA_POLY_R+KUGI_POLY_R)) ) &&
				(objp->cx/ONE < (kugi_data[div_data[i+1]*2+2]
						+ p_sys_w.pachi_data.mkugi_data[div_data[i+1]][0]/2
						+(TAMA_POLY_R+KUGI_POLY_R)) ) &&
				(objp->cy/ONE > (kugi_data[div_data[i+1]*2+3]
						+ p_sys_w.pachi_data.mkugi_data[div_data[i+1]][1]/2
						-(TAMA_POLY_R+KUGI_POLY_R)) ) &&
				(objp->cy/ONE < (kugi_data[div_data[i+1]*2+3]
						+ p_sys_w.pachi_data.mkugi_data[div_data[i+1]][1]/2
						+(TAMA_POLY_R+KUGI_POLY_R)) ) ){

#if 0
				if( p_culc_distance(kugi_data[div_data[i+1]*2+2]*ONE,
								kugi_data[div_data[i+1]*2+3]*ONE,
						objp->cx, objp->cy) < (TAMA_POLY_R+KUGI_POLY_R)*ONE ){
#else
				dist_square = p_culc_square( &shift, objp->cx, objp->cy,
					(kugi_data[div_data[i+1]*2+2]
					+ p_sys_w.pachi_data.mkugi_data[div_data[i+1]][0]/2)*ONE,
					(kugi_data[div_data[i+1]*2+3]
					+ p_sys_w.pachi_data.mkugi_data[div_data[i+1]][1]/2)*ONE );
				if( dist_square < (TAMA_POLY_R+KUGI_POLY_R) *
									(TAMA_POLY_R+KUGI_POLY_R) *
									(ONE>>shift)*(ONE>>shift) ){
#endif
					return( div_data[i+1] );
				}
			}
		}
	}

	return( -1 );
}


static int p_yaku_hit_search( TAMA_W *objp )
{
	int		i;
	int		line, row;
	short	*div_data;
	short	*kugi_data;
	long	theta;
	int		shift;
	u_long	dist_square;

	kugi_data = p_sys_w.p_data->yaku_data;

	if( (objp->cx/ONE > p_sys_w.kugi_x_min) &&
							(objp->cx/ONE < p_sys_w.kugi_x_max) &&
							(objp->cy/ONE > p_sys_w.kugi_y_min) &&
							(objp->cy/ONE < p_sys_w.kugi_y_max) ){
		row = ((objp->cx/ONE-p_sys_w.kugi_x_min)*KUGI_DIV_NO) /
					(p_sys_w.kugi_x_max-p_sys_w.kugi_x_min);
		line = ((objp->cy/ONE-p_sys_w.kugi_y_min)*KUGI_DIV_NO) /
					(p_sys_w.kugi_y_max-p_sys_w.kugi_y_min);


		div_data = p_sys_w.yaku_divide[row][line];

		for( i=0; i<div_data[0] ; i++ ){
			if( (objp->cx/ONE > (kugi_data[div_data[i+1]*2+2]
											-(TAMA_POLY_R+KUGI_POLY_R)) ) &&
				(objp->cx/ONE < (kugi_data[div_data[i+1]*2+2]
											+(TAMA_POLY_R+KUGI_POLY_R)) ) &&
				(objp->cy/ONE > (kugi_data[div_data[i+1]*2+3]
											-(TAMA_POLY_R+KUGI_POLY_R)) ) &&
				(objp->cy/ONE < (kugi_data[div_data[i+1]*2+3]
											+(TAMA_POLY_R+KUGI_POLY_R)) ) ){

#if 0
				if( p_culc_distance(kugi_data[div_data[i+1]*2+2]*ONE,
								kugi_data[div_data[i+1]*2+3]*ONE,
						objp->cx, objp->cy) < (TAMA_POLY_R+KUGI_POLY_R)*ONE ){
#else
				dist_square = p_culc_square( &shift, objp->cx, objp->cy,
									kugi_data[div_data[i+1]*2+2]*ONE,
									kugi_data[div_data[i+1]*2+3]*ONE );
				if( dist_square < (TAMA_POLY_R+KUGI_POLY_R) *
									(TAMA_POLY_R+KUGI_POLY_R) *
									(ONE>>shift)*(ONE>>shift) ){
#endif
											/* W␳		*/
					theta = ratan2( objp->cy-kugi_data[div_data[i+1]*2+3]*ONE,
									objp->cx-kugi_data[div_data[i+1]*2+2]*ONE);

					objp->cx = kugi_data[div_data[i+1]*2+2]*ONE +
										S_cos(theta,ONE)*(TAMA_POLY_R+KUGI_POLY_R);
					objp->cy = kugi_data[div_data[i+1]*2+3]*ONE +
										S_sin(theta,ONE)*(TAMA_POLY_R+KUGI_POLY_R);

					return( div_data[i+1] );
				}
			}
		}
	}

	return( -1 );
}

void O_TAMA( TAMA_W *objp )
{
	SVECTOR		v0, v1, v2, v3;
	long		sxy0, sxy1, sxy2, sxy3;
	long		p, flag, z;
	MATRIX 		mr;										/* ǂݍݗpد */
	MATRIX		mo;										/* o͗pد */
	MATRIX		ml;										/* o͗pد */
	SVECTOR		angle;						/* ]p */
	VECTOR		trans;						/* ʒu */

	if( p_sys_w.pause_flag == 0 ){
		objp->timer++;
	}

if( objp->timer > 20*60*5 ){
	NFntPrint( "STOP TAMA   SPEED=%x\n", objp->first_speed );
}

	angle.vx = angle.vy = angle.vz = 0;

/*
NFntPrint( "ST=%x,X=%x,Y=%x,VX=%x,VY=%x\n", objp->status, objp->cx, objp->cy, objp->vx, objp->vy );
*/

	v0.vx = v1.vx = v2.vx = v3.vx = objp->cx/ONE;
	v0.vy = v1.vy = objp->cy/ONE-KUGI_POLY_R;
	v2.vy = v3.vy = objp->cy/ONE+KUGI_POLY_R;
	v1.vz = v3.vz = 0;

	if( objp->cz == TAMA_POLY_Z ){
		v0.vz = v2.vz = KUGI_POLY_H-60;
		z=RotAverage4( &v0, &v1, &v2, &v3, &sxy0,&sxy1,&sxy2,&sxy3,&p,&flag );
		v1.vz = v3.vz = objp->cz;
	}
	else{
		v0.vz = v2.vz = objp->cz;
		z=RotAverage4( &v0, &v1, &v2, &v3, &sxy0,&sxy1,&sxy2,&sxy3,&p,&flag );
	}

	trans.vx = objp->cx/ONE;
	trans.vy = objp->cy/ONE;
	trans.vz = objp->cz;

	ReadRotMatrix(&mr);								/* د̓ǂ݂ */
	PushMatrix();									/* ۰د push*/

	RotMatrix(&angle, &mo);							/* ] */
	TransMatrix(&mo, &trans);						/* sړ */
	CompMatrix(&mr, &mo, &ml);						/* د̍ */
	SetTransMatrix(&ml);							/* sړ޸ِݒ */
	SetRotMatrix(&p_sys_w.tama_matrix);				/* ]دݒ */

	setVector(&v0, -TAMA_POLY_R, -TAMA_POLY_R, 0);
	setVector(&v1, TAMA_POLY_R, -TAMA_POLY_R, 0);
	setVector(&v2, -TAMA_POLY_R, TAMA_POLY_R, 0);
	setVector(&v3, TAMA_POLY_R, TAMA_POLY_R, 0);

	RotAverage4( &v0, &v1, &v2, &v3,
				(long *)&objp->prim.x0, (long *)&objp->prim.x1,
				(long *)&objp->prim.x2, (long *)&objp->prim.x3, &p, &flag );

	if( objp->pri == KUGI_OT ){
		GsSortPoly( &objp->prim, 
			(GsOT *)&Wot[KUGI_OT][M_activebuff()],
			z>>(14-OT3_LENGTH) );
	}
	else{
		GsSortPoly( &objp->prim, 
			(GsOT *)&Wot[objp->pri][M_activebuff()],
			z>>(14-OT_LENGTH) );
	}

	PopMatrix();									/* ۰د pop */
}

static void tama_prim_set( u_long *timp, POLY_FT4 *prim )
{
	long	random;

	/*-------------------------------------------------------- POLY_FT4  */
	SetPolyFT4(prim);

	/*------------------------------------------------------------- RGB  */
	srand(S_sys_w->stimer);
	random = rand();				/* ͂O`RQVUV		*/

	if( random < 5 ){		/* TrʁiPԂɂPj	*/
		setRGB0(prim, 0x50,0x40,0x30);
	}
	else{
		random %= 0x20;
		setRGB0(prim, 0x80+random,0x80+random,0x80+random);
	}

	prim->tpage = S_TimGetTPage(timp, 0);
	prim->clut = S_TimGetClut(timp);

	S_TimSetUVWH(timp, prim);
}


u_long p_culc_distance( long x0, long y0, long x1, long y1 )
{
	int		shift = 0;
	int		abs_max;
	int		x, y;

	if( abs(y0-y1) > abs(x0-x1) ){
		abs_max = abs(y0-y1);
	}
	else{
		abs_max = abs(x0-x1);
	}

	while( (abs_max>>shift) > 0x4000 )	shift++;

	x=(x0-x1)>>shift;
	y=(y0-y1)>>shift;

	return( p_tama_root((u_long)(x*x+y*y))<<shift );
}


u_long p_culc_square( int *shift, long x0, long y0, long x1, long y1 )
{
	int		abs_max;
	int		x, y;

	*shift = 0;

	if( abs(y0-y1) > abs(x0-x1) ){
		abs_max = abs(y0-y1);
	}
	else{
		abs_max = abs(x0-x1);
	}

	while( (abs_max>>*shift) > 0x4000 )	(*shift)++;

	x=(x0-x1)>>(*shift);
	y=(y0-y1)>>(*shift);

	return( (u_long)(x*x+y*y) );
}


static long p_circle_xy( long xy, long cen0, long cen1, long r, int fugou )
{
	long	soutai_xy;
	long	rtn;
	int		shift = 0;

	while( (r>>shift) > 0x4000 )	shift++;

	r = r>>shift;
	soutai_xy = (cen0-xy)>>shift;

	rtn = p_tama_root(r*r - soutai_xy*soutai_xy);

	rtn = rtn<<shift;

	if( fugou == ZAHYOU_SMALL ){
		rtn = cen1-rtn;
	}
	else{
		rtn = cen1+rtn;
	}

	return( rtn );
}

unsigned long p_tama_root( unsigned long val )
{
	unsigned long	buff, rtn;

	if( val == 0 )	return( 0 );

	buff = 1;
	rtn = val;

	while( buff < rtn ){
		buff <<= 1;
		rtn >>= 1;
	}

	do{
		rtn = buff;
		buff = (val/buff + buff) >> 1;
	}while( buff < rtn );

	return( rtn );
}


static void O_NYUUSHOU( NYUUSHOU_W *objp )
{
	objp->timer++;

	if( (objp->timer > 40) && (p_sys_w.haraidasi_time == 0) ){
		p_sys_w.pachi_data.haraidasi[objp->pachi_status] += objp->haraidasi;

		if( p_sys_w.pachi_status != P_ATARI_STAT ){
			p_sys_w.pachi_data.konkai_tama_suu += objp->haraidasi;
		}

		SD_call( SD_CHINJYAR );
		p_sys_w.haraidasi_time = 16;

		p_sys_w.haraidashi_flag = 1;
		S_obj_clear( (u_long *)objp );
	}
}
