#include "lt_all.h"
#include "s_init.h"
#include "s_color.h"
#include "s_trans.h"
#include "s_cdhd.h"
#include "cd_sect.h"
#include "s_string.h"
#include "s_step.h"
#include "s_gsdobj.h"
#include "pachinko.h"
#include "p_kugi.h"
#include "p_tama.h"
#include "p0_data.h"
#include "p0_main.h"
#include "p1_data.h"
#include "p1_main.h"
#include "p2_data.h"
#include "p2_main.h"
#include "p3_data.h"
#include "p3_main.h"
#include "p4_data.h"
#include "p4_main.h"
#include "p5_data.h"
#include "p5_main.h"
#include "p_view.h"
#include "p_data.h"
#include "p_dlist.h"
#include "p_smenu.h"
#include "sdcall.h"

#define STATIC static

STATIC void s_pachinko_i(void);
STATIC void s_pachinko_m(void);
STATIC void s_pachinko_e(void);
STATIC void s_kugi_chousei_i(void);
STATIC void s_kugi_chousei_m(void);
STATIC void s_kugi_chousei_e(void);
STATIC int p_data_load_set();
STATIC int p_data_load_wait();
STATIC int p_sub_load_set();
STATIC int p_sub_load_wait();
STATIC int p_data_load1_set();
STATIC int p_data_load1_wait();
STATIC int p_data_load2_set();
STATIC int p_data_load2_wait();
STATIC void p_data_set();
STATIC int P_modelsize_set();
STATIC u_long *P_light_set(u_short pri);
STATIC void p_dai_light(GsF_LIGHT_W *objp);
STATIC void p_dai_light_init(GsF_LIGHT_W *objp);
STATIC void p_dai_light_main(GsF_LIGHT_W *objp);
STATIC void p_atari_xywh_set();
STATIC void p_set_graph_data();
STATIC void p_data_renew();
STATIC void p_power_indi();
STATIC void p_power_indi_init();


static 	OPD_W			*opd_p[8];
static	GsBOXF			fade_prim;
static	POLY_FT4		power_ft4;

P_DATCVT_W	*p_datas[] = { &p0_datas, &p1_datas, &p2_datas, 
							&p3_datas, &p4_datas, &p5_datas};

static int			cd_que_no;

#ifndef CD_READ
static long			p_sub_pro_size[] = { PACHI0_SIZE, PACHI1_SIZE, PACHI2_SIZE, 							PACHI3_SIZE, PACHI4_SIZE,PACHI5_SIZE };
static char			*p_sub_pro_file[] = { PACHI0_FILE, PACHI1_FILE, PACHI2_FILE, 							PACHI3_FILE,PACHI4_FILE,PACHI5_FILE};
#else
static long			cd_p_sub_pro_size[] = { CD_PACHI0_SIZE, CD_PACHI1_SIZE,
									CD_PACHI2_SIZE,	CD_PACHI3_SIZE,
									CD_PACHI4_SIZE, CD_PACHI5_SIZE };
static u_long		cd_p_sub_pro_sect[] = { CD_PACHI0_SECT, CD_PACHI1_SECT,
									CD_PACHI2_SECT, CD_PACHI3_SECT,
									CD_PACHI4_SECT, CD_PACHI5_SECT};
#endif
static u_long		p_sub_main[] = {	(u_long)p0_main,	(u_long)p1_main,
										(u_long)p2_main,	(u_long)p3_main,
										(u_long)p4_main,	(u_long)p4_main,
										};

#define	P_DATA_FILE		("c:/vx022/dat/p_data.cvt")


void Pachinko_main()
{
	switch( p_sys_w.main_step ){
		case 0:
			s_pachinko_i();
			break;
		case 1:
			s_pachinko_m();
			break;
		case 2:
			s_pachinko_e();
			break;
	}
}

int P_kugi_chousei_main()
{
	switch( p_sys_w.main_step ){
		case 0:
			s_kugi_chousei_i();
		case 1:
			s_kugi_chousei_m();
			break;
		case 2:
			s_kugi_chousei_e();
			break;
		case 3:
			return( 1 );
			break;
	}

	return( 0 );
}

/*---< stepw_s >--------------------------------*/
/*	s_pachinko_i								*/
/*----------------------------------------------*/
STATIC void s_pachinko_i(void)
{
	static int sound_tbl[] = {
				SD_CTL_STAGE_KING, SD_CTL_STAGE_KING, SD_CTL_STAGE_KISS,
				SD_CTL_STAGE_KISS, SD_CTL_STAGE_KISS, SD_CTL_STAGE_KISS };

	switch( p_sys_w.main_step_s ){
		case 0:
			S_disp_sys_change(512, 240);

			SD_call(sound_tbl[S_sys_w->pachinkow.pach_num]);

			p_sys_w.p_data = p_datas[S_sys_w->pachinkow.pach_num];
												/* ݺ۸т۰	*/
/*			P_dai_view_init();*/
/*			P_light_set(3);	*/					/* ݺײ߲ľ */
			if( p_data_load_set() )
				P_main_step_s_up();
			break;
		case 1:
			if( p_data_load_wait() )
				P_main_step_s_up();
			break;
		case 2:
			if( p_sub_load_set() )
				P_main_step_s_up();
			break;
		case 3:
			if( p_sub_load_wait() )
				P_main_step_s_up();
			break;
		case 4:
												/* VRAM풓ް۰	*/
			if( p_data_load1_set() )
				P_main_step_s_up();
			break;
		case 5:
			if( p_data_load1_wait() )
				P_main_step_s_up();
			break;
		case 6:
												/* VRAM풓ް۰	*/
			if( p_data_load2_set() ){
				P_main_step_s_up();
			}
			break;
		case 7:
			if( p_data_load2_wait() ){
				P_main_step_s_up();
			}
			break;
		case 8:
			p_data_set();
			p_sys_w.timer = 0;
			p_sys_w.play_timer = 0;
			p_sys_w.pause_flag = 0;
			p_sys_w.pachi_status = P_TUUJOU_STAT;
			S_fadein_black();							/* ̪ޱ */
			P_fade_prim_init( &fade_prim );
			S_sys_w->vsync_no = 3;
/*				P_dai_view_init();*/
			P_dai_view_init();
/*				P_dai_view_main();*/
			P_tama_op_init();
			P_step_set(0);
			P_main_step_up();
			break;
		default:
			break;
	}
}

/*---< stepw_s >--------------------------------*/
/*	s_pachinko_m								*/
/*----------------------------------------------*/
STATIC void s_pachinko_m(void)
{
	void			(*function)();

	p_sys_w.timer++;

	P_data_print();
	p_power_indi();

	switch( p_sys_w.pause_flag ){
		case 0:					/* vC		*/
			p_sys_w.play_timer++;

			p_data_renew();

			p_set_graph_data();

			P_dai_view_main();

			p_sys_w.tamadome_flag = OFF;
			if( p_sys_w.haraidasi_time > 0 )	p_sys_w.haraidasi_time--;

			P_tama_op_main();

			function = (void *)p_sub_main[S_sys_w->pachinkow.pach_num];
			(*function)();

			if( M_fade_flag() == OFF ){
				if( M_joy_trg(0) & PADR1 ){
					p_sys_w.pause_flag = 2;
				}
			}
			break;

		case 1:					/* |[Y				*/
			P_sub_menu();
			GsSortBoxFill( &fade_prim, (GsOT *)&Wot[8][M_activebuff()],OTSIZE-1);
			break;
		case 2:					/* tF[hAEg		*/
			fade_prim.r += 32;
			fade_prim.g += 32;
			fade_prim.b += 32;
			if( fade_prim.r >= 160 ){
				P_data_comment_init();
				P_sub_menu_init();
				p_sys_w.pause_flag = 1;
			}
			GsSortBoxFill( &fade_prim, (GsOT *)&Wot[8][M_activebuff()],OTSIZE-1);
			break;
		case 3:					/* tF[hC		*/
			fade_prim.r -= 32;
			fade_prim.g -= 32;
			fade_prim.b -= 32;
			if( fade_prim.r <= 0 )
				p_sys_w.pause_flag = 0;
			GsSortBoxFill( &fade_prim, (GsOT *)&Wot[8][M_activebuff()],OTSIZE-1);
			break;
	}
}

/*---< stepw_s >--------------------------------*/
/*	s_pachinko_e								*/
/*----------------------------------------------*/
STATIC void s_pachinko_e(void)
{
}


STATIC void s_kugi_chousei_i(void)
{
	if(M_fade_flag() == OFF) {
		S_disp_sys_change(512, 240);
		P_kugi_set(0,1);
		P_dai_view_init();
		P_main_step_up();
		S_trans_set((u_long *)((p_sys_w.p_chousei_data)->tim), 1);
		p_sys_w.chousei_objp = (GsDOBJ2_W *)P_tmd_set( (p_sys_w.p_chousei_data)->tmd );
		S_sys_w->vsync_no = 3;
		S_fadein_black();							/* ̪ޱ */
	}
}

/*---< stepw_s >--------------------------------*/
/*	s_pachinko_m								*/
/*----------------------------------------------*/
STATIC void s_kugi_chousei_m(void)
{
	P_dai_view_main();

	P_kugi_chousei();

	if(M_fade_flag() == OFF) {
		if(M_joy_new(0) & PADRright){
			S_fadeout_black();							/* ̪ޱ */
			P_main_step_up();
		}
	}
}

/*---< stepw_s >--------------------------------*/
/*	s_pachinko_e								*/
/*----------------------------------------------*/
STATIC void s_kugi_chousei_e(void)
{
	P_dai_view_main();

	if(M_fade_flag() == OFF) {
		S_obj_clear( (u_long *)p_sys_w.kugi_objp );
		S_obj_clear( (u_long *)p_sys_w.chousei_objp );
		P_main_step_up();
	}
}


/*---< local function >-----------------------------------------------------*/
/*	`F		p_sub_load_set(objp)										*/
/*	F		USER_W	*objp	:޼ު߲								*/
/*	F		1ڂް̓ǂݍ										*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC int p_data_load_set()
{
#ifndef CD_READ
	if((cd_que_no = S_cdhd_que_set(HD_DATA,(u_long)P_DATA_TOP,
								P_DATA_SIZE, P_DATA_FILE)) != -1)
#else
	if((cd_que_no = S_cdhd_que_set(CD_DATA,(u_long)P_DATA_TOP,
								CD_P_DATA_SIZE, CD_P_DATA_SECT)) != -1)
#endif
	{
		return(1);
	}

	return(0);
}

/*---< local function >-----------------------------------------------------*/
/*	`F		p_sub_load_wait(objp)									*/
/*	F		USER_W	*objp	:޼ު߲								*/
/*	F		ް̓ǂݍ												*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC int p_data_load_wait()
{
	if(S_cdhd_que_stat(cd_que_no) == CD_STATUS_END) {
		return(1);
	}
	else{
		SFntPrint(80, 120, 0, 0, "PACHI DATA LOADING");
		return(0);
	}
}

/*---< local function >-----------------------------------------------------*/
/*	`F		p_sub_load_set(objp)										*/
/*	F		USER_W	*objp	:޼ު߲								*/
/*	F		1ڂް̓ǂݍ										*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC int p_sub_load_set()
{
#ifndef CD_READ
	if((cd_que_no = S_cdhd_que_set(HD_DATA,(u_long)LoadAddress3,
				p_sub_pro_size[S_sys_w->pachinkow.pach_num],
				(u_long)p_sub_pro_file[S_sys_w->pachinkow.pach_num])) != -1)
#else
	if((cd_que_no = S_cdhd_que_set(CD_DATA,(u_long)LoadAddress3,
				cd_p_sub_pro_size[S_sys_w->pachinkow.pach_num],
				cd_p_sub_pro_sect[S_sys_w->pachinkow.pach_num])) != -1)
#endif
	{
		return(1);
	}

	return(0);
}

/*---< local function >-----------------------------------------------------*/
/*	`F		p_sub_load_wait(objp)									*/
/*	F		USER_W	*objp	:޼ު߲								*/
/*	F		ް̓ǂݍ												*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC int p_sub_load_wait()
{
	if(S_cdhd_que_stat(cd_que_no) == CD_STATUS_END) {
		return(1);
	}
	else{
		SFntPrint(80, 120, 0, 0, "PACHI SUB LOADING");
		return(0);
	}
}

/*---< local function >-----------------------------------------------------*/
/*	`F		p_data_load1_set(objp)										*/
/*	F		USER_W	*objp	:޼ު߲								*/
/*	F		1ڂް̓ǂݍ										*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC int p_data_load1_set()
{
#ifndef CD_READ
	if((cd_que_no = S_cdhd_que_set(HD_DATA,(p_sys_w.p_data)->file1_dst,(p_sys_w.p_data)->file1_size,(p_sys_w.p_data)->file1_sect)) != -1)
#else
	if((cd_que_no = S_cdhd_que_set(CD_DATA,(p_sys_w.p_data)->file1_dst,(p_sys_w.p_data)->file1_size,(p_sys_w.p_data)->file1_sect)) != -1)
#endif
	{
		return(1);
	}

	return(0);
}

/*---< local function >-----------------------------------------------------*/
/*	`F		p_data_load1_wait(objp)									*/
/*	F		USER_W	*objp	:޼ު߲								*/
/*	F		ް̓ǂݍ												*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC int p_data_load1_wait()
{
	if(S_cdhd_que_stat(cd_que_no) == CD_STATUS_END) {
		P_timinit_load( (p_sys_w.p_data)->timinit );
		return(1);
	}
	else{
		SFntPrint(80, 120, 0, 0, "P0 LOAD1 DATA LOADING");
		return(0);
	}
}

/*---< local function >-----------------------------------------------------*/
/*	`F		p_data_load2_set(objp)										*/
/*	F		USER_W	*objp	:޼ު߲								*/
/*	F		2ڂް̓ǂݍ										*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC int p_data_load2_set()
{
#ifndef CD_READ
	if((cd_que_no = S_cdhd_que_set(HD_DATA,(p_sys_w.p_data)->file2_dst,(p_sys_w.p_data)->file2_size,(p_sys_w.p_data)->file2_sect)) != -1)
#else
	if((cd_que_no = S_cdhd_que_set(CD_DATA,(p_sys_w.p_data)->file2_dst,(p_sys_w.p_data)->file2_size,(p_sys_w.p_data)->file2_sect)) != -1)
#endif
	{
		return(1);
	}

	return(0);
}

/*---< local function >-----------------------------------------------------*/
/*	`F		p_data_load2_wait(objp)									*/
/*	F		USER_W	*objp	:޼ު߲								*/
/*	F		ް̓ǂݍ												*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC int p_data_load2_wait()
{
	if(S_cdhd_que_stat(cd_que_no) == CD_STATUS_END) {
		return(1);
	}
	else{
		SFntPrint(80, 120, 0, 0, "P0 LOAD2 DATA LOADING");
		return(0);
	}
}


void P_timinit_load( u_long *timp )
{
	int i;

	for(i=0 ; timp[i] != TIM_DATA_END ; i++) {
		S_trans_set((u_long *)(timp[i]), 1);		/* ø */
	}
}


STATIC void p_data_set()
{
	/*---------------------------------------------------- ݺٻ޾ */
	P_modelsize_set();

	P_kugi_maxmin_set();

	P_kugi_set(0, 0);

	P_atari_kugi_set();
	p_atari_xywh_set();

	/*--------------------------------------------------------- tmdް  */
	P_tmdinit_load( (p_sys_w.p_data)->tmdinit );


													/*	p`RȊO		*/
	S_trans_set((u_long *)P_DATA_CSR_PLAY_P, (u_short)1);
	S_trans_set((u_long *)P_DATA_CSR_PLAY_NU, (u_short)1);
	S_trans_set((u_long *)P_DATA_CSR_PLAY_N2, (u_short)1);
	S_trans_set((u_long *)P_DATA_COL_PLAY, (u_short)1);
	S_trans_set((u_long *)P_DATA_COL_PLAY_NU, (u_short)1);
	S_trans_set((u_long *)P_DATA_CSR_PLAY_P2, (u_short)1);
	S_trans_set((u_long *)P_DATA_CSR_PLAY_P3, (u_short)1);

	opd_p[0]= (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,sizeof(OPD_W),(u_short)1);
	opd_p[0]->ot = 8;
	opd_p[0]->opd_address = (u_long)P_DATA_OPD_DK_PLAY;
	opd_p[0]->center_x = -256;
	opd_p[0]->center_y = -104;
/*
	opd_p[0]->center_x = 0;
	opd_p[0]->center_y = 0;
*/
	O_OPD_W_INIT(opd_p[0], 0);

	P_data_print_init();
	p_power_indi_init();
}


/***< global function >******************************************************/
/*	`F		P_modelsize_set(datap)										*/
/*	F		P_DATCVT_W	*datap:	ް߲								*/
/*	F		ݸނ̻ނĂ										*/
/*	ԒlF		s	0													*/
/*					1													*/
/****************************************************************************/
STATIC int P_modelsize_set()
{
#if 0
	TMD_PRIM	tprim;
	long		scale = 0;								/* ݸ */

	/*------------------------------------------------------------- ܰر */
	bzero((char *)&(S_sys_w->pdw), sizeof(P_DATA_W));

	/*--------------------------------------- ݸް̻ XY 𒲂ׂ */
	OpenTMD((p_sys_w.p_data)->modelsizeXY,0);
	if(ReadTMD(&tprim) != NULL) {
		S_sys_w->pdw.modelsizex = abs(tprim.x0.vx-tprim.x1.vx);
		S_sys_w->pdw.modelsizey = abs(tprim.x0.vy-tprim.x2.vy);
	}
	else{
		return(0);
	}

	/*---------------------------------------- ݸް̻ Z 𒲂ׂ */
	OpenTMD((p_sys_w.p_data)->modelsizeZ,0);
	if(ReadTMD(&tprim) != NULL) {
		S_sys_w->pdw.modelsizez = abs(tprim.x0.vz-tprim.x1.vz);
	}
	else{
		return(0);
	}

	/*------------------------------------------------- ق̽قĂ */
	scale = (p_sys_w.p_data)->origsizex/S_sys_w->pdw.modelsizex;

	S_sys_w->pdw.modelscale = scale;

#endif
	return(1);
}


STATIC void p_atari_xywh_set()
{
	TMD_PRIM	tprim;
	GsDOBJ2_W		*obj2p = 0;
	int			i;

	/*------------------------------------ A^f[^̂wxvg 𒲂ׂ */
	for(i=0; (long)(p_sys_w.p_data)->atari_data[i].data!=ATARI_DATA_END; i++){
		OpenTMD((p_sys_w.p_data)->atari_data[i].data,0);
		ReadTMD(&tprim);
		(p_sys_w.p_data)->atari_data[i].x =
						((tprim.x0.vx<tprim.x1.vx)?tprim.x0.vx:tprim.x1.vx);
		(p_sys_w.p_data)->atari_data[i].y =
						((tprim.x0.vy<tprim.x2.vy)?tprim.x0.vy:tprim.x2.vy);
		(p_sys_w.p_data)->atari_data[i].w = abs(tprim.x0.vx-tprim.x1.vx);
		(p_sys_w.p_data)->atari_data[i].h = abs(tprim.x0.vy-tprim.x2.vy);

		if( (p_sys_w.p_data)->atari_data[i].tmd_data != NULL ){
			(p_sys_w.p_data)->atari_data[i].atari_r =
										abs(tprim.x0.vx-tprim.x1.vx)/2;

			(p_sys_w.p_data)->atari_data[i].tmd_objp =
						P_tmd_set( (p_sys_w.p_data)->atari_data[i].tmd_data );

			OpenTMD((u_long *)((p_sys_w.p_data)->atari_data[i].tmd_data->point),0);
			if(ReadTMD(&tprim) != NULL) {
				(p_sys_w.p_data)->atari_data[i].point_x =
												(tprim.x0.vx+tprim.x1.vx)/2;
				(p_sys_w.p_data)->atari_data[i].point_y =
												(tprim.x0.vy+tprim.x2.vy)/2;
			}
		}
	}
}


void P_tmdinit_load( P_DATTMD_W *tmdp )
{
	int		i;

	for( i=0; tmdp[i].code != TMD_DATA_END; i++) {
		P_tmd_set( &tmdp[i] );
	}
}

u_long *P_tmd_set(P_DATTMD_W *tmdp)
{
	TMD_PRIM		tprim;
	GsDOBJ2_W		*obj2p = 0;
	GsDOBJ3_W		*obj3p = 0;

	switch(tmdp->code) {
		case GSDOBJ3:
			if((obj3p = (GsDOBJ3_W *)S_gsdobj3_set(tmdp->setfunc,
									(u_long *)tmdp->data,
			 						tmdp->pri,
			  						tmdp->type)) != NULL) {
				if(tmdp->point != NULL) {
					OpenTMD((u_long *)tmdp->point,0);
					if(ReadTMD(&tprim) != NULL) {
						obj3p->x = (tprim.x0.vx+tprim.x1.vx)/2;
						obj3p->y = tprim.x2.vy;
					}
				}
				M_state_ot(obj3p) = tmdp->ot;
				M_gs_gsdobj_attribute(obj3p) = tmdp->attribute;
			}
			return((u_long *)obj3p);

		case GSDOBJ2:
			if((obj2p = (GsDOBJ2_W *)S_gsdobj2_set(tmdp->setfunc,
									(u_long *)tmdp->data,
			 						tmdp->pri,
			  						tmdp->type,
			  						tmdp->n)) != NULL) {
				if(tmdp->point != NULL) {
					OpenTMD((u_long *)tmdp->point,0);
					if(ReadTMD(&tprim) != NULL) {
						obj2p->x = (tprim.x0.vx+tprim.x1.vx)/2;
						obj2p->y = (tprim.x0.vy+tprim.x2.vy)/2;
					}
				}

				M_state_ot(obj2p) = tmdp->ot;
				M_gs_gsdobj_attribute(obj2p) = tmdp->attribute;
			}
			return((u_long *)obj2p);

		default:	break;
	}
	return(NULL);
}


/***< global function >******************************************************/
/*	`F		P_light_set(pri)											*/
/*	F		u_short	pri													*/
/*	F		ݺײ߲ľ										*/
/*	ԒlF		u_long	*objp:޼ު߲									*/
/*				0 ̎́AĎs											*/
/****************************************************************************/
STATIC u_long *P_light_set(u_short pri)
{
	PRIM_W		*objp;

	objp = (PRIM_W *)S_obj_set((u_long)NULL,
					(u_long)p_dai_light,					/* obj֐ */
					(int)sizeof(GsF_LIGHT_W),				/* size */
					pri);								/* Dԍ */
	return((u_long *)objp);
}


/*---< local function >-----------------------------------------------------*/
/*	`F		p_dai_light(obj)											*/
/*	F		GsF_LIGHT_W		*obj:޼ު߲							*/
/*	F		ݺ̐ݒ											*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
/*----- step -----*/
static void (*p_dai_light_step[])(GsF_LIGHT_W *) = {
			p_dai_light_init,
			p_dai_light_main,
			};

/*----- function -----*/
STATIC void p_dai_light(GsF_LIGHT_W *objp)
{
	(*p_dai_light_step[M_state_step(objp)])(objp);			/* ðټެ */
}

/*---< local function >-----------------------------------------------------*/
/*	`F		p_dai_light_init(objp)										*/
/*	F		GsF_LIGHT_W		*obj:޼ު߲							*/
/*	F		ݺ̏ݒ										*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC void p_dai_light_init(GsF_LIGHT_W *objp)
{
	/*------------------------------------------------------- <ײID0 ݒ> */
	/*-----------------------------------------------sҰݒ */
	M_gs_light_vx_set(objp, 0, 30);
	M_gs_light_vy_set(objp, 0, 30);
	M_gs_light_vz_set(objp, 0, 100);
 
	/*-------------------------------------------------sFҰݒ */
	M_gs_light_r_set(objp, 0, 0x20);
	M_gs_light_g_set(objp, 0, 0x30);
	M_gs_light_b_set(objp, 0, 0x50);

	/*------------------------------------------ p[^ݒ */
	GsSetFlatLight(0,&M_gs_light(objp, 0));

	/*------------------------------------------------------- <ײID1 ݒ> */
	M_gs_light_vx_set(objp, 1, 20);
	M_gs_light_vy_set(objp, 1, -50);
	M_gs_light_vz_set(objp, 1, -100);
	M_gs_light_r_set(objp, 1, 0x30);
	M_gs_light_g_set(objp, 1, 0x30);
	M_gs_light_b_set(objp, 1, 0x30);
	GsSetFlatLight(0,&M_gs_light(objp, 1));
  
	/*------------------------------------------------------- <ײID2 ݒ> */
	M_gs_light_vx_set(objp, 2, -20);
	M_gs_light_vy_set(objp, 2, 20);
	M_gs_light_vz_set(objp, 2, 100);
	M_gs_light_r_set(objp, 2, 0x30);
	M_gs_light_g_set(objp, 2, 0x30);
	M_gs_light_b_set(objp, 2, 0x30);
	GsSetFlatLight(0,&M_gs_light(objp, 2));

/*	GsSetAmbient(ONE/2,ONE/2,ONE/2);*/					/* ޴Ă̐ݒ */
	GsSetAmbient(ONE,ONE,ONE);					/* ޴Ă̐ݒ */

	GsSetLightMode(0);							/* vZ̫Ă̕ݒ*/

	M_state_step(objp)++;						/* ï߱ */
}

/*---< local function >-----------------------------------------------------*/
/*	`F		p_dai_light_main(objp)										*/
/*	F		GsF_LIGHT_W		*obj:޼ު߲							*/
/*	F		ݺ													*/
/*	ԒlF		Ȃ														*/
/*--------------------------------------------------------------------------*/
STATIC void p_dai_light_main(GsF_LIGHT_W *objp)
{
}


STATIC void p_set_graph_data()
{
	long	total_jikan;
	long	total_motitama;
	int		i;

	total_jikan = p_sys_w.pachi_data.play_jikan[P_TUUJOU_STAT] +
					p_sys_w.pachi_data.play_jikan[P_KAKUHEN_STAT] +
					p_sys_w.pachi_data.play_jikan[P_ATARI_STAT];
	if( total_jikan % (20*60*p_sys_w.pachi_data.moti_tama_range_x) == 0 ){
		total_motitama = p_sys_w.pachi_data.haraidasi[P_TUUJOU_STAT]
						+ p_sys_w.pachi_data.haraidasi[P_KAKUHEN_STAT]
						+ p_sys_w.pachi_data.haraidasi[P_ATARI_STAT]
						- p_sys_w.pachi_data.tounyuu[P_TUUJOU_STAT]
						- p_sys_w.pachi_data.tounyuu[P_KAKUHEN_STAT]
						- p_sys_w.pachi_data.tounyuu[P_ATARI_STAT];

		if( p_sys_w.pachi_data.moti_tama_yuukou_x == 128 ){
			p_sys_w.pachi_data.moti_tama_range_x *= 2;
			p_sys_w.pachi_data.moti_tama_yuukou_x /= 2;
			for( i=0; i<64; i++ ){
				p_sys_w.pachi_data.moti_tama_graph_y[i] = 
					p_sys_w.pachi_data.moti_tama_graph_y[i*2];
			}
		}
		p_sys_w.pachi_data.moti_tama_graph_y[p_sys_w.pachi_data.moti_tama_yuukou_x] = total_motitama;
		p_sys_w.pachi_data.moti_tama_yuukou_x++;
	}
}

STATIC void p_power_indi_init()
{
	SetPolyFT4( &power_ft4 );
	power_ft4.tpage = GetTPage( 0, 1, 960, 256 );
	power_ft4.clut = GetClut( 336, 504 );
	setRGB0( &power_ft4, 0x80, 0x80, 0x80 );
	setUVWH( &power_ft4, 128, 64, 94, 9 );
}

STATIC void p_power_indi()
{
	setXY4( &power_ft4,		144,									83,
					144+((p_sys_w.tama.power-TAMA_POWER_MIN)*94)
							/(TAMA_POWER_MAX-TAMA_POWER_MIN),		83,
							144,									92,
					144+((p_sys_w.tama.power-TAMA_POWER_MIN)*94)
							/(TAMA_POWER_MAX-TAMA_POWER_MIN),		92 );

	GsSortPoly( &power_ft4, (GsOT *)&Wot[8][M_activebuff()], 10 );
}


void P_fade_prim_init( GsBOXF *fade_prim )
{
	fade_prim->attribute = (2<<28)|(1<<30);
	fade_prim->x = -256;
	fade_prim->y = -120;
	fade_prim->w = 512;
	fade_prim->h = 240;
	fade_prim->r = 0;
	fade_prim->g = 0;
	fade_prim->b = 0;
}


/***< global function >******************************************************/
/*	`F		P_light_Gs2_LED00											*/
/*	F		GsDOBJ2_W	*objp	:޼ު߲							*/
/*	F		LED̓_													*/
/*	ԒlF		Ȃ														*/
/****************************************************************************/
void P_light_Gs2_LED00(GsDOBJ2_W *objp)
{
	if((M_stimer()>>3) & 0x01) {
		M_gs_gsdobj_attribute(objp) |= ATTR31;
	} else {
		M_gs_gsdobj_attribute(objp) &= ATTR31N;
	}
}


void P_fuusha_rotate(GsDOBJ2_W *objp)
{
	if( p_sys_w.pause_flag == 0 ){
		if( objp->z_rotate > 256*ONE ){
			objp->z_rotate = 256*ONE;
		}
		else if( objp->z_rotate < -256*ONE ){
			objp->z_rotate = -256*ONE;
		}

		objp->angle.vz -= (objp->z_rotate/ONE);
		objp->angle.vz %= ONE;

		objp->z_rotate *= 62;
		objp->z_rotate /= 64;
	}
}


STATIC void p_data_renew()
{
	p_sys_w.pachi_data.konkai_jikan++;
	p_sys_w.pachi_data.play_jikan[p_sys_w.pachi_status] ++;

	if(p_sys_w.pachi_data.konkai_kaiten_suu>
			p_sys_w.pachi_data.hamari_kaiten_suu){
		p_sys_w.pachi_data.hamari_kaiten_suu=
					p_sys_w.pachi_data.konkai_kaiten_suu;
	}

	if( (p_sys_w.pachi_data.hamari_tama_suu <
					-p_sys_w.pachi_data.konkai_tama_suu) &&
					(p_sys_w.pachi_data.konkai_tama_suu < 0) ){
		p_sys_w.pachi_data.hamari_tama_suu=
					-p_sys_w.pachi_data.konkai_tama_suu;
	}
}


void P_step_up(void)
{
	p_sys_w.step++;
	p_sys_w.step_end = OFF;
	p_sys_w.step_s = 0;
	p_sys_w.step_s_end = OFF;
}

/*-------------------------------------*/
void P_step_set(u_short st)
{
	p_sys_w.step = st;
	p_sys_w.step_end = OFF;
	p_sys_w.step_s = 0;
	p_sys_w.step_s_end = OFF;
}

void P_step_s_up(void)
{
	p_sys_w.step_s++;
	p_sys_w.step_s_end = OFF;
}

/*-------------------------------------*/
void P_step_s_set(u_short st)
{
	p_sys_w.step_s = st;
	p_sys_w.step_s_end = OFF;
}

void P_step_e_up(void)
{
	p_sys_w.step_e++;
	p_sys_w.step_e_end = OFF;
}

/*-------------------------------------*/
void P_step_e_set(u_short st)
{
	p_sys_w.step_e = st;
	p_sys_w.step_e_end = OFF;
}

void P_main_step_up(void)
{
	p_sys_w.main_step++;
	p_sys_w.main_step_end = OFF;
	p_sys_w.main_step_s = 0;
	p_sys_w.main_step_s_end = OFF;
}

/*-------------------------------------*/
void P_main_step_set(u_short st)
{
	p_sys_w.main_step = st;
	p_sys_w.main_step_end = OFF;
	p_sys_w.main_step_s = 0;
	p_sys_w.main_step_s_end = OFF;
}

void P_main_step_s_up(void)
{
	p_sys_w.main_step_s++;
	p_sys_w.main_step_s_end = OFF;
}

/*-------------------------------------*/
void P_main_step_s_set(u_short st)
{
	p_sys_w.main_step_s = st;
	p_sys_w.main_step_s_end = OFF;
}
