#ifndef	P_PACHINKO_H_DEF
#define P_PACHINKO_H_DEF

#include "p_kugi.h"
#include "s_gsdobj.h"
#include "s_memory.h"
#ifndef FOR_SOUND
#define PACHINKO_FILE		"../pro/pachinko.bin"
#else
#define PACHINKO_FILE		"pachinko.bin"
#endif
#define PACHINKO_SIZE		36752

#define		TMD_DATA_END		-1
#define		TIM_DATA_END		-1
#define		ATARI_DATA_END		-1


#define		TAMA_POLY_R		(55*4)				/* ʂ̔a					*/
#define		TAMA_POLY_Z		(-120*4)		/*(-80*4)*/	/* ʂ Z W		*/
#define		TAMA_G			(ONE/2)		/* d͉x				*/
#define		TAMA_CALC_TIME	(16)		/* 16 ʂ̍WvZ			*/
#define		TAMA_MAX		(30)
#define		ROT_ATARI_MAX	(8)

#define		TAMA_POWER_MAX	(0x90000)
#define		TAMA_POWER_MIN	(0x0)

#define		RAIL_E			2048				/* [̒˕ԂW		*/
#define		RAIL_TEIKO		4060				/* [̒R				*/

#define		KUGI_E			2048				/* NM̒˕ԂW		*/
#define		YAKU_E			768					/* m̒˕ԂW		*/

#define		TAMA_UTIDASI_S		(1<<0)
#define		TAMA_STOP_S			(1<<1)


#define		GSDOBJ3				0x00
#define		GSDOBJ2				0x01

#define		TAMA_RAIL			0
#define		TAMA_BANMEN			1
#define		TAMA_OUT			2
#define		TAMA_MODORI			3
#define		TAMA_NYUUSHOU15		4
#define		TAMA_NYUUSHOU13		5
#define		TAMA_NYUUSHOU6		6
#define		TAMA_NYUUSHOU5		7
#define		TAMA_END			8


#define		ATARI_NASI				0
#define		ATARI_FUUSHA_1			1
#define		ATARI_FUUSHA_2			2
#define		ATARI_MAIN_CH			3
#define		ATARI_SUB_CH			4
#define		ATARI_NYUUSHOU			5
#define		ATARI_END				6

typedef	struct _P_DATTMD_W {
	short		code;							/*  */
	u_long		setfunc;						/* Ċ֐ */
	u_long		data;							/* ް */
	u_long		pri;							/* ײè */
	u_long		type;							/*  */
	u_long		n;								/* ޯ */
	u_long		point;							/* ʒuް */
	u_long		ot;								/* OT ̗D */
	u_long		attribute;						/* ޭ */
} P_DATTMD_W;


typedef	struct _P_DATATARI_W {
	u_long				*data;							/* ް */
	u_long				atari_status;
	u_long				tama_status;
	long				x, y, w, h;		/* A^͈̔(programő) */
	P_DATTMD_W			*tmd_data;
	long				*tmd_objp;
	long				point_x;
	long				point_y;
	long				atari_r;
} P_DATATARI_W;

typedef	struct _P_DATCVT_W {
	u_long		file1_dst;						/* 1ڂ̓ǂݍ */
	u_long		file1_size;						/* 1ڂ̓ǂݍ */
	u_long		file1_sect;						/* 1ڂ̓ǂݍ */
	u_long		file2_dst;						/* 2ڂ̓ǂݍ */
	u_long		file2_size;						/* 2ڂ̓ǂݍ */
	u_long		file2_sect;						/* 2ڂ̓ǂݍ */
	P_DATTMD_W	*tmdinit;					/* ]ptmdް߲ */
	u_long		*timinit;					/* ]ptimް߲ */
	long		origsizex;					/* ؼّ̻ނ */
	long		origsizey;					/* ؼّ̻ނ */
	u_long		*ekisho_model;				/* ݸފ߲ */
	long		ekisho_dotx;				/* t̂hbg	*/
	long		ekisho_doty;				/* t̂hbg	*/
	long		*kugi_timA;					/* B̑ʗpø		*/
	long		*kugi_timB;					/* B̓pø		*/
	short		*kugi_data;					/* B̍Wf[^		*/
	short		*mkugi_data;				/* B̍Wf[^		*/
	short		*yaku_data;					/* ̂̃A^Wf[^		*/
	long		kugi_pri;					/* B̕\D揇		*/
	long		*tama_tim;					/* ʂø		*/
	long		cenAx;						/* S_ A ̑Βl */
	long		cenAy;						/* S_ A ̑Βl */
	long		cenAr;						/* a A */
	long		cenBx;						/* S_ B ̑Βl */
	long		cenBy;						/* S_ B ̑Βl */
	long		cenBr;						/* a B */
	long		cenCx;						/* S_ C ̑Βl */
	long		cenCy;						/* S_ C ̑Βl */
	long		cenCr;						/* a C */
	long		cenDx;						/* S_ D ̑Βl */
	long		cenDy;						/* S_ D ̑Βl */
	long		cenDr;						/* a D */
	long		cenEx;						/* S_ E ̑Βl */
	long		cenEy;						/* S_ E ̑Βl */
	long		cenEr;						/* a E */
	long		cenFx;						/* S_ F ̑Βl */
	long		cenFy;						/* S_ F ̑Βl */
	long		cenFr;						/* a F */
	long		chABy;						/* A,B ̐؂ւ|Cg	*/
	long		chCDy;						/* C,D ̐؂ւ|Cg	*/
	long		uchidashiBy;				/* ʑło|Cg	*/
	long		hassha_y;					/* ݺʔ߲ */
	P_DATATARI_W	*atari_data;			/* A^ް߲ */
} P_DATCVT_W;

typedef	struct _TAMA_W {
	OBJ_W_HEAD			header;						/* ޼ުܰͯް */
	POLY_FT4			prim;
	long				cx, cy, cz;		/* ʂ̍W(Œ菬_)				*/
	long				vx, vy;			/* ʂ̃xNg(Œ菬_)			*/
	u_long				status;			/* ʂ̃Xe[^X					*/
	short				main_ch_flag;	/* C`bJ[̃A^tO	*/
	short				sub_ch_flag;	/* Tu`bJ[̃A^tO		*/
	int					pri;
	int					timer;
	int					first_speed;	/* fobOp						*/
} TAMA_W;

#define		P_MEMORY_MAX		5
#define		P_RAND_MAX			(4)

typedef struct	_P_MEMORY{
	long		rand[P_RAND_MAX];
	short		digital[3];
}P_MEMORY;

typedef struct	_P_TAMA{
	u_long				handle_flag;	/* ło					*/
	long				power;			/* ło					*/
}P_TAMA;

typedef struct _P_CHOUSEI_W{
	P_DATTMD_W	*tmd;				/* B̔Ֆʗpø		*/
	u_long		*tim;				/* B̔Ֆʗpø		*/
	long		*kugi_timA;			/* B̑ʗpø		*/
	long		*kugi_timB;			/* B̓pø		*/
	long		*kugi_timA1;		/* B̑ʗpø		*/
	long		*kugi_timB1;		/* B̓pø		*/
	long		*kugi_timA2;		/* B̑ʗpø		*/
	long		*kugi_timB2;		/* B̓pø		*/
	short		*kugi_data;			/* B̍Wf[^		*/
	short		*mkugi_data;		/* B̍Wf[^		*/

}P_CHOUSEI_W;

typedef struct _P_SYS_W{
	P_DATCVT_W	*p_data;
	P_CHOUSEI_W	*p_chousei_data;

	u_long		main_step;				/* ްѽïߒl					*/
	u_long		main_step_end;			/* ްѽïߒl					*/
	u_long		main_step_s;				/* ްѽïߒl					*/
	u_long		main_step_s_end;			/* ްѽïߒl					*/
	u_long		step;					/* ްѽïߒl					*/
	u_long		step_end;				/* ްѽïߏI׸			*/
	u_long		step_s;					/* ްѻ޽ïߒl				*/
	u_long		step_s_end;				/* ްѻ޽ïߏI׸			*/
	u_long		step_e;					/* tïߒl				*/
	u_long		step_e_end;				/* tïߏI׸			*/

	u_long		timer;
	u_long		play_timer;
	u_long		uchidasi_time;
	long		haraidasi_time;
	u_long		pause_flag;

	MATRIX		tama_matrix;

	short		memory_no;				/* ۗʐ						*/
	P_MEMORY	memory[P_MEMORY_MAX];	/* ۗʗ					*/
	short		memory_s_no;			/* ۗʐ(Tu`bJ[@	*/
	P_MEMORY	memory_s[P_MEMORY_MAX];	/* ۗʗ(Tu`bJ[)	*/

	enum	_pachi_status{ P_TUUJOU_STAT, P_KAKUHEN_STAT, P_ATARI_STAT }
				pachi_status;

	S_MEMORY_DATA	pachi_data;			/* [J[hZ[upf[^	*/

	short		digital[3][2];			/* fW^RDE	*/
	short		uv[4][2];				/* t̕\tu				*/
	SVECTOR		model_vect[4];			/* t޸					*/
	short		dotx;
	short		doty;
	long		chousei_number;			/* NM̖{					*/
	long		mkugi_number;			/* NM̖{					*/
	short		*kugi_divide[KUGI_DIV_NO][KUGI_DIV_NO];
	short		*mkugi_divide[KUGI_DIV_NO][KUGI_DIV_NO];
	short		*yaku_divide[KUGI_DIV_NO][KUGI_DIV_NO];
									/* 蔻piOԂɐ)	*/
	long		kugi_x_min;
	long		kugi_x_max;
	long		kugi_y_min;
	long		kugi_y_max;
	KUGI_W		*kugi_objp;
	GsDOBJ2_W	*chousei_objp;
	long		*poly_address_kugi;
	long		*poly_address_mkugi;
	P_TAMA		tama;
	long		hassha_x;
	long		hassha_y;
	short		tamadome_flag;
	short		denchuu_flag;
	short		attacker_flag;
	short		haraidashi_flag;
	short		v_zone_flag;
	TAMA_W		*tama_objp[TAMA_MAX];
	short		calc_no;
	short		attacker_nyuushou;
	long		*rot_atari[ROT_ATARI_MAX];
	short		hyouji_data[4];
	short		main_ch_counter;
	long		quiz_motidama;
	long		haraidasi_oto;
}P_SYS_W;



extern	P_SYS_W		p_sys_w;
extern	P_CHOUSEI_W p_chousei_data[];


extern void Pachinko_main();
extern void P_light_Gs2_LED00(GsDOBJ2_W *objp);
extern void P_main_step_up(void);
extern void P_main_step_set(u_short st);
extern void P_main_step_s_up(void);
extern void P_main_step_s_set(u_short st);
extern void P_step_up(void);
extern void P_step_set(u_short st);
extern void P_step_s_up(void);
extern void P_step_s_set(u_short st);
extern void P_step_e_up(void);
extern void P_step_e_set(u_short st);
extern void P_fuusha_rotate(GsDOBJ2_W *objp);
extern void P_tmdinit_load( P_DATTMD_W *tmdp );
extern void P_timinit_load( u_long *timp );
extern u_long *P_tmd_set(P_DATTMD_W *tmdp);
extern int P_kugi_chousei_main();
extern void P_fade_prim_init( GsBOXF *fade_prim );

#endif

