/***< file >*********************************************************/
/*	Title		:	PlayStation										*/
/*	Code		:	vx022											*/
/*	Filename	:	u_lev.c											*/
/*	Author		:	usr01681 Mizutani								*/
/*	Date		:	1996.4.5										*/
/*	Note		:@ǂǂeXg[h@xZNg				*/
/********************************************************************/

/*==================================================================*/
/*	Include															*/
/*==================================================================*/
#include	<rand.h>		/* bWCuBp 		*/
#include 	"lt_all.h"
#include	"s_work.h"
#include	"s_trans.h"
#include 	"s_color.h"
#include 	"sprite.h"

#include	"q_gdata.h"
#include	"q_sprite.h"
#include 	"l_kanji.h"
#include	"s_obj.h"
#include	"s_objset.h"
#include	"sd_call.h"
#include	"sdcall.h"

#include	"u_lev.h"
#include	"get_opdc.h"
#include	"mizu.h"

/*==================================================================*/
/*	define											                */
/*==================================================================*/

/*	TIM	̕\ʒu	*/
#define		S10_X	-160+41
#define		S10_Y	-120+16+25
#define		S20_X	-160+41
#define		S20_Y	-120+16+30
#define		S11_X	-160+41
#define		S11_Y	-120+16+134
#define		K10_X	-160+15
#define		K10_Y	-120+16+5
#define		K20_X	-160+15
#define		K20_Y	-120+16+5
#define		K11_X	-160+15
#define		K11_Y	-120+16+72
#define		K21_X	-160+15
#define		K21_Y	-120+16+72
#define		K12_X	-160+15
#define		K12_Y	-120+16+139
#define		K22_X	-160+15
#define		K22_Y	-120+16+139

/*@Q[TuXebvils_step)̂߂define@*/
enum{
	LS_INIT,
	LS_FADEIN,
	LS_FADEWAIT,
	LS_TOJO,
	LS_SETUMEI,
	LS_MAIN,
	LS_EXIT,
};

/*@SPRITÊ߂define@*/
enum{
	S_1,
	S_2,
	S_3,
	K_10,
	K_11,
	K_12,
	K_20,
	K_21,
	K_22,
	LS_SPRITE_MAX,
};

/*	OPD_Ŵ߂define	*/
enum{
	SCE_2,
	SCE_3A,
	SCE_3B,
	SCE_4,
	SCE_SE,
	D_TIT,
	LS_OPDW_MAX,
};

/*==================================================================*/
/*  \̂̐錾													*/
/*==================================================================*/
/*==================================================================*/
/*  ϐ錾														*/
/*==================================================================*/
static	char			ls_step;	/*LEVEL SELECT	STEP*/
static	char			local_step;	/*LEVEL SELECT	LOCAL STEP*/
static	char			level;		/*LEVEL*/
static	char			setumei_flg;
static	short			cursor;
static	_QUIZ_SPRITE	sprite[LS_SPRITE_MAX];
static	OPD_W			*ls_opd[LS_OPDW_MAX];
static	POLY_G4			back;

/*==================================================================*/
/*	vg^Cv錾												*/
/*==================================================================*/
static void	trans_tpage	(void);
static void	screen_init	(void);
static void	back_init	(void);
static char	daio_tojo	(void);
static char	daio_setumei(void);
static void	levsel_main	(void);

/*==================================================================*/
/*	vO														*/
/*==================================================================*/
void u_lev_init()
{
	bzero( (char *)sprite,	sizeof(sprite) );
	ls_step	= LS_INIT;
	level	= 0;
	setumei_flg = OFF;	/*𕷂H@ON:@OFF:Ȃ*/
	cursor	= K_22;
}

char u_lev_main()
{
	short	i;
	char	tmp;
	
	switch(ls_step){
		case LS_INIT:
			trans_tpage();
			back_init();
			screen_init();
			ls_step = LS_FADEIN;
			break;
			
		case LS_FADEIN:
			S_fadein_black();
			ls_step = LS_FADEWAIT;
			break;
			
		case LS_FADEWAIT:
			if(M_fade_flag() == OFF){
				local_step = 0;
				ls_step = LS_TOJO;
			}
			break;
			
		case LS_TOJO:
			tmp = daio_tojo();
			if( tmp != 0 )	local_step = 0;
			if( tmp == 1 )	ls_step = LS_SETUMEI;
			if( tmp == 2 )	ls_step = LS_MAIN;
			break;
			
		case LS_SETUMEI:
			if( daio_setumei() ){
				local_step = 0;
				ls_step = LS_MAIN;
			}
			break;
			
		case LS_MAIN:
			levsel_main();
			if( level != 0 )	ls_step = LS_EXIT;
			break;
		
		case LS_EXIT:
			return	level;
			break;
	}
	
	for( i=0; i<LS_SPRITE_MAX; i++ ){
		if( sprite[i].prim.state == ON ){
			GsSortFastSprite(&(sprite[i].prim.sprite), 
				(GsOT *)&Wot[sprite[i].sOt][M_activebuff()], 
					(u_short)sprite[i].prim.coord.vz);	
		}
	}
	
	/*	Of[VwiOTo^	*/
	GsSortPoly( &back, (GsOT *)&Wot[1][M_activebuff()], 60 );
	
	return 0;
}

/*------------------------------------------------------------------*/
/*		s֓]											*/
/*------------------------------------------------------------------*/
static void trans_tpage()
{
	RECT	rect;
	
	/*	sNA[	*/
	setRECT(&rect,320,0,704,256);
	ClearImage(&rect,0,0,0);
	setRECT(&rect,320,256,640,256);
	ClearImage(&rect,0,0,0);
	
	S_trans_set((u_long*)Q_GDATA_CSR_OUKAN_1,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_OUKAN_2,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_BODY_1,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_BODY_2,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_BODY_3,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_0,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_1,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_4,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_5,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_7,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_8,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_9,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_15,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_16,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_19,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_21,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_22,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_LIP_0,		1);
	S_trans_set((u_long*)Q_GDATA_CSR_LIP_1,		1);
	S_trans_set((u_long*)Q_GDATA_CSR_LIP_6,		1);
	S_trans_set((u_long*)Q_GDATA_CSR_HANDR_0,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_HANDR_1,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_HANDR_2,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_HANDR_5,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_HANDR_7,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_HANDL_0,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_HANDL_5,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_HANDL_7,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_HANDL_8,	1);
	S_trans_set((u_long*)Q_GDATA_COL_OHCHAN,	1);
	
	S_trans_set((u_long*)Q_GDATA_CSR_Q_SETU0,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_Q_SETU1,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_Q_SETU2,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_Q_SETU3,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_Q_SETU4,	1);
	S_trans_set((u_long*)Q_GDATA_COL_Q_KURUN,	1);
	
	S_trans_set((u_long*)Q_GDATA_TIM_SETU_P1,	1);
	S_trans_set((u_long*)Q_GDATA_TIM_SETU_P2,	1);
	S_trans_set((u_long*)Q_GDATA_TIM_KYU_P1,	1);
	S_trans_set((u_long*)Q_GDATA_TIM_KYU_P2,	1);
	S_trans_set((u_long*)Q_GDATA_COL_M_PR,		1);
	
	S_trans_set((u_long*)Q_GDATA_CSR_D_TIT1,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_D_TIT2,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_D_TIT3,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_D_KYU,		1);
	S_trans_set((u_long*)Q_GDATA_COL_D_TIT,		1);
}

/*------------------------------------------------------------------*/
/*		c`s`̂hmhs												*/
/*------------------------------------------------------------------*/
static void back_init ()
{
	SetPolyG4( &back );
	setRGB0( &back, 0xa1, 0xc4, 0xf0 );
	setRGB1( &back, 0xa1, 0xc4, 0xf0 );
	setRGB2( &back, 0x29, 0x63, 0xf8 );
	setRGB3( &back, 0x29, 0x63, 0xf8 );
	setXY4(  &back, -160,-120+16, 160,-120+16, -160,120-16, 160,120-16 );
}

/*------------------------------------------------------------------*/
/*		c`s`̂hmhs												*/
/*------------------------------------------------------------------*/
static void screen_init ()
{
	/*	SETU_P1 ̓o^	pl̖_*/
	setVector(&(sprite[S_1].prim.coord), S10_X, S10_Y, PRI09	);
	InitSprite(&sprite[S_1].prim,(u_long*)Q_GDATA_TIM_SETU_P1,ONE);
	sprite[S_1].sOt = 2;
	sprite[S_1].prim.state = OFF;
	
	/*	SETU_P2 ̓o^	pl{[h*/
	setVector(&(sprite[S_2].prim.coord), S20_X, S20_Y, PRI09	);
	InitSprite(&sprite[S_2].prim,(u_long*)Q_GDATA_TIM_SETU_P2,ONE);
	sprite[S_2].sOt = 2;
	sprite[S_2].prim.state = OFF;
	
	/*	SETU_P2 ̓o^	pl̖_*/
	setVector(&(sprite[S_3].prim.coord), S11_X, S11_Y, PRI09	);
	InitSprite(&sprite[S_3].prim,(u_long*)Q_GDATA_TIM_SETU_P1,ONE);
	sprite[S_3].sOt = 2;
	sprite[S_3].prim.state = OFF;
	
	/*	KYU_P1 ̓o^	㋉ppl*/
	setVector(&(sprite[K_10].prim.coord), K10_X, K10_Y, PRI08	);
	InitSprite(&sprite[K_10].prim,(u_long*)Q_GDATA_TIM_KYU_P1,ONE);
	sprite[K_10].sOt = 2;
	sprite[K_10].prim.state = OFF;
	
	/*	KYU_P2 ̓o^	㋉ppl*/
	setVector(&(sprite[K_20].prim.coord), K20_X, K20_Y, PRI09	);
	InitSprite(&sprite[K_20].prim,(u_long*)Q_GDATA_TIM_KYU_P2,ONE);
	sprite[K_20].sOt = 2;
	sprite[K_20].prim.state = OFF;
	
	/*	KYU_P1 ̓o^	ppl*/
	setVector(&(sprite[K_11].prim.coord), K11_X, K11_Y, PRI08	);
	InitSprite(&sprite[K_11].prim,(u_long*)Q_GDATA_TIM_KYU_P1,ONE);
	sprite[K_11].sOt = 2;
	sprite[K_11].prim.state = OFF;
	
	/*	KYU_P2 ̓o^	ppl*/
	setVector(&(sprite[K_21].prim.coord), K21_X, K21_Y, PRI09	);
	InitSprite(&sprite[K_21].prim,(u_long*)Q_GDATA_TIM_KYU_P2,ONE);
	sprite[K_21].sOt = 2;
	sprite[K_21].prim.state = OFF;
	
	/*	KYU_P1 ̓o^	ppl*/
	setVector(&(sprite[K_12].prim.coord), K12_X, K12_Y, PRI08	);
	InitSprite(&sprite[K_12].prim,(u_long*)Q_GDATA_TIM_KYU_P1,ONE);
	sprite[K_12].sOt = 2;
	sprite[K_12].prim.state = OFF;
	
	/*	KYU_P2 ̓o^	ppl*/
	setVector(&(sprite[K_22].prim.coord), K22_X, K22_Y, PRI09	);
	InitSprite(&sprite[K_22].prim,(u_long*)Q_GDATA_TIM_KYU_P2,ONE);
	sprite[K_22].sOt = 2;
	sprite[K_22].prim.state = OFF;
}

/*------------------------------------------------------------------*/
/*		䉤@o													*/
/*------------------------------------------------------------------*/
static char	daio_tojo	(void)
{
	switch(local_step){
		case 0:	/*scene_2.opdo^*/
			ls_opd[SCE_2] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
						(int)sizeof(OPD_W),(u_short)1);
			ls_opd[SCE_2]->ot = 3;
			ls_opd[SCE_2]->opd_address = Q_GDATA_OPD_SCENE_2;
			ls_opd[SCE_2]->center_x = -160;
			ls_opd[SCE_2]->center_y = -120+16;
			O_OPD_W_INIT(ls_opd[SCE_2], 0);
			local_step++;
			break;
		
		case 1: /*oAj*/
			if ( (getOpdCommand(ls_opd[SCE_2])==OPD_CMD_STOP) &&
				((long)(ls_opd[SCE_2]->timer)==0) )
			{
				O_opd_anime_change( ls_opd[SCE_2], 2 );
				local_step++;
			}
			break;
			
		case 2:	/*H@҂*/
			if( M_joy_trg(0) & PADRright ){	
				setumei_flg = ON;
				return 1;/**/
			}
			if( M_joy_trg(0) & PADRdown  ){
				setumei_flg = OFF;
				return 2;/*Ȃ*/
			}
			/*䉤@ڃp`Aj*/
			if( rand()%200 == 3 )
				O_opd_anime_change( ls_opd[SCE_2], 2 );
			break;
	}
	return 0;
}

/*------------------------------------------------------------------*/
/*		䉤@												*/
/*------------------------------------------------------------------*/
static char	daio_setumei(void)
{
	switch(local_step){
		case 0:	/*[I*/
			/*scene_3a.opdo^*/
			ls_opd[SCE_3A] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
						(int)sizeof(OPD_W),(u_short)1);
			ls_opd[SCE_3A]->ot = 3;
			ls_opd[SCE_3A]->opd_address = Q_GDATA_OPD_SCENE_3A;
			ls_opd[SCE_3A]->center_x = -160;
			ls_opd[SCE_3A]->center_y = -120+16;
			/*[IAj*/
			O_OPD_W_INIT(ls_opd[SCE_3A], 0);
			
			ls_opd[SCE_2]->terminate_flag = ON;
			local_step++;
			break;
		
		case 1: /*plo*/
			if( (getOpdCommand(ls_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(ls_opd[SCE_3A]->timer)==0) )
			{
				/*scene_se.opdo^*/
				ls_opd[SCE_SE] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
							(int)sizeof(OPD_W),(u_short)1);
				ls_opd[SCE_SE]->ot = 3;
				ls_opd[SCE_SE]->opd_address = Q_GDATA_OPD_SCENE_SE;
				ls_opd[SCE_SE]->center_x = -160;
				ls_opd[SCE_SE]->center_y = -120+16;
				/*ploAj*/
				O_OPD_W_INIT(ls_opd[SCE_SE], 0);
				
				/*䉤Aj*/
				O_opd_anime_change( ls_opd[SCE_3A], 1 );
				local_step++;
			}
			break;
			
		case 2: /*̂P*/
			if( (getOpdCommand(ls_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(ls_opd[SCE_3A]->timer)==0) )
			{
				/*setu_p1.tim & setu_p2.tim@pl\*/
				sprite[S_1].prim.state = ON;
				sprite[S_2].prim.state = ON;
				sprite[S_3].prim.state = ON;
				
				/*scene_se.opd@pl*/
				ls_opd[SCE_SE]->terminate_flag = ON;
				
				/*scene_3b.opdo^*/
				ls_opd[SCE_3B] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
							(int)sizeof(OPD_W),(u_short)1);
				ls_opd[SCE_3B]->ot = 3;
				ls_opd[SCE_3B]->opd_address = Q_GDATA_OPD_SCENE_3B;
				ls_opd[SCE_3B]->center_x = -160;
				ls_opd[SCE_3B]->center_y = -120+16;
				/*plF̂PAj*/
				O_OPD_W_INIT(ls_opd[SCE_3B], 0);
				
				/*䉤F̂PAj*/
				O_opd_anime_change( ls_opd[SCE_3A], 2 );
				local_step++;
			}
			break;
			
		case 3: /*̂Q*/
			if( (getOpdCommand(ls_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(ls_opd[SCE_3A]->timer)==0) )
			{
				/*䉤F̂QAj*/
				O_opd_anime_change( ls_opd[SCE_3A], 3 );
				/*plF̂QAj*/
				O_opd_anime_change( ls_opd[SCE_3B], 1 );
				local_step++;
			}
			break;
			
		case 4: /*̂R*/
			if( (getOpdCommand(ls_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(ls_opd[SCE_3A]->timer)==0) )
			{
				/*䉤F̂RAj*/
				O_opd_anime_change( ls_opd[SCE_3A], 4 );
				/*plF̂RAj*/
				O_opd_anime_change( ls_opd[SCE_3B], 2 );
				local_step++;
			}
			break;
			
		case 5: /*̂S*/
			if( (getOpdCommand(ls_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(ls_opd[SCE_3A]->timer)==0) )
			{
				/*䉤F̂SAj*/
				O_opd_anime_change( ls_opd[SCE_3A], 5 );
				/*plF̂SAj*/
				O_opd_anime_change( ls_opd[SCE_3B], 3 );
				local_step++;
			}
			break;
			
		case 6: /*̂T*/
			if( (getOpdCommand(ls_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(ls_opd[SCE_3A]->timer)==0) )
			{
				/*䉤F̂TAj*/
				O_opd_anime_change( ls_opd[SCE_3A], 6 );
				/*plF̂TAj*/
				O_opd_anime_change( ls_opd[SCE_3B], 4 );
				local_step++;
			}
			break;
			
		case 7: /*plޏ*/
			if( (getOpdCommand(ls_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(ls_opd[SCE_3A]->timer)==0) )
			{
				/*scene_3b.opd@*/
				ls_opd[SCE_3B]->terminate_flag = ON;
				
				/*scene_se.opdo^*/
				ls_opd[SCE_SE] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
							(int)sizeof(OPD_W),(u_short)1);
				ls_opd[SCE_SE]->ot = 3;
				ls_opd[SCE_SE]->opd_address = Q_GDATA_OPD_SCENE_SE;
				ls_opd[SCE_SE]->center_x = -160;
				ls_opd[SCE_SE]->center_y = -120+16;
				/*plޏAj*/
				O_OPD_W_INIT(ls_opd[SCE_SE], 1);
				
				/*䉤Aj*/
				O_opd_anime_change( ls_opd[SCE_3A], 7 );
				
				/*setu_p1.tim & setu_p2.tim@pl*/
				sprite[S_1].prim.state = OFF;
				sprite[S_2].prim.state = OFF;
				sprite[S_3].prim.state = OFF;
				
				local_step++;
			}
			break;
			
		case 8:/*I*/
			if( (getOpdCommand(ls_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(ls_opd[SCE_3A]->timer)==0) )
			{
				/*scene_se.opd@*/
				ls_opd[SCE_SE]->terminate_flag = ON;
				return 1;
			}
			break;
	}
	return 0;
}

/*------------------------------------------------------------------*/
/*		xZNĝl`hm										*/
/*------------------------------------------------------------------*/
static void levsel_main	()
{
	switch(local_step){
		case 0:	/*ǂɂH*/
			/*xpl@ʊOɕ\*/
			sprite[K_10].prim.sprite.x = K10_X - 128;
			sprite[K_20].prim.sprite.x = K20_X - 128;
			sprite[K_11].prim.sprite.x = K11_X - 128;
			sprite[K_21].prim.sprite.x = K21_X - 128;
			sprite[K_12].prim.sprite.x = K12_X - 128;
			sprite[K_22].prim.sprite.x = K22_X - 128;
			sprite[K_10].prim.state = ON;
			sprite[K_20].prim.state = ON;
			sprite[K_11].prim.state = ON;
			sprite[K_21].prim.state = ON;
			sprite[K_12].prim.state = ON;
			sprite[K_22].prim.state = ON;
			/*J[\̃ftHg̈ʒu͏*/
			sprite[K_22].prim.sprite.cx = 304;
			
			/*scene_3a.opdo^*/
			ls_opd[SCE_4] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
						(int)sizeof(OPD_W),(u_short)1);
			ls_opd[SCE_4]->ot = 3;
			ls_opd[SCE_4]->opd_address = Q_GDATA_OPD_SCENE_4;
			ls_opd[SCE_4]->center_x = -160;
			ls_opd[SCE_4]->center_y = -120+16;
			/*ǂɂHAj*/
			O_OPD_W_INIT(ls_opd[SCE_4], 0);
			
			/*Ȏ䉤opd*/
			switch( setumei_flg ){
				case ON:	ls_opd[SCE_3A]->terminate_flag = ON; break;
				case OFF:	ls_opd[SCE_2]->terminate_flag  = ON; break;
			}
			local_step++;
			break;
			
		case 1:	/*xplo*/
			if( sprite[K_10].prim.sprite.x < K10_X ){
				sprite[K_10].prim.sprite.x++;
				sprite[K_20].prim.sprite.x++;
				sprite[K_11].prim.sprite.x++;
				sprite[K_21].prim.sprite.x++;
				sprite[K_12].prim.sprite.x++;
				sprite[K_22].prim.sprite.x++;
			}
			else	local_step++;
			break;
			
		case 2:	/*xI*/
			if( M_joy_trg(0) & PADLup	){
				sprite[cursor].prim.sprite.cx = 288;
				if( cursor == K_20 )	cursor = K_22;
				else					cursor--;
				sprite[cursor].prim.sprite.cx = 304;
				goto END;
			}
			if( M_joy_trg(0) & PADLdown	){
				sprite[cursor].prim.sprite.cx = 288;
				if( cursor == K_22 )	cursor = K_20;
				else					cursor++;
				sprite[cursor].prim.sprite.cx = 304;
				goto END;
			}
			
			if( M_joy_trg(0) & PADRright	)	local_step++;
			END:
			break;
			
		case 3:	/*tF[hAEg*/
			S_fadeout_black();
			local_step++;
			break;
			
		case 4:	/*tF[hAEg҂*/
			if(M_fade_flag() == OFF){
				ls_opd[SCE_4]->terminate_flag = ON;
				local_step++;
			}
			break;
			
		case 5:	/*eXg\\tF[hC*/
			/*xpl*/
			sprite[K_10].prim.state = OFF;
			sprite[K_20].prim.state = OFF;
			sprite[K_11].prim.state = OFF;
			sprite[K_21].prim.state = OFF;
			sprite[K_12].prim.state = OFF;
			sprite[K_22].prim.state = OFF;
			/*wi𔒂ɂ*/
			setRGB0( &back, 0xff, 0xff, 0xff );
			setRGB1( &back, 0xff, 0xff, 0xff );
			setRGB2( &back, 0xff, 0xff, 0xff );
			setRGB3( &back, 0xff, 0xff, 0xff );
			/*d_tits.opdo^*/
			ls_opd[D_TIT] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
					(int)sizeof(OPD_W),(u_short)1);
			ls_opd[D_TIT]->ot = 3;
			ls_opd[D_TIT]->opd_address = Q_GDATA_OPD_D_TITS;
			ls_opd[D_TIT]->center_x = -160;
			ls_opd[D_TIT]->center_y = -120+16;
			/*^Cg*/
			switch(cursor){
				case K_20:	O_OPD_W_INIT(ls_opd[D_TIT], 2); break;
				case K_21:	O_OPD_W_INIT(ls_opd[D_TIT], 1); break;
				case K_22:	O_OPD_W_INIT(ls_opd[D_TIT], 0); break;
			}
			S_fadein_black();
			local_step++;
			break;
			
		case 6:	/*tF[hC҂͑҂*/
			if(M_fade_flag() == OFF){
				if( M_joy_trg(0) & PADRright ){
					S_fadeout_black();
					local_step++;
				}
			}
			break;
			
		case 7:
			if(M_fade_flag() == OFF){
				ls_opd[D_TIT]->terminate_flag = ON;
				switch(cursor){
					case K_20:	level = 3;	break;	/*㋉*/
					case K_21:	level = 2;	break;	/**/
					case K_22:	level = 1;	break;	/**/
				}
			}
			break;
	}
}

