/***< file >*********************************************************/
/*	Title		:	PlayStation										*/
/*	Code		:	vx022											*/
/*	Filename	:	u_q2p.c											*/
/*	Author		:	usr01681 Mizutani								*/
/*	Date		:	1996.4.11										*/
/*	Note		:@ǂǂeXg[h@Ԕ\							*/
/********************************************************************/

/*==================================================================*/
/*	Include															*/
/*==================================================================*/
#include	<rand.h>		/* bWCuBp 		*/
#include 	"lt_all.h"
#include	"s_work.h"
#include	"s_trans.h"
#include 	"s_color.h"
#include 	"sprite.h"
#include	"s_obj.h"
#include	"s_objset.h"

#include	"q_gdata.h"
#include	"q_sprite.h"
#include 	"l_kanji.h"
#include	"sd_call.h"
#include	"sdcall.h"

#include	"u_q2p.h"
#include	"get_opdc.h"
#include	"mizu.h"

/*==================================================================*/
/*	define											                */
/*==================================================================*/

/*@Q[TuXebviq2p_step)̂߂define@*/
enum{
	Q2P_INIT,
	Q2P_FADEIN,
	Q2P_FADEWAIT,
	Q2P_HANTEI,
	Q2P_ASK,
	Q2P_SETUMEI,
	Q2P_TITLE_INIT,
	Q2P_TITLE,
	Q2P_EXIT,
};

/*@SPRITÊ߂define@*/
enum{
	S_1,
	S_2,
	S_3,
	Q2P_SPRITE_MAX,
};

/*	OPD_Ŵ߂define	*/
enum{
	SCE_2,
	SCE_3A,
	SCE_3B,
	SCE_SE,
	D_TIT,
	Q2P_OPDW_MAX,
};

/*	TIM	̕\ʒu	*/
#define		S10_X	-160+41
#define		S10_Y	-120+16+25
#define		S20_X	-160+41
#define		S20_Y	-120+16+30
#define		S11_X	-160+41
#define		S11_Y	-120+16+134

/*==================================================================*/
/*  \̂̐錾													*/
/*==================================================================*/
typedef struct{
	char		level;
	short		mochidama;
}	_STATUS;


/*==================================================================*/
/*  ϐ錾														*/
/*==================================================================*/
static	char			q2p_step;
static	char			local_step;
static	char			setumei_flg;
static	_QUIZ_SPRITE	Sprite[Q2P_SPRITE_MAX];
static	OPD_W			*q2p_opd[Q2P_OPDW_MAX];
static	POLY_G4			back;
static	_STATUS			Status;

/*==================================================================*/
/*	vg^Cv錾												*/
/*==================================================================*/
static void	trans_tpage	(void);
static void	screen_init	(void);
static void	back_init	(void);
static void	tit_init	(void);
static void	opdw_clear	(void);
static void	hantei_main	(void);
static char	daio_ask	(void);
static char	daio_setumei(void);

/*==================================================================*/
/*	vO														*/
/*==================================================================*/
void u_q2p_init(char level, short mochidama)
{
	bzero( (char *)Sprite,	sizeof(Sprite) );
	bzero( (char *)&Status,	sizeof(Status) );
	q2p_step	= Q2P_INIT;
	setumei_flg = OFF;
	local_step	= 0;
	Status.level = level;
	Status.mochidama = mochidama;
}

char u_q2p_main()
{
	short	i;
	
	switch(q2p_step){
		case Q2P_INIT:
			trans_tpage();
			screen_init();
			back_init();
			q2p_step = Q2P_FADEIN;
			break;
			
		case Q2P_FADEIN:
			S_fadein_black();
			q2p_step = Q2P_FADEWAIT;
			break;
			
		case Q2P_FADEWAIT:
			if(M_fade_flag() == OFF){
				local_step = 0;
				q2p_step = Q2P_HANTEI;
			}
			break;
			
		case Q2P_HANTEI:
			hantei_main();
			q2p_step = Q2P_ASK;
			break;
			
		case Q2P_ASK:
			switch( daio_ask() ){
				case 1:	
					local_step = 0;
					setumei_flg = ON;
					q2p_step = Q2P_SETUMEI;
					break;
				case 2:	
					local_step = 0;
					setumei_flg = OFF;
					S_fadeout_black();
					q2p_step = Q2P_TITLE_INIT;
					break;
			}
			break;
			
		case Q2P_SETUMEI:
			if( daio_setumei() ){
				local_step = 0;
				S_fadeout_black();
				q2p_step = Q2P_TITLE_INIT;
			}
			break;
			
			
		case Q2P_TITLE_INIT:
			if(M_fade_flag() == OFF){
				tit_init();
				S_fadein_black();
				q2p_step = Q2P_TITLE;
			}
			break;
			
		case Q2P_TITLE:
			if(M_fade_flag() == OFF){
				if( M_joy_trg(0) & PADRright ){
					S_fadeout_black();
					q2p_step = Q2P_EXIT;
				}
			}
			break;
			
			
		case Q2P_EXIT:
			if(M_fade_flag() == OFF){
				U_status( Status.level, Status.mochidama, NULL, NULL );
				opdw_clear();
				return	1;
			}
			break;
	}
	
	for( i=0; i<Q2P_SPRITE_MAX; i++ ){
		if( Sprite[i].prim.state == ON ){
			GsSortFastSprite(&(Sprite[i].prim.sprite), 
				(GsOT *)&Wot[Sprite[i].sOt][M_activebuff()], 
					(u_short)Sprite[i].prim.coord.vz);	
		}
	}
	
	/*	Of[VwiOTo^	*/
	GsSortPoly( &back, (GsOT *)&Wot[1][M_activebuff()], 60 );
	
	NFntPrint("Q2P = %d\n",Status.mochidama);
	NFntPrint("q2p_step = %d\n",q2p_step);
	NFntPrint("LOCAL   = %d\n",local_step);
	return 0;
}

/*------------------------------------------------------------------*/
/*		s֓]											*/
/*------------------------------------------------------------------*/
static void trans_tpage()
{
	RECT	rect;
	
	/*	sNA[	*/
	setRECT(&rect,320,0,448,256);
	ClearImage(&rect,0,0,0);
	setRECT(&rect,320,256,192,256);
	ClearImage(&rect,0,0,0);
	
	S_trans_set((u_long*)Q_GDATA_TIM_SETU_P1,	1);
	S_trans_set((u_long*)Q_GDATA_TIM_SETU_P2,	1);
}

/*------------------------------------------------------------------*/
/*		wîhmhs												*/
/*------------------------------------------------------------------*/
static void back_init ()
{
	SetPolyG4( &back );
	setRGB0( &back, 0xa1, 0xc4, 0xf0 );
	setRGB1( &back, 0xa1, 0xc4, 0xf0 );
	setRGB2( &back, 0x29, 0x63, 0xf8 );
	setRGB3( &back, 0x29, 0x63, 0xf8 );
	setXY4(  &back, -160,-120+16, 160,-120+16, -160,120-16, 160,120-16 );
}

/*------------------------------------------------------------------*/
/*		c`s`̂hmhs											*/
/*------------------------------------------------------------------*/
static void screen_init ()
{
	/*	SETU_P1 ̓o^	pl̖_*/
	setVector(&(Sprite[S_1].prim.coord), S10_X, S10_Y, PRI09	);
	InitSprite(&Sprite[S_1].prim,(u_long*)Q_GDATA_TIM_SETU_P1,ONE);
	Sprite[S_1].sOt = 2;
	Sprite[S_1].prim.state = OFF;
	
	/*	SETU_P2 ̓o^	pl{[h*/
	setVector(&(Sprite[S_2].prim.coord), S20_X, S20_Y, PRI09	);
	InitSprite(&Sprite[S_2].prim,(u_long*)Q_GDATA_TIM_SETU_P2,ONE);
	Sprite[S_2].sOt = 2;
	Sprite[S_2].prim.state = OFF;
	
	/*	SETU_P2 ̓o^	pl̖_*/
	setVector(&(Sprite[S_3].prim.coord), S11_X, S11_Y, PRI09	);
	InitSprite(&Sprite[S_3].prim,(u_long*)Q_GDATA_TIM_SETU_P1,ONE);
	Sprite[S_3].sOt = 2;
	Sprite[S_3].prim.state = OFF;
}

/*------------------------------------------------------------------*/
/*		ZeXg^Cgʂ								*/
/*------------------------------------------------------------------*/
static void	tit_init()
{
	/*䉤OPD*/
	if( setumei_flg == ON )	q2p_opd[SCE_3A]->terminate_flag = ON;
	else					q2p_opd[SCE_2 ]->terminate_flag = ON;
	
	/*wi𔒂ɂ*/
	setRGB0( &back, 0xff, 0xff, 0xff );
	setRGB1( &back, 0xff, 0xff, 0xff );
	setRGB2( &back, 0xff, 0xff, 0xff );
	setRGB3( &back, 0xff, 0xff, 0xff );
	
	/*d_tits.opdo^*/
	q2p_opd[D_TIT] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
		(int)sizeof(OPD_W),(u_short)1);
	q2p_opd[D_TIT]->ot = 3;
	q2p_opd[D_TIT]->opd_address = Q_GDATA_OPD_D_TITS;
	q2p_opd[D_TIT]->center_x = -160;
	q2p_opd[D_TIT]->center_y = -120+16;
	
	/*^Cg*/
	switch(Status.level){
		case 1:	O_OPD_W_INIT(q2p_opd[D_TIT], 3); break;	/**/
		case 2:	O_OPD_W_INIT(q2p_opd[D_TIT], 4); break;	/**/
		case 3:	O_OPD_W_INIT(q2p_opd[D_TIT], 5); break;	/*㋉*/
	}
}

/*------------------------------------------------------------------*/
/*		nocQv̂bkd`q										*/
/*------------------------------------------------------------------*/
static void opdw_clear	()
{
	short	i;
	
	for( i = 0; i < Q2P_OPDW_MAX; i++ ){
		q2p_opd[i]->terminate_flag = ON;
	}
}

/*------------------------------------------------------------------*/
/*		Ԕ@MAIN												*/
/*------------------------------------------------------------------*/
static	void hantei_main()
{
	/*	ʂOȉ@@@Q[I[o[	*/
	if( Status.mochidama <= 0 ){
		Status.mochidama = 0;
	}
	/*	ʂPOOOPOOOɂ	*/
	else if( Status.mochidama < 1000 ){
		Status.mochidama = 1000;
	}
}

/*------------------------------------------------------------------*/
/*		䉤@𕷂˂									*/
/*------------------------------------------------------------------*/
static char	daio_ask	(void)
{
	switch(local_step){
		case 0:	/*scene_2.opdo^*/
			q2p_opd[SCE_2] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
						(int)sizeof(OPD_W),(u_short)1);
			q2p_opd[SCE_2]->ot = 3;
			q2p_opd[SCE_2]->opd_address = Q_GDATA_OPD_SCENE_2;
			q2p_opd[SCE_2]->center_x = -160;
			q2p_opd[SCE_2]->center_y = -120+16;
			O_OPD_W_INIT(q2p_opd[SCE_2], 1);
			local_step++;
			break;
		
		case 1: /*u𕷂HvAj*/
			if ( (getOpdCommand(q2p_opd[SCE_2])==OPD_CMD_STOP) &&
				((long)(q2p_opd[SCE_2]->timer)==0) )
			{
				O_opd_anime_change( q2p_opd[SCE_2], 2 );
				local_step++;
			}
			break;
			
		case 2:	/*H@҂*/
			if( M_joy_trg(0) & PADRright )		return 1;/**/
			if( M_joy_trg(0) & PADRdown  )		return 2;/*Ȃ*/
			/*䉤@ڃp`Aj*/
			if( rand()%200 == 3 ){
				O_opd_anime_change( q2p_opd[SCE_2], 2 );
			}
			break;
	}
	return 0;
}

/*------------------------------------------------------------------*/
/*		䉤@												*/
/*------------------------------------------------------------------*/
static char	daio_setumei(void)
{
	switch(local_step){
		case 0:	/*[I*/
			/*scene_3a.opdo^*/
			q2p_opd[SCE_3A] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
						(int)sizeof(OPD_W),(u_short)1);
			q2p_opd[SCE_3A]->ot = 3;
			q2p_opd[SCE_3A]->opd_address = Q_GDATA_OPD_SCENE_3A;
			q2p_opd[SCE_3A]->center_x = -160;
			q2p_opd[SCE_3A]->center_y = -120+16;
			/*[IAj*/
			O_OPD_W_INIT(q2p_opd[SCE_3A], 0);
			
			q2p_opd[SCE_2]->terminate_flag = ON;
			local_step++;
			break;
		
		case 1: /*plo*/
			if( (getOpdCommand(q2p_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(q2p_opd[SCE_3A]->timer)==0) )
			{
				/*scene_se.opdo^*/
				q2p_opd[SCE_SE] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
							(int)sizeof(OPD_W),(u_short)1);
				q2p_opd[SCE_SE]->ot = 3;
				q2p_opd[SCE_SE]->opd_address = Q_GDATA_OPD_SCENE_SE;
				q2p_opd[SCE_SE]->center_x = -160;
				q2p_opd[SCE_SE]->center_y = -120+16;
				/*ploAj*/
				O_OPD_W_INIT(q2p_opd[SCE_SE], 0);
				
				/*䉤Aj*/
				O_opd_anime_change( q2p_opd[SCE_3A], 1 );
				local_step++;
			}
			break;
			
		case 2: /*̂P*/
			if( (getOpdCommand(q2p_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(q2p_opd[SCE_3A]->timer)==0) )
			{
				/*setu_p1.tim & setu_p2.tim@pl\*/
				Sprite[S_1].prim.state = ON;
				Sprite[S_2].prim.state = ON;
				Sprite[S_3].prim.state = ON;
				
				/*scene_se.opd@pl*/
				q2p_opd[SCE_SE]->terminate_flag = ON;
				
				/*scene_3b.opdo^*/
				q2p_opd[SCE_3B] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
							(int)sizeof(OPD_W),(u_short)1);
				q2p_opd[SCE_3B]->ot = 3;
				q2p_opd[SCE_3B]->opd_address = Q_GDATA_OPD_SCENE_3B;
				q2p_opd[SCE_3B]->center_x = -160;
				q2p_opd[SCE_3B]->center_y = -120+16;
				/*plF̂PAj*/
				O_OPD_W_INIT(q2p_opd[SCE_3B], 0);
				
				/*䉤F̂PAj*/
				O_opd_anime_change( q2p_opd[SCE_3A], 2 );
				local_step++;
			}
			break;
			
		case 3: /*̂Q*/
			if( (getOpdCommand(q2p_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(q2p_opd[SCE_3A]->timer)==0) )
			{
				/*䉤F̂QAj*/
				O_opd_anime_change( q2p_opd[SCE_3A], 3 );
				/*plF̂QAj*/
				O_opd_anime_change( q2p_opd[SCE_3B], 1 );
				local_step++;
			}
			break;
			
		case 4: /*̂R*/
			if( (getOpdCommand(q2p_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(q2p_opd[SCE_3A]->timer)==0) )
			{
				/*䉤F̂RAj*/
				O_opd_anime_change( q2p_opd[SCE_3A], 4 );
				/*plF̂RAj*/
				O_opd_anime_change( q2p_opd[SCE_3B], 2 );
				local_step++;
			}
			break;
			
		case 5: /*̂S*/
			if( (getOpdCommand(q2p_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(q2p_opd[SCE_3A]->timer)==0) )
			{
				/*䉤F̂SAj*/
				O_opd_anime_change( q2p_opd[SCE_3A], 5 );
				/*plF̂SAj*/
				O_opd_anime_change( q2p_opd[SCE_3B], 3 );
				local_step++;
			}
			break;
			
		case 6: /*̂T*/
			if( (getOpdCommand(q2p_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(q2p_opd[SCE_3A]->timer)==0) )
			{
				/*䉤F̂TAj*/
				O_opd_anime_change( q2p_opd[SCE_3A], 6 );
				/*plF̂TAj*/
				O_opd_anime_change( q2p_opd[SCE_3B], 4 );
				local_step++;
			}
			break;
			
		case 7: /*plޏ*/
			if( (getOpdCommand(q2p_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(q2p_opd[SCE_3A]->timer)==0) )
			{
				/*scene_3b.opd@*/
				q2p_opd[SCE_3B]->terminate_flag = ON;
				
				/*scene_se.opdo^*/
				q2p_opd[SCE_SE] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
							(int)sizeof(OPD_W),(u_short)1);
				q2p_opd[SCE_SE]->ot = 3;
				q2p_opd[SCE_SE]->opd_address = Q_GDATA_OPD_SCENE_SE;
				q2p_opd[SCE_SE]->center_x = -160;
				q2p_opd[SCE_SE]->center_y = -120+16;
				/*plޏAj*/
				O_OPD_W_INIT(q2p_opd[SCE_SE], 1);
				
				/*䉤Aj*/
				O_opd_anime_change( q2p_opd[SCE_3A], 7 );
				
				/*setu_p1.tim & setu_p2.tim@pl*/
				Sprite[S_1].prim.state = OFF;
				Sprite[S_2].prim.state = OFF;
				Sprite[S_3].prim.state = OFF;
				
				local_step++;
			}
			break;
			
		case 8:/*I*/
			if( (getOpdCommand(q2p_opd[SCE_3A])==OPD_CMD_STOP) &&
				((long)(q2p_opd[SCE_3A]->timer)==0) )
			{
				/*scene_se.opd@*/
				q2p_opd[SCE_SE]->terminate_flag = ON;
				return 1;
			}
			break;
	}
	return 0;
}

