/***< file >*********************************************************/
/*	Title		:	PlayStation										*/
/*	Code		:	vx022											*/
/*	Filename	:	u_result.c										*/
/*	Author		:	usr01681 Mizutani								*/
/*	Date		:	1996.5.15										*/
/*	Note		:@ǂǂeXg[h@ʔ\				*/
/********************************************************************/

/*==================================================================*/
/*	Include															*/
/*==================================================================*/
#include	<rand.h>		/* bWCuBp 		*/
#include 	"lt_all.h"
#include	"s_work.h"
#include	"s_trans.h"
#include 	"s_color.h"
#include 	"sprite.h"
#include	"udeda.h"
#include	"q_gdata.h"
#include	"q_sprite.h"
#include 	"l_kanji.h"
#include	"sd_call.h"
#include	"sdcall.h"

#include	"pachinko.h"
#include	"p_kugi.h"
#include	"get_opdc.h"
#include	"mizu.h"

/*==================================================================*/
/*	define											                */
/*==================================================================*/
#define		FNT_CX		0		/*\j[tHg̃J[pbg*/
#define		FNT_CY		480		/*\j[tHg̃J[pbg*/
#define		FNT_VRAMX	320		/*\j[tHg*/
#define		FNT_VRAMY	256		/*\j[tHg*/

/*@Q[TuXebvipsel_step)Ǘ@*/
enum{
	RES_TRANS,
	RES_INIT,
	RES_FADEIN,
	RES_FADEWAIT,
	RES_TITLE,
	RES_TITLE_OUT,
	RES_MAIN_IN,
	RES_MAIN,
	RES_EXIT,
};

/*@SPRITÊ߂define@*/
enum{
	Q_HANTEI,
	P_HANTEI,
	RES_SPRITE_MAX,
};

/*	OPD_Ŵ߂define	*/
enum{
	TITLE,
	HAPPYOU,
	SCENE_8,
	RES_OPDW_MAX,
};

/*==================================================================*/
/*  \̂̐錾													*/
/*==================================================================*/
typedef struct{
	char	Q_hantei;	/*NCY*/
	char	P_hantei;	/*Z@*/
	char	T_hantei;	/*@*/
} _HANTEI;

/*==================================================================*/
/*  ϐ錾														*/
/*==================================================================*/
static	char			res_step;
static	char			local_step;
static	_QUIZ_SPRITE	Sprite[RES_SPRITE_MAX];
static	OPD_W			*res_opd[RES_OPDW_MAX];
static	POLY_G4			back;
static	_HANTEI			Hantei;

/*==================================================================*/
/*	vg^Cv錾												*/
/*==================================================================*/
static void	trans_tpage	(void);
static void	screen_init1(void);
static void	screen_init2(void);
static void opdw_clear	(void);
static void	back_init	(void);
static char	hantei_main	(void);

/*==================================================================*/
/*	vO														*/
/*==================================================================*/
void result_init()
{
	bzero( (char *)Sprite,	sizeof(Sprite) );
	res_step	= RES_TRANS;
	local_step	= 0;
}

char result_main()
{
	short	i;
	
	switch(res_step){
		case RES_TRANS:
			trans_tpage();
			S_fadeout_black();
			res_step = RES_INIT;
			break;
			
		case RES_INIT:
			if(M_fade_flag() == OFF){
				back_init();
				screen_init1();
				res_step = RES_FADEIN;
			}
			break;
			
		case RES_FADEIN:
			S_fadein_black();
			res_step = RES_FADEWAIT;
			break;
			
		case RES_FADEWAIT:
			if(M_fade_flag() == OFF){
				local_step = 0;
				res_step = RES_TITLE;
			}
			break;
			
		case RES_TITLE:
			if( M_joy_trg(0) & PADRright ){
				S_fadeout_black();
				res_step = RES_TITLE_OUT;
			}
			break;
			
		case RES_TITLE_OUT:
			if(M_fade_flag() == OFF){
				res_opd[TITLE]->terminate_flag = ON;
				screen_init2();
				S_fadein_black();
				res_step = RES_MAIN_IN;
			}
			break;
			
		case RES_MAIN_IN:
			if(M_fade_flag() == OFF){
				res_step = RES_MAIN;
			}
			break;
			
		case RES_MAIN:
			NFntPrint("RESULT\n");
			if( hantei_main() ){
				S_fadeout_black();
				res_step = RES_EXIT;
			}
			break;
			
		case RES_EXIT:
			if(M_fade_flag() == OFF){
				opdw_clear();
				return	1;
			}
			break;
	}
	
	/*	Of[VwiOTo^	*/
	GsSortPoly( &back, (GsOT *)&Wot[1][M_activebuff()], 60 );
	
	/*	XvCgg債GsSortSpritegp	*/
	for( i=0; i<RES_SPRITE_MAX; i++ ){
		if( Sprite[i].prim.state == ON ){
			GsSortFastSprite(&(Sprite[i].prim.sprite), 
				(GsOT *)&Wot[Sprite[i].sOt][M_activebuff()], 
					(u_short)Sprite[i].prim.coord.vz);	
		}
	}
	return 0;
}

/*------------------------------------------------------------------*/
/*		s֓]											*/
/*------------------------------------------------------------------*/
static void trans_tpage()
{
	short	i;
	RECT	rect;
	u_short char_pallette1[] = {	RGB5(0,0,0),	RGB5(0,0,0),
	RGB5(31,15,15),	RGB5(15,15,31),	RGB5(10,10,10),	RGB5(0,0,0),
	RGB5(0,0,0),	RGB5(0,0,0),	RGB5(0,0,0),	RGB5(0,0,0),
	RGB5(0,0,0),	RGB5(0,0,0),	RGB5(0,0,0),	RGB5(0,0,0),
	RGB5(0,0,0),	RGB5(0,0,0) };
	
	char	inp_font[][32] =	
				{
					"@L~̃p`R̒mx́A",
					"ȂuւȂ傱vlI@",
					"ƕ׋Ȃƃ_B",
					"@B̑IAłA^",
					"ׂăob`BL~̓L",
					"OEIuEp`J[II",
				};
	
	int		vy_tbl[] = {
				FNT_VRAMY,		FNT_VRAMY+11,	FNT_VRAMY+23,
				FNT_VRAMY+36,	FNT_VRAMY+47,	FNT_VRAMY+59,
				FNT_VRAMY+72,	FNT_VRAMY+83,	FNT_VRAMY+95,	};
	
	
	/*	sNA[	*/
	setRECT(&rect,320,0,704,256);
	ClearImage(&rect,0,0,0);
	setRECT(&rect,320,256,640,256);
	ClearImage(&rect,0,0,0);
	
	/*@\j[tHgppbg[h		*/
	OLoadImage( FNT_CX, FNT_CY, 16, 1, (long *)char_pallette1 );
	
	/*@\j[tHg[h	*/
	/*	KvȂ̂]悤ɉǂ\		TEST		*/
	for( i = 0; i < 6; i++ ){
		Kanji12_load( inp_font[i], (u_short *)Q_GDATA_BIN_FONT_TBL,
						32, 4, FNT_VRAMX, vy_tbl[i], 0 );
	}
	
	S_trans_set((u_long*)Q_GDATA_CSR_D_LAST0,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_D_LAST1,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_D_LAST2,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_D_LAST3,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_D_LAST4,	1);
	S_trans_set((u_long*)Q_GDATA_COL_KEKKA,		1);
	S_trans_set((u_long*)Q_GDATA_CSR_BODY_1,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_EYES_0,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_LIP_1,		1);
	S_trans_set((u_long*)Q_GDATA_CSR_HANDL_7,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_OUKAN_1,	1);
	S_trans_set((u_long*)Q_GDATA_COL_OHCHAN,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_D_TIT1,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_D_TIT2,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_D_TIT3,	1);
	S_trans_set((u_long*)Q_GDATA_CSR_D_KYU,		1);
	S_trans_set((u_long*)Q_GDATA_COL_D_TIT,		1);
}

/*------------------------------------------------------------------*/
/*		wîhmhs												*/
/*------------------------------------------------------------------*/
static void back_init ()
{
	SetPolyG4( &back );
	setRGB0( &back, 0xff, 0xff, 0xff );
	setRGB1( &back, 0xff, 0xff, 0xff );
	setRGB2( &back, 0xff, 0xff, 0xff );
	setRGB3( &back, 0xff, 0xff, 0xff );
	setXY4(  &back, -160,-120+16, 160,-120+16, -160,120-16, 160,120-16 );
}

/*------------------------------------------------------------------*/
/*		ʂ̂hmhs												*/
/*------------------------------------------------------------------*/
static void screen_init1 ()
{
	res_opd[TITLE] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
		(int)sizeof(OPD_W),(u_short)1);
	res_opd[TITLE]->ot = 2;
	res_opd[TITLE]->opd_address = (u_long)Q_GDATA_OPD_D_TITS;
	res_opd[TITLE]->center_x = -160;
	res_opd[TITLE]->center_y = -120+16;
	O_OPD_W_INIT(res_opd[TITLE], 6);
}

static void screen_init2()
{
	/*wiFւ*/
	setRGB0( &back, 0xa1, 0xc4, 0xf0 );
	setRGB1( &back, 0xa1, 0xc4, 0xf0 );
	setRGB2( &back, 0x29, 0x63, 0xf8 );
	setRGB3( &back, 0x29, 0x63, 0xf8 );
	
	res_opd[HAPPYOU] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
		(int)sizeof(OPD_W),(u_short)1);
	res_opd[HAPPYOU]->ot = 3;
	res_opd[HAPPYOU]->opd_address = (u_long)Q_GDATA_OPD_HAPPYOU;
	res_opd[HAPPYOU]->center_x = -160;
	res_opd[HAPPYOU]->center_y = -120+16;
	O_OPD_W_INIT(res_opd[HAPPYOU], 1);
	
	res_opd[SCENE_8] = (OPD_W*)S_obj_set(NULL,(u_long)O_OPD_W,
		(int)sizeof(OPD_W),(u_short)1);
	res_opd[SCENE_8]->ot = 4;
	res_opd[SCENE_8]->opd_address = (u_long)Q_GDATA_OPD_SCENE_8;
	res_opd[SCENE_8]->center_x = -160;
	res_opd[SCENE_8]->center_y = -120+16;
	O_OPD_W_INIT(res_opd[SCENE_8], 0);
	
	/*	hantei()Ɉړ\	*/
	/*@\j[tHg̕\iJ[quiz.cœ]̂gpj@*/	
	Sprite[Q_HANTEI].prim.sprite.cx = FNT_CX;
	Sprite[Q_HANTEI].prim.sprite.cy = FNT_CY;
	Sprite[Q_HANTEI].prim.sprite.u = 0;
	Sprite[Q_HANTEI].prim.sprite.v = (char)FNT_VRAMY;
	Sprite[Q_HANTEI].prim.sprite.w = 168;
	Sprite[Q_HANTEI].prim.sprite.h = 35;
	Sprite[Q_HANTEI].prim.sprite.x = -160+31;
	Sprite[Q_HANTEI].prim.sprite.y = -120+16+35;
	Sprite[Q_HANTEI].prim.sprite.attribute = 0;
	Sprite[Q_HANTEI].prim.sprite.scalex = ONE;
	Sprite[Q_HANTEI].prim.sprite.scaley = ONE;
	Sprite[Q_HANTEI].prim.sprite.rotate = 0;
	Sprite[Q_HANTEI].prim.sprite.tpage = GetTPage(0,0,FNT_VRAMX,FNT_VRAMY);
	Sprite[Q_HANTEI].prim.sprite.r = 0x80;
	Sprite[Q_HANTEI].prim.sprite.g = 0x80;
	Sprite[Q_HANTEI].prim.sprite.b = 0x80;
	Sprite[Q_HANTEI].prim.state = ON;
	Sprite[Q_HANTEI].sOt = 7;
	Sprite[Q_HANTEI].prim.coord.vz = 60;
	
	/*@\j[tHg̕\iJ[quiz.cœ]̂gpj@*/	
	Sprite[P_HANTEI].prim.sprite.cx = FNT_CX;
	Sprite[P_HANTEI].prim.sprite.cy = FNT_CY;
	Sprite[P_HANTEI].prim.sprite.u = 0;
	Sprite[P_HANTEI].prim.sprite.v = (char)FNT_VRAMY+36;
	Sprite[P_HANTEI].prim.sprite.w = 168;
	Sprite[P_HANTEI].prim.sprite.h = 35;
	Sprite[P_HANTEI].prim.sprite.x = -160+31;
	Sprite[P_HANTEI].prim.sprite.y = -120+16+86;
	Sprite[P_HANTEI].prim.sprite.attribute = 0;
	Sprite[P_HANTEI].prim.sprite.scalex = ONE;
	Sprite[P_HANTEI].prim.sprite.scaley = ONE;
	Sprite[P_HANTEI].prim.sprite.rotate = 0;
	Sprite[P_HANTEI].prim.sprite.tpage = GetTPage(0,0,FNT_VRAMX,FNT_VRAMY+36);
	Sprite[P_HANTEI].prim.sprite.r = 0x80;
	Sprite[P_HANTEI].prim.sprite.g = 0x80;
	Sprite[P_HANTEI].prim.sprite.b = 0x80;
	Sprite[P_HANTEI].prim.state = ON;
	Sprite[P_HANTEI].sOt = 7;
	Sprite[P_HANTEI].prim.coord.vz = 60;
	
	
	
}

/*------------------------------------------------------------------*/
/*																*/
/*------------------------------------------------------------------*/
static char hantei_main()
{
	/*	NCY	*/
	switch( Status.Q_point ){
		case 1:	break;
		case 2:	break;
		case 3:	break;
	}
	
	/*	Z	*/
	if( Status.P_point == 0 ){
	}
	else{
		switch( Status.P_point/1000 ){
			case 10:	break;
			case 9:		break;
			case 8:		break;
			case 7:		break;
			case 6:		break;
			case 5:		break;
			case 4:		break;
			case 3:		break;
			case 2:		break;
			case 1:		break;
			case 0:		NFntPrint("DAME\n");break;
		}
	}
	
	if( M_joy_trg(0) & PADRright )	return 1;
	else							return 0;
}
/*------------------------------------------------------------------*/
/*		OPD_W̃NA												*/
/*------------------------------------------------------------------*/
static void opdw_clear()
{
	short	i;
	
	for( i = 0; i < RES_OPDW_MAX; i++ ){
		res_opd[i]->terminate_flag = ON;
	}
}
