/***< file >***********************************************************/
/*	Title		:	PlayStation										*/
/*	Code		:	vx022											*/
/*	Filename	:	udeda.c											*/
/*	Author		:	usr01737 oohashi 						*/
/*	Date		:	1996.1.18										*/
/*	Note		:	r[hC								*/
/*******************************************************************/

/*==================================================================*/
/*	Include															*/
/*==================================================================*/
#include "lt_all.h"
#include "s_step.h"
#include "s_cdhd.h"
#include "s_init.h"
#include "s_color.h"
#include "l_kanji.h"
#include "udeda.h"
#include "quiz.h"
#include "q_gdata.h"

#include "u_lev.h"
#include "u_q2p.h"
#include "p_sel.h"
#include "u_result.h"
#include "pachinko.h"
#include "cd_sect.h"

/*====================================================================*/
/*	define											                  */
/*====================================================================*/
#define		TEST	ON

/*====================================================================*/
/*  \̂̐錾													  */
/*====================================================================*/
/*====================================================================*/
/*  ϐ錾														  */
/*====================================================================*/
_STATUS		Status;
static	int			iCdQueNumber;

/*====================================================================*/
/*	vg^Cv錾												  */
/*====================================================================*/
static	void	u_init			(void);
static	char	u_pachi_check	(void);

/*==================================================================*/
/*	vO														*/
/*==================================================================*/
void udeda_main()
{
#if 0
	NFntPrint("LEVEL = %d\n",Status.level );
	NFntPrint("DAI   = %d\n",Status.pachidai );
	NFntPrint("KUGI  = %d\n",Status.pachikugi);
#endif
	
#if TEST
	NFntPrint("U_STEP= %d\n",M_gstepw() );
	NFntPrint("Q_P   = %d\n",Status.Q_point );
	NFntPrint("P_P   = %d\n",Status.P_point );
	NFntPrint("T_P   = %d\n",Status.Q_point+Status.P_point );
	NFntPrint("TIME  = %d\n",Status.Ptime);
	NFntPrint("HARA0 = %d\n",p_sys_w.pachi_data.haraidasi[0]);
	NFntPrint("HARA1 = %d\n",p_sys_w.pachi_data.haraidasi[1]);
	NFntPrint("HARA2 = %d\n",p_sys_w.pachi_data.haraidasi[2]);
	NFntPrint("TONU0 = %d\n",p_sys_w.pachi_data.tounyuu[0]);
	NFntPrint("TONU1 = %d\n",p_sys_w.pachi_data.tounyuu[1]);
	NFntPrint("TONU2 = %d\n",p_sys_w.pachi_data.tounyuu[2]);
	NFntPrint("TONU0 = %d\n",p_sys_w.pachi_data.play_jikan[0]);
	NFntPrint("TONU1 = %d\n",p_sys_w.pachi_data.play_jikan[1]);
	NFntPrint("TONU2 = %d\n",p_sys_w.pachi_data.play_jikan[2]);
#endif
	
	switch (M_gstepw()) 
	{
		case U_INIT:
			u_init();
			S_gstepw_set(U_QUIZ_LOAD);
			break;
			
		case U_QUIZ_LOAD:
#ifndef	CD_READ
			if((iCdQueNumber = 
					S_cdhd_que_set(HD_DATA,(u_long)LoadAddress3,
					QUIZ_FILE_SIZE,(u_long)QUIZ_FILE)) != -1)
#else
			if((iCdQueNumber = 
					S_cdhd_que_set(CD_DATA,(u_long)LoadAddress3,
					CD_QUIZ_SIZE,(u_long)CD_QUIZ_SECT)) != -1)
#endif
			{
				S_disp_sys_change(320,240);
				S_gstepw_set(U_QUIZ_LOAD_CHECK);
			}	
			break;
			
		case U_QUIZ_LOAD_CHECK:
			if( S_cdhd_que_stat( iCdQueNumber ) == CD_STATUS_END )
			{
				S_gstepw_set(U_DATA_LOAD);
			}
			break;
			
		case U_DATA_LOAD:
#ifndef	CD_READ
			if((iCdQueNumber = S_cdhd_que_set(HD_DATA,
				(u_long)Q_GDATA_TOP,
					Q_GDATA_SIZE,(u_long)Q_GDATA_FILE)) != -1)
#else
			if((iCdQueNumber = S_cdhd_que_set(CD_DATA,
				(u_long)Q_GDATA_TOP,
					CD_Q_GDATA_SIZE,(u_long)CD_Q_GDATA_SECT)) != -1)
#endif
			{
				S_gstepw_set(U_DATA_LOAD_CHECK);
			}
			break;
			
		case U_DATA_LOAD_CHECK:
			if( S_cdhd_que_stat( iCdQueNumber ) == CD_STATUS_END )
			{
				S_gstepw_set(U_LEVSEL_INIT);
				S_fadeout_black();
			}
			break;
			
		case U_LEVSEL_INIT:
			if(M_fade_flag() == OFF){
				u_lev_init();
				S_gstepw_set(U_LEVSEL_MAIN);
			}
			break;
		
		case U_LEVSEL_MAIN:
			if( (Status.level = u_lev_main()) != 0 )
				S_gstepw_set(U_QUIZ_INIT);
			break;
		
		case U_QUIZ_INIT:
			QuizInit(Status.level);
			S_gstepw_set(U_QUIZ_MAIN);
			break;

		case U_QUIZ_MAIN:
			if(  QuizMain() ){
				Status.Q_point = QuizPoint();
				S_gstepw_set(U_QUIZ_2_PACHI_INIT);
			}
			break;
			
		case U_QUIZ_2_PACHI_INIT:
			u_q2p_init(Status.level,Status.Q_point);
			S_gstepw_set(U_QUIZ_2_PACHI_MAIN);
			break;
			
		case U_QUIZ_2_PACHI_MAIN:
			if( u_q2p_main() ){
				if( Status.Q_point <= 0 ){
					S_fadeout_black();
					S_gstepw_set(U_PACHI_EXIT);
				}else{
					S_gstepw_set(U_PACHI_SELECT_INIT);
				}
			}
			break;
			
		case U_PACHI_SELECT_INIT:
			S_sys_w->vsync_no = 2;
			S_disp_sys_change(512, 240);
			psel_init(Status.level,Status.Q_point);
			S_gstepw_set(U_PACHI_SELECT);
			break;
			
		case U_PACHI_SELECT:
			if( psel_main() ){
				S_gstepw_set(U_PACHI_INIT);
			}
			break;
			
		case U_PACHI_INIT:
			P_main_step_set( 0 );
			S_gstepw_set(U_PACHI_MAIN);
			break;
			
		case U_PACHI_MAIN:
			Pachinko_main();
			if( u_pachi_check() ){
				S_fadeout_black();
				S_gstepw_set(U_PACHI_EXIT);
			}
			break;
			
		case U_PACHI_EXIT:
			if(M_fade_flag() == OFF){
				S_obj_init();
				S_disp_sys_change(320,240);
				S_sys_w->vsync_no = 1;
				S_gstepw_set(U_QUIZ_LOAD2);
			}
			break;
			
		case U_QUIZ_LOAD2:
#ifndef	CD_READ
			if((iCdQueNumber = 
					S_cdhd_que_set(HD_DATA,(u_long)LoadAddress3,
					QUIZ_FILE_SIZE,(u_long)QUIZ_FILE)) != -1)
#else
			if((iCdQueNumber = 
					S_cdhd_que_set(CD_DATA,(u_long)LoadAddress3,
					CD_QUIZ_SIZE,(u_long)CD_QUIZ_SECT)) != -1)
#endif
			{
				S_gstepw_set(U_QUIZ_LOAD_CHECK2);
			}	
			break;
			
		case U_QUIZ_LOAD_CHECK2:
			if( S_cdhd_que_stat( iCdQueNumber ) == CD_STATUS_END )
			{
				S_gstepw_set(U_DATA_LOAD2);
			}
			break;
			
		case U_DATA_LOAD2:
#ifndef	CD_READ
			if((iCdQueNumber = S_cdhd_que_set(HD_DATA,
				(u_long)Q_GDATA_TOP,
					Q_GDATA_SIZE,(u_long)Q_GDATA_FILE)) != -1)
#else
			if((iCdQueNumber = S_cdhd_que_set(CD_DATA,
				(u_long)Q_GDATA_TOP,
					CD_Q_GDATA_SIZE,(u_long)CD_Q_GDATA_SECT)) != -1)
#endif
			{
				S_gstepw_set(U_DATA_LOAD_CHECK2);
			}
			break;

		case U_DATA_LOAD_CHECK2:
			if( S_cdhd_que_stat( iCdQueNumber ) == CD_STATUS_END )
			{
				S_gstepw_set(U_PACHI_2_RESULT);
			}
			break;
		
			
		case U_PACHI_2_RESULT:
			result_init();
			S_gstepw_set(U_RESULT_MAIN);
			break;
			
		case U_RESULT_MAIN:
			if( result_main() ){
				S_gstepw_set(U_EXIT);
			}
			break;
			
		case U_EXIT:
			S_stepw_set(3);		/*[hIɖ߂*/
			break;
	}
}


void	U_status(char lev, short point, short dai, short kugi)
{
	/*	ꂼ̃eXgȂǂ̌ʂGETB	*/
	/*	Esς̍ڂɂNULL		*/
	
	if( lev   != NULL )		Status.level     = lev;
	if( point != NULL )		Status.Q_point   = point;
	if( dai   != NULL )		Status.pachidai  = dai;
	if( kugi  != NULL )		Status.pachikugi = kugi;
}

/*------------------------------------------------------------------*/
/*		r̂hmhs											*/
/*------------------------------------------------------------------*/
static void	u_init()
{
	S_sys_w->vsync_no = 1;
	S_obj_init();
	bzero( (char *)&Status,	sizeof(Status) );
}

/*------------------------------------------------------------------*/
/*		ZeXg@ԃ`FbN									*/
/*------------------------------------------------------------------*/
static	char	u_pachi_check	()
{
	Status.Ptime = p_sys_w.pachi_data.play_jikan[0]
					+p_sys_w.pachi_data.play_jikan[1]
					+p_sys_w.pachi_data.play_jikan[2];
	
	Status.P_point = (short)( 
		p_sys_w.pachi_data.haraidasi[0]-p_sys_w.pachi_data.tounyuu[0]
		+p_sys_w.pachi_data.haraidasi[1]-p_sys_w.pachi_data.tounyuu[1]
		+p_sys_w.pachi_data.haraidasi[2]-p_sys_w.pachi_data.tounyuu[2] );
	
#if 0
	if( Status.Ptime == (20*10) )						goto END;
	if( (Status.Q_point + Status.P_point) <= 0 )		goto END;
	if( (Status.Q_point + Status.P_point) >= 10000 )	goto END;
#else
	if( M_joy_trg(1) & PADRright )	goto END;
#endif
	
	return 0;
	
	END:
	return 1;
}

