/***< file >*****************************************************************/
/*	Title		:	PS-X Tool												*/
/*	Version		:	1.00													*/
/*	Code		:	vx022													*/
/*	Filename	:	psxcsr.c												*/
/*	Date		:	05/29/1995												*/
/*	Note		:	ڲðݗpްް°								*/
/*									 Copyright(C) by KONAMI.Co.LTD			*/
/*****************************************************************************/

/*==========================================================================*/
/*	Include																	*/
/*==========================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <ctype.h>
#include <errno.h>
#include <unistd.h>
#include <math.h>
#include "psxcvt.h"

#define		MAX_COLUMN	256
#define		MAX_WORD	16

#define	CSR_TYPE		0x00
#define	COL_TYPE		0x01
#define	OPD_TYPE		0x02
#define	TMD_TYPE		0x03
#define	PMD_TYPE		0x04
#define	TOD_TYPE		0x05
#define	TIM_TYPE		0x06
#define	BGD_TYPE		0x07
#define	CEL_TYPE		0x08
#define	ANM_TYPE		0x09
#define	BIN_TYPE		0x0a

u_long		baseaddress;						/* ް̱ڽް */
u_char		incfilename[128];				/* ݸٰ̧Ȱ */
u_char		cvtfilename[128];				/* ްް̧Ȱ */
FILE		*cfgfp;							/* ̨̧ق߲ */
FILE		*incfp;							/* ݸٰ̧ق߲ */
FILE		*cvtfp;							/* WJ̧ق߲ */


#define		s_swap(val)		(((val&0xff00)>>8)|((val&0x00ff)<<8))

typedef	struct _CSR_BUFF{
	char	name[64];			/*	t@C			*/
	u_long	x,y;				/*	VRAM̍W		*/
	u_long	address;			/*	MM̃AhX		*/
	int		col_mode;			/*	16 or 256			*/
}CSR_BUFF;

typedef	struct _COL_BUFF{
	char	name[64];			/*	t@C			*/
	u_long	x,y;				/*	VRAM̍W		*/
	u_long	address;			/*	MM̃AhX		*/
	int		col_mode;			/*	16 or 256			*/
}COL_BUFF;

#define			OPD_BUFF_MAX	256

CSR_BUFF		csr_buff[OPD_BUFF_MAX];
COL_BUFF		col_buff[OPD_BUFF_MAX];
int				csr_buff_count = 0;
int				col_buff_count = 0;

/*==========================================================================*/
/*	define																	*/
/*==========================================================================*/

/*----------------------------------------------*/
/*	ܰޯ̧									*/
/*----------------------------------------------*/
#define		ON			1
#define		OFF			0
#define		OK			1
#define		NG			0

/*==========================================================================*/
/*	Program																	*/
/*==========================================================================*/
u_short	mainx(char *);							/* Ҳݏ */
void	TopDefineSet( char *fname);
void	LastDefineSet( char *fname);
void	DefineSet( char *defname, char *fname, char *ext);
void	ColDefineSet( char *col_name, char *fname );
FILE	*Wfile_open(char *writefile, char *mode);
FILE	*Rfile_open(char *readfile, char *mode);
int		del_ext(char *filename);
int		check_ext(char *readfile, char	*ext);
int		ColConvert( char string_buff[MAX_WORD][MAX_COLUMN], char *fname );
u_long	StrDataSet(char *dp);
u_long	StrDataSetBin(char *dp);
int		ColDataSet( char string[MAX_WORD][MAX_COLUMN] );
int		Check_format(FILE *fp, u_char kind);
int		PsxDataSet( char string[MAX_WORD][MAX_COLUMN] );
void	PsxDefineSet( char *file_name, char *fname, int type );
int		PsxConvert( char string_buff[MAX_WORD][MAX_COLUMN],
													char *fname, int type );
int		TimConvert( char string_buff[MAX_WORD][MAX_COLUMN], char *fname );
int		TimDataSet( char string[MAX_WORD][MAX_COLUMN] );
void	TimDefineSet( char *file_name, char *fname );
int		KugiConvert( char string_buff[MAX_WORD][MAX_COLUMN], char *fname );
void	KugiDefineSet( char *file_name, char *fname );
int		KugiDataSet( char string[MAX_WORD][MAX_COLUMN] );
long	CsrTransWH(FILE *csrfp, u_long pic, u_long w, u_long h, u_short *data);
int		CsrDataSet( char string[MAX_WORD][MAX_COLUMN] );
void	CsrDefineSet( char *file_name, char *fname );
int		CsrConvert( char string_buff[MAX_WORD][MAX_COLUMN], char *fname );
int		OpdDataSet( char string[MAX_WORD][MAX_COLUMN] );
int		OpdGetCommand( char cmd_name[], u_long *val );
void	OpdDefineSet( char *file_name, char *fname );
int		OpdConvert( char string_buff[MAX_WORD][MAX_COLUMN], char *fname );

/***< function >*************************************************************/
/*	`F	main(int, char *[])												*/
/*	F	int		argcFײݏ̈̐OSn				*/
/*	F	char	*argv[]:i[Ă؏̱ڽzƂĂnr*/
/*							nB									*/
/*	ԂlF																*/
/****************************************************************************/
main(int argc, char **argv)
{
	char		file_name[64];

	if( argc < 2 ){
		printf( "argv[1] ɃRtBOt@Cw肵Ă\n" );
		exit(0);
	}

	strcpy( file_name, argv[1] );

	/*------------------------------------------------ ̨̧ق̓ǂݍ */
	if( check_ext(file_name, ".cnf") != 0 ){
		exit(0);
	}

	bzero( (char *)csr_buff, sizeof(csr_buff) );
	bzero( (char *)col_buff, sizeof(col_buff) );
	csr_buff_count = 0;
	col_buff_count = 0;

	if(mainx(file_name) != OK) {
		printf("f[^̕ϊɎs܂\n");
	} else {
		printf("<<< done data convert >>>\n\n\n");
		printf("ȉ̃t@C쐬܂̂ŊmFĉB\n");
		printf("%s\n", cvtfilename);
		printf("%s\n", incfilename);
	}
}

/*--------------------------- mainx -----------------------------------------*/
u_short mainx(char *file_name)
{
	char		*bufp;
	int			i;
	char		line_buff[MAX_COLUMN];
	char		string_buff[MAX_WORD][MAX_COLUMN];
	int			string_num;
	int			rtn = OK;

	/*----------------------------------------------------- ݒ (INIT) */
	cvtfp = incfp = cfgfp = NULL;
	baseaddress = 0;

	if( (cfgfp = Rfile_open(file_name, "rt")) == NULL){	/* config file open */
		rtn = NG;
		goto end;
	}

	fseek(cfgfp, 0, SEEK_SET);

	/*-------------------------------------------------------- OUTFILE open */
	while((fgets(line_buff, MAX_COLUMN, cfgfp)) != NULL) {

		bzero( (char *)string_buff, sizeof(string_buff) );

		bufp = strtok( line_buff," \t" );
		for( i=0; i<MAX_WORD; i++ ){
			if( sscanf(bufp, "%s", string_buff[i]) != 1 )	break;
			if( (bufp = strtok( NULL," \t" )) == NULL ) break;
		}

		strlwr(string_buff[0]);								/* ϊ */

		if(strcmp(string_buff[0], "cvtfile") == NULL) {
			if( cvtfp != NULL ){
				printf( "CVTFILE̎w肪܂\n" );
				rtn = NG;
				goto end;
			}
			del_ext( file_name );
			sprintf(cvtfilename, "%s%s.cvt", string_buff[1], file_name );
			cvtfp = Wfile_open(cvtfilename, "wb+");	/* include file open */
			printf("---------- CVTFILE open ----------------\n");
		}
		else if(strcmp(string_buff[0], "includefile") == NULL) {
			if( incfp != NULL ){
				printf( "INCLUDEFILE̎w肪܂\n" );
				rtn = NG;
				goto end;
			}
			del_ext( file_name );
			sprintf(incfilename, "%s%s.h", string_buff[1], file_name );
			incfp = Wfile_open(incfilename, "wt+");	/* include file open */
			printf("---------- INCLUDEFILE open ----------------\n");
		}
		else if(strcmp(string_buff[0], "address") == NULL) {
			baseaddress = StrDataSet(string_buff[1]);	/* ްڽ */
			printf("---------- ADDRESS set ----------------\n\n");
			break;
		}
	}

	if( cvtfp == NULL ){
		printf( "CVTFILE̎w肪܂\n" );
		rtn = NG;
		goto end;
	}
	if( incfp == NULL ){
		printf( "INCLUDE̎w肪܂\n" );
		rtn = NG;
		goto end;
	}
	if( baseaddress == 0 ){
		printf( "ADDRESS̎w肪AOw肳Ă܂\n" );
		rtn = NG;
		goto end;
	}

	TopDefineSet( file_name); 	/* ]ڽ  */

	/*--------------------------------------------------------- DATA set */
	fseek(cfgfp, 0, SEEK_SET);
	printf("---------- DATA make start -----------------\n");
	while((fgets(line_buff, MAX_COLUMN, cfgfp)) != NULL) {

		bzero( (char *)string_buff, sizeof(string_buff) );

		string_num = 0;
		bufp = strtok( line_buff," \t" );
		for( i=0; i<MAX_WORD; i++ ){
			if( sscanf(bufp, "%s", string_buff[i]) != 1 )	break;
			string_num++;
			if( (bufp = strtok( NULL," \t" )) == NULL ) break;
		}

		strlwr(string_buff[0]);								/* ϊ */

		if(strcmp(string_buff[0], "end") == NULL) {
			break;
		}
		else if(strcmp(string_buff[0], "data") == NULL) {
			if( string_num<2 ){
				printf( "data t@Cw肳Ă܂\n" );
			}
			else if(strcmp(strchr(string_buff[1],'.'), ".csr") == NULL){
				CsrConvert(string_buff, file_name);
			}
			else if(strcmp(strchr(string_buff[1],'.'), ".col") == NULL){
				if( ColConvert(string_buff, file_name) != OK ){
					printf( "%s̕ϊɎs܂\n", string_buff[1] );
				}
			}
			else if(strcmp(strchr(string_buff[1],'.'), ".opd") == NULL){
				OpdConvert(string_buff, file_name);
			}
			else if(strcmp(strchr(string_buff[1],'.'), ".tmd") == NULL){
				if( strcmp(string_buff[2],"KUGI_DATA") == NULL ){
					KugiConvert(string_buff, file_name);
				}
				else{
					PsxConvert(string_buff, file_name, TMD_TYPE);
				}
			}
			else if(strcmp(strchr(string_buff[1],'.'), ".pmd") == NULL){
				PsxConvert(string_buff, file_name, PMD_TYPE);
			}
			else if(strcmp(strchr(string_buff[1],'.'), ".tod") == NULL){
				PsxConvert(string_buff, file_name, TOD_TYPE);
			}
			else if(strcmp(strchr(string_buff[1],'.'), ".tim") == NULL){
				TimConvert(string_buff, file_name);
			}
			else if(strcmp(strchr(string_buff[1],'.'), ".bgd") == NULL){
				PsxConvert(string_buff, file_name, BGD_TYPE);
			}
			else if(strcmp(strchr(string_buff[1],'.'), ".cel") == NULL){
				PsxConvert(string_buff, file_name, CEL_TYPE);
			}
			else if(strcmp(strchr(string_buff[1],'.'), ".anm") == NULL){
				PsxConvert(string_buff, file_name, ANM_TYPE);
			}
			else if((strcmp(strchr(string_buff[1],'.'), ".bin") == NULL) ||
					(strcmp(strchr(string_buff[1],'.'), ".dat") == NULL) ){
				PsxConvert(string_buff, file_name, BIN_TYPE);
			}
			else{
				printf( "t@Cł[%s]\n", string_buff[1] );
			}
		}
	}

	LastDefineSet(file_name);

end:
	if( incfp != NULL )	fclose(incfp);			/* include file close */
	if( cfgfp != NULL )	fclose(cfgfp);			/* config file close */
	if( cvtfp != NULL )	fclose(cvtfp);			/* develop file close */

	printf("---------- DATA make end -------------------\n\n");

	return(rtn);
}

int check_ext(char *readfile, char	*ext)
{
	int		i, j;
	char	*ext_adr;
	int		rtn;

	rtn = 0;

	if( (ext_adr = strchr(readfile,'.')) == (char *)NULL ){
		strcat( readfile, ext );
	}
	else{
		if( strcmp(ext_adr,ext) != 0 ){
			printf("w肳ꂽt@C̊gq %s ł͂܂\n", ext );
			rtn = -1;
			goto end;
		}
	}

end:
	return(rtn);
}

int del_ext(char *filename)
{
	int		i, j;
	char	*ext_adr;
	int		rtn;

	rtn = 0;

	if( (ext_adr = strchr(filename,'.')) != (char *)NULL ){
		*ext_adr = NULL;
	}

end:
	return(rtn);
}

void DefineSet( char *defname, char *fname, char *ext)
{
	char	name_buff[MAX_COLUMN];

	strcpy( name_buff, (char *)(strrchr(defname,'\\')+1) );
	strupr( name_buff );									/* 啶	*/
	*strchr( name_buff, '.' ) = NULL;

	fprintf(incfp, "#define\t\t%s_%s_%s\t\t0x%08x",
							fname, ext, name_buff, ftell(cvtfp)+baseaddress);
}

void TopDefineSet(char *fname)
{
	fprintf(incfp,"\t\t/*--------------------------------------------------*/\n");
	fprintf(incfp,"\t\t/*		psxcvt 		include file					*/\n");
	fprintf(incfp,"\t\t/*													*/\n");
	fprintf(incfp,"\t\t/*		code name	VX022							*/\n");
	fprintf(incfp,"\t\t/*--------------------------------------------------*/\n");

	fprintf(incfp, "\n\n");

	strupr(fname);								/* 啶	*/
	fprintf(incfp, "#ifndef\t\t%s_DEF\n", fname);	/* #ifndef <filename>_DEF */
	fprintf(incfp, "#define\t\t%s_DEF\n\n", fname);/* #define <filename>_DEF */

	fprintf(incfp, "/*--- top address ---*/\n");
	fprintf(incfp, "#define\t\t%s_TOP\t\t0x%08x\t\t/* set address */\n\n",
												fname, baseaddress);
	fprintf(incfp, "/*--- data address ---*/\n");
}


void LastDefineSet(char *fname)
{
	fseek( cvtfp, 0, SEEK_END );

	strupr(fname);								/* 啶	*/

	fprintf(incfp, "\n");
	fprintf(incfp, "/*--- last address ---*/\n");
	fprintf(incfp, "#define\t\t%s_LAST_ADDR\t\t0x%08x\t\t/* last address */\n\n",
										fname, ftell(cvtfp)+baseaddress);

	fprintf(incfp, "/*--- data size ---*/\t\n");
	fprintf(incfp, "#define\t\t%s_SIZE\t\t0x%08x\t\t/* file size */\n\n",
										fname, ftell(cvtfp));

	fprintf(incfp, "\n#endif\n");
}

u_long StrDataSet(char *dp)
{
	u_long	rtn;

	if( strncmp(dp, "0x", 2) == NULL) {				/* 16ȉꍇ */
		sscanf( dp+2, "%x", &rtn );
	}
#if 0
	else if( strncmp(dp, "0", 1) == NULL) {			/* 8ȉꍇ */
		sscanf( dp+1, "%o", &rtn );
	}
#endif
	else {											/* 10ȉꍇ */
		sscanf( dp, "%d", &rtn );
	}

	return(rtn);
}


u_long StrDataSetBin(char *dp)
{
	u_long	rtn = 0;

	if( *dp != NULL ){
		while( ((*dp)=='0') || (*dp=='1') ){
			rtn <<= 1;

			if( (*dp) == '1' ){
				rtn |= 1;
			}
			dp++;
		}
	}

	return(rtn);
}

/*--< function >------------------------------------------------------------*/
/*	`F	Rfile_open(readfile)											*/
/*	F	char	*readfileF̧ٖ߲								*/
/*	F	̧قJ邩ǂ̧߲Ԃ						*/
/*	ԂlFFILE *	F̧߲												*/
/*--------------------------------------------------------------------------*/
FILE *Rfile_open(char *readfile, char *mode)
{
	FILE 	*rfp;							/* ǂݍ̧ */

	if ( ( rfp = fopen ( readfile, mode )) == NULL ) {
			printf("READt@C̃I[vɎs܂[%s]\n", readfile);
			return(NULL);
	}
	printf("%s read file open\n", readfile);
	return(rfp);
}

/*--< function >------------------------------------------------------------*/
/*	`F	Wfile_open(writefile)											*/
/*	F	char	*writefile:̧ٖ߲								*/
/*	F	ݗp̧ق쐬̧߲Ԃ							*/
/*	ԂlFFILE *	:̧߲												*/
/*--------------------------------------------------------------------------*/
FILE *Wfile_open(char *writefile, char *mode)
{
	FILE 	*wfp;								/* ̧߲ */
	int		i;

	if ( ( wfp = fopen ( writefile, mode )) == NULL ) {
		printf("WRITEt@C̃I[vɎs܂[%s]\n", writefile);
		exit(1);
	}
	printf("%s write file open\n", writefile);
	return(wfp);
}


int CsrConvert( char string_buff[MAX_WORD][MAX_COLUMN], char *fname )
{
	CsrDefineSet(string_buff[1], fname);	/* include file ް */

	if( CsrDataSet(string_buff) != OK ){
		return( NG );
	}

	return( OK );
}


int ColConvert( char string_buff[MAX_WORD][MAX_COLUMN], char *fname )
{
	ColDefineSet(string_buff[1], fname);	/* include file ް */

	if( ColDataSet(string_buff) != OK ){
		return( NG );
	}

	return( OK );
}


/*--< function >------------------------------------------------------------*/
/*	`F	PsxConvert(dp)													*/
/*	F	u_char	*dp	:ް߲											*/
/*	F	gpް								*/
/*	ԂlFȂ															*/
/*--------------------------------------------------------------------------*/
int PsxConvert( char string_buff[MAX_WORD][MAX_COLUMN], char *fname, int type )
{
										/* include file ް */
	PsxDefineSet(string_buff[1], fname, type);

	if( PsxDataSet(string_buff) != OK ){
		return( NG );
	}

	return( OK );
}


int OpdConvert( char string_buff[MAX_WORD][MAX_COLUMN], char *fname )
{
										/* include file ް */
	OpdDefineSet(string_buff[1], fname);

	if( OpdDataSet(string_buff) != OK ){
		return( NG );
	}

	return( OK );
}


/***< global function >******************************************************/
/*	`F	TimConvert(dp)													*/
/*	F	u_char	*dp	:ް߲											*/
/*	F	ڲð݂Ŏgpް								*/
/*	ԂlFȂ															*/
/****************************************************************************/
int TimConvert( char string_buff[MAX_WORD][MAX_COLUMN], char *fname )
{
										/* include file ް */
	TimDefineSet(string_buff[1], fname );

	if( TimDataSet(string_buff) != OK ){
		return( NG );
	}

	return( OK );
}


int KugiConvert( char string_buff[MAX_WORD][MAX_COLUMN], char *fname )
{
										/* include file ް */
	KugiDefineSet(string_buff[1], fname );

	if( KugiDataSet(string_buff) != OK ){
		return( NG );
	}

	return( OK );
}


void CsrDefineSet( char *file_name, char *fname )
{
	DefineSet(file_name, fname, "CSR");
	fprintf(incfp, "\t\t /* csr data */\n");
}


void ColDefineSet( char *file_name, char *fname )
{
	DefineSet(file_name, fname, "COL");
	fprintf(incfp, "\t\t /* col data */\n");
}


void PsxDefineSet( char *file_name, char *fname, int type )
{
	switch( type ){
		case	BIN_TYPE:
			DefineSet(file_name, fname, "BIN");
			fprintf(incfp, "\t\t /* bin data */\n");
			break;
		case	TMD_TYPE:
			DefineSet(file_name, fname, "TMD");
			fprintf(incfp, "\t\t /* tmd data */\n");
			break;
		case	PMD_TYPE:
			DefineSet(file_name, fname, "PMD");
			fprintf(incfp, "\t\t /* pmd data */\n");
			break;
		case	TOD_TYPE:
			DefineSet(file_name, fname, "TOD");
			fprintf(incfp, "\t\t /* tod data */\n");
			break;
		case	BGD_TYPE:
			DefineSet(file_name, fname, "BGD");
			fprintf(incfp, "\t\t /* bgd data */\n");
			break;
		case	CEL_TYPE:
			DefineSet(file_name, fname, "CEL");
			fprintf(incfp, "\t\t /* cel data */\n");
			break;
		case	ANM_TYPE:
			DefineSet(file_name, fname, "ANM");
			fprintf(incfp, "\t\t /* anm data */\n");
			break;
	}
}


void OpdDefineSet( char *file_name, char *fname )
{
	DefineSet(file_name, fname, "OPD");
	fprintf(incfp, "\t\t /* opd data */\n");
}


void TimDefineSet( char *file_name, char *fname )
{
	DefineSet(file_name, fname, "TIM");
	fprintf(incfp, "\t\t /* tim data */\n");
}


void KugiDefineSet( char *file_name, char *fname )
{
	DefineSet(file_name, fname, "KUGI");
	fprintf(incfp, "\t\t /* kugi data */\n");
}


/*--< function >------------------------------------------------------------*/
/*	`F	ColDataSet(dp)													*/
/*	F	char	*dp:	̧߲										*/
/*	F	colް̧قdevelop fileɏ							*/
/*	ԂlFȂ															*/
/*--------------------------------------------------------------------------*/
#define	KIND_POINT	0x08						/* ͯްނ߲ */
#define K_CSR 		0x00						/* PIGŞفA*.csr */
#define K_COL 		0x06						/* PIGŞفA*.col */
#define K_OPD 		0x0f						/* PIGŞفA*.opd */
#define	COL_DATA	0x20						/* װްͯް */
#define	PRESS_FLAG	0x0a

/*--< function >------------------------------------------------------------*/
/*	`F	Check_format(fp, kind)											*/
/*	F																	*/
/*	F	̧̫ϯĂ											*/
/*	ԂlF																*/
/*--------------------------------------------------------------------------*/
int Check_format(FILE *fp, u_char kind)
{
	u_char	chk;

	fseek(fp, KIND_POINT, SEEK_SET);
	fread(&chk, sizeof(char), 1, fp);

	if(chk != kind){
		printf( "t@Cʂ܂[%d:%d]\n", chk, kind );
		return( NG );
	}

	return( OK );
}


int CsrDataSet( char string[MAX_WORD][MAX_COLUMN] )
{
	FILE		*rdfp = NULL;							/* *.col ̧߲ */
	CSR_W		csr_head;
	u_char		col_mode;
	u_char		press_flag;
	u_char		workbuf[0x5000];
	long		datasize;
	char		*bufp[2];

	if( csr_buff_count >= OPD_BUFF_MAX ){
		printf( "CSRt@C̐܂\n" );
		return( NG );
	}

	if( (rdfp=Rfile_open(string[1], "rb")) == NULL ){	/* read file̵ */
		return( NG );
	}

	csr_buff[csr_buff_count].address = ftell(cvtfp)+baseaddress;
	if( (bufp[1] = strtok( string[1],"\\" )) != NULL)	bufp[0] = bufp[1];
	else												bufp[0] = string[1];
	while( (bufp[1] = strtok( NULL," \\" )) != NULL )	bufp[0] = bufp[1];
	strcpy(csr_buff[csr_buff_count].name,bufp[0]);
	strlwr(csr_buff[csr_buff_count].name);					/* ϊ */

	if( Check_format(rdfp, K_CSR) != OK ){			/* ̧ق̎ނ */
		fclose( rdfp );
		return( NG );
	}

	fseek(rdfp, PRESS_FLAG, SEEK_SET);				/* װӰނ߲ɼ */
	fread(&press_flag, sizeof(u_char), 1, rdfp);

	if( press_flag != 0 ){
		printf( "kꂽt@C͎gpł܂\n" );
		fclose( rdfp );
		return( NG );
	}

	fseek(rdfp, COL_MODE, SEEK_SET);				/* װӰނ߲ɼ */
	fread(&col_mode, sizeof(u_char), 1, rdfp);

	csr_head.code = CSR_TYPE | (col_mode?COLMODE_CODE:0);
	csr_buff[csr_buff_count].col_mode = (col_mode?256:16);

	csr_head.x = csr_buff[csr_buff_count].x = StrDataSet(string[2]);
	csr_head.y = csr_buff[csr_buff_count].y = StrDataSet(string[3]);
	csr_head.w = StrDataSet(string[4]);		/* [߸ق͐؂̂Ă	*/
	csr_head.h = StrDataSet(string[5]);

	if( fwrite(&csr_head, sizeof(CSR_W), 1, cvtfp) != 1 ){
		printf( "wb_݂̏Ɏs܂\n" );
		fclose( rdfp );
		return( NG );
	}

	switch(col_mode) {
		case 0:
			if( (datasize = CsrTransWH(rdfp, BIT4PIC,
							csr_head.w, csr_head.h, (u_short *)workbuf)) < 0 ){
				printf( "f[^̕ϊɎs܂\n" );
				fclose( rdfp );
				return( NG );
			}
			fwrite(workbuf, sizeof(u_short), datasize, cvtfp);
			break;
		case 1:
			if( (datasize = CsrTransWH(rdfp, BIT8PIC,
							csr_head.w, csr_head.h, (u_short *)workbuf)) < 0 ){
				printf( "f[^̕ϊɎs܂\n" );
				fclose( rdfp );
				return( NG );
			}
			fwrite(workbuf, sizeof(u_short), datasize, cvtfp);
			break;
		default:
			printf( "ȃJ[[hł[%d]\n", col_mode );
			fclose( rdfp );
			return( NG );
	}

	if( rdfp != NULL )
		fclose( rdfp );

	csr_buff_count++;

	return( OK );
}


int ColDataSet( char string[MAX_WORD][MAX_COLUMN] )
{
	int			palmode;						/* گӰ */
	u_short		coldata;						/* i[ر */
	int			i, paln = 0;
	FILE		*colfp = NULL;							/* *.col ̧߲ */
	u_char		work[32];
	COL_W		col_head;
	char		*bufp[2];
	u_long		stp_data;

	if( col_buff_count >= OPD_BUFF_MAX ){
		printf( "COLt@C̐܂\n" );
		return( NG );
	}

	if( (colfp=Rfile_open(string[1], "rb")) == NULL ){	/* read file̵ */
		return( NG );
	}

	col_buff[col_buff_count].address = ftell(cvtfp)+baseaddress;
	if( (bufp[1] = strtok( string[1],"\\" )) != NULL)	bufp[0] = bufp[1];
	else												bufp[0] = string[1];
	while( (bufp[1] = strtok( NULL," \\" )) != NULL )	bufp[0] = bufp[1];
	strcpy(col_buff[col_buff_count].name,bufp[0]);
	strlwr(col_buff[col_buff_count].name);					/* ϊ */

	if( Check_format(colfp, K_COL) != OK ){			/* ̧ق̎ނ */
		fclose( colfp );
		return( NG );
	}

	fseek(colfp, COL_DATA, SEEK_SET);				/* װް߲ɼ */

	palmode = StrDataSet(string[6]);		/* dfpstrް */

	if( (palmode != 16) && (palmode != 256) ){
		printf("palet mode܂[%d]\n", palmode);
		fclose( colfp );
		return( NG );
	}

	col_buff[col_buff_count].col_mode = palmode;

	col_head.code = COL_TYPE;							/* datacode  */
	col_head.x = col_buff[col_buff_count].x = StrDataSet(string[2]);
	col_head.y = col_buff[col_buff_count].y = StrDataSet(string[3]);
	col_head.w = StrDataSet(string[4]);
	col_head.h = StrDataSet(string[5]);

	if( fwrite(&col_head, sizeof(COL_W), 1, cvtfp) != 1 ){
		printf( "wb_݂̏Ɏs܂\n" );
		fclose( colfp );
		return( NG );
	}

	stp_data = StrDataSetBin( string[7] );

	for(i = 0 ; i < col_head.w ; i++) {
/*	for(i = 0 ; i < palmode ; i++) {*/
		coldata = 0;
		fread(work, sizeof(u_long), 1, colfp);
		coldata |= (work[0] >> 3);
		coldata  = (coldata << 5);
		coldata |= (work[1] >> 3);
		coldata  = (coldata << 5);
		coldata |= (work[2] >> 3);
		/*----------------------- 擪گĂOȂ瓧Fɂ */
#if 0
		if(coldata == 0) {
			if( i % 16 != 0 ) {
				coldata |= 0x8000;
			}
		}
#else
		if( i < 16 ){
/*			if( coldata == 0 )		printf( "BLACK col NO:%d\n", i );*/
			if( stp_data & (1<<(15-i))  ){
				coldata |= 0x8000;
			}
		}
		else{
			if(coldata == 0) {
/*				printf( "BLACK col NO:%d\n", i );*/
				if( i % 16 != 0 ) {
					coldata |= 0x8000;
				}
			}
		}
#endif

		fwrite(&coldata, sizeof(u_short), 1, cvtfp);
	}

	if( colfp != NULL )
		fclose( colfp );

	col_buff_count++;

	return( OK );
}


int PsxDataSet( char string[MAX_WORD][MAX_COLUMN] )
{
	u_long		data_size;
	FILE		*rdfp = NULL;						/* read ̧߲ */
	u_char		work[1024];

	if( (rdfp=Rfile_open(string[1], "rb")) == NULL ){	/* read file̵ */
		return( NG );
	}

	fseek(rdfp, 0, SEEK_SET);					/* װް߲ɼ */
	while( (data_size=fread(work, sizeof(u_char), 1024, rdfp)) > 0 ){
		fwrite(work, sizeof(u_char), data_size, cvtfp);
	}

	if( rdfp != NULL )
		fclose( rdfp );

	return( OK );
}


int OpdDataSet( char string[MAX_WORD][MAX_COLUMN] )
{
	u_long			data_size;
	FILE			*rdfp = NULL;						/* read ̧߲ */
	OPD_HEAD		opd_head_buff;
	OPD_COL_DATA	opd_col_buff;
	OPD_CSR_DATA	opd_csr_buff;
	OPD_PAT_DATA	opd_pat_buff;
	OPD_OBJ_DATA	opd_obj_buff;
	OPD_ANM_DATA	opd_anm_buff;
	struct	_obj_data{
		short		u, v;
		short		char_code;
		short		palette;
		char		pad;
		u_char		w, h;
		char		pad2[5];
	}obj_data;
	u_long			head_p;
	u_long			pat_p;
	u_long			anm_p;
	int				i, j;
	int				col_file_id = -1;
	int				csr_file_id = -1;
	short			csr_file_no;
	short			pattern_no;
	short			anime_no;
	char			name_buff[64];
	u_long			l_val;
	short			s_val;
	u_char			c_val;

	strlwr(string[2]);							/* ϊ */
	if( check_ext(string[2], ".col") != 0 ){
		printf( "J[t@Cُł[%s]\n", string[2] );
		return( NG );
	}

	for( i=0; i<col_buff_count; i++ ){
		if( strcmp(col_buff[i].name, string[2]) == NULL ){
			col_file_id = i;
			break;
		}
	}

	if( col_file_id == -1 ){
		printf( "J[t@C[%s]ϊĂ܂\n", string[2] );
		return( NG );
	}

	bzero( (char *)&opd_head_buff, sizeof(opd_head_buff) );
	bzero( (char *)&opd_col_buff, sizeof(opd_col_buff) );
	bzero( (char *)&opd_csr_buff, sizeof(opd_csr_buff) );
	bzero( (char *)&opd_pat_buff, sizeof(opd_pat_buff) );
	bzero( (char *)&opd_obj_buff, sizeof(opd_obj_buff) );
	bzero( (char *)&opd_anm_buff, sizeof(opd_anm_buff) );

	if( (rdfp=Rfile_open(string[1], "rb")) == NULL ){	/* read file̵ */
		printf( "%s̃I[vɎs܂\n" );
		return( NG );
	}

	if( Check_format(rdfp, K_OPD) != OK ){			/* ̧ق̎ނ */
		fclose( rdfp );
		return( NG );
	}

										/* tHgTCY`FbN		*/
	fseek(rdfp, 0x1a, SEEK_SET);
	fread((char *)&s_val, sizeof(short), 1, rdfp);
	if( s_val != 0x0808 ){
		printf( "tHgTCY%04xł\n", s_val );
		fclose( rdfp );
		return( NG );
	}

	fseek(rdfp, 0, SEEK_SET);
	head_p = ftell(cvtfp);

									/*	wb_Ƀ_~[f[^	*/
	fwrite((char *)&opd_head_buff, sizeof(opd_head_buff), 1, cvtfp);

	opd_head_buff.color_mode = col_buff[col_file_id].col_mode;
	opd_col_buff.address = col_buff[col_file_id].address;
	opd_col_buff.x = col_buff[col_file_id].x;
	opd_col_buff.y = col_buff[col_file_id].y;

									/* J[t@C̃f[^	*/
	opd_head_buff.col_address = ftell(cvtfp)+baseaddress;
	fwrite((char *)&opd_col_buff, sizeof(opd_col_buff), 1, cvtfp);

	fseek(rdfp, 0x20, SEEK_SET);
	fread((char *)&csr_file_no, sizeof(short), 1, rdfp);

	opd_head_buff.csr_address = ftell(cvtfp)+baseaddress;
	for( i=0; i<s_swap(csr_file_no); i++ ){
		fseek(rdfp, 0x22+8*i, SEEK_SET);
		bzero((char *)name_buff, sizeof(name_buff) );
		fread((char *)name_buff, 8, 1, rdfp);

		strlwr(name_buff);							/* ϊ */
		if( check_ext(name_buff, ".csr") != 0 ){
			printf( "CSRt@Cُł[%s]\n", name_buff );
			return( NG );
		}

		csr_file_id = -1;

		for( j=0; j<csr_buff_count; j++ ){
			if( strcmp(csr_buff[j].name, name_buff) == NULL ){
				csr_file_id = j;
				break;
			}
		}

		if( csr_file_id == -1 ){
			printf( "CSRt@CϊĂ܂[%s]\n", name_buff );
			return( NG );
		}

		if( opd_head_buff.color_mode != csr_buff[csr_file_id].col_mode ){
			printf( "CSRt@C̃pbg[hsKł[%s:%d,%d]\n",csr_buff[csr_file_id].name, opd_head_buff.color_mode, csr_buff[csr_file_id].col_mode );
			return( NG );
		}

		opd_csr_buff.address = csr_buff[csr_file_id].address;
		opd_csr_buff.x = csr_buff[csr_file_id].x;
		opd_csr_buff.y = csr_buff[csr_file_id].y;

									/* CSRt@C̃f[^	*/
		fwrite((char *)&opd_csr_buff,sizeof(opd_csr_buff),1,cvtfp);
	}

	pat_p = ftell(cvtfp);
	opd_head_buff.pat_address = ftell(cvtfp)+baseaddress;

									/* p^[ǂݏo	*/
	fread((char *)&pattern_no, sizeof(short), 1, rdfp);

									/* _~[̃p^[f[^	*/
	for( i=0; i<s_swap(pattern_no); i++ ){
		fwrite((char *)&opd_pat_buff,sizeof(opd_pat_buff),1,cvtfp);
	}

	for( i=0; i<s_swap(pattern_no); i++ ){
		bzero( name_buff, sizeof(name_buff) );

		fread((char *)name_buff, 16, 1, rdfp);

		opd_pat_buff.command = OpdGetCommand(name_buff, &opd_pat_buff.address);

		if( opd_pat_buff.command == -1 ){
			return( NG );
		}

		fread((char *)&c_val, 1, 1, rdfp);

		if( opd_pat_buff.command == OPD_CMD_DATA ){

			if( opd_head_buff.obj_number == 0 ){
				opd_head_buff.obj_number = c_val;
			}
			else{
				if( opd_head_buff.obj_number != c_val ){
					printf( "IuWFrŕύXĂ܂.[pat no:%d,%d]\n",i,c_val );
					return( NG );
				}
			}

/*			fseek(rdfp, 85, SEEK_CUR);*/
			fseek(rdfp, ftell(rdfp)+85, SEEK_SET);
			fseek(cvtfp, 0, SEEK_END);
			opd_pat_buff.address = ftell(cvtfp)+baseaddress;
			for( j=0; j<opd_head_buff.obj_number; j++ ){
				fread((char *)&obj_data, sizeof(obj_data), 1, rdfp);
				opd_obj_buff.u = s_swap(obj_data.u);
				opd_obj_buff.v = s_swap(obj_data.v);
				opd_obj_buff.w = obj_data.w;
				opd_obj_buff.h = obj_data.h;
				opd_obj_buff.csr_number = s_swap(obj_data.char_code);
				if( opd_head_buff.color_mode != 16 ){
					opd_obj_buff.palette_number = 0;
				}
				else{
					opd_obj_buff.palette_number =
										((obj_data.palette)&0xf000)>>12;
				}
				fwrite((char *)&opd_obj_buff,sizeof(opd_obj_buff),1,cvtfp);
			}
		}
		else{
			if( c_val != NULL ){
				printf( "R}hɃIuWF[%d]ݒ肳Ă܂\n", c_val );
				return( NG );
			}
			fseek(rdfp, ftell(rdfp)+85, SEEK_SET);
		}

		fseek( cvtfp, pat_p+i*sizeof(opd_pat_buff), SEEK_SET );
		fwrite((char *)&opd_pat_buff,sizeof(opd_pat_buff),1,cvtfp);
	}

	fseek(cvtfp, 0, SEEK_END);
	anm_p = ftell(cvtfp);
	opd_head_buff.anm_address = ftell(cvtfp)+baseaddress;

	fread((char *)&anime_no, sizeof(anime_no), 1, rdfp);

											/* _~[f[^	*/
	for( i=0; i<s_swap(anime_no); i++ ){
		fwrite((char *)&l_val,sizeof(l_val),1,cvtfp);
	}

	for( i=0; i<s_swap(anime_no); i++ ){
		fseek(rdfp, ftell(rdfp)+16, SEEK_SET);
		fread((char *)&s_val, sizeof(s_val), 1, rdfp);
		s_val = s_swap(s_val);

		fseek( cvtfp, 0, SEEK_END );
		l_val = ftell(cvtfp)+baseaddress;
/*		fwrite((char *)&s_val,sizeof(s_val),1,cvtfp);*/

		for( j=0; j<s_val; j++ ){
			fread((char *)&opd_anm_buff, sizeof(opd_anm_buff), 1, rdfp);
			opd_anm_buff.pat_number = s_swap(opd_anm_buff.pat_number);
			opd_anm_buff.time = s_swap(opd_anm_buff.time);
			fwrite((char *)&opd_anm_buff,sizeof(opd_anm_buff),1,cvtfp);
		}

		fseek( cvtfp, anm_p+i*4, SEEK_SET );
		fwrite((char *)&l_val,sizeof(l_val),1,cvtfp);
	}

	fseek(cvtfp, head_p, SEEK_SET);
	fwrite((char *)&opd_head_buff,sizeof(opd_head_buff),1,cvtfp);

	fseek( cvtfp, 0, SEEK_END );

	if( rdfp != NULL )
		fclose( rdfp );

	return( OK );
}


int OpdGetCommand( char cmd_name[], u_long *val )
{
	int		i;
	int		arg;
	char	cmd_buff[32];

	if( (arg = sscanf( cmd_name, "%s %ld", cmd_buff, val )) == 1 ){
		*val = 0;
	}

	if( strcmp(cmd_buff, "LOOP") == NULL ){
		return( OPD_CMD_LOOP );
	}
	else if( strcmp(cmd_buff, "STOP") == NULL ){
		return( OPD_CMD_STOP );
	}
	else if( strcmp(cmd_buff, "END") == NULL ){
		return( OPD_CMD_END );
	}
	else if( strcmp(cmd_buff, "GOTO") == NULL ){
		if( arg != 2 ){
			printf( "GOTOR}ḧςł[%s]\n", cmd_name );
			return( -1 );
		}
		return( OPD_CMD_GOTO );
	}
	else if( strcmp(cmd_buff, "TR_CSR") == NULL ){
		if( arg != 2 ){
			printf( "TR_CSRR}ḧςł[%s]\n", cmd_name );
			return( -1 );
		}
		return( OPD_CMD_TR_CSR );
	}
	else if( strcmp(cmd_buff, "ST_ANIME") == NULL ){
		if( arg != 2 ){
			printf( "ST_ANIMER}ḧςł[%s]\n", cmd_name );
			return( -1 );
		}
		return( OPD_CMD_ST_ANIME );
	}
	else if( strcmp(cmd_buff, "AC_ANIME") == NULL ){
		return( OPD_CMD_AC_ANIME );
	}
	else if( strcmp(cmd_buff, "SET_FLAG") == NULL ){
		if( arg != 2 ){
			printf( "SET_FLAGR}ḧςł[%s]\n", cmd_name );
			return( -1 );
		}
		return( OPD_CMD_SET_FLAG );
	}
	else if( strcmp(cmd_buff, "REPEAT") == NULL ){
		if( arg != 2 ){
			printf( "REPEATR}ḧςł[%s]\n", cmd_name );
			return( -1 );
		}
		return( OPD_CMD_REPEAT );
	}
	else{
		return( OPD_CMD_DATA );
	}
}


int TimDataSet( char string[MAX_WORD][MAX_COLUMN] )
{
	u_long		data_size;
	FILE		*rdfp = NULL;						/* read ̧߲ */
	u_short		work[1024];
	u_long		tim_data;
	u_long		stp_data;
	int			i;

	if( (rdfp=Rfile_open(string[1], "rb")) == NULL ){	/* read file̵ */
		return( NG );
	}

	fseek(rdfp, 0, SEEK_SET);
	/*-------------------------------------------------------- tim ID write */
	fread(&tim_data, sizeof(u_long), 1, rdfp);
	fwrite(&tim_data, sizeof(u_long), 1, cvtfp);

	/*------------------------------------------------------ tim FLAG check */
	fread(&tim_data, sizeof(u_long), 1, rdfp);
	fwrite(&tim_data, sizeof(u_long), 1, cvtfp);

	if((tim_data & 0x08) != 0) {
		fread(&tim_data, sizeof(u_long), 1, rdfp);
		fwrite(&tim_data, sizeof(u_long), 1, cvtfp);		/* bnum write */

		fread(work, sizeof(u_short), (tim_data-4)/2, rdfp);		/* r 3, 4, 5 */

		/*------------------------------------------------------ CLUT0  */
		if((work[4] & 0x07fff) == 0) {
			work[4] = 0;
		}

		if( string[2][0] != NULL ){
			stp_data = StrDataSetBin( string[2] );
			for( i=0; i<16; i++ ){
				if( stp_data & (1<<(15-i))  ){
					work[i+4] |= 0x8000;
				}
				else{
					work[i+4] &= 0x7fff;
				}
			}
		}

		fwrite(work, sizeof(u_short), (tim_data-4)/2, cvtfp);	/* r 3, 4, 5 */
	}

	while( (data_size=fread(work, sizeof(u_short), 1024, rdfp)) > 0 ){
		fwrite(work, sizeof(u_short), data_size, cvtfp);
	}

	if( rdfp != NULL )
		fclose( rdfp );

	return( OK );
}


int KugiDataSet( char string[MAX_WORD][MAX_COLUMN] )
{
	u_long		data_address;
	u_long		data_num;
	FILE		*rdfp = NULL;						/* read ̧߲ */
	short		data[4];
	int			i;

	if( (rdfp=Rfile_open(string[1], "rb")) == NULL ){	/* read file̵ */
		return( NG );
	}

	fseek(rdfp, 0x0c, SEEK_SET);					/* ްJn߲ǂݏo */
	fread(&data_address, sizeof(long), 1, rdfp);

	fseek(rdfp, 0x20, SEEK_SET);					/* ްǂݏo */
	fread(&data_num, sizeof(long), 1, rdfp);
	data_num /= 3;
	fwrite(&data_num, sizeof(long), 1, cvtfp);

	fseek(rdfp, data_address+0x0c, SEEK_SET);		/* ްJn߲ɼ */

	while( fread((char *)data, sizeof(short), 4, rdfp) == 4 ){
		
		if( data[2] == 0 ){
			fwrite(data, sizeof(short), 2, cvtfp);
			data_num--;
			if( data_num == 0 )	break;
		}
	}

	if( rdfp != NULL )
		fclose( rdfp );

	return( OK );
}


/*--< function >------------------------------------------------------------*/
/*	`F	CsrTransWH(dp)													*/
/*	F	u_long	pic			:16bit߸ق̐							*/
/*			u_long	w			;w										*/
/*			u_long	h			;h										*/
/*	F	wްނɕϊނ߂								*/
/*	ԂlFu_long datasize:	ް 									*/
/*--------------------------------------------------------------------------*/
long CsrTransWH(FILE *csrfp, u_long pic, u_long w, u_long h, u_short *data)
{
	u_short		wk;
	int			i, j;						/* ٰߗpϐ */

	fseek(csrfp, CSR_CHRDATA, SEEK_SET);			/* ް߲ɼ */

	w /= pic;

	for (i = 0 ; i < h ; i++) {
		if(pic == BIT4PIC) {
			fseek(csrfp, CSR_CHRDATA+i*64, SEEK_SET);
			for(j = 0 ; j < w ; j++) {
				if(fread(&wk, sizeof(u_short), 1, csrfp) != 1) {
					printf("%x߸Ӱނ̻ޕϊs܂\n",pic);
					return( -1 );
				}
				*data = (((wk&0xf0f0)>>4) | ((wk&0x0f0f)<<4));
				data++;
			}
		} else {
			fseek(csrfp, CSR_CHRDATA+i*128, SEEK_SET);
			if(fread(data, sizeof(u_short), w, csrfp) != w) {
				printf("%x߸Ӱނ̻ޕϊs܂\n",pic);
				return( -1 );
			}
			data += w;
		}
	}

	return( w*h );
}


/***< function >*************************************************************/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԂlF																*/
/****************************************************************************/
/*--< function >------------------------------------------------------------*/
/*	`F																	*/
/*	F																	*/
/*	F																	*/
/*	ԂlF																*/
/*--------------------------------------------------------------------------*/
